\ LIFETING.FTH

\ Dr. Tings "Life" (?)

\ Abgetippt aus FORTH DIMENSIONS 15/1 , Mai/Juni 1993, S.30-34.

\ Fred Behringer 30.12.93

\ Per INCLUDE LIFETING an Turbo-Forth (das Hostsystem von F-TP)
\ oder an F-TP selbst anbinden.  Es funktioniert bei beiden und
\ gibt einen guten Eindruck von den Geschwindigkeitsverhltnis-
\ sen.  Man beachte,  dass damit keine eigentliche Aussage ber
\ die Schnelligkeit von F-TP gemacht werden kann, da der grte
\ Teil der Arbeit  im Hin- und Herschaufeln der Bildschirmdaten
\ besteht. Es vermittelt aber einen Eindruck von der Arbeit des
\ Servers und des Link-Adapters.

\ Aufruf:  n GENERATIONS [RET]


DECIMAL

35 CONSTANT WHITE                    \ ASCII #
32 CONSTANT BLACK                    \ blank

: ADDRESS1 ( n -- ad )               \ first area of life objects
     2047 AND                        \ n modulo 2048
     PAD + ;                         \ add offset to PAD

: ADDRESS2 ( n -- ad )               \ 2nd area for next generation
     ADDRESS1                        \ add 2048 to the ADDRESS1
     2048 + ;                        \ let ADDRESS1 do the modulus

: NEIGHBORS ( -- )
     2048 0                          \ scan the entire map
     DO  I 01 + ADDRESS1 C@          \ add objects in 8 neighbors
         I 01 - ADDRESS1 C@ +
         I 79 + ADDRESS1 C@ +
         I 79 - ADDRESS1 C@ +
         I 80 + ADDRESS1 C@ +
         I 80 - ADDRESS1 C@ +
         I 81 + ADDRESS1 C@ +
         I 81 - ADDRESS1 C@ +
         I      ADDRESS1 C@          \ object in this location ?
         IF   DUP 2 =                \ yes. 2 or 3 neighbors ?
              SWAP 3 = OR
              IF 1 ELSE 0 THEN       \ over-crowded
         ELSE 3 =                    \ empty location
              IF 1 ELSE 0 THEN       \ give birth if 3 life neighbors
         THEN
         I ADDRESS2 C!               \ store next generation
     LOOP ;

: REFRESH ( -- )                     \ copy next generation to current
     PAD 2048 + PAD 2048 CMOVE ;

: DISPLAY ( -- )                     \ show current map on screen
     0 0 AT                          \ move cursor to upper left corner
     PAD 1920 0                      \ scan 1920 locations
     DO   DUP C@                     \ life object here ?
          IF WHITE ELSE BLACK THEN   \ show it
          EMIT
          1 +                        \ next location
     LOOP DROP ;

: INIT-MAP ( ad -- )                 \ generate a map from some memory
     2048 0                          \ look at a 2048-byte area
     DO   DUP C@ 1 AND               \ use its least significant bit
          IF 1 ELSE 0 THEN           \ to assign life object
          I ADDRESS1 C!              \ in our current map
          1 +
     LOOP DROP ;

: GENERATIONS ( n -- )               \ repeat n generations
     0 DO NEIGHBORS                  \ compute next generation
          REFRESH                    \ copy to current map
          DISPLAY                    \ and show it
     LOOP ;

500 INIT-MAP                         \ initialize the map
 10 GENERATIONS                      \ do 10 generations
