\ ******************************************************
\ *                                                    *
\ *  TRANSSYS.FTH                                      *
\ *                                                    *
\ *  Server fr das Transputer-System (T800)           *
\ *                                                    *
\ *  Fred Behringer, Planegger Str. 24, 81241 Mnchen  *
\ *                                                    *
\ *  Version 1.00                           12.4.1992  *
\ *                                                    *
\ ******************************************************


\ Als INCLUDE-Datei fr das Turbo-FORTH-System gedacht.
\ Liefert Server,  Transputer-Assembler, Transputer-Disassembler
\ und alles, was ntig ist, um vom AT-x86-Turbo-FORTH-System aus
\ die Transputer-Systeme zu steuern.
\ Wird in ein  sich dafr im Vokabular FORTH einrichtendes Voka-
\ bular mit Namen SERVER gelegt.



CR .( ---------- Einige ntzliche FORTH-Ergnzungen ----------- )


ONLY FORTH ALSO DEFINITIONS

HEX

CODE  2NIP   ( n1 n2 n3 n4 -- n3 n4 )
   AX POP   BX POP   CX POP   CX POP
   BX PUSH  AX PUSH
   NEXT END-CODE

CODE  2TUCK  ( n1 n2 n3 n4  -- n3 n4 n1 n2 n3 n4 )
   AX POP   BX POP   CX POP   DX POP
   BX PUSH  AX PUSH  DX PUSH  CX PUSH  BX PUSH  AX PUSH
   NEXT END-CODE

CODE  2AND  ( d1 d2 -- d3 )
   AX POP  DX POP  BX POP  BX AX AND
   BX POP  BX DX AND  2PUSH END-CODE

CODE  2OR  ( d1 d2 -- d3 )
   AX POP  DX POP  BX POP  BX AX OR
   BX POP  BX DX OR  2PUSH END-CODE

CODE  2XOR  ( d1 d2 -- d3 )
   AX POP  DX POP  BX POP  BX AX XOR
   BX POP  BX DX XOR  2PUSH END-CODE

CODE  2NOT  ( d -- d' )
   AX POP  AX NOT  DX POP  DX NOT
   2PUSH END-CODE

CODE  4DROP  ( n1 n2 n3 n4 -- )
   AX POP  AX POP  AX POP  AX POP NEXT END-CODE

: D<=   D>  NOT ;    : D>=   D<  NOT ;    : D<>   D=  NOT ;
: D0<   0.  D<  ;    : D0>   0.  D>  ;
: D0<=  D0> NOT ;    : D0>=  D0< NOT ;    : D0<>  D0= NOT ;

: SGN   ( n -- -1/0/1 )   DUP  0< SWAP  0> - ;
: DSGN  ( d -- -1/0/1 )  2DUP D0< -ROT D0> - ;

: D1+!  ( ad -- )    DUP 2@ 1. D+ ROT 2! ;  \ 2Variable um 1 inkrementieren
: D1-!  ( ad -- )    DUP 2@ 1. D- ROT 2! ;  \              1 dekrementieren
: D4+!  ( ad -- )    DUP 2@ 4. D+ ROT 2! ;  \              4 inkrementieren
: D4-!  ( ad -- )    DUP 2@ 4. D- ROT 2! ;  \              4 dekrementieren
: D+!   ( d ad -- )  0 2TUCK DROP 2@ D+ 2SWAP DROP 2! ;
: D4+   ( d -- d+4 ) 4. D+ ;
: D4-   ( d -- d-4 ) 4. D- ;
: D1+   ( d -- d+1 ) 1. D+ ;
: D1-   ( d -- d-1 ) 1. D- ;

: D16/  ( d -- d )   D2/ D2/ D2/ D2/ ;

: 4+    ( n -- n+4 ) 4 + ;
: 4*    ( n -- n*4 ) 4 * ;

: BD. ( d -- )               \ Zeigt 32-Bit-Zahl binr an (absolut)
   BASE @ 2 BASE !
   -ROT UD. BASE ! ;

: HD. ( d -- )               \ Zeigt 32-Bit-Zahl hexadezimal an (absolut)
   BASE @ HEX
   -ROT UD. BASE ! ;

: KEY(J/N) ( -- o )
   1
   BEGIN
     DROP
     KEY DUP 0= IF KEY DROP THEN  \ Funktionscode ?
     DUP DUP 4A = SWAP            \ J ?
             6A = OR              \ j ?
     IF DROP 4A EXIT THEN         \ -- J
     DUP DUP 4E = SWAP            \ N ?
             6E = OR              \ n ?
     IF DROP 4E EXIT THEN         \ -- N
   AGAIN ;



CR .( ---------------- Vokabulare einrichten ------------------ )


ONLY FORTH ALSO DEFINITIONS
VOCABULARY TASSEMBLER  VOCABULARY SERVER

: [TASSEMBLER] ( -- ) CONTEXT @ AVOC ! TASSEMBLER ; IMMEDIATE
: [SERVER]     ( -- ) CONTEXT @ AVOC ! SERVER     ; IMMEDIATE
: [FROM]       ( -- ) AVOC @ CONTEXT !            ; IMMEDIATE



ONLY FORTH ALSO SERVER ALSO DEFINITIONS



CR .( -------------- Variablen und Konstanten ----------------- )


HEX


VARIABLE LINKBASE  150 LINKBASE !  \ Voreinstellung entsprechend B004 und TEK8

: DATIN   LINKBASE @ ;  \ R
: DATOUT  DATIN  1 + ;  \ W
: STATIN  DATIN  2 + ;  \ R/W
: STATOUT DATIN  3 + ;  \ R/W
: RESET   DATIN 10 + ;  \ W
: ERROR   RESET      ;  \ R
: ANALYSE DATIN 11 + ;  \ W

80000070. 2CONSTANT MEMSTART

2VARIABLE ORG           \ Tsystem-Einsprung. Adresse muss durch 4 teilbar sein.
80000200. ORG 2!        \ Kann ( weitgehend ) beliebig gelegt werden.
: WPTR ( -- d )         \ Legt Workspace-Pointer zur Zeit des TSystem-
   ORG 2@ 100. D- ;     \ Bootens auf Stack. ( Erste Adresse, ab der
                        \ das Transputer-Forth-System geladen wird. )
2VARIABLE TBOOT-END     \ Jeweiliger Stand des DP-Ts nach den einzelnen
                        \ Schritten des Bootvorgangs.
2VARIABLE DP-T          \ Dictionary-Pointer ins TRam
MEMSTART  DP-T 2!       \ Zunchst einmal

2VARIABLE EOS           \ Ende des Tsystems. Oder beabsichtigtes Ende.
80030000. EOS 2!        \ Hngt natrlich vom RAM-Vorrat ab.

2VARIABLE BUFJUMP       \ Zum Aufbau von Vorwrtssprngen bei IF..THEN usw.
                        \ Bei Erreichen  von  THEN,  wenn also alles,  was
                        \ bersprungen werden soll, assembliert ist,  wird
                        \ DP-T kurzzeitig nach HERE-T+10  umgeleitet.  Der
                        \ Wert von HERE-T+10 wird in BUFJUMP solange aufbe-
                        \ wahrt,  bis  ?>RESOLVE  abgearbeitet ist.  Dabei
                        \ wird xxx CJ nach HERE-T+10 assembliert.  xxx ist
                        \ die Lnge  des Sprungs,  die ja  zu Anfang  noch
                        \ nicht bekannt war.  Anschlieend wird xxx CJ per
                        \ TMOVE  an den Anfang  des zu berspringenden Pro-
                        \ grammstcks gelegt.

 VARIABLE ASCFILT             \ Bei TDUMP nur ASCII-Zeichen ausgeben ?
          ASCFILT ON          \ ON = ja
 VARIABLE ABSICHERUNG         \ Abfragen zur Sicherheit
          ABSICHERUNG ON      \ beim Assemblieren usw.
 VARIABLE ABSAVE              \ Zum temporren Ablegen bei OPR




CR .( ------------ Vorgezogene Worte des Servers -------------- )


DEFER C,-T
DEFER TMOVE

\ Die bisher  im Vokabular  SERVER  schon definierten Kon-
\ stanten, Variablen  und  vorgezogenen Worte  werden nun
\ dem Transputer-Assembler bereits zur Verfgung gestellt.



CR .( ---------------- Transputer-Assembler ------------------- )


ONLY FORTH ALSO SERVER ALSO TASSEMBLER ALSO DEFINITIONS

: [FROM] [COMPILE] [FROM] ; IMMEDIATE  \ Rckkehr zu bisherigem CONTEXT

\ Das ist nicht  der vom Meta-Compiler  als Bestandteil des
\ Transputer-FORTH-Systems zu generierende  T800-Assembler.
\ Der vorliegende T800-Assembler arbeitet vom AT-x86-Wirts-
\ system aus; wahlweise im Reset-Zustand ber PEEK und POKE
\ oder ber die Links. Je nach Umleitung von TCODE! kann er
\ in das Wirtssystem-RAM oder in das T800-RAM assemblieren.

\ Beispielsweise eingeben:
\ TASSEMBLER ( oder SERVER )  80020000. DP-T 2!  123456. LDC [RET]

\ Im Transputer-RAM-Bereich ab 80020000 liegt dann der Transputer-
\ Maschinen-Befehl LDC  mit dem Operanden 123456 .  Man berzeuge
\ sich davon durch Eingabe von 80020000. 100. TDUMP [RET] .

HEX

: HERE-T  DP-T 2@ ;


CR .( -------------- Verarbeitung der Operanden --------------- )

: MAKE-PFIX ( d o -- )        \ Oprnd|Opc 0o
   DUP                        \ Oprnd|Opc 0o|Opc 0o
   CASE
     2 OF -ROT 2DUP 0F. D>
          IF   ABSICHERUNG @ DUP IF CR THEN
               ABORT" Operand zu gro fr PFIX"
          ELSE DROP SWAP 10 * OR C,-T EXIT
          THEN                                           ENDOF
     6 OF -ROT 2DUP 0F. D>
          IF   ABSICHERUNG @ DUP IF CR THEN
               ABORT" Operand zu gro fr NFIX"
          ELSE DROP SWAP 10 * OR C,-T EXIT
          THEN                                           ENDOF
    0F OF      ABSICHERUNG @
          IF
               CR ." Wirklich OPR explizit verlangt ? (J/N) "
               KEY(J/N) ASCII N = ABORT" Neu anfangen !" CR
          THEN                                           ENDOF
   ENDCASE
   >R 2DUP DROP R>            \ Oprnd|LoOprnd|Opc 0o
   10 * SWAP 0F AND OR        \ Oprnd|Code ox
   -ROT                       \ Code ox|Oprnd
   BEGIN
     D16/ 2DUP  D0>           \ Code ox|Oprnd 1 Nibble nach rechts noch > 0 ?
   WHILE
     2DUP DROP 0F AND 20 OR   \ Code ox|Oprnd neu|Pfix 2x
     -ROT                     \ Code ox|Pfix 2x|Oprnd neu
   REPEAT
   2DROP                      \ Code ox|Pfix 2x ... Pfix 2x
   BEGIN
    DUP C,-T                  \ Assemblieren
    10 / 2 <>                 \ Noch Pfix ?
   UNTIL ;

: MAKE-NFIX ( d o -- )        \ Oprnd|Opc 0o
   DUP                        \ Oprnd|Opc 0o|Opc 0o
   CASE
     2 OF CR ABSICHERUNG @ ABORT" Unzulssiger Operand fr PFIX" ENDOF
     6 OF CR ABSICHERUNG @ ABORT" Unzulssiger Operand fr NFIX" ENDOF
    0F OF CR ABSICHERUNG @ ABORT" Unzulssiger Operand fr OPR"  ENDOF
   ENDCASE
   >R 2DUP 2DUP 2NOT          \ Oprnd|Oprnd|NotOprnd
   2SWAP DROP R>              \ Oprnd|NotOprnd|LoOprnd|Opc 0o
   10 * SWAP 0F AND OR        \ Oprnd|NotOprnd|Code ox
   >R                         \ Oprnd|NotOprnd
   BEGIN
     2DUP 0FF. D>             \ Oprnd|NotOprnd noch > FFh ?
   WHILE
     D16/ 2SWAP D16/ 2DUP     \ NotOprnd|Oprnd|Oprnd
     DROP 0F AND 20 OR        \ NotOprnd|Oprnd|Pfix 2x
     >R 2SWAP                 \ Oprnd|NotOprnd
   REPEAT
   D16/ DROP 60 OR C,-T 2DROP \ -- Nfix 6x assemblieren
   BEGIN
    R> DUP C,-T               \ Assemblieren
    10 / 2 <>                 \ Noch Pfix ?
   UNTIL ;

DEFER TCODE!
: (TCODE!) ( d o -- d o )     \ Opc|Oprnd
   -ROT 2DUP D0>= IF ROT MAKE-PFIX ELSE ROT MAKE-NFIX THEN ;
' (TCODE!) IS TCODE!



CR .( ----- Assemblieren, aufgeschlsselt nach Wortklassen ---- )


: 1MI CREATE C, DOES> C@ TCODE! ;


00 1MI J     01 1MI LDLP 02 1MI PFIX  03 1MI LDNL  04 1MI LDC
05 1MI LDNLP 06 1MI NFIX 07 1MI LDL   08 1MI ADC   09 1MI CALL
0A 1MI CJ    0B 1MI AJW  0C 1MI EQC   0D 1MI STL   0E 1MI STNL  0F 1MI OPR

: 2MI
   CREATE , DOES> @ 0 0F
   ABSICHERUNG @ ABSAVE ! ABSICHERUNG OFF TCODE! ABSAVE @ ABSICHERUNG ! ;

00 2MI REV     01 2MI LB     02 2MI BSUB     03 2MI ENDP    04 2MI DIFF
05 2MI ADD     06 2MI GCALL  07 2MI IN       08 2MI PROD    09 2MI GT
0A 2MI WSUB    0B 2MI OUT    0C 2MI SUB      0D 2MI STARTP  0E 2MI OUTBYTE
0F 2MI OUTWORD 10 2MI SETERR 12 2MI RESETCH  13 2MI CSUB0   15 2MI STOPP
16 2MI LADD    17 2MI STLB   18 2MI STHF     19 2MI NORM    1A 2MI LDIV
1B 2MI LDPI    1C 2MI STLF   1D 2MI XDBLE    1E 2MI LDPRI   1F 2MI REM
20 2MI RET     21 2MI LEND   22 2MI LDTIMER  29 2MI TESTERR 2A 2MI TESTPRANAL
2B 2MI TIN     2C 2MI DIV    2E 2MI DIST     2F 2MI DISC    30 2MI DISS
31 2MI LMUL    32 2MI NOT    33 2MI XOR      34 2MI BCNT    35 2MI LSHR
36 2MI LSHL    37 2MI LSUM   38 2MI LSUB     39 2MI RUNP    3A 2MI XWORD
3B 2MI SB      3C 2MI GAJW   3D 2MI SAVEL    3E 2MI SAVEH   3F 2MI WCNT
40 2MI SHR     41 2MI SHL    42 2MI MINT     43 2MI ALT     44 2MI ALTWT
45 2MI ALTEND  46 2MI AND    47 2MI ENBT     48 2MI ENBC    49 2MI ENBS
4A 2MI MOVE    4B 2MI OR     4C 2MI CSNGL    4D 2MI CCNT1   4E 2MI TALT
4F 2MI LDIFF   50 2MI STHB   51 2MI TALTWT   52 2MI SUM     53 2MI MUL
54 2MI STTIMER    55 2MI STOPERR       56 2MI CWORD       57 2MI CLRHALTERR
58 2MI SETHALTERR 59 2MI TESTHALTERR   5A 2MI DUP         5B 2MI MOVE2DINIT
5C 2MI MOVE2DALL  5D 2MI MOVE2DNONZERO 5E 2MI MOVE2DZERO  63 2MI UNPACKSN
6C 2MI POSTNORMSN 6D 2MI ROUNDSN       71 2MI LDINF       72 2MI FMUL
73 2MI CFLERR     74 2MI CRCWORD       75 2MI CRCBYTE     76 2MI BITCNT
77 2MI BITREVWORD 78 2MI BITREVNBITS   81 2MI WSUBDB      82 2MI FPLDNLDBI
83 2MI FPCHKERR   84 2MI FPSTNLDB      86 2MI FPLDNLSNI   87 2MI FPADD
88 2MI FPSTNLSN   89 2MI FPSUB         8A 2MI FPLDNLDB    8B 2MI FPMUL
8C 2MI FPDIV      8E 2MI FPLDNLSN      8F 2MI FPREMFIRST  90 2MI FPREMSTEP
91 2MI FPNAN      92 2MI FPORDERED     93 2MI FPNOTFINITE 94 2MI FPGT
95 2MI FPEQ       96 2MI FPI32TOR32    98 2MI FPI32TOR64  9A 2MI FPB32TOR64
9C 2MI FPTESTERR  9D 2MI FPRTOI32      9E 2MI FPSTNLI32   9F 2MI FPLDZEROSN
0A0 2MI FPLDZERODB   0A1 2MI FPINT        0A3 2MI FPDUP
0A4 2MI FPREV        0A6 2MI FPLDNLADDDB  0A8 2MI FPLDNLMULDB
0AA 2MI FPLDNLADDSN  0AB 2MI FPENTRY      0AC 2MI FPLDNLMULSN

\ Die folgenden 8 Befehle sind in den blichen Unterlagen nicht dokumentiert.
\ Vergleiche Reinecke/Schreiner: Transputer-Leitfaden, S.106.

23 2MI TESTLDS    24 2MI TESTLDE       25 2MI TESTLDD        26 2MI TESTSTS
27 2MI TESTSTE    28 2MI TESTSTD       2D 2MI TESTHARDCHAN  1FF 2MI START

: 3MI CREATE , DOES> @ 0 LDC FPENTRY ;

01 3MI FPUSQRTFIRST  02 3MI FPUSQRTSTEP  03 3MI FPUSQRTLAST
04 3MI FPURP         05 3MI FPURM        06 3MI FPURZ
07 3MI FPUR32TOR64   08 3MI FPUR64TOR32  09 3MI FPUEXPDEC32
0A 3MI FPUEXPINC32   0B 3MI FPUABS       0D 3MI FPUNOROUND
0E 3MI FPUCHKI32     0F 3MI FPUCHKI64    11 3MI FPUDIVBY2
12 3MI FPUMULBY2     22 3MI FPURN        23 3MI FPUSETERR
9C 3MI FPUCLRERR

\ GT, EQC usw. liefern fr TRUE  in Areg den Wert 1.  Das soll beibe-
\ halten werden.  Im Vokabular TASSEMBLER  gilt also  FALSE := 0  und
\ TRUE := 1 .  Das ist sicher keine wesentliche Einschrnkung, da man
\ ja bei Vergleichen sowieso meist in der Kategorie  "gleich oder un-
\ gleich 0" denkt. Trotzdem: Aufpassen !!!  -  0. LDC NOT liefert den
\ Wert -1 , nicht 1 ! Um bei Logikwerten 0 und 1  das logische Gegen-
\ teil  eines Vergleichsergebnisses  n Areg  zu erzeugen,  msste man
\ nach  der bitweisen Invertierung  noch 2 hinzuaddieren.  Das Krzel
\ INV ist ( im Transputer-Maschinencode und im Vokabular TASSEMBLER )
\ noch nicht vergeben.  Um alle Klarheiten restlos zu beseitigen, sei
\ also auch fr die logische Inversion noch ein Makro eingefhrt:

: INV 0. EQC     ;                 \ Das ist einfacher als NOT 2. ADC
: NEG NOT 1. ADC ;       \ negiert Inhalt von A mit berlaufbeachtung

\ Vorsicht beim Assemblieren !  Die Bezeichnungen fr die Logik-Worte
\ AND, OR, XOR, NOT usw. aus dem Vokabular FORTH werden in TASSEMBLER
\ von  Bezeichnungen  fr  Maschinenbefehle  berlagert.  Die Sequenz
\ 5. 7. D+ LDC  erscheint sinnvoll, die Sequenz  17. NOT LDC weniger.
\ Letztere  ldt nicht etwa  die bitweise Negation von 17  ins Areg !


CR .( Vergleiche : Breg o Areg  ==> Areg = TRUE {1}, sonst FALSE {0} )

: >  GT    ;
: <= > INV ;
: <  REV > ;
: >= < INV ;
: =  DIFF 0. EQC ;
: <> = INV ;


CR .( Vergleiche mit 0 : Areg o 0 ==> Areg = TRUE {1}, sonst FALSE {0} )

: 0>  0. LDC >  ;
: 0<= 0. LDC <= ;
: 0<  0. LDC <  ;
: 0>= 0. LDC >= ;
: 0=  0. EQC    ;
: 0<> 0= INV    ;


CR .( Vergleiche: vorzeichenlos, sonst wie oben )

: U<  TESTERR 2. EQC SUM CSUB0 TESTERR ;
: U>= U< INV  ;
: U>  REV U<  ;
: U<= REV U>= ;


CR .( Steuerstrukturen { IF THEN usw. } )

\ Beispiel: TASSEMBLER 0> IF 123456. LDC THEN
\           Als Compilat ( bei HEX-Eingabe ) erscheint:
\           40 F9 A6 21 22 23 24 25 46
\ Bei Sprngen bis zu 15 Byte: 1IF; bis zu 255 Byte: 2IF usw.
\ Wird nIF zu gro gewhlt, so bleibt ( bleiben )
\ ( ohne Schaden ) ein ( mehrere ) PFIX 0 vorgelagert.
\ Dadurch wurde ein zweiter Assemblier-Durchgang vermieden.
\ Wird nIF zu klein gewhlt, so erscheint eine Fehlermeldung.
\ hnliche Verhltnisse gelten fr nELSE .
\ Bei BEGIN .. UNTIL steht schon im ersten Durchlauf jedwede Informa-
\ tion  zur  Verfgung,  sodass sich  eine byteweise Aufspaltung  er-
\ brigt.  Man knnte  bei komplizierteren Vorhaben  und unabsehbaren
\ Sprunglngen bei nIF und nELSE vielleicht so vorgehen, dass man zu-
\ nchst vorsichtshalber nur mit FARIF und FARELSE arbeitet  ( in den
\ allermeisten Fllen wird man schon mit IF und ELSE  auskommen ) und
\ den Quelltext dann  nach Durchsicht  des Compilats  von Hand korri-
\ giert.  Reizvoll wre darberhinaus  die Automatisierung eines sol-
\ chen Vorgehens.  Alle Sprungstrukturen sind gegen Logikfehler gesi-
\ chert ( Meldung "Struktur unvollstndig" ).


: ?>MARK ( n -- fl maxlen. ad. )    \ ad. = THERE + n
  TRUE SWAP 1. ROT 0                \ TRUE vorlufig noch = -1 ( von FORTH )
  DO 20 C,-T D2* D2* D2* D2* LOOP HERE-T ;

: 1IF 1 ?>MARK ;  : 2IF 2 ?>MARK ;  : 3IF 3 ?>MARK ;
: 4IF 4 ?>MARK ;  : 5IF 5 ?>MARK ;  : 6IF 6 ?>MARK ;

: ?>RESOLVE ( fl maxlen. ad. -- )
   2TUCK HERE-T 2SWAP D- 2TUCK D<=
   IF CR ." Sprung zu weit. Nchsthheres Strukturelement "
         ." (nIF, nELSE, nWHILE) versuchen !" ABORT
   ELSE HERE-T 2ROT 2ROT HERE-T 10. D+ 2DUP BUFJUMP 2! DP-T 2! CJ
      BUFJUMP 2@ 2SWAP HERE-T BUFJUMP 2@ D-
      D- HERE-T BUFJUMP 2@ D- TMOVE DP-T 2!
   THEN ?CONDITION ;

: ?<MARK ( -- fl ad. ) TRUE HERE-T ;   \ immer noch TRUE von FORTH ( =-1 )

: ?<RESOLVE  ( fl ad. -- )
   2DUP HERE-T 2TUCK D- CJ 2OVER HERE-T D- 2OVER DP-T 2! CJ
   2SWAP HERE-T D- 2SWAP DP-T 2! CJ ?CONDITION ;

: ?<RESOLVE-DO  ( fl ad. d -- )
   LDLP
   HERE-T 2SWAP D- 3. D+ HERE-T 2SWAP  1. 6 0
   DO D2* D2* D2* D2* 2SWAP 1. D+ 2OVER 2OVER D>= IF 1. D- THEN 2SWAP LOOP
   2DROP         2SWAP 04 -ROT TCODE! DP-T 2! ?CONDITION
   LEND ;

CR .( Ab jetzt nicht mehr IF von FORTH )

:    IF 3IF       ;  \ Normale   IF-Verwendung: Sprnge bis 4 Kilobyte
: FARIF 5IF       ;  \ Zweitnormale Verwendung: Sprnge bis 1 Megabyte

: THEN ?>RESOLVE  ;  \ Ab jetzt nicht mehr THEN von FORTH

: TELSE ( fl1 maxlen1. ad1. n -- fl2 maxlen2. ad2. )
  0. LDC ?>MARK 5 0 DO 9 ROLL LOOP ?>RESOLVE ;

: 1ELSE 1 TELSE ;  : 2ELSE 2 TELSE ;  : 3ELSE 3 TELSE ;
: 4ELSE 4 TELSE ;  : 5ELSE 5 TELSE ;  : 6ELSE 6 TELSE ;

:    ELSE 3ELSE ;    \ Wie bei IF: Sprnge bis 4 Kilobyte
: FARELSE 5ELSE ;    \             Sprnge bis 1 Megabyte
                     \ Ab jetzt nicht mehr ELSE von FORTH

:    WHILE    IF ;  : 1WHILE 1IF ;  : 2WHILE 2IF ;  : 3WHILE 3IF ;
: FARWHILE FARIF ;  : 4WHILE 4IF ;  : 5WHILE 5IF ;  : 6WHILE 6IF ;

: BEGIN  ?<MARK                        ;
: UNTIL  ?<RESOLVE                     ;
: AGAIN  0. LDC UNTIL                  ;
: REPEAT 3 0 DO 7 ROLL LOOP AGAIN THEN ;

\ Achtung:  Alle Sprungkonstruktionen, vorwrts und rckwrts, mit Ausnahme
\ der DO-LOOPs, werden mit CJ gebildet. CJ hat die unangenehme Eigenschaft,
\ bei  ausgefhrtem  Sprung  den  Entscheidungswert Areg = 0  beizubehalten
\ ( Areg' = Areg usw.). Bei nicht ausgefhrtem Sprung wird dagegen der Ent-
\ scheidungswert Areg = 1 , wie eigentlich auch zu erwarten,  vom CPU-Stack
\ entfernt ( Areg' = Breg usw.). Es erscheint mir sinnvoller, es bei diesem
\ Hinweis zu belassen, als die 0 bei IF-THEN, BEGIN-UNTIL usw. knstlich zu
\ entfernen.  Ein erster Fall, bei dem dieser Hinweis wichtig wird, ist das
\ untenstehende Makro ABS.

CR .( Ab jetzt DO und LOOP anders als im Vokabular FORTH )

: DO   ( d -- fl ad. d )   >R >R ?<MARK R> R>   ;
: DO*  ( anz strt d -- fl ad. d )
  2SWAP LDC 2DUP STL 2DUP 1. D+ 2ROT LDC STL DO ;
: LOOP ( fl ad. d -- )     ?<RESOLVE-DO         ;

\ Diese DO-Konstruktion ist dynamisch (!) und kann geschachtelt werden (!).
\ Im Wptr-Offset d ( "lokale Variable d" )  wird ein Startwert verlangt.  d
\ wird als Steuervariable betrachtet  und bei jedem Schleifendurchgang um 1
\ erhht.  Im Wptr-Offset d+1 wird die ( vorzeichenlose ) gewnschte Anzahl
\ von Schleifendurchgngen erwartet.  d+1 wird bei jedem Schleifendurchgang
\ um 1 erniedrigt. Ist d+1 nach dem Erniedrigen <= 0, dann wird die Schlei-
\ fe verlassen und mit dem nchsten Befehl nach LOOP (eigentlich nach LEND)
\ fortgefahren.

\ DO* legt zunchst strt nach Wptr-Offset d und dann anz nach d+1, bevor es
\ die Funktion von DO bernimmt.

: TRUE    1. LDC ;   \ Achtung: TRUE = 1 in TASSEMBLER !!!
: FALSE   0. LDC ;   \         FALSE = 0, wie in FORTH

CR .( Weitere Makros { Pseudo-Opcodes } )

: ADD64 ( d -- )  0. LDC      \ z = y+x mit berlaufprfung
   2DUP 4DUP 4DUP LDL 2. D+   \ d = Wptr-Offset (lokale Variable);
   LDL LSUM STL 1. D+ LDL 3.  \ x in d/d+1; y in d+2/d+3
   D+ LDL LADD 1. D+ STL ;    \ z in d/d+1 (lo/hi)
: SUB64 ( d -- )  0. LDC      \ z = y-x mit berlaufprfung
   2DUP 4DUP 4DUP 2. D+ LDL   \ d = Wptr-Offset (lokale Variable);
   LDL LDIFF STL 3. D+ LDL 1  \ x in d/d+1; y in d+2/d+3
   D+ LDL LSUB 1. D+ STL ;    \ z in d/d+1 (lo/hi)
: MUL32*64 ( d -- )  0. LDC   \ Vorzeichenlose Multiplikation; z = x*y;
   2DUP 4DUP 4DUP LDL 2. D+   \ d = Wptr-Offset (lokale Variable);
   LDL LMUL 4. D+ STL LDL 3.  \ x in d; y in d+2/d+3; z in d+4/d+5
   D+ LDL LMUL 5. D+ STL ;    \ (lo/hi) "bertrag" bleibt in Areg
: MUL64 ( d -- )  0. LDC      \ Vorzeichenlose Multiplikation; z = x*y;
   2DUP 4DUP 4DUP 4DUP        \ d = Wptr-Offset (lokale Variable);
   4DUP 4DUP 4DUP 4DUP        \ x in d/d1; y in d+2/d+3;
   LDL 2. D+ LDL LMUL 4. D+   \ z in d+4/d+5/d+6/d+7 (lo..hi)
   STL LDL 3. D+ LDL LMUL
   REV 6. D+ STL 1. D+ LDL 2.
   D+ LDL LMUL 5. D+ STL 1.
   D+ LDL 3. D+ LDL LMUL REV
   7. D+ STL 0. LDC REV 6.
   D+ LDL LSUM 6. D+ STL 7.
   D+ LDL SUM 7. D+ STL ;
: DIV64/32 ( d -- )  0. LDC   \ Vorzeichenlose Division; z = y/x;
   2DUP 4DUP 4DUP 3. D+ LDL   \ d = Wptr-Offset (lokale Variable);
   LDL LDIV 5. D+ STL 2. D+   \ x in d; y in d+2/d+3; z in d+4/d+5
   LDL LDL LDIV 4. D+ STL ;   \ (lo/hi); Quotient in z; Rest in Areg
: ABS DUP 0> IF               \ Absolutwert von AREG
   ELSE REV NEG REV THEN REV ;
: ROL ( d -- )                \ Rotation von Areg um d Bits nach links
   0. LDC REV LDC LSHL OR ;
: ROR ( d -- )                \ Rotation von Areg um d Bits nach rechts
   0. LDC LDC LSHR OR ;
: SAL ( d -- )                \ Arithmetische Verschiebung von Areg um
   XDBLE LDC LSHL CSNGL ;     \ d Bits nach links
: SAR ( d -- )                \ Arithmetische Verschiebung von Areg um
   XDBLE LDC LSHR ;           \ d Bits nach rechts
: LROL ( d1 d2 -- ) 4DUP REV  \ Rotation des Doppelwortes Breg/Areg ( Breg
   DUP STL REV LDC LSHL 2DUP  \ hherwertig ) um d1 Bits nach links; Vorsicht:
   1. D+ STL 2DUP LDL 2SWAP   \ bei d1 > 20h wird der Transputer bis zu 3
   20. 2SWAP D- LDC SHR 1. D+ \ Minuten lang blockiert und die Rotation wirkt
   LDL OR ;                   \ wie ein Shift ( rechts aufgefllte Nullen ) ;
                              \ d2 = Wptr-Offset ( lokale Hilfsvariable ) ;
                              \ d2+1Wort wird ebenfalls in Anspruch genommen
: LROR ( d1 d2 -- ) 4DUP DUP  \ Rotation des Doppelwortes Breg/Areg ( Breg
   STL LDC LSHR 2DUP 1. D+    \ hherwertig ) um d1 Bits nach rechts;
   STL 2DUP LDL 2SWAP 20.     \ brige Bemerkungen wie bei LROL
   2SWAP D- LDC SHL OR 1. D+
   LDL ;
: BITCNT* 0. LDC REV BITCNT ; \ Anzahl der gesetzten Bits in Areg

\ Es folgen einige Systemkonstanten, die in TRANSMET fr die Meta-Compilation
\ von Code-Definitionen aus TKERNEL.FTH zur Verfgung stehen mssen. Sie sind
\ eigentlich dem Meta-Compiler zuzuordnen. Sie stellen "lokale Variablen" des
\ zu erzeugenden Transputer-Zielsystems dar.

HEX
 2. 2CONSTANT IP      \ Instruction-Pointer
 3. 2CONSTANT W       \ W-Register
 4. 2CONSTANT RP      \ Returnstack-Pointer
 5. 2CONSTANT SP      \ Datenstack-Pointer
 6. 2CONSTANT AREG    \ Pseudoregister zur Zwischenablage ( von Areg )
 7. 2CONSTANT BREG    \ Pseudoregister zur Zwischenablage ( von Breg )
 8. 2CONSTANT CREG    \ Pseudoregister zur Zwischenablage ( von Creg )
 9. 2CONSTANT DREG    \ Pseudoregister fr Extrazwecke
0A. 2CONSTANT EREG    \ Pseudoregister fr Extrazwecke
0B. 2CONSTANT FREG    \ Pseudoregister fr Extrazwecke
0C. 2CONSTANT GREG    \ Pseudoregister fr Extrazwecke
0D. 2CONSTANT HREG    \ Pseudoregister fr Extrazwecke
0E. 2CONSTANT BPUSHP  \ bewahrt Adresse BPUSH auf
0F. 2CONSTANT CPUSHP  \ bewahrt Adresse CPUSH auf
10. 2CONSTANT NEXTP   \ Label-Adresse von >NEXT
11. 2CONSTANT COLDP   \ bewahrt Adresse des Einsprungpunktes zu Coldstart auf
12. 2CONSTANT WARMP   \ bewahrt Adresse des Einsprungpunktes zu Warmstart auf
                      \ Der Inhalt von 0D bis 15 wird beim Meta- Compilieren
                      \ nachgeliefert
13. 2CONSTANT DODOESP \ fr DOES> zum indirekten Sprung nach DODOES
                      \ Nachtrgliche nderung nur mit 1 an erster Hexstelle !
14. 2CONSTANT 'QUIT   \ cfa von QUIT
15. 2CONSTANT NESTP   \ Label-Adresse von NEST
16. 2CONSTANT 'BOOT   \ cfa von BOOT

: X0 AREG ; : X1 BREG ; : Y0 CREG ; : Y1 DREG ;  \ Fr doppeltgenaue
: Z0 EREG ; : Z1 FREG ; : Z2 GREG ; : Z3 HREG ;  \ Arithmetik usw.
: WPTR WPTR ;
: BUFJUMP BUFJUMP ;

\ Und abschlieend noch ein Makro. ( Der T800 hat doch zu wenig Register. )

: APUSH  AREG STL  BREG STL  SP LDL    -4. ADC  SP STL
         AREG LDL    SP LDL  0. STNL  BREG LDL ;



CR .( ------------------------- Server ------------------------ )


ONLY FORTH ALSO SERVER ALSO DEFINITIONS

HEX

: [TASSEMBLER] [COMPILE] [TASSEMBLER] ; IMMEDIATE
: [FROM]       [COMPILE] [FROM]       ; IMMEDIATE
: [FORTH]                FORTH        ; IMMEDIATE


CR .( ---------------- PEEK und POKE nach RESET --------------- )


: TRESET ( -- )
   0 ANALYSE PC!
   0 RESET   PC!
   1 RESET   PC!  1 MS
   0 RESET   PC!  ;

: TANALYSE ( -- )
   0 ANALYSE PC!
   0 RESET   PC!
   1 ANALYSE PC!  3 MS
   1 RESET   PC!  1 MS
   0 RESET   PC!  1 MS
   0 ANALYSE PC!  ;

: TSTATUS ( port -- )     \ Warten bis Status an
   BEGIN                  \ Port gleich 1
     DUP PC@ 1 AND
     1 =
   UNTIL DROP ;

: TSTATUS-TIMEOUT ( port -- )           \ Nur begrenzt warten bis
   DUP PC@ 1 AND 1 = IF DROP EXIT THEN  \ Status an Port gleich 1
   10 MS
       PC@ 1 AND 1 = IF EXIT
                     ELSE BOLD CR ." TSystem an Linkport "
                                  LINKBASE @ H. BS EMIT
                                  ." h nicht in Reset ?"
                          ABORT CR
                     THEN ;

: TPEEK ( ad. -- )        \ Peek 4 Bytes vom T800 nach PAD
      1 PAD     C!        \ Steuerbyte
   SWAP PAD 1+  2!        \ Adresse
   \ TRESET                 noch sicherstellen, dass aus Reset heraus !!!
   5 0 DO                 \ Adresse ausgeben
       STATOUT TSTATUS-TIMEOUT
       PAD I + C@ DATOUT PC!
       LOOP
   9 5 DO                 \ 4 Bytes hereinholen
       STATIN  TSTATUS-TIMEOUT
       DATIN   PC@  PAD I + C!
       LOOP ;

:  @-T ( ad. -- d )        \ Peek d (4 Bytes) vom T800
   TPEEK PAD 5 + 2@ SWAP ;

: C@-T ( ad. -- o )        \ Peek o (1 Byte)
   TPEEK PAD 5 + C@ ;

: TPOKE ( ad. -- )         \ Poke 4 Bytes von PAD nach T800
      0 PAD     C!         \ Steuerbyte
   SWAP PAD 1+  2!         \ Adresse
   \ TRESET                \ noch sicherstellen, dass aus Reset heraus !!!
   9 0 DO                  \ 4 Bytes ab PAD+5
       STATOUT TSTATUS-TIMEOUT
       PAD I + C@ DATOUT PC!
       LOOP ;

: C!-T ( o ad. -- )        \ Poke o (1 Byte)
   2DUP TPEEK              \ 4 Bytes vom T800 holen
   ROT PAD 5 + C!          \ 1 Byte ersetzen
   TPOKE ;                 \ Alles wieder zum T800

:  !-T ( d ad. -- )        \ Poke d (4 Bytes)
   2SWAP
   SWAP PAD 5 + 2!
   TPOKE ;

: (C,-T) ( o -- ) DP-T 2@ C!-T DP-T D1+! ;
' (C,-T) IS C,-T

: ALIGN-T ( -- )
   DP-T 2@ DROP  3 AND  4 SWAP  -  3 AND
   BEGIN DUP  0<> WHILE  BL C,-T 1-  REPEAT  DROP ;
   \ DP-T auf nchstgelegene T-Adresse mit Byteselektor = 0
   \ Zwischenstellen werden mit BL aufgefllt



CR .( ----------------------- Debugging ----------------------- )
HEX

: ?ASCII ( c1 -- c2 )        \ Nicht-ASCII-Zeichen --> Punkt ?
   ASCFILT @                 \ TRUE = ja
   IF
     DUP 21 7E BETWEEN NOT   \ nicht ASCII ?
     IF  DROP 2E  THEN       \ dann Punkt
   ELSE
     DUP     7  =            \ Bell
     OVER    8  =  OR        \ Del
     OVER   0A  =  OR        \ Linefeed
     OVER   0D  =  OR        \ CR
     OVER   1B  =  OR        \ ESC
     OVER  0FF  =  OR        \ Bell usw. ?
     IF  DROP BL  THEN       \ dann Blank
   THEN ;

: TDUMP^ ." 0  1  2  3  4  5  6  7   8  9  A  B  C  D  E  F  0123456789ABCDEF" ;

: TDUMP ( ad. l. -- )  \ DUMP im TRAM. Stop: SPACE. Weiter: Space. Exit: CR CR
   CR >R >R BASE @ HEX -ROT R> R> 2OVER   \ Anzeige in Hex
   10 MU/MOD 2DROP >R 2SWAP R@ 0 D- R>
   DUP 3 * DUP 17 > IF 1+ THEN 0A + (CURSOR) NIP 0B SWAP AT TDUMP^
   (CURSOR) NIP AT BOLD ." \/" 3C + (CURSOR) NIP AT ." V" ATTOFF CR
   BEGIN
     BEGIN
       2DUP   <# # # # # # # # # #> TYPE SPACE SPACE \ Adresse anzeigen
        8 0 DO 2DUP C@-T 0 <# # # #> TYPE SPACE 1. D+ LOOP SPACE
        8 0 DO 2DUP C@-T 0 <# # # #> TYPE SPACE 1. D+ LOOP SPACE  10. D-
       10 0 DO 2DUP C@-T           ?ASCII  EMIT 1. D+ LOOP CR
       2SWAP 10. D- 2TUCK
       D0<= STOP? OR         \ Ende oder Abbruch ?
     UNTIL
     (CURSOR) DUP 18 = IF 0 0 AT 0B SPACES TDUMP^ THEN AT
     BOLD (CURSOR) -1 0 (FRAME) ." Weiter: +   Zurck: -   Exit: RET"
     ATTOFF AT
     KEY
     DUP ASCII + = IF  DROP 2SWAP 2DROP 100. 2SWAP
                        FALSE ELSE
         ASCII - = IF  2SWAP 2DROP 100. 2SWAP 200. D- DARK 0B 0 AT TDUMP^ CR
                        FALSE ELSE
     2DROP 2DROP BASE ! TRUE  THEN  THEN
   UNTIL 0C 0D (FRAME) CR ;

CODE LK! ( seg ad n -- ) \ n Bytes ab Langadresse seg:ad zu Link
               CX POP    \ fr Zhler CX
               BX POP    \ Anfangsadresse
               ES POP    \ Segment
                  HERE   \ Schleifenanfang
       BEGIN
           LINKBASE #    \ Basis-Portadresse
               DI MOV
        0 [DI] DX MOV
               DX INC
               DX INC
               DX INC    \ STATOUT-Portadresse
            DX AL IN     \ Output-Status von Link
           1 # AL AND
           1 # AL CMP
            0=           \ schon = 1 ?
       UNTIL
    ES: 0 [BX] AL MOV    \ Byte von Adresse
           LINKBASE #    \ Basis-Portadresse
               DI MOV
        0 [DI] DX MOV
               DX INC    \ DATOUT-Portadresse
            AL DX OUT    \ Daten an Link
               BX INC    \ nchste Adresse
                  LOOP
       NEXT END-CODE

CODE LK@ ( seg ad n -- ) \ n Bytes von Link zu Langadresse ab seg:ad
               CX POP    \ fr Zhler CX
               BX POP    \ Anfangsadresse
               ES POP    \ Segment
                  HERE   \ Schleifenanfang
       BEGIN
           LINKBASE #    \ Basis-Portadresse
                 DI MOV
          0 [DI] DX MOV
               DX INC
               DX INC    \ STATIN-Portadresse
             DX AL IN    \ Input-Status von Link
           1 # AL AND
           1 # AL CMP
            0=           \ schon = 1 ?
       UNTIL
           LINKBASE #    \ Basis-Portadresse
               DI MOV
        0 [DI] DX MOV    \ DATIN-Portadresse
            DX AL IN     \ Daten von Link
    AL ES: 0 [BX] MOV    \ zu Adresse
               BX INC    \ nchste Adresse
                  LOOP
       NEXT END-CODE


HEX
CR .( ----------------------- Ergnzung ----------------------- )

CODE (FREE) ( drv -- b/sec #cluster-tot #cluster sec/cluster )
     DX POP  36 # AH MOV 21 INT CX PUSH DX PUSH BX PUSH 1PUSH END-CODE

: OK-HOST ( -- )
     CR BOLD
     ." OK " ATTOFF ." im Host-FORTH-System" CR
     ." Wiederaufnahme mit START [RET] oder BYE [RET] TRESUME [RET]" CR ;
     \ Auch mglich: " Wiederaufnahme mit TRESET GOTO-SYSTEM [RET]"

CODE KBUF128 ( -- )            \ Tastaturpuffer nach Segment 60h
     CLI                       \ Interrupts verbieten
     40 # BX MOV  BX ES MOV    \ BIOS-Datensegment nach ES
     80 # BX MOV               \ Zeiger auf Pufferanfang nach BX
     200 # ES: 0 [BX] MOV      \ Zeiger mit 200h belegen
     82 # BX MOV               \ Zeiger auf Pufferende nach BX
     300 # ES: 0 [BX] MOV      \ Zeiger mit 300h belegen
     1A # BX MOV               \ Zeiger auf Warteschlangenanfang nach BX
     200 # ES: 0 [BX] MOV      \ Zeiger mit 200h belegen
     1C # BX MOV               \ Zeiger auf Warteschlangenende nach BX
     200 # ES: 0 [BX] MOV      \ Zeiger mit 200h belegen
     STI                       \ Interrupts wieder zulassen
     NEXT END-CODE

CODE KBUF16 ( -- )             \ Tastaturpuffer nach 1E-3D
     CLI                       \ Interrupts verbieten
     40 # BX MOV  BX ES MOV    \ BIOS-Datensegment nach ES
     80 # BX MOV               \ Zeiger auf Pufferanfang nach BX
     1E # ES: 0 [BX] MOV       \ Zeiger mit 1Eh belegen
     82 # BX MOV               \ Zeiger auf Pufferende nach BX
     3E # ES: 0 [BX] MOV       \ Zeiger mit 3Eh belegen
     1A # BX MOV               \ Zeiger auf Warteschlangenanfang nach BX
     1E # ES: 0 [BX] MOV       \ Zeiger mit 1Eh belegen
     1C # BX MOV               \ Zeiger auf Warteschlangenende nach BX
     1E # ES: 0 [BX] MOV       \ Zeiger mit 1Eh belegen
     STI                       \ Interrupts wieder zulassen
     NEXT END-CODE

CODE KBUF! ( n -- )            \ Zeichen in Tastaturpuffer schreiben
     CLI                       \ Interrupts verbieten
     40 # BX MOV  BX ES MOV    \ BIOS-Datensegment nach ES
     1C # BX MOV               \ Zeiger auf Warteschlangenende nach BX
     ES: 0 [BX] DI MOV         \ Warteschlangenende nach DI
     AX POP  AX ES: 0 [DI] MOV \ Zeichen vom Stack und ans Schlangenende
     DI INC  DI INC            \ Schlangenende um 2 erhhen
     82 # BX MOV               \ Zeiger auf Pufferende nach BX
     ES: 0 [BX] AX MOV         \ Pufferende nach AX
     AX DI CMP  0=             \ Wenn Pufferende = Schlangenende,
     IF  80 # BX MOV           \ dann Zeiger auf Pufferanfang nach BX
         ES: 0 [BX] DI MOV     \ und Pufferanfang nach DI
     THEN
        1C # BX MOV            \ Sodann Zeiger auf Schlangenende nach BX
        DI ES: 0 [BX] MOV      \ und DI nach Zeiger auf Schlangenende
     STI                       \ Interrupts wieder zulassen
     NEXT END-CODE

CODE WHICHKEY? ( -- n )
     1 # AH MOV 16 INT 0=      \ Liegt Zeichen an ?
     IF 0 # AX MOV THEN        \ Nein, dann 0 auf Stack; sonst
     1PUSH END-CODE            \ erweiterter Code ( hi/lo = Scan/ASCII )



CR .( --------- Transputer ruft Host { Schnittstelle } -------- )

2VARIABLE PARAM-BYE
VARIABLE TFB    \ Transfer-Buffer
0FE ALLOT       \ 0. Byte = Transfer-Code; wenn > 80, dann -> SERVE2
                \ 1. Byte = Anzahl der noch folgenden Bytes

: 0OUT 0 TFB 1+ C! ;  : 1OUT 1 TFB 1+ C! ;  : 2OUT 2 TFB 1+ C! ;
: 3OUT 3 TFB 1+ C! ;  : 4OUT 4 TFB 1+ C! ;  : 5OUT 5 TFB 1+ C! ;

: SERVE1 ( -- )
    DSEGMENT TFB 1+ 1 LK@  \ Anzahl n nach TFB
    DSEGMENT TFB 2+ TFB 1+ C@ DUP 0= IF 2DROP DROP ELSE LK@ THEN
                           \ n Bytes nach TFB+2 einlesen
    TFB C@                 \ Transfer-Code
    CASE
       0 OF 1OUT TFB 2+ C@ (IN) TFB 2+ C!                  ENDOF
       1 OF 0OUT TFB 2+ C@ TFB 3 + C@ (OUT)                ENDOF
       2 OF 1OUT TFB 2+  @ TFB 6 + C@ BDOS TFB 2+ C!       ENDOF
       3 OF 0OUT TFB 2+ C@ TFB 3 + C@ (AT) 2DROP           ENDOF
       4 OF 2OUT (CURSOR)  TFB 3 + C! TFB 2+ C!            ENDOF
       5 OF 0OUT TFB 2+ C@ TFB 3 + C@ (FRAME)              ENDOF
       6 OF 0OUT TFB 2+ C@   GRMODE ! (MODE)               ENDOF
       7 OF 1OUT #FILES    TFB 2+  C!                      ENDOF
       8 OF 0OUT TFB 2+ C@ CR BYE                          ENDOF \ BYE-FOR-DOS
       9 OF                             ( frei geworden )  ENDOF
      0A OF 2OUT DSEGMENT  TFB 2+   !                      ENDOF
      0B OF 1OUT KEY?      TFB 2+  C!                      ENDOF
      0C OF 2OUT KEY DUP 0= IF KEY ELSE 0 THEN
                           TFB 3 + C! TFB 2+ C!            ENDOF
      0D OF 0OUT TFB 2+ C@ (CLOSE)                         ENDOF
      0E OF 1OUT DRV       TFB 2+  C!                      ENDOF
      0F OF 2OUT HERE      TFB 2+   !                      ENDOF \ HERE-HOST
      10 OF 2OUT TFB 82 + @ TFB 2+  !                      ENDOF \ INDBBUF
      11 OF 0OUT TFB 2+ @ TFB 82 +  !                      ENDOF \ OUTDBBUF
      12 OF 1OUT TFB 82 + C@ TFB 2+ C!                     ENDOF \ INBTBUF
      13 OF 0OUT TFB 2+ C@ TFB 82 + C!                     ENDOF \ OUTBTBUF
      14 OF 4OUT TFB 80 + 2@ SWAP  TFB 2+ 2!               ENDOF \ INWDBUF
      15 OF 0OUT TFB 2+ 2@ SWAP  TFB 80 + 2!               ENDOF \ OUTWDBUF
      16 OF 0OUT TFB 2+ C@ TFB 80 + 2@ SWAP
                 2DUP LC@ + 1+ LC!                         ENDOF \ H$B!
      17 OF 2OUT TFB 2+   @ TFB 6 + C@ (OPEN)
                 TFB 3 + C! TFB 2+  C!                     ENDOF
      18 OF 2OUT TFB 2+   @ TFB 6 + C@ (CREATE)
                 TFB 3 + C! TFB 2+  C!                     ENDOF
      19 OF 1OUT TFB 2+   @ TFB 6 + C@ (GETLINE) TFB 2+ C! ENDOF
      1A OF 3OUT TFB 2+   @ TFB 4 + @ TFB 6 +  @
                 TFB 8 + C@ (GET)     TFB 4 + C! TFB 2+  ! ENDOF \ GET-HOST
      1B OF 3OUT TFB 2+   @ TFB 4 + @ TFB 6 +  @
                 TFB 8 + C@ (PUT)     TFB 4 + C! TFB 2+  ! ENDOF \ PUT-HOST
      1C OF 5OUT TFB 2+  2@ SWAP   TFB 6 + C@   TFB 7 + C@
                 (SEEK) TFB 6 + C!       SWAP   TFB 2+  2! ENDOF
      1D OF 10   TFB 1+ C! TFB 2+ @ (FREE) TFB 2+ 10 ERASE
                 TFB 2+ ! TFB 6 + ! TFB 0A + !  TFB 0E + ! ENDOF
      1E OF 1OUT HERE 1+  TFB 2+ C@ (SEARCH0)   TFB 2+  C! ENDOF
      1F OF 1OUT                    (SEARCH)    TFB 2+  C! ENDOF
      20 OF 1OUT HERE 1+  PAD 1+    (REN)       TFB 2+  C! ENDOF
      21 OF 1OUT TFB 2+  @  PC@  TFB 2+ C!                 ENDOF
      22 OF 2OUT TFB 2+  @   P@  TFB 2+  !                 ENDOF
      23 OF 0OUT TFB 2+ C@  TFB 3 + @  PC!                 ENDOF
      24 OF 0OUT TFB 2+  @  TFB 4 + @   P!                 ENDOF
      25 OF 1OUT TFB 2+  @  TFB 4 + @  LC@ TFB 2+ C!       ENDOF \ C@-H
      26 OF 0OUT TFB 2+ C@  TFB 3 + @  TFB 5 + @ LC!       ENDOF \ C!-H
      27 OF 2OUT TFB 2+  @  TFB 4 + @   L@ TFB 2+  !       ENDOF \  @-H
      28 OF 0OUT TFB 2+  @  TFB 4 + @  TFB 6 + @  L!       ENDOF \  !-H
      29 OF 4OUT TFB 2+  @  TFB 4 + @  2DUP   L@
                 TFB 4 + !      2+ L@  TFB 2+  !           ENDOF \ 2@-H
      2A OF 0OUT TFB 2+  @  TFB 6 + @  TFB 8 + @  2+  L!
                 TFB 4 + @  TFB 6 + @  TFB 8 + @      L!   ENDOF \ 2!-H
      2B OF 0OUT TFB 2+ 2@  SWAP PARAM-BYE 2!   OK-HOST
                            HANDLE OFF ALLCLOSE CR ABORT   ENDOF \ BYE/ESC
      2C OF 0OUT TFB 2+  @  KBUF!                          ENDOF \ KBUF!
      2D OF 2OUT            WHICHKEY?      TFB 2+  !       ENDOF
    ENDCASE
    DSEGMENT TFB 2+ TFB 1+ C@ DUP 0= IF 2DROP DROP EXIT THEN LK! ;

: SERVE2 ( -- )
    TFB C@      \ Transfer-Code
    CASE
      80 OF TFB 80 + 2@ SWAP 2DUP LC@ 1+  LK!      ENDOF \ IN$
      81 OF TFB 80 + 2@ SWAP 2DUP
             1 LK@ 2DUP LC@ SWAP 1+ SWAP  LK@      ENDOF \ OUT$
      82 OF DSEGMENT DMA 80 LK!                    ENDOF \ DMA
      83 OF                                        ENDOF \ GET
      84 OF DSEGMENT 1000 + 0
            DSEGMENT TFB 2 LK@  TFB @ LK@          ENDOF \ (PUT)
      85 OF DSEGMENT TFB 6 LK@
            TFB @  TFB 2+ @  TFB 4 + @    LK!      ENDOF \ CMOVE-H>T
      86 OF DSEGMENT TFB 6 LK@
            TFB @  TFB 2+ @  TFB 4 + @    LK@      ENDOF \ CMOVE-T>H
      87 OF DSEGMENT TFB 10 +           1 LK@
            DSEGMENT TFB 11 + TFB 10 + C@ LK@
                     TFB 11 + TFB 10 + C@ $EXECUTE ENDOF \ $EXECUTE-HOST
    ENDCASE ;

: SERVE  ( -- )
    DSEGMENT TFB 1 LK@                        \ Transfer-Code nach TFB
    TFB C@ 80 < IF SERVE1 ELSE SERVE2 THEN ;  \ Direkt oder ber TFB ?

: LISTEN
    STATIN
    BEGIN
      DUP PC@  1 AND   IF SERVE THEN
\      WHICHKEY? DUP IF 1B = IF DROP EXIT THEN THEN DROP  \ raus ???
      WHICHKEY? 10B = IF DROP EXIT THEN
    AGAIN ;


CR .( ------------------- Transputer booten  ------------------ )

: TRAMTEST ( ad1. ad2. -- fl )       \ Testet Bereich ad1. bis ad2.: 0 = OK
   D1+                               \ einschlielich ad2.
   2OVER D- 2DUP                     \ ad1 ad2-ad1 ad2-ad1
   D0<=           IF CR BOLD ." Testbereich <= 0"    ABORT THEN
   2DUP 10000. D> IF CR BOLD ." Testbereich >= 64 k" ABORT THEN
   DROP 0                            \ Schleifengrenzen
   FALSE -ROT                        \ Vorgabe "ok"
   DO  DROP                          \ "ok" weg
       2DUP I 0 D+                   \ nchste Adresse
       2DUP C@-T >R                  \ Bytewert aufbewahren
       2DUP 055 -ROT C!-T            \ mit 55 belegen und wieder auslesen
       2DUP C@-T 055 <> IF R> DROP 2DROP TRUE LEAVE THEN
       2DUP 0AA -ROT C!-T            \ mit AA belegen und wieder auslesen
       2DUP C@-T 0AA <> IF R> DROP 2DROP TRUE LEAVE THEN
       2DUP  R> -ROT C!-T            \ Bytewert restaurieren
       2DROP                         \ nchste Adresse weg
       FALSE                         \ Vorgabe "ok"
   LOOP
   NIP NIP ;                         \ Anfangsadresse weg

: TEST-IT ( -- )
   WPTR WPTR TRAMTEST
   IF   CR BOLD
        ." Falsche Linkadresse ( " DATIN H. BS EMIT
        ." h ) oder keine oder nicht funktionstchtige TKarte ! "
        CR ATTOFF BYE                \ gendert 21.4.95
   THEN ;

: LOAD-TBOOT ( -- )
     TEST-IT
     MEMSTART DP-T 2!
     [TASSEMBLER]
     MINT STHF MINT STLF
     MINT MINT 9. STNL MINT MINT 0A. STNL
     0. LDC STTIMER
     TESTERR FPTESTERR CLRHALTERR
     WPTR LDC GAJW   \ Workspace-Pointer auf WPTR setzen
     [FROM]
     DP-T 2@ TBOOT-END 2! ;

: TPOKE-GCALL ( ad. -- )
     TBOOT-END 2@ DP-T 2!
     [TASSEMBLER] LDC GCALL [FROM] ;

: GO-FROM-TBOOT ( -- )
     STATOUT TSTATUS-TIMEOUT  2 DATOUT PC!   \ 2 Bytes ab MEMSTART einladen.
     STATOUT TSTATUS-TIMEOUT 24 DATOUT PC!   \ Das sind sie  ( = MINT, also
     STATOUT TSTATUS-TIMEOUT F2 DATOUT PC! ; \ erster Befehl des Bootstrap-
                                             \ Programms aus LOAD-TBOOT ).

: GO-AND-LISTEN ( -- )  GO-FROM-TBOOT LISTEN ;

HEIGHT 2 * ALLOC DROP

: LDNLP ( ofs -- ad )  \ ofs = Offset to WPTR. ad = absolute Adresse
     D2* D2* [TASSEMBLER] WPTR [FROM] D+ ;

: TPOKE-LOAD-SYSTEM ( len. -- )
     TBOOT-END 2@ DP-T 2!
     [TASSEMBLER] WPTR LDC       \ Systemanfang
     MINT 10. ADC                \ Eingabekanal
     LDC  IN                     \ Systemlnge
     START                       \ Transputer in Reset
     [FROM]
     DP-T 2@ TBOOT-END 2! ;      \ Dictionary-Pointer angleichen

: TPOKE-LOAD-TRAM ( ad. len. -- )
     TBOOT-END 2@ DP-T 2!
     2SWAP [TASSEMBLER] LDC      \ Anfangsadresse
     MINT 10. ADC                \ Eingabekanal
     LDC  IN                     \ Systemlnge
     START                       \ Transputer in Reset
     [FROM] ;                    \ Zurck zum bisherigen Vokabular ( SERVER )

: GOTO-SYSTEM ( -- )
     TEST-IT
     [TASSEMBLER]  'QUIT      [FROM] LDNLP @-T     \ cfa von QUIT
     [FORTH] 2DUP
     [TASSEMBLER]  IP         [FROM] LDNLP !-T     \ cfa(QUIT) nach IP
     [TASSEMBLER]   W         [FROM] LDNLP !-T     \ und        nach  W
     LOAD-TBOOT
     [TASSEMBLER]  NESTP      [FROM] LDNLP @-T     \ Label-Adresse von NEST
     TPOKE-GCALL                                   \ Einsprung ins T-System
     GO-AND-LISTEN ;

: GOTO-SYSTEM-BOOT ( -- )
     TEST-IT
     [TASSEMBLER]  'BOOT      [FROM] LDNLP @-T     \ cfa von BOOT
     [FORTH] 2DUP
     [TASSEMBLER]  IP         [FROM] LDNLP !-T     \ cfa(BOOT) nach IP
     [TASSEMBLER]   W         [FROM] LDNLP !-T     \ und       nach  W
     LOAD-TBOOT
     [TASSEMBLER]  NESTP      [FROM] LDNLP @-T     \ Label-Adresse von NEST
     TPOKE-GCALL                                   \ Einsprung ins T-System
     GO-AND-LISTEN ;

: START ( -- )
     CR ." Wenn keine Reaktion: Ist berhaupt ein Forth-System"
     CR ." oder ein sonstiges lauffhiges Programm im Transputer-RAM ?
     SERVER TRESET 1C0D KBUF! GOTO-SYSTEM ;

: GOTO-TRAM ( ad. -- )   \ lt den Transputer an die Stelle ad. im TRAM
     LOAD-TBOOT          \ springen und das Programm dort abarbeiten
     TPOKE-GCALL
     GO-FROM-TBOOT ;

: LOAD-TFILE ( <filename[.ext]> ad. -- len. ) \ Datei nach ad. ins TRAM laden
     OPEN >R 2DUP                             \ Datei ffnen. Handle nach R
     BEGIN
       DSEGMENT 1000 + 0                      \ Bis zu 32K in RAM-Puffer
       8000 R@ (GET) ?DOS-ERR                 \ ad. ad'. len'
       DUP 0 U>                               \ Bei 0> wre 8000 negativ !
       IF
         DUP >R -ROT 2DUP R> 0                \ ad. len' ad'. ad'. len'.
         LOAD-TBOOT
         2TUCK                                \ ad. len' ad'. len'. ad'. len'.
         TPOKE-LOAD-TRAM                      \ ad. len' ad'. len'.
         DROP                                 \ ad. len' ad'. len'
         DSEGMENT 1000 + 0 ROT                \ ad. len' ad'. seg+1000 0 len'
         GO-FROM-TBOOT LK!                    \ ad. len' ad'.
         ROT                                  \ ad. ad'. len'
         0 D+                                 \ ad. ad'. ( := ad'.+len'. )
         FALSE                                \ Weiter in Schleife
       ELSE
         DROP 2SWAP D-                        \ len.
         TRUE                                 \ Schleife beenden
       THEN
     UNTIL
     R> (CLOSE)  ;                            \ Datei wieder schlieen

: LOAD-SYSTEM ( <filename[.ext]> -- )         \ System nach WPTR einladen
     WPTR LOAD-TFILE                          \ Keine 64K-Beschrnkung !
     TRESET GOTO-SYSTEM ;                     \ Reset und Sprung ins TSystem

: LOAD-SYSTEM-BOOT ( <filename[.ext]> -- )    \ System nach WPTR einladen
     WPTR LOAD-TFILE                          \ Keine 64K-Beschrnkung !
     TRESET GOTO-SYSTEM-BOOT ;                \ Reset und Sprung ins TSystem
                                              \ TStack wird initiiert.


CR .( -- Blocktransfer von TRAM zu TRAM ber das Wirtssystem -- )


: TCMOVE  ( ad1. ad2. l. -- )       \ Verschiebt l. Bytes im TRAM byteweise
   [TASSEMBLER]                     \ von ad1. nach ad2. , angefangen bei ad1.
   WPTR BREG D2* D2* D+ !-T         \ BREG = Lnge
   WPTR CREG D2* D2* D+ !-T         \ CREG = Ziel
   WPTR AREG D2* D2* D+ !-T  [FROM] \ AREG = Quelle
   LOAD-TBOOT [TASSEMBLER]
   AREG LDL  LB  CREG LDL  SB
   CREG LDL  1. ADC  CREG STL
   AREG LDLP  0C. LDC  LEND  START
   GO-FROM-TBOOT  [FROM] ;

: TCMOVE> ( ad1. ad2. l. -- )       \ Verschiebt l. Bytes im TRAM byteweise
   [TASSEMBLER]                     \ von ad1. nach ad2. , angefangen bei ad2.
       WPTR BREG D2* D2* D+ !-T     \ BREG = Lnge
   D1- WPTR CREG D2* D2* D+ !-T     \ CREG = Ziel-1.
   D1- WPTR DREG D2* D2* D+ !-T     \ DREG = Quelle-1.
   [FROM]
   LOAD-TBOOT [TASSEMBLER]
   DREG LDL  BREG LDL  ADD  LB
   CREG LDL  BREG LDL  ADD  SB
   AREG LDLP  0D. LDC  LEND  START  \ AREG = Dummy ; Kontrollstruktur-Beginn
   GO-FROM-TBOOT  [FROM] ;

: (TMOVE) ( ad1. ad2. l. -- )       \ Verschiebt l. Bytes im TRAM byteweise
   2ROT 2ROT 4DUP DU<               \ von ad1. nach ad2. ; wird je nach Rich-
   IF   2ROT TCMOVE>                \ tung ber TCMOVE oder TCMOVE> ausgefhrt.
   ELSE 2ROT TCMOVE THEN ;

: <TMOVE> ( ad1. ad2. l. -- )       \ Schneller als (TMOVE) , jedoch
   [TASSEMBLER]                     \ berlappung nicht erlaubt !
   WPTR AREG D2* D2* D+ !-T         \ AREG = Lnge
   WPTR BREG D2* D2* D+ !-T         \ BREG = Ziel
   WPTR CREG D2* D2* D+ !-T  [FROM] \ CREG = Quelle
   LOAD-TBOOT [TASSEMBLER]
   CREG LDL  BREG LDL  AREG LDL  MOVE  START
   GO-FROM-TBOOT  [FROM] ;          \ Scheint auch bei berlappung zu gehen !!!

' <TMOVE> IS TMOVE                  \ Ab jetzt auch fr TASSEMBLER bereit


CR .( ------------------ Hilfe und Begrung ------------------ )
CR


: ?-T2 ( -- ) CR                                                 BOLD
   ." HELP " ATTOFF ." <wort>      erklrt <wort>"            CR BOLD
   ." SEE  " ATTOFF ." <wort>      decompiliert oder "
   ." disassembliert <wort>"                                  CR BOLD
   ." TRESET" ATTOFF ."            setzt T800 in Reset"       CR
   ." xxx " BOLD ." LINKBASE !" ATTOFF ."    setzt neue "
   ." Linkadapter-Basisadresse"                               CR
   ." xx aaa. " BOLD ." C!-T" ATTOFF ."      speichert Byte "
   ." xx nach aaa. im T800"                                   CR
   ." xxx. aaa. " BOLD ." !-T" ATTOFF ."     speichert Wort "
   ." xxx. ( 4 Bytes ) nach aaa. im T800"                     CR
   ." aaa. " BOLD ." C@-T" ATTOFF ."         holt Byte von "
   ." aaa. im T800"                                           CR
   ." aaa. " BOLD ." @-T" ATTOFF ."          holt Wort "
   ." ( 4 Bytes ) von aaa. im T800"                           CR
   ." aaa. xxx. " BOLD ." TDUMP" ATTOFF ."   holt xxx. Bytes "
   ." ab aaa. als Speicherauszug vom T800.  Belie-"           CR
   ."                  bige Taste unterbricht ;  beliebige "
   ." Taste  nimmt wieder auf,"                               CR
   ."                  [RET] bricht ab. Weiter um 100 Bytes "
   ." mit + [RET], zurck mit"                                CR
   ."                  - [RET] ."                             CR BOLD
   ." Weiter: " ATTOFF ." [Taste]"                            CR
   KEY 0= IF KEY DROP THEN ;

: (?-T) ( fl -- )  \ fl = FALSE: Hilfe ohne Weiterschaltung
   CR BOLD
   ." ******************************************************" CR
   ." *                                                    *" CR
   ." *  F-TP  -  Forth fr den Transputer T800            *" CR
   ." *                                                    *" CR
   ." *  Fred Behringer, Planegger Str. 24, 81241 Mnchen  *" CR
   ." *                                                    *" CR
   ." *  Version 1.00                           12.4.1992  *" CR
   ." *                                                    *" CR
   ." *  TRANSSYS.COM   -  Server vom und zum PC-Host zum  *" CR
   ." *  und vom T800 ber den Peek- und Poke-Mechanismus  *" CR
   ." *                                                    *" CR
   ." ******************************************************" CR CR
   ." Syntax: " ATTOFF ." TRANSSYS 150 LINKBASE ! [RET]  "
   ." oder z.B.  TRANSSYS HEX 154 LINKBASE ! "                CR
   ." oder z.B.  TRANSSYS DECIMAL 336 LINKBASE !  oder z.B.  "
   ." TRANSSYS [RET]   ( die "                                CR
   ." Linkadapter-Basisadresse stellt sich dann auf 150h ,  "
   ." wie bei TEK8 oder B004,"                                CR
   ." ein - soweit nicht durch PORTTSYS.BAT umgelenkt ) ."    CR BOLD
   ." Glossar " ATTOFF ." siehe SERVER.VOC . <wort> wird "
   ." erklrt durch Eingabe von " BOLD ." HELP " ATTOFF
   ." <wort>."                                                CR BOLD
   ." Neucompilieren: " ATTOFF ." MAKETSYS [RET]. Weiteres "
   ." siehe MAKETSYS.BAT. SERVER muss Such-"                   CR
   ." vokabular sein. Gegebenenfalls per SERVER [RET] aufrufen." CR
   0= IF EXIT THEN                                               BOLD
   ." Weitere Hilfe: " ATTOFF ." [SPACE]  "                      BOLD
   ." Exit: " ATTOFF ." [RET]"                                CR
   BEGIN KEY
     CASE
     0D OF EXIT      ENDOF
     20 OF ?-T2 EXIT ENDOF
     ENDCASE
   AGAIN ;

: ?-T ( -- ) TRUE (?-T) ;   \ Hilfe mit Weiterschalten

: ?ERROR$-TRANSSYS ( ad len fl -- ) \ wie ?ERROR$, nur andere Meldung
   DUP
   IF ['] (SOURCE) IS SOURCE  ['] (?ERROR) IS ?ERROR
      HANDLE @ 0<
      IF HANDLE OFF CR
      ." Parameter-Eingabestring '"
      STR$ TYPE ."  '" CR
      ." bei Aufruf von TRANSSYS.COM [RET] fehlerhaft : "
      THEN #STRINGS OFF
   THEN
   (?ERROR) ;

: $EXECUTE-TRANSSYS ( ad len -- )  \ wie $EXECUTE, nur andere Meldung
   #STRINGS 1+!  ['] SOURCE$          IS SOURCE
                 ['] ?ERROR$-TRANSSYS IS ?ERROR
   STR$ >R >R    ['] STR$ >BODY 2!
   >IN @ >R  >IN OFF  HANDLE @ >R
   #STRINGS @  NEGATE  HANDLE !  RUN
   #STRINGS 1-!  #STRINGS @ 0=
            IF   ['] (?ERROR) IS ?ERROR
                 ['] (SOURCE) IS SOURCE
            THEN
   R> HANDLE !  R> >IN !
           R> R> ['] STR$ >BODY 2! ;

: LINK-MELDUNG ( -- )
   CR ." Hex-Inhalt von LINKBASE WPTR ORG EOS WIDTH : "
   CR BOLD DATIN  H. WPTR HD. ORG 2@ HD. EOS 2@ HD. WIDTH @ H.
   CR ." Weiter: [Taste]" ATTOFF
   KEY 0= IF KEY DROP THEN ;

: HELLO-T ( -- )
   HANDLE OFF DSEGMENT SEGMENT> !
   DMA 1+ @ 2020 <>                   \ Wenn zunchst zweimal BL,
   IF ?-T CR LINK-MELDUNG THEN        \ dann keinerlei Meldungen.
   DMA C@                             \ Kommandozeilenparameter ?
   IF
     DMA COUNT 1+ 0 SWAP 0            \ ad 0 len+1 0
     DO
       DROP
       DUP I + C@ ASCII ^ =           \ Auf Begrenzer 5Eh prfen
       IF I LEAVE THEN I
     LOOP                             \ ad I
     $EXECUTE-TRANSSYS                \ bergebenen Kommandostring ausfhren
   THEN ;

' HELLO-T IS BOOT  \ Umdirigieren fr Parameterbergabe
                   \ bei Aufruf von TRANSSYS.COM



eof

*******************************************************************************
