.( TCORE.FTH )

WARNING OFF
DECIMAL
CR .( ********************************************************* )
CR .( *                                                       * )
CR .( *  F-TP 1.00    [ Turbo-FORTH-83 fr Transputer T800 ]  * )
CR .( *                                                       * )
CR .( *  Zweiter Teil des Quelltextes des 32-Bit-Transputer-  * )
CR .( *  FORTH-Systems.  Wird von  TKERNEL.FTH  per  INCLUDE  * )
CR .( *  hinzugeladen.                                        * )
CR .( *                                                       * )
CR .( *  Fred Behringer,  Planegger Str. 24,   81241 Mnchen  * )
CR .( *                       26.12.1992                      * )
CR .( *                                                       * )
CR .( ********************************************************* )

CR .( Kommentarzeilen und Datenstack-Kommentare )
: \   ( -- ) C/L >IN !   ; IMMEDIATE
\ : \   ( -- ) >IN @ NEGATE  C/L MOD  >IN +! ; IMMEDIATE
: (S  ( -- ) [COMPILE] ( ; IMMEDIATE


CR .( Die Konstrukte ONLY und ALSO )

CONTEXT DUP @ SWAP 4+ !                 \ Macht FORTH ebenfalls verfgbar
VOCABULARY ROOT  ROOT DEFINITIONS       \ Grundvokabular
: ALSO  ( -- ) CONTEXT DUP 4+ #VOCS 2- 4* CMOVE> ;
: ONLY  ( -- ) ['] ROOT >BODY CONTEXT #VOCS 1- 4* 2DUP ERASE + ! ROOT ;
: SEAL  ( -- ) ' >BODY CONTEXT #VOCS 4* ERASE CONTEXT ! ;
: PREVIOUS ( -- )
     CONTEXT DUP 4+ SWAP #VOCS 2- 4* CMOVE CONTEXT #VOCS 2- 4* + OFF ;
: FORTH       FORTH       ;
: DEFINITIONS DEFINITIONS ;
: ORDER ( -- )   \ Ausgabe von Suchordnung und Vokabular fr Definitionen
     CR ." Suchvokabular(e): "
     CONTEXT #VOCS 0  DO DUP @ ?DUP IF BODY> >NAME .ID THEN 4+ LOOP  DROP
     CR ." Definitionsvokabular: "
     CURRENT @ BODY> >NAME .ID ;
: VOCS  ( -- )                          \ Anzeige aller Vokabulare
     ." : " VOC-LINK @
     BEGIN DUP #THREADS 4* - BODY> >NAME .ID  @ DUP 0= UNTIL  DROP ;
ONLY FORTH ALSO DEFINITIONS

HEX
CR .( Ein paar neue I/O-Worte )
: BD.      ( d -- )  \ zeigt 64-Bit-Zahl binr an ( absolut )
   BASE @ 2 BASE ! -ROT UD. BASE ! ;
: HD.      ( d -- )  \ zeigt 64-Bit-Zahl hexadezimal an ( absolut )
   BASE @ HEX -ROT UD. BASE ! ;
: KEY(J/N) ( -- fl )                    \ Verwechslungssichere Ja-Nein-Abfrage
   1
   BEGIN
     DROP
     KEY DUP 0= IF KEY DROP THEN        \ Funktionstaste ?
     DUP DUP 4A = SWAP                  \ J ?
             6A = OR                    \ j ?
     IF DROP 4A EXIT THEN               \ -- J
     DUP DUP 4E = SWAP                  \ N ?
             6E = OR                    \ n ?
     IF DROP 4E EXIT THEN               \ -- N
   AGAIN ;

: .WEITER ( -- )
     (CURSOR) NIP 17 >
     IF  CR ." Weiter, bitte Taste drcken ..." KEY DROP 0 17 AT
         10 0 DO CR LOOP 0 9 AT 20 SPACES 0 8 AT
     THEN ;

\ -------
\ LIST war vorher in TKERNEL.FTH . Ich habe es jetzt ( 20.9.95 )
\ stark erweitert und hierher gelegt, da TKERNEL.FTH zu lang ge-
\ worden war.

HEX

: LIST ( <filename> -- ) \ Textdatei ansehen
     ECHO @ HANDLE @ ECHO ON
     OPEN HANDLE !  -1 0 (FRAME)
       BEGIN
         GETLINE
         FALSE KEY?
         IF
           DROP
           BOLD CR
           9 SPACES
           ." Weiter: Taste   Einzelschritt: +   Etwas zurck: -   Exit: RET"
           ATTOFF
           KEY DROP KEY
           0 (CURSOR) NIP 2DUP AT 48 SPACES 1- AT
           CASE
                  0D OF TRUE                                        ENDOF
             ASCII - OF BEGIN
                          DARK -1 0 (FRAME)
                          0 HANDLE @ 1 (SEEK) DROP 960 - DUP 0>=
                          IF
                            HANDLE @ 0 (SEEK)
                            ABORT" Lesefehler" DROP
                            ECHO @ ECHO OFF GETLINE ECHO !
                          ELSE
                            DROP 0 HANDLE @ 0 (SEEK)
                            ABORT" Lesefehler" DROP
                          THEN
                          18 0 DO GETLINE LOOP
                          BOLD CR
                          9 SPACES
                          ." Weiter: Taste   Etwas zurck: -"
                          ATTOFF
                          KEY
                          0 (CURSOR) NIP 2DUP AT 2B SPACES 1- AT
                          ASCII - = NOT
                        UNTIL
                        FALSE                                       ENDOF
             ASCII + OF BEGIN
                          GETLINE
                          BOLD CR
                          9 SPACES
                          ." Weiter: Taste   Einzelschritt: +"
                          ATTOFF
                          KEY
                          0 (CURSOR) NIP 2DUP AT 2B SPACES 1- AT
                          ASCII + =  NOT EOF? @  OR
                        UNTIL
                        FALSE                                       ENDOF
             FALSE SWAP
           ENDCASE
         THEN
         EOF? @ OR
       UNTIL
     0C 0D (FRAME) CR
     CLOSE HANDLE ! ECHO ! ;

\ ---------


CR .( Inhalt einer Diskette anzeigen, Directory )
\ Dieser Teil war vorher in TKERNEL.FTH .  Das Hostsystem mit dem
\ Server,  dem Cross-Assembler  und dem Metacompiler war ab einem
\ gewissen Zeitpunkt zu gro geworden und die Metacompilation hat
\ nicht mehr funktioniert.  Deshalb habe ich diesen Teil  hierher
\ genommen.  Es lassen sich  sicher  noch viele andere Teile  von
\ TKERNEL.FTH  hierher nach TCORE.FTH  verschieben. ( Hier werden
\ sie  nicht mehr metacompiliert,  sondern schon  vom Transputer-
\ FORTH-Kernsystem compiliert.

HEX
VARIABLE ATTDIR   \ 0-2 : Art der Verzeichnisdarstellung bei DIR
ATTDIR OFF
: .NAME0 ( -- )  \ Zeigt Namen und Erweiterung der gefundenen Datei an
     PAD DMA 1E + DUP DUP 0C    \ ad ad ad lenmax
     0 SCAN DROP OVER -         \ ad ad len-ohne-0
     ASCII . SCAN               \ ad ad-punkt len rest
     >R DUP >R OVER -           \ string-name
     9 OVER - -ROT
     PAD 15 + C@ 10 AND 10 =    \ Wenn Unterverzeichnis
     ATTDIR @ 2 > AND           \ und nicht erste Zeile
     ATTDIR @ 4 = OR            \ oder/und vorher Unterverzeichnis,
     ATTDIR @ 5 <> AND          \ insgesamt aber nicht letztes Spaltenfeld,
     IF CR THEN                 \ dann neue Zeile
     TYPE                       \ String bis zur Lnge 9 anzeigen
     R> 1+ R> ?DUP IF 1-        \ string-ext bis zum Punkt
     3 OVER - -ROT
     ASCII . EMIT               \ Gibt Punkt aus und
     DUP 3 SWAP - >R
     TYPE 1- R> + SPACES        \ zeigt Erweiterung an, falls vorhanden
     ELSE DROP 4 SPACES THEN    \ Sonst Platz lassen
     1- SPACES
     PAD 15 + C@ 10 AND         \ Wenn Unterverzeichnis
     IF ."  <DIR>" 4 ATTDIR !   \ Ab jetzt nicht mehr erste Zeile
     ELSE #OUT @ 2 41 BETWEEN   \ Nur wenn kein Unterverzeichnis und
     IF B3 EMIT THEN 3 ATTDIR ! \ nicht rechter Rand, dann Trennstrich
     THEN
     #OUT @ 41 > IF CR 5 ATTDIR ! THEN ;
: .NAME1 ( -- )  \ Zeigt Namen, Erweiterung und Lnge der gefundenen Datei an
     PAD DMA 1E + DUP DUP 0C    \ ad ad ad lenmax
     0 SCAN DROP OVER -         \ ad ad len-ohne-0
     ASCII . SCAN               \ ad ad-punkt len rest
     >R DUP >R OVER -           \ string-name
     9 OVER - -ROT TYPE         \ Bis zur Lnge 9 anzeigen
     R> 1+ R> ?DUP IF 1-        \ string-ext bis zum Punkt
     3 OVER - -ROT
     ASCII . EMIT               \ Gibt Punkt aus und
     TYPE SPACES                \ zeigt Erweiterung an, falls vorhanden
     ELSE DROP 4 SPACES THEN
     SPACES
     PAD 15 + C@ 10 AND
     IF ."  <DIR>" ELSE PAD 1A + W@ 6 .R THEN
     #OUT @ 42 < IF B3 EMIT THEN
     #OUT @ 4E > IF CR THEN ;
: .NAME2 ( -- )  \ Zeigt alle verfgbaren Informationen der gefundenen Datei an
     PAD DMA 1E + DUP DUP 0C    \ ad ad ad lenmax
     0 SCAN DROP OVER -         \ ad ad len-ohne-0
     ASCII . SCAN               \ ad ad-punkt len rest
     >R DUP >R OVER -           \ string-name
     9 OVER - -ROT TYPE SPACES  \ Bis zur Lnge 9 anzeigen
     R> 1+ R> ?DUP IF 1-        \ string-ext bis zum Punkt
     3 OVER - -ROT TYPE SPACES  \ Zeigt die Erweiterung an, falls vorhanden
     ELSE DROP 3 SPACES THEN
     PAD 15 + C@ 10 AND
     IF ."  <DIR>   " ELSE PAD 1A + W@ 9 .R THEN 2 SPACES
     PAD 18 + W@
     DUP    1F AND                  2 .R ASCII . EMIT
     DUP   1E0 AND 16/ 2/
           DUP 0A < IF ASCII 0 EMIT . ELSE . THEN BS EMIT ASCII . EMIT
          FE00 AND 16/ 16/ 2/  50 + 2 .R 2 SPACES
     PAD 16 + W@
     DUP  F800 AND 16/ 16/ 8/       2 .R ASCII . EMIT
           7E0 AND 16/ 2/ DUP 0A < IF ASCII 0 EMIT . ELSE . THEN SPACE
     PAD 15 + C@
     DUP  1 AND IF ASCII R EMIT ELSE ASCII . EMIT THEN
     DUP  2 AND IF ASCII H EMIT ELSE ASCII . EMIT THEN
     DUP  4 AND IF ASCII S EMIT ELSE ASCII . EMIT THEN
         20 AND IF ASCII A EMIT ELSE ASCII . EMIT THEN
     CR ;
DECIMAL
: (DIR) ( -- )
     128 SET-DMA ( der bliche DTA-Wert im Host-PSP )  BASE @ >R DRV >R DECIMAL
     HERE 2+ C@ ASCII : =
     IF HERE 1+ C@ UPC ASCII A - SELECT THEN
     ATTDIR @
     22 (SEARCH0)
     IF CR BEGIN DUP
             CASE
               0 OF .NAME0 ENDOF
               1 OF .NAME1 ENDOF
               2 OF .NAME2 ENDOF
             ENDCASE
             (SEARCH) 0= STOP? OR
           UNTIL
     THEN
     ATTDIR !
     #OUT @ IF CR THEN
     DRV ASCII A + EMIT ." : "  FREE .
     ." Bytes frei von " . ." Bytes insgesamt "
     R> SELECT R> BASE ! ;
\ Die Dateienschablone muss als ASCII0-String in HERE-HOST liegen.
: DIR ( -- )
     BL WORD COUNT DUP  0= IF 2DROP " *.*" THEN  DROP 1-
     DSEGMENT FLIP HERE-HOST OR OUTWDBUF OUT$ 0 H$B! (DIR) ;

HEX
CR .( Weitere DOS-Befehle )

\ Am 7.3.96 von TKERNEL.FTH nach hier ( TCORE.FTH ) verlagert.

: (REN) ( ad-ascii0-1 ad-ascii0-2 -- fl ) 20 INBYTE ;
      \ Der alte Dateiname muss in HERE-HOST,
      \ der neue in PAD-Host als ASCII0-String liegen.

: REN ( <filename1 filename2> -- )
     BL WORD DSEGMENT FLIP HERE-HOST OR OUTWDBUF OUT$ 0 H$B!
     BL WORD DSEGMENT FLIP  PAD-HOST OR OUTWDBUF OUT$ 0 H$B! (REN) ?DOS-ERR ;
     \ Mit diesem REN kann man auch Dateien von einem Verzeichnis oder
     \ Unterverzeichnis in ein anderes verschieben ( natrlich nicht
     \ kopieren ). REN DATEI.EXT FORTH\DATEI.EXT verschiebt die Datei
     \ DATEI.EXT in das Unterverzeichnis FORTH .

: MKDIR ( <pathname> -- )   \ Verzeichnis einrichten
     PATHWAY 39 BDOS ?DOS-ERR ;
: RMDIR ( <pathname> -- )   \ Verzeichnis lschen
     PATHWAY 3A BDOS ?DOS-ERR ;
: CHDIR ( <pathname> -- )   \ Verzeichnis wechseln
     PATHWAY 3B BDOS ?DOS-ERR ;
: DEL   ( <pathname> -- )  \ Datei lschen
     PATHWAY 41 BDOS ?DOS-ERR ;

: A: 0 SELECT ;  : D: 3 SELECT ;  : G:  6 SELECT ;  : J:  9 SELECT ;
: B: 1 SELECT ;  : E: 4 SELECT ;  : H:  7 SELECT ;  : K: 0A SELECT ;
: C: 2 SELECT ;  : F: 5 SELECT ;  : I:  8 SELECT ;


DECIMAL
CR .( Stringbearbeitung )

\ Am 22.3.96 von TKERNEL.FTH nach hier ( TCORE.FTH ) verlagert.

: LEN$    ( ad len -- ad len lenmax)  OVER 2- C@ ;
: INPUT$ ( $var ---)  OVER >R LEN$ NIP DUP >R EXPECT SPAN @ R> MIN R> 1- C! ;
: RIGHT$  ( ad1 len1 l -- ad2 len2 )  0 MAX OVER MIN >R + R@ - R> ;
: LEFT$   ( ad1 len1 l -- ad2 len2 )  0 MAX MIN ;
: MID$    ( ad1 len1 pos l -- ad2 len2 )  >R OVER SWAP - RIGHT$ R> LEFT$ ;
: ITEM  ( ad len n -- adn lenn )
     1 MAX >R TUCK R> 0
     DO   ROT  DROP BL SKIP OVER SWAP  BL SCAN  LOOP
     DROP OVER - ;
     \ Angenommen, der bei ad len in ITEM beginnende String enthlt
     \ mehrere "Worte", die durch  BL  getrennt sind.  Dann liefert
     \ ad len n ITEM  mit  adn lenn  die Adresse und Lnge des nten
     \ "Wortes" im String. Dabei wirken 0, -1 usw wie 1 und grere
     \ n als mglich wie das grtmgliche n.
: INSERT   ( ad1 len1 ad2 len2 -- )
     ROT OVER MIN >R R@ - OVER DUP R@ + ROT CMOVE> R> CMOVE ;
: INSERT$  ( str strvar pos -- )
     0 MAX OVER MIN  -ROT LEN$ SWAP 4 PICK + OVER MIN
     2 PICK 1- C!  2 PICK - >R + R> INSERT  ;
: APPEND$  ( ad1 len1 ad2 len2 -- )  DUP INSERT$ ;
: ERASE$   ( ad len pos l -- )
     >R 0 MAX OVER MIN  2DUP - R> MIN 0 MAX  2 PICK OVER - 4 PICK 1- C!
     ROT OVER - 2 PICK -  >R -ROT + TUCK + SWAP  R> CMOVE ;
VARIABLE FOUND
: SCAN-1ST ( a n c --- a n )  CAPS @ IF DROP ELSE SCAN THEN ;
: SEARCH   ( strad strlen bad blen -- n f )
     FOUND OFF  SWAP >R  2DUP U>=
     IF OVER - 1+ 2 PICK C@ R@ -ROT >R
        BEGIN R@ SCAN-1ST DUP
          IF >R 3DUP SWAP COMPARE 0=  IF FOUND ON R> DROP 0 >R THEN  R> THEN
          DUP
        WHILE 1 /STRING
        REPEAT R> 2DROP -ROT
     THEN 2DROP R> - FOUND @ ;
: SEARCH$ ( str strvar -- pos len )
     2 PICK >R SEARCH IF R> ELSE R> 2DROP 0 0 THEN ;
: DELETE$ ( str strvar -- ) 2DUP >R >R SEARCH$ R> R> 2SWAP ERASE$ ;


HEX
CR .( Hinzuladen des Transputer-Assemblers )

\ Die folgenden  "lokalen Variablen"  ( Wortoffsets zu WPTR )  wurden schon
\ im TKERNEL definiert. Sie belegen zur Zeit ( 1.7.1993 ) die Pltze 1-14h.
\ Das heit, Aufruf von IP ( in ASSEMBLER ) liefert die Konstante 1, Aufruf
\ von W die Konstante 2 usw. Beispielsweise erhlt man die absolute Adresse
\ von W in einer Doppelpunktdefinition ber die Wortfolge [ ASSEMBLER ] W 4
\ * WPTR + [ FORTH ] , in einer CODE-Definition ber W LDLP .

\ IP      Instruction-Pointer
\ W       W-Register
\ RP      Returnstack-Pointer
\ SP      Datenstack-Pointer
\ AREG    Pseudoregister zur Zwischenablage ( von Areg der CPU )
\ BREG    Pseudoregister zur Zwischenablage ( von Breg der CPU )
\ CREG    Pseudoregister zur Zwischenablage ( von Creg der CPU )
\ DREG    Pseudoregister fr Extrazwecke
\ EREG    Pseudoregister fr Extrazwecke    ( auch berlauf  fr Floating )
\ FREG    Pseudoregister fr Extrazwecke    ( auch berlauf  fr Arithmetik )
\ GREG    Pseudoregister fr Extrazwecke    ( auch Errorflag fr Floating )
\ HREG    Pseudoregister fr Extrazwecke    ( auch Errorflag fr Arithmetik )

\ BPUSHP  bewahrt Adresse BPUSH auf
\ CPUSHP  bewahrt Adresse CPUSH auf
\ NEXTP   Label-Adresse von >NEXT
\ COLDP   Adresse des Einsprungpunktes zu Coldstart
\ WARMP   Adresse des Einsprungpunktes zu Warmstart
\ DODOESP Adresse des Einsprungpunktes zu DODOES
\ 'QUIT   cfa von QUIT. Wird fr GOTO-SYSTEM bentigt.
\ 'BOOT   cfa con BOOT. Wird von GOTO-SYSTEM-BOOT bentigt.
\ NESTP   Label-Adresse von NEST. Wird fr GOTO-SYSTEM bentigt.

\ Hinzu kommen noch folgende Adrekonstanten:

\ WPTR    Wert des Workspace-Pointers nach dem Meta-Compilieren
\ TPAD    Gespiegelter Anfangs-RAM-Bereich ( 4k )

\ Um das Error-Flag bei Arithmetik-Code-Definitionen zur gelegentlichen
\ Abfrage auf hherer Ebene, die nach Beenden einerTestphase wieder ab-
\ gestellt wird, retten zu knnen,  fhre ich noch vier andere Bezeich-
\ nungen fr  FREG bis HREG  ein:  FOFLAG,  AOFLAG,  FEFLAG  und AEFLAG
\ ( Floating-Point-Overflow-Flag,  Arithmetic-Overflow-Flag,  Floating-
\ Point-Error-Flag und Arithmetic-Error-Flag ). Siehe gleich unten.

\ Der Workspacepointer ist zur Zeit ( 1.6.1993 ) auf WPTR = 80000100
\ eingestellt. Der Systemanfang ( ORIGIN ) liegt zur Zeit ( 1.6.93 )
\ bei 80000200. Es knnen also zur Zeit ( 1.6.1993 ) die Wortoffsets
\ 13h-39h als  ( fr das FORTH-System natrlich global einsetzbare )
\ "lokale Variablen"  ( z.B. fr die Zhlparameter bei ASSEMBLER-DO-
\ schleifen ) oder fr andere Ablagezwecke verwendet werden.

\ Der Assembler enthlt einige Relikte, die aus der Entwicklungszeit
\ stammen und im vorliegenden System nicht verwendet werden. Ich bin
\ nicht ganz sicher, ob ich sie nicht in einer spteren Version ver-
\ wenden werde. Ich lasse sie einfach mal stehen.


ONLY FORTH ALSO DEFINITIONS
: LABEL CREATE CONTEXT @ AVOC ! ASSEMBLER ;
: DOES? ( IP -- IP' fl )
     DUP 4 ( DOES-SIZE:=4 ) + SWAP @ 0F0F00 OR 0F67F2F40 = ;

ASSEMBLER ALSO DEFINITIONS

: FOFLAG EREG ;  : AOFLAG FREG ;  : FEFLAG GREG ;  : AEFLAG HREG ;

: C; ( -- )   END-CODE ;
DEFER C,      FORTH ' C,    ASSEMBLER IS C,
DEFER ,       FORTH ' ,     ASSEMBLER IS ,
DEFER HERE    FORTH ' HERE  ASSEMBLER IS HERE
DEFER ?>MARK  DEFER ?>RESOLVE  DEFER (?>RESOLVE)
DEFER ?<MARK  DEFER ?<RESOLVE


CR .( Verarbeitung der Operanden )

VARIABLE NFIX-FLAG
VARIABLE PFIX-FLAG

: MAKE-CODE ( n o -- )            \ n = operand, o = Opcode
   16* SWAP DUP                   \ o0 n n
   BITREV 4 BITREVN DUP 0F =      \ o0 n 1.Nibble flag
   IF   NFIX-FLAG ON
        PFIX-FLAG ON              \ o0 n 1.Nibble
   ELSE NFIX-FLAG OFF
   THEN
   DUP 1 0F WITHIN                \ o0 n 1.Nibble flag
   IF DUP 20 OR C,                \ o0 n 1.Nibble
      PFIX-FLAG ON
   THEN
   0=                             \ o0 n flag
   IF PFIX-FLAG OFF THEN          \ o0 n
   6 0
   DO  16* DUP                    \ o0 n n
     BITREV 4 BITREVN             \ o0 n x.Nibble
     NFIX-FLAG @ 0=
     PFIX-FLAG @ AND              \ o0 n x.Nibble flag
     IF DUP 20 OR C, THEN         \ o0 n x.Nibble
     DUP 0F <> I 5 = OR           \ o0 n x.Nibble flag
     NFIX-FLAG @ AND              \ ( <>F oder 6.Schleifenstufe ) bei NFIX ON ?
     IF NFIX-FLAG OFF             \ o0 n x.Nibble
        DUP NOT 0F AND            \ o0 n x.Nibble not(x.Nibble)
        60 OR C,                  \ o0 n x.Nibble
     THEN
     DUP 0<> PFIX-FLAG @ 0= AND   \ o0 n x.Nibble flag
     IF PFIX-FLAG ON DUP 20 OR C,
     THEN                         \ o0 n x.Nibble
     DROP                         \ o0 n
   LOOP
   16* BITREV 4 BITREVN OR C, ;

DEFER TCODE!
' MAKE-CODE IS TCODE!

CR .( Assemblieren, aufgeschlsselt nach Wortklassen )
CR .( 1MI )

: 1MI CREATE C, DOES> C@ TCODE! ;

00 1MI J     01 1MI LDLP 02 1MI PFIX  03 1MI LDNL  04 1MI LDC
05 1MI LDNLP 06 1MI NFIX 07 1MI LDL   08 1MI ADC   09 1MI CALL
0A 1MI CJ    0B 1MI AJW  0C 1MI EQC   0D 1MI STL   0E 1MI STNL  0F 1MI OPR

CR .( 2MI )

: 2MI CREATE CC, DOES> CC@ 0F TCODE! ;

00 2MI REV     01 2MI LB     02 2MI BSUB     03 2MI ENDP    04 2MI DIFF
05 2MI ADD     06 2MI GCALL  07 2MI IN       08 2MI PROD    09 2MI GT
0A 2MI WSUB    0B 2MI OUT    0C 2MI SUB      0D 2MI STARTP  0E 2MI OUTBYTE
0F 2MI OUTWORD 10 2MI SETERR 12 2MI RESETCH  13 2MI CSUB0   15 2MI STOPP
16 2MI LADD    17 2MI STLB   18 2MI STHF     19 2MI NORM    1A 2MI LDIV
1B 2MI LDPI    1C 2MI STLF   1D 2MI XDBLE    1E 2MI LDPRI   1F 2MI REM
20 2MI RET     21 2MI LEND   22 2MI LDTIMER  29 2MI TESTERR 2A 2MI TESTPRANAL
2B 2MI TIN     2C 2MI DIV    2E 2MI DIST     2F 2MI DISC    30 2MI DISS
31 2MI LMUL    32 2MI NOT    33 2MI XOR      34 2MI BCNT    35 2MI LSHR
36 2MI LSHL    37 2MI LSUM   38 2MI LSUB     39 2MI RUNP    3A 2MI XWORD
3B 2MI SB      3C 2MI GAJW   3D 2MI SAVEL    3E 2MI SAVEH   3F 2MI WCNT
40 2MI SHR     41 2MI SHL    42 2MI MINT     43 2MI ALT     44 2MI ALTWT
45 2MI ALTEND  46 2MI AND    47 2MI ENBT     48 2MI ENBC    49 2MI ENBS
4A 2MI MOVE    4B 2MI OR     4C 2MI CSNGL    4D 2MI CCNT1   4E 2MI TALT
4F 2MI LDIFF   50 2MI STHB   51 2MI TALTWT   52 2MI SUM     53 2MI MUL
54 2MI STTIMER    55 2MI STOPERR       56 2MI CWORD       57 2MI CLRHALTERR
58 2MI SETHALTERR 59 2MI TESTHALTERR   5A 2MI DUP         5B 2MI MOVE2DINIT
5C 2MI MOVE2DALL  5D 2MI MOVE2DNONZERO 5E 2MI MOVE2DZERO  63 2MI UNPACKSN
6C 2MI POSTNORMSN 6D 2MI ROUNDSN       71 2MI LDINF       72 2MI FMUL
73 2MI CFLERR     74 2MI CRCWORD       75 2MI CRCBYTE     76 2MI BITCNT
77 2MI BITREVWORD 78 2MI BITREVNBITS   81 2MI WSUBDB      82 2MI FPLDNLDBI
83 2MI FPCHKERR   84 2MI FPSTNLDB      86 2MI FPLDNLSNI   87 2MI FPADD
88 2MI FPSTNLSN   89 2MI FPSUB         8A 2MI FPLDNLDB    8B 2MI FPMUL
8C 2MI FPDIV      8E 2MI FPLDNLSN      8F 2MI FPREMFIRST  90 2MI FPREMSTEP
91 2MI FPNAN      92 2MI FPORDERED     93 2MI FPNOTFINITE 94 2MI FPGT
95 2MI FPEQ       96 2MI FPI32TOR32    98 2MI FPI32TOR64  9A 2MI FPB32TOR64
9C 2MI FPTESTERR  9D 2MI FPRTOI32      9E 2MI FPSTNLI32   9F 2MI FPLDZEROSN
0A0 2MI FPLDZERODB   0A1 2MI FPINT        0A3 2MI FPDUP
0A4 2MI FPREV        0A6 2MI FPLDNLADDDB  0A8 2MI FPLDNLMULDB
0AA 2MI FPLDNLADDSN  0AB 2MI FPENTRY      0AC 2MI FPLDNLMULSN

\ Die folgenden 8 Befehle sind in den blichen Unterlagen nicht dokumentiert.
\ Vergleiche Reinecke/Schreiner: Transputer-Leitfaden, S.106.

23 2MI TESTLDS    24 2MI TESTLDE       25 2MI TESTLDD        26 2MI TESTSTS
27 2MI TESTSTE    28 2MI TESTSTD       2D 2MI TESTHARDCHAN  1FF 2MI START

CR .( 3MI )

: 3MI CREATE CC, DOES> CC@ LDC FPENTRY ;

01 3MI FPUSQRTFIRST  02 3MI FPUSQRTSTEP  03 3MI FPUSQRTLAST
04 3MI FPURP         05 3MI FPURM        06 3MI FPURZ
07 3MI FPUR32TOR64   08 3MI FPUR64TOR32  09 3MI FPUEXPDEC32
0A 3MI FPUEXPINC32   0B 3MI FPUABS       0D 3MI FPUNOROUND
0E 3MI FPUCHKI32     0F 3MI FPUCHKI64    11 3MI FPUDIVBY2
12 3MI FPUMULBY2     22 3MI FPURN        23 3MI FPUSETERR
9C 3MI FPUCLRERR

\ GT, EQC usw. liefern fr TRUE  in Areg den Wert 1.  Das soll beibe-
\ halten werden.  Im Vokabular TASSEMBLER  gilt also  FALSE := 0  und
\ TRUE := 1 .  Das ist sicher keine wesentliche Einschrnkung, da man
\ ja bei Vergleichen sowieso meist in der Kategorie  "gleich oder un-
\ gleich 0" denkt.  Trotzdem: Aufpassen !!!  -  0 LDC NOT liefert den
\ Wert -1 , nicht 1 ! Um bei Logikwerten 0 und 1  das logische Gegen-
\ teil  eines Vergleichsergebnisses  in Areg  zu erzeugen, msste man
\ nach  der bitweisen Invertierung  noch 2 hinzuaddieren.  Das Krzel
\ INV ist ( im Transputer-Maschinencode und im Vokabular TASSEMBLER )
\ noch nicht vergeben.  Um alle Klarheiten restlos zu beseitigen, sei
\ also auch fr die logische Inversion noch ein Makro eingefhrt:

: INV 0 EQC     ;                   \ Das ist einfacher als NOT 2 ADC
: NEG NOT 1 ADC ;        \ negiert Inhalt von A mit berlaufbeachtung

\ Vorsicht beim Assemblieren !  Die Bezeichnungen fr die Logik-Worte
\ AND, OR, XOR, NOT usw. aus dem Vokabular FORTH werden in TASSEMBLER
\ von  Bezeichnungen  fr  Maschinenbefehle  berlagert.  Die Sequenz
\ 5 7 + LDC  erscheint sinnvoll, die Sequenz  17 NOT LDC weniger.
\ Letztere  ldt nicht etwa  die bitweise Negation von 17  ins Areg !
\ hnliches gilt fr DUP .


CR .( Steuerstrukturen { IF THEN usw.} )

\ Beispiel: ASSEMBLER 0> IF 123456 LDC THEN
\           Als Compilat ( bei HEX-Eingabe ) erscheint:
\           40 F9 A6 21 22 23 24 25 46
\ Bei Sprngen bis zu 15 Byte: 1IF ;  bis zu 255 Byte: 2IF usw.  Wird
\ nIF zu gro gewhlt,  so bleibt  ( bleiben )  ( ohne Schaden )  ein
\ ( mehrere )  PFIX 0  vorgelagert.  Dadurch wurde ein zweiter Assem-
\ blier-Durchgang vermieden.  Wird nIF zu klein gewhlt, so erscheint
\ eine Fehlermeldung. hnliche Verhltnisse gelten fr nELSE .
\ In einer mIF..nELSE..THEN-Konstruktion  knnen  m und n  unabhngig
\ voneinander gewhlt werden.  Wichtig ist nur,  dass die Sprnge  in
\ den einzelnen Zweigen  nicht zu gro gewhlt werden.  Dagegen wehrt
\ sich  das System aber  mit einer Fehlermeldung  und dem Abbruch des
\ Compiliervorgangs.
\ Bei BEGIN .. UNTIL steht schon im ersten Durchlauf jedwede Informa-
\ tion zur Verfgung, sodass sich eine byteweise Aufspaltung erbrigt.
\ Man knnte bei komplizierteren Vorhaben und unabsehbaren Sprungln-
\ gen  bei nIF und nELSE  vielleicht so vorgehen,  dass man  zunchst
\ vorsichtshalber nur mit FARIF und FARELSE arbeitet  ( in den aller-
\ meisten Fllen wird man schon mit IF und ELSE  auskommen )  und den
\ Quelltext dann  nach Durchsicht des Compilats  von Hand korrigiert.
\ Reizvoll wre darberhinaus  die Automatisierung eines solchen Vor-
\ gehens.
\ Alle Sprungstrukturen  sind  gegen Logikfehler gesichert  ( Meldung
\ "Struktur unvollstndig" ).

\ Achtung:  Alle  Sprungkonstruktionen,  vorwrts und rckwrts,  mit
\ Ausnahme der DO-LOOPs, werden mit CJ (Sprung bei CPU-Aregister = 0)
\ gebildet.  CJ  hat  die unangenehme Eigenschaft,  bei  ausgefhrtem
\ Sprung den Entscheidungswert Areg = 0 beizubehalten  ( Areg' = Areg
\ usw.).  Bei  nicht ausgefhrtem Sprung  wird dagegen  der Entschei-
\ dungswert Areg = 1 , wie eigentlich auch zu erwarten, vom CPU-Stack
\ entfernt ( Areg' = Breg usw.).
\
\ Betrachten wir das folgende Beispiel:
\ CODE XXX SP LDL 0 LDNL 5 LDC =
\      IF 7 LDC ELSE 8 LDC THEN  SP LDL 0 STNL NEXT END-CODE
\ Als Doppelpunktdefinition geschrieben, wrde dieses Beispiel wie
\ folgt aussehen:
\ : XXX 5 = IF 7 ELSE 8 THEN ;
\
\ Ich habe  THEN und ELSE  ( und logischerweise auch 1ELSE usw. )  so
\ eingerichtet, dass die obige CODE-Definition das erwartete Ergebnis
\ ( siehe Doppelpunktdefinition ) liefert.  Das geht bei THEN auf Ko-
\ sten von zwei  und bei ELSE auf Kosten von einem zustzlichen Byte.
\ Um aber ( z.B fr eine grere Zahl von hintereinander auszufhren-
\ den Sprngen,  bei denen es  nicht  darauf ankommt,  CPU-Stackwerte
\ ber den jeweiligen Sprung hinberzuretten ) auch eine krzere Ver-
\ sion, ohne die zwei zustzlichen Bytes, zur Verfgung zu haben, ha-
\ be ich die "einfacheren" Sprungstrukturelemente (THEN) usw. ( siehe
\ unten ) eingefhrt. Als den Normalfall betrachte ich aber THEN usw.
\ Diese Konstruktion  kann zu keiner Fehlberlegung der eben angedeu-
\ teten Art fhren.  Allerdings beachte man, dass der Stackinhalt des
\ CPU-Cregisters verlorengeht.
\
\ Mit dem "einfacheren" (THEN) und (ELSE) msste die obige CODE-Defi-
\ nition wie folgt geschrieben werden,  um die gewnschten Ergebnisse
\ ( siehe Doppelpunktdefinition ) zu liefern:
\ CODE XXX SP LDL 0 LDNL 5 LDC =
\      IF      7 LDC SP LDL 0 STNL
\      (ELSE)  8 LDC SP LDL 0 STNL
\      (THEN)  NEXT END-CODE
\ Man sieht,  dass die Einsparungen dort, wo es zum Tragen kommt,  in
\ gewissem Mae  wieder aufgehoben  werden.  Bei komplizierteren Bei-
\ spielen sogar betrchtlich.  Was bleibt, ist vielleicht ein kleiner
\ Zeitvorteil.
\
\ Man knnte  die CODE-Definition  mit dem "einfacheren"  (THEN)  und
\ (ELSE)  auch wie folgt schreiben:
\ CODE XXX SP LDL 0 LDNL 5 LDC =
\      IF 7 LDC  (ELSE) DIFF  8 LDC  0 LDC (THEN) DIFF
\      SP LDL 0 STNL NEXT END-CODE
\ Damit ist die Definition der abgesicherten Sprungelemente THEN  und
\ ELSE  vorgegeben.


: A?>MARK ( n -- fl maxlen ad )    \ ad = HERE + n
     TRUE 1 ROT 0                  \ TRUE vorlufig noch = -1 ( von FORTH )
     DO 20 C, 16* LOOP HERE ;

2VARIABLE BUFJUMP                  \ Zum Aufbau von xxx CJ

: (A?>RESOLVE) ( fl maxlen ad -- ) \ ad = Anfang der IF-Struktur, ohne xxx CJ
     TUCK                          \ fl ad maxlen ad
     HERE SWAP - TUCK <=           \ fl ad hr-ad maxlen hr-ad
     IF   CR ." Sprung zu weit. Nchsthheres Strukturelement "
             ." (nIF, nELSE, nWHILE) versuchen !" ABORT
     ELSE HERE                     \ fl ad hr-ad hr
          -ROT TUCK                \ fl hr hr-ad ad hr-ad
          BUFJUMP DP ! CJ HERE     \ fl hr hr-ad ad bj+len
          BUFJUMP -                \ fl hr hr-ad ad len ( Lnge von xxx CJ )
          -                        \ fl hr hr-ad ad-len
          DP ! CJ                  \ fl hr
          DP !                     \ fl ( DP jetzt wieder auf
     THEN                          \      Ende der IF-Konstruktion )
     ?CONDITION ;                  \ -- Stack ausgeglichen ?

: A?>RESOLVE 0 LDC (A?>RESOLVE) DIFF ;

: A?<MARK ( -- fl ad ) TRUE HERE ; \ immer noch TRUE von FORTH ( = -1 )
                                   \ ad = Adresse z.B. bei BEGIN

: A?<RESOLVE  ( fl ad -- )
     [ FORTH ] DUP [ ASSEMBLER ]   \ fl ad ad
     HERE TUCK -                   \ fl ad hr ad-hr
     CJ                            \ fl ad hr                    1.Approx.
     OVER HERE - OVER              \ fl ad hr ad-(hr+len1) hr
     DP !                          \ fl ad hr ad-(hr+len1)
     CJ                            \ fl ad hr
     SWAP HERE -                   \ fl hr ad-(hr+len2)          2.Approx.
     SWAP                          \ fl ad-(hr+len2) hr
     DP !                          \ fl ad-(hr+len2)
     CJ                            \ fl ( DP jetzt auf hr+len2 ) Ausgleich
     ?CONDITION ;                  \ -- Stack ausgeglichen ?

: A?<RESOLVE-DO ( fl ad ofs -- )   \ ofs = Wortoffset zu WPTR
     LDLP                          \ fl ad ( von DO stammend )
     HERE 2DUP SWAP -              \ fl ad hr1 hr1-ad
     LDC LEND                      \ fl ad hr1             1. Approximation
     2DUP HERE -ROT                \ fl ad hr1 hr2 ad hr1
     DP ! -                        \ fl ad hr1 hr2-ad
     LDC LEND                      \ fl ad hr1             2. Approximation
     HERE -ROT                     \ fl hr3 ad hr1
     DP ! -                        \ fl hr3-ad
     LDC LEND                      \ fl                    Letzter Ausgleich
     ?CONDITION ;                  \ -- Stack ausgeglichen ?

DEFER ?<RESOLVE-DO
' A?<RESOLVE-DO IS ?<RESOLVE-DO

\ Wegen ofs siehe die Bemerkungen weiter oben ber den freien Platz fr
\ "lokale Variablen" im Sinne des Transputers.


' A?>MARK    ASSEMBLER IS ?>MARK
' A?>RESOLVE ASSEMBLER IS ?>RESOLVE  ' (A?>RESOLVE) ASSEMBLER IS (?>RESOLVE)
' A?<MARK    ASSEMBLER IS ?<MARK
' A?<RESOLVE ASSEMBLER IS ?<RESOLVE


: 1IF 1 ?>MARK ;  : 2IF 2 ?>MARK ;  : 3IF 3 ?>MARK ;
: 4IF 4 ?>MARK ;  : 5IF 5 ?>MARK ;  : 6IF 6 ?>MARK ;


CR .( Ab jetzt nicht mehr IF von FORTH )

:    IF 3IF          ;  \ Normale   IF-Verwendung: Sprnge bis 4 Kilobyte
: FARIF 5IF          ;  \ Zweitnormale Verwendung: Sprnge bis 1 Megabyte

: (THEN) (?>RESOLVE) ;
:  THEN   ?>RESOLVE  ;  \ Ab jetzt nicht mehr THEN von FORTH


: (TELSE) ( fl1 maxlen1 ad1 n -- fl2 maxlen2 ad2 )
     0 LDC ?>MARK 3 0 DO 5 ROLL LOOP (?>RESOLVE)      ;
:  TELSE  ( fl1 maxlen1 ad1 n -- fl2 maxlen2 ad2 )
     0 LDC ?>MARK 3 0 DO 5 ROLL LOOP (?>RESOLVE) DIFF ;


: (1ELSE) 1 (TELSE) ;  : (2ELSE) 2 (TELSE) ;  : (3ELSE) 3 (TELSE) ;
: (4ELSE) 4 (TELSE) ;  : (5ELSE) 5 (TELSE) ;  : (6ELSE) 6 (TELSE) ;
:  1ELSE  1  TELSE  ;  :  2ELSE  2  TELSE  ;  :  3ELSE  3  TELSE  ;
:  4ELSE  4  TELSE  ;  :  5ELSE  5  TELSE  ;  :  6ELSE  6  TELSE  ;


:    (ELSE) (3ELSE) ;
: (FARELSE) (5ELSE) ;
:     ELSE   3ELSE  ;  \ Wie bei IF: Sprnge bis 4 Kilobyte
:  FARELSE   5ELSE  ;  \             Sprnge bis 1 Megabyte
                       \ Ab jetzt nicht mehr ELSE von FORTH

:    WHILE    IF ;  : 1WHILE 1IF ;  : 2WHILE 2IF ;  : 3WHILE 3IF ;
: FARWHILE FARIF ;  : 4WHILE 4IF ;  : 5WHILE 5IF ;  : 6WHILE 6IF ;

: BEGIN  0 LDC ?<MARK DIFF            ;
: UNTIL  ?<RESOLVE                    ;
: AGAIN  0 LDC UNTIL                  ;
\ : REPEAT 3 0 DO 7 ROLL LOOP AGAIN THEN ; RAUSWERFEN !!!!!
: (REPEAT) 4 ROLL 4 ROLL AGAIN (THEN) ;
:  REPEAT  4 ROLL 4 ROLL AGAIN  THEN  ;


CR .( Ab jetzt DO und LOOP anders als im Vokabular FORTH )

\ : DO   ( d -- fl ad d )   >R >R ?<MARK R> R>    ;
\ : DO*  ( anz strt d -- fl ad. d )
\   2SWAP LDC 2DUP STL 2DUP 1. D+ 2ROT LDC STL DO ;
\ : LOOP ( fl ad d -- )     ?<RESOLVE-DO          ;

: DO   ( ofs -- fl ad ofs ) ?<MARK ROT   ; \ ofs = Wortoffset zu WPTR
: LOOP ( fl ad ofs -- )     ?<RESOLVE-DO ;

\ Diese DO-Konstruktion ist dynamisch ( ! ) und kann geschachtelt
\ werden ( ! ). Im Wptr-Offset ofs ( "lokale Variable" ) wird ein
\ Startwert verlangt. ofs wird als Steuervariable betrachtet  und
\ bei jedem Schleifendurchgang um 1 erhht.  Im Wptr-Offset ofs+1
\ wird die  ( vorzeichenlose )  gewnschte Anzahl  von Schleifen-
\ durchgngen erwartet.  ofs+1 wird  bei jedem Schleifendurchgang
\ um 1 erniedrigt. Ist ofs+1 nach dem Erniedrigen <= 0, dann wird
\ die Schleife verlassen  und  mit dem nchsten Befehl  nach LOOP
\ ( eigentlich nach LEND ) fortgefahren.
\ Beispiel:
\ HEX
\ CODE XXX 20 DO SP LDL 0 LDNL 1 ADC SP LDL 0 STNL LOOP NEXT END-CODE
\ Angenommen,  die "lokale Variable" 20 hat ( wie im System mit Stand
\ vom 1.6.1993 ) die absolute Adresse 80000180 ( alles hexadezimal ).
\ Aufruf:
\ 500 80000180 !  1000 80000184 !  50 XXX
\ Ergebnis:
\ .s 1050
\ 80000180 @ u. 14FF
\ 80000184 @ u. 0

\ Will man  in DO  statt "lokaler" Variablen  die normalen 2VARIABLEn
\ verwenden, so muss man sich zuvor per OFFSET aus der Variablenadres-
\ se deren Offset zum Workspace-Pointer beschaffen:

: OFFSET   ( ad -- ofs ) WPTR - 4/ ;
: DEOFFSET ( ofs -- ad ) 4* WPTR + ;  \ Absolute Adresse aus Offset

\ Hier ein etwas komplizierteres, wenn auch wenig sinnvolles, Beispiel:
\ HEX
\ 2VARIABLE XXX
\ : YYY 150 XXX ! 30 XXX 4+ !
\      ASM[ XXX OFFSET
\           DO SP LDL 0 LDNL 1 ADC SP LDL 0 STNL LOOP
\           NEXT
\      ]FORTH . ;
\ Der Aufruf 450 YYY liefert 480 auf dem Bildschirm.

: TRUE    1 LDC ;   \ Achtung: TRUE = 1  in ASSEMBLER !!!
: FALSE   0 LDC ;   \         FALSE = 0, wie in FORTH

CR .( NEXT und einige Makros, die den Einsprung zu NEXT abkrzen. )

: APUSH  AREG STL  BREG STL  SP LDL    -4 ADC  SP STL
         AREG LDL    SP LDL  0 STNL  BREG LDL ;

: 1PUSH         BPUSHP LDL  GCALL ;
: 2PUSH         CPUSHP LDL  GCALL ;
: 3PUSH  APUSH  CPUSHP LDL  GCALL ;
: NEXT           NEXTP LDL  GCALL ;


CR .( Vergleiche : Breg  Areg  ==> Areg = TRUE {1}, sonst FALSE {0} )

\ Die folgenden Vergleichsmakros wirken auf Werte, die schon auf dem
\ CPU-Stack liegen.
\ Also nicht  CODE XXX SP LDL 0 LDNL 5 <
\                  1IF 1 LDC SP LDL 0 STNL 1ELSE 0 LDC SP LDL 0 STNL THEN
\                  NEXT END-CODE ,
\ sondern     CODE XXX SP LDL 0 LDNL 5 LDC <
\                  1IF 1 LDC SP LDL 0 STNL 1ELSE 0 LDC SP LDL 0 STNL THEN
\                  NEXT END-CODE .
\ Als High-Level-Wort wrde das wie folgt aussehen:
\             : XXX 5 < IF 1 ELSE 0 THEN ;

: >  GT    ;
: <= > INV ;
: <  REV > ;
: >= < INV ;
: =  DIFF 0 EQC ;
: <> = INV ;


CR .( Vergleiche mit 0 : Areg  0 ==> Areg = TRUE {1}, sonst FALSE {0} )

\ Beispiel fr die folgenden Makros zum Vergleich mit dem Wert 0:
\             CODE XXX SP LDL 0 LDNL 0<
\                  1IF 1 LDC SP LDL 0 STNL 1ELSE 0 LDC SP LDL 0 STNL THEN
\                  NEXT END-CODE ,
\ was als High-Level-Wort wie folgt au3sehen wrde:
\             : XXX 0< IF 1 ELSE 0 THEN ;

: 0>  0 LDC >  ;
: 0<= 0 LDC <= ;
: 0<  0 LDC <  ;
: 0>= 0 LDC >= ;
: 0=  0 EQC    ;
: 0<> 0= INV   ;

CR .( Vergleiche: vorzeichenlos, sonst wie oben )

: U<  TESTERR 2 EQC SUM CSUB0 TESTERR ;
: U>= U< INV  ;
: U>  REV U<  ;
: U<= REV U>= ;


CR .( Weitere Makros { Pseudo-Opcodes } )  \ In High-Level bernehmen ????
\                                       \ Mit schon Bestehendem vergleichen !!!!
\                                       \ Vielleicht doch als Makros lassen !!!
\   Diese Dinge stammen aus meinem urspnglichen Cross-Assembler, der in
\   den Server eingegangen ist. So, wie sie hier stehen, sind sie natrlich
\   nicht brauchbar. Ich werde sie irgendwann verarbeiten.  -  26.5.95
\ : ADD64 ( d -- )  0. LDC      \ z = y+x mit berlaufprfung
\    2DUP 4DUP 4DUP LDL 2. D+   \ d = Wptr-Offset (lokale Variable);
\    LDL LSUM STL 1. D+ LDL 3.  \ x in d/d+1; y in d+2/d+3
\    D+ LDL LADD 1. D+ STL ;    \ z in d/d+1 (lo/hi)
\ : SUB64 ( d -- )  0. LDC      \ z = y-x mit berlauf0rfung
\    2DUP 4DUP 4DUP 2. D+ LDL   \ d = Wptr-Offset (lokale Variable);
\    LDL LDIFF STL 3. D+ LDL 1  \ x in d/d+1; y in d+2/d+3
\    D+ LDL LSUB 1. D+ STL ;    \ z in d/d+1 (lo/hi)
\ : MUL32*64 ( d -- )  0. LDC   \ Vorzeichenlose Multiplikation; z = x*y;
\    2DUP 4DUP 4DUP LDL 2. D+   \ d = Wptr-Offset (lokale Variable);
\    LDL LMUL 4. D+ STL LDL 3.  \ x in d; y in d+2/d+3; z in d+4/d+5
\    D+ LDL LMUL 5. D+ STL ;    \ (lo/hi) "bertrag" bleibt in Areg
\ : MUL64 ( d -- )  0. LDC      \ Vorzeichenlose Multiplikation; z = x*y;
\    2DUP 4DUP 4DUP 4DUP        \ d = Wptr-Offset (lokale Variable);
\    4DUP 4DUP 4DUP 4DUP        \ x in d/d1; y in d+2/d+3;
\    LDL 2. D+ LDL LMUL 4. D+   \ z in d+4/d+5/d+6/d+7 (lo..hi)
\    STL LDL 3. D+ LDL LMUL
\    REV 6. D+ STL 1. D+ LDL 2.
\    D+ LDL LMUL 5. D+ STL 1.
\    D+ LDL 3. D+ LDL LMUL REV
\    7. D+ STL 0. LDC REV 6.
\    D+ LDL LSUM 6. D+ STL 7.
\    D+ LDL SUM 7. D+ STL ;
\ : DIV64/32 ( d -- )  0. LDC   \ Vorzeichenlose Division; z = y/x;
\    2DUP 4DUP 4DUP 3. D+ LDL   \ d = Wptr-Offset (lokale Variable);
\    LDL LDIV 5. D+ STL 2. D+   \ x in d; y in d+2/d+3; z in d+4/d+5
\    LDL LDL LDIV 4. D+ STL ;   \ (lo/hi); Quotient in z; Rest in Areg
\ : ABS DUP 0> IF               \ Absolutwert von AREG
\    ELSE REV NEG REV THEN REV ;
\ : ROL ( d -- )                \ Rotation von Areg um d Bits nach links
\    0. LDC REV LDC LSHL OR ;
\ : ROR ( d -- )                \ Rotation von Areg um d Bits nach rechts
\    0. LDC LDC LSHR OR ;
\ : SAL ( d -- )                \ Arithmetische Verschiebung von Areg um
\    XDBLE LDC LSHL CSNGL ;     \ d Bits nach links
\ : SAR ( d -- )                \ Arithmetische Verschiebung von Areg um
\    XDBLE LDC LSHR ;           \ d Bits nach rechts
\ : LROL ( d1 d2 -- ) 4DUP REV  \ Rotation des Doppelwortes Breg/Areg ( Breg
\    DUP STL REV LDC LSHL 2DUP  \ hherwertig ) um d1 Bits nach links; Vorsicht:
\    1. D+ STL 2DUP LDL 2SWAP   \ bei d1 > 20h wird der Transputer bis zu 3
\    20. 2SWAP D- LDC SHR 1. D+ \ Minuten lang blockiert und die Rotation wirkt
\    LDL OR ;                   \ wie ein Shift ( rechts aufgefllte Nullen ) ;
\                               \ d2 = Wptr-Offset ( lokale Hilfsvariable ) ;
\                               \ d2+1Wort wird ebenfalls in Anspruch genommen
\ : LROR ( d1 d2 -- ) 4DUP DUP  \ Rotation des Doppelwortes Breg/Areg ( Breg
\    STL LDC LSHR 2DUP 1. D+    \ hherwertig ) um d1 Bits nach rechts;
\    STL 2DUP LDL 2SWAP 20.     \ brige Bemerkungen wie bei LROL
\    2SWAP D- LDC SHL OR 1. D+
\    LDL ;
\ : BITCNT* 0. LDC REV BITCNT ; \ Anzahl der gesetzten Bits in Areg

CR .( Ende des Transputer-FORTH-Assemblers )

CR .( Einbettung von Assemblercode in Doppelpunktdefinitionen )
ONLY FORTH ALSO DEFINITIONS
HEX

: ASM[   ( -- )   \ leitet in Doppelpunktdefinition Assemblercodeteil ein
     BASE @ CONTEXT @  HERE 0C + ,
     COMPILE BRANCH  HERE 0 ,  HERE 4+ ,
     ASSEMBLER  [COMPILE] [ ;  IMMEDIATE
: ]FORTH ( -- )   \ beendet Assemblercodeteil in Doppelpunktdefinition
     [COMPILE] ALIGN HERE SWAP ! CONTEXT ! BASE ! [COMPILE] ] ;
\ Beispiel:
\ : (CONSOLE) PAUSE ASM[  ... Assemblercode ... NEXT ]FORTH ;


CR .( Einbettung von FORTH-Code in Code-Definitionen )
ONLY FORTH ALSO ASSEMBLER ALSO FORTH DEFINITIONS
HEX

: ASM]FORTH ( -- )           \ bergang von Codeteil zu FORTH-Teil
     [COMPILE] ALIGN         \ Wortanpassung fr FORTH-Worte
      5 LDC   LDPI           \ Wo geht es weiter
      W STL   W LDL          \ mit der FORTH-Wort-Adressen-Liste ?
      0 LDNL  GCALL
     [COMPILE] ALIGN         \ Wortanpassung fr FORTH-Worte
     AVOC @ CONTEXT !        \ CONTEXT wieder herstellen
     ['] : @ ,               \ NEST hineincompilieren
     !CSP                    \ Stackberprfung einschalten
     [COMPILE] ] ; IMMEDIATE \ und berleitung zur Wortliste

: FORTH[ASM ( -- )           \ bergang von FORTH-Teil zu Codeteil
     HERE 4+ ,               \ cfa und pfa fllen ( Wort ohne Header
     HERE 4+ ,               \ als CODE-Definition aufbauen
     ?CSP                    \ Stack berprfen
     [COMPILE] [             \ in den Interpreter-Modus schalten
     CONTEXT @ AVOC !        \ High-Level-Vokabular aufbewahren
     ASSEMBLER               \ ins Vokabular ASSEMBLER schalten
     RP LDL 0 LDNL IP STL    \ nchste Adresse = Instruction-Pointer
     RP LDL 4 ADC  RP STL    \ von Rckkehradresse befreien
     ; IMMEDIATE             \ Ausfhrung bei Compilation des neuen Wortes


CR .( Beenden einer Code-Definition durch Doppelpunkt-Definitionen )
ONLY FORTH ALSO ASSEMBLER ALSO DEFINITIONS
HEX

: C;FORTH ( -- )             \ Assemblerversion von ASM]FORTH
     [COMPILE] ASM]FORTH     \ Gleiche Funktion wie ASM]FORTH
             ; IMMEDIATE

ONLY FORTH ALSO DEFINITIONS
HEX


\ Fr den folgenden Teil gilt dasselbe wie fr den Teil "Inhalt
\ einer Diskette anzeigen, Directory":  TKERNEL.FTH war fr den
\ ( vom Host aus wirkenden ) Metacompiler zu gro geworden.

CR .( 64-Bit-Logik-Operationen )

CODE 2AND ( d1 d2 -- d3 )     \ d3 = d1 and d2
      SP LDL  3 LDNL  SP LDL  1 LDNL  AND  SP LDL  3 STNL
      SP LDL  2 LDNL  SP LDL  0 LDNL  AND  SP LDL  2 STNL
      SP LDL  8 ADC   SP STL  NEXT END-CODE
CODE 2OR  ( d1 d2 -- d3 )     \ d3 = d1 or d2
      SP LDL  3 LDNL  SP LDL  1 LDNL  OR   SP LDL  3 STNL
      SP LDL  2 LDNL  SP LDL  0 LDNL  OR   SP LDL  2 STNL
      SP LDL  8 ADC   SP STL  NEXT END-CODE
CODE 2XOR ( d1 d2 -- d3 )     \ d3 = d1 xor d2
      SP LDL  3 LDNL  SP LDL  1 LDNL  XOR  SP LDL  3 STNL
      SP LDL  2 LDNL  SP LDL  0 LDNL  XOR  SP LDL  2 STNL
      SP LDL  8 ADC   SP STL  NEXT END-CODE
CODE 2NOT ( d -- d' )         \ d' = not d
      SP LDL  0 LDNL  NOT  SP LDL  0 STNL
      SP LDL  1 LDNL  NOT  SP LDL  1 STNL  NEXT END-CODE


\ Fr den folgenden Teil gilt dasselbe wie fr den Teil "Inhalt
\ einer Diskette anzeigen, Directory":  TKERNEL.FTH war fr den
\ ( vom Host aus wirkenden ) Metacompiler zu gro geworden.

CR .( 32-Bit-Stack-Operationen )
HEX

CODE -ROLL ( nn ... n1 n0 n  --  n0 nn ... n1 )  \ 2 -ROLL = -ROT usw.
        SP LDL    0 LDNL  EREG STL  \ n
        SP LDL     4 ADC    SP STL
        SP LDL    0 LDNL  FREG STL  \ n0
      EREG LDL      BCNT  BREG STL  \ Lnge
        SP LDL  CREG STL            \ Ziel
        SP LDL     4 ADC  AREG STL  \ Quelle
      AREG LDL    LB  CREG LDL  SB
      CREG LDL     1 ADC  CREG STL
      AREG LDLP   0C LDC  LEND      \ vergleiche CMOVE
      FREG LDL  EREG LDL    SP LDL  WSUB 0 STNL  NEXT END-CODE


\ Fr den folgenden Teil gilt dasselbe wie fr den Teil "Inhalt
\ einer Diskette anzeigen, Directory":  TKERNEL.FTH war fr den
\ ( vom Host aus wirkenden ) Metacompiler zu gro geworden.

CR .( 64-Bit-Stackoperationen )
DECIMAL

CODE 2OVER ( d2 d2 -- d1 d2 d1 )
      SP LDL  2 LDNL  SP LDL  3 LDNL  2PUSH  END-CODE
CODE 4DUP ( a b c d -- a b c d a b c d )
      SP LDL  -16 ADC  SP STL
      SP LDL  7 LDNL  SP LDL  3 STNL  SP LDL  6 LDNL  SP LDL  2 STNL
      SP LDL  5 LDNL  SP LDL  1 STNL  SP LDL  4 LDNL  SP LDL  0 STNL
      NEXT END-CODE
CODE 2ROT ( a b c d e f -- c d e f a b )
      SP LDL  5 LDNL  AREG STL  SP LDL  4 LDNL
      SP LDL  3 LDNL  SP LDL  5 STNL  SP LDL  2 LDNL  SP LDL  4 STNL
      SP LDL  1 LDNL  SP LDL  3 STNL  SP LDL  0 LDNL  SP LDL  2 STNL
            AREG LDL  SP LDL  1 STNL  SP LDL  0 STNL  NEXT END-CODE
CODE 2-ROT ( a b c d e f -- e f a b c d )
      SP LDL  0 LDNL  AREG STL  SP LDL  1 LDNL
      SP LDL  2 LDNL  SP LDL  0 STNL  SP LDL  3 LDNL  SP LDL  1 STNL
      SP LDL  4 LDNL  SP LDL  2 STNL  SP LDL  5 LDNL  SP LDL  3 STNL
            AREG LDL  SP LDL  4 STNL  SP LDL  5 STNL  NEXT END-CODE
CODE 2NIP ( a b c d -- c d )
      SP LDL  1 LDNL  SP LDL  3 STNL  SP LDL  0 LDNL  SP LDL  2 STNL
      SP LDL  8 ADC   SP STL  NEXT  END-CODE
CODE 2TUCK ( a b c d -- c d a b c d )
      SP LDL  -8 ADC  SP STL
      SP LDL  3 LDNL  SP LDL  1 STNL  SP LDL  2 LDNL  SP LDL  0 STNL
      SP LDL  5 LDNL  SP LDL  3 STNL  SP LDL  4 LDNL  SP LDL  2 STNL
      SP LDL  1 LDNL  SP LDL  5 STNL  SP LDL  0 LDNL  SP LDL  4 STNL
      NEXT  END-CODE
CODE 2PICK ( dm ... d2 d1 k -- dm ... d2 d1 dk )  \ k = 32-Bit
       SP LDL  0 LDNL  SP LDL  4 ADC  WSUBDB  DUP  4 ADC  0 LDNL
       SP LDL  0 STNL  0 LDNL  1PUSH END-CODE
CODE 2ROLL  ( dn ... d1 d0 n  --  ... d1 d0 dn )   \ 1 2ROLL = 2SWAP usw.
        SP LDL    0 LDNL  EREG STL                 \ n
        SP LDL     4 ADC    SP STL
      EREG LDL    SP LDL  WSUBDB  0 LDNL FREG STL  \ dnlo
      EREG LDL    SP LDL  WSUBDB  1 LDNL GREG STL  \ dnhi
      EREG LDL     0 LDC  WSUBDB         BREG STL  \ Lnge
        SP LDL     7 ADC  CREG STL                 \ Ziel-1
        SP LDL    -1 ADC  DREG STL                 \ Quelle-1
      DREG LDL  BREG LDL  ADD LB
      CREG LDL  BREG LDL  ADD SB
      AREG LDLP   13 LDC  LEND                     \ vergleiche CMOVE>
      FREG LDL    SP LDL  0 STNL
      GREG LDL    SP LDL  1 STNL  NEXT END-CODE
CODE 2-ROLL ( dn ... d1 d0 n  --  d0 dn ... d1 )  \ 2 2-ROLL = 2-ROT usw.
        SP LDL    0 LDNL  EREG STL          \ n
        SP LDL     4 ADC    SP STL
        SP LDL    0 LDNL  FREG STL          \ d0lo
        SP LDL    1 LDNL  GREG STL          \ d0hi
      EREG LDL     0 LDC  WSUBDB  BREG STL  \ Lnge
        SP LDL  CREG STL                    \ Ziel
        SP LDL     8 ADC  AREG STL          \ Quelle
      AREG LDL    LB  CREG LDL  SB
      CREG LDL     1 ADC  CREG STL
      AREG LDLP   12 LDC  LEND              \ vergleiche CMOVE
      FREG LDL  EREG LDL    SP LDL  WSUBDB  0 STNL
      GREG LDL  EREG LDL    SP LDL  WSUBDB  1 STNL  NEXT END-CODE


\ Fr den folgenden Teil gilt dasselbe wie fr den Teil "Inhalt
\ einer Diskette anzeigen, Directory":  TKERNEL.FTH war fr den
\ ( vom Host aus wirkenden ) Metacompiler zu gro geworden.

CR .( 32-Bit-Multiplikation und -Division, symmetrische Rundung )
CODE MUL   ( n1 n2 -- n fl )   \ Flag = FALSE bei berlauf
      TESTERR  SP LDL  1 LDNL  SP LDL  0 LDNL  MUL
      TESTERR  NEG  SP LDL  0 STNL  SP LDL  1 STNL  NEXT END-CODE
CODE /-REM ( n1 n2 -- n3 n4 )  \ n3 = Rest von n1/n2 ; n4 = n1/n2
      SP LDL  0 LDNL  AREG STL  SP LDL  1 LDNL  BREG STL
      BREG LDL  AREG LDL  DIV   SP LDL  0 STNL
      BREG LDL  AREG LDL  REM   SP LDL  1 STNL  NEXT END-CODE
CODE /-    ( n1 n2 -- n )      \ n = n1/n2 ; keine floored division,
      SP LDL  1 LDNL  SP LDL  0 LDNL  DIV  \ symmetrische Rundung
      SP LDL  1 STNL  SP LDL  4 ADC   SP STL  NEXT END-CODE
CODE -REM  ( n1 n2 -- n )      \ n = Rest von n1/n2
      SP LDL  1 LDNL  SP LDL  0 LDNL  REM  SP LDL  1 STNL
      SP LDL  4 ADC   SP STL  NEXT END-CODE

\ Und hier noch ein paar ANS-Empfehlungen ( siehe auch Abschnitt dpANS-5 ):

: M* ( n1 n2 -- d ) NOOP ;
' *D IS M*

: M+ ( d1 n -- d2 ) \ d2 = d1 + n
      S>D D+ ;


\ Auch der folgende Teil ist aus TKERNEL.FTH herausgenommen worden.

DECIMAL
CR .( 64-Bit-Vergleichsoperationen )
CODE D=   ( d1 d2 -- fl )
      SP LDL  3 LDNL  SP LDL  1 LDNL  XOR
      SP LDL  2 LDNL  SP LDL  0 LDNL  XOR  OR  0 EQC
      -1 ADC  NOT  SP LDL  3 STNL  SP LDL  12 ADC  SP STL  NEXT END-CODE
CODE D<>  ( d1 d2 -- fl )
      SP LDL  3 LDNL  SP LDL  1 LDNL  XOR
      SP LDL  2 LDNL  SP LDL  0 LDNL  XOR  OR  0 EQC
      -1 ADC       SP LDL  3 STNL  SP LDL  12 ADC  SP STL  NEXT END-CODE
CODE D0=  ( d -- fl )
      SP LDL  0 LDNL  0 EQC  SP LDL  1 LDNL  0 EQC  AND  -1 ADC  NOT
      SP LDL  1 STNL  SP LDL  4 ADC  SP STL  NEXT END-CODE
CODE D0<> ( d -- fl )
      SP LDL  0 LDNL  0 EQC  SP LDL  1 LDNL  0 EQC  AND  -1 ADC
      SP LDL  1 STNL  SP LDL  4 ADC  SP STL  NEXT END-CODE
CODE D0<  ( d -- fl )
      SP LDL  1 LDNL  MINT  AND  0 EQC  -1 ADC
      SP LDL  1 STNL  SP LDL  4 ADC  SP STL  NEXT END-CODE
CODE D0>= ( d -- fl )
      SP LDL  1 LDNL  MINT  AND  0 EQC  -1 ADC  NOT
      SP LDL  1 STNL  SP LDL  4 ADC  SP STL  NEXT END-CODE
CODE D0>  ( d -- fl )
      SP LDL  1 LDNL  SP LDL  0 LDNL  OR  0 EQC  AREG STL
      SP LDL  1 LDNL  MINT  AND  0 EQC  0 EQC
      AREG LDL  OR  -1 ADC
      SP LDL  1 STNL  SP LDL  4 ADC  SP STL  NEXT END-CODE
CODE D0<= ( d -- fl )
      SP LDL  1 LDNL  SP LDL  0 LDNL  OR  0 EQC  AREG STL
      SP LDL  1 LDNL  MINT  AND  0 EQC  0 EQC
      AREG LDL  OR  NOT  1 ADC
      SP LDL  1 STNL  SP LDL  4 ADC  SP STL  NEXT END-CODE
CODE DU>  ( ud1 ud2 -- fl )   \ ud1 > ud2
      TESTERR  SP LDL  1 LDNL  SP LDL  3 LDNL  CSUB0  TESTERR  AREG STL
      SP LDL  1 LDNL  SP LDL  3 LDNL  XOR  0 EQC
      SP LDL  0 LDNL  SP LDL  2 LDNL  CSUB0  TESTERR  AND  AREG LDL  OR
      -1 ADC  NOT  SP LDL  3 STNL  SP LDL  12 ADC  SP STL  NEXT END-CODE
CODE DU<  ( ud1 ud2 -- fl )   \ ud1 < ud2
      TESTERR  SP LDL  3 LDNL  SP LDL  1 LDNL  CSUB0  TESTERR  AREG STL
      SP LDL  3 LDNL  SP LDL  1 LDNL  XOR  0 EQC
      SP LDL  2 LDNL  SP LDL  0 LDNL  CSUB0  TESTERR  AND  AREG LDL  OR
      -1 ADC  NOT  SP LDL  3 STNL  SP LDL  12 ADC  SP STL  NEXT END-CODE
CODE DU<= ( ud1 ud2 -- fl )   \ ud1  ud2
      TESTERR  SP LDL  3 LDNL  SP LDL  1 LDNL  CSUB0  TESTERR  AREG STL
      SP LDL  3 LDNL  SP LDL  1 LDNL  XOR  0 EQC
      SP LDL  0 LDNL  SP LDL  2 LDNL  CSUB0  TESTERR  0 EQC  AND  AREG LDL
      OR  -1 ADC  NOT  SP LDL  3 STNL  SP LDL  12 ADC  SP STL  NEXT END-CODE
CODE DU>= ( ud1 ud2 -- fl )   \ ud1  ud2
      TESTERR  SP LDL  1 LDNL  SP LDL  3 LDNL  CSUB0  TESTERR  AREG STL
      SP LDL  1 LDNL  SP LDL  3 LDNL  XOR  0 EQC
      SP LDL  2 LDNL  SP LDL  0 LDNL  CSUB0  TESTERR  0 EQC  AND  AREG LDL
      OR  -1 ADC  NOT  SP LDL  3 STNL  SP LDL  12 ADC  SP STL  NEXT END-CODE
CODE D> ( d1 d2 -- fl )       \ fl = TRUE, wenn d1 > d2
      SP LDL  0 LDNL  AREG STL  SP LDL  1 LDNL  BREG STL
      SP LDL  2 LDNL  CREG STL  SP LDL  3 LDNL  DREG STL
      0 LDC  EREG STL
      BREG LDL  DREG LDL  XOR  0 EQC  11 CJ
      TESTERR   AREG LDL  CREG LDL  CSUB0  TESTERR  AREG STL  0 LDC  4 CJ
      DREG LDL  BREG LDL  GT  AREG STL
      AREG LDL  EREG LDL  XOR  NOT  1 ADC
      SP LDL  3 STNL  SP LDL  12 ADC  SP STL  NEXT END-CODE
CODE D< ( d1 d2 -- fl )       \ fl = TRUE, wenn d1 < d2
      SP LDL  2 LDNL  AREG STL  SP LDL  3 LDNL  BREG STL
      SP LDL  0 LDNL  CREG STL  SP LDL  1 LDNL  DREG STL
      0 LDC  EREG STL
      BREG LDL  DREG LDL  XOR  0 EQC  11 CJ
      TESTERR   AREG LDL  CREG LDL  CSUB0  TESTERR  AREG STL  0 LDC  4 CJ
      DREG LDL  BREG LDL  GT  AREG STL
      AREG LDL  EREG LDL  XOR  NOT  1 ADC
      SP LDL  3 STNL  SP LDL  12 ADC  SP STL  NEXT END-CODE
CODE D<= ( d1 d2 -- fl )  \ fl = TRUE, wenn d1  d2
      SP LDL  0 LDNL  AREG STL  SP LDL  1 LDNL  BREG STL
      SP LDL  2 LDNL  CREG STL  SP LDL  3 LDNL  DREG STL
      1 LDC  EREG STL
      BREG LDL  DREG LDL  XOR  0 EQC  11 CJ
      TESTERR   AREG LDL  CREG LDL  CSUB0  TESTERR  AREG STL  0 LDC  4 CJ
      DREG LDL  BREG LDL  GT  AREG STL
      AREG LDL  EREG LDL  XOR  NOT  1 ADC
      SP LDL  3 STNL  SP LDL  12 ADC  SP STL  NEXT END-CODE
CODE D>= ( d1 d2 -- fl )  \ fl = TRUE, wenn d1  d1
      SP LDL  2 LDNL  AREG STL  SP LDL  3 LDNL  BREG STL
      SP LDL  0 LDNL  CREG STL  SP LDL  1 LDNL  DREG STL
      1 LDC  EREG STL
      BREG LDL  DREG LDL  XOR  0 EQC  11 CJ
      TESTERR   AREG LDL  CREG LDL  CSUB0  TESTERR  AREG STL  0 LDC  4 CJ
      DREG LDL  BREG LDL  GT  AREG STL
      AREG LDL  EREG LDL  XOR  NOT  1 ADC
      SP LDL  3 STNL  SP LDL  12 ADC  SP STL  NEXT END-CODE
CODE DMAX ( d1 d2 -- d ) \ d = max{d1,d2}
      SP LDL  0 LDNL  AREG STL  SP LDL  1 LDNL  BREG STL
      SP LDL  2 LDNL  CREG STL  SP LDL  3 LDNL  DREG STL
      TESTERR
      BREG LDL  DREG LDL  XOR  0 EQC            \ 1 bei BREG = DREG
      AREG LDL  CREG LDL  CSUB0  REV  TESTERR   \ 1 bei AREG < CREG
      AND                                       \ 1 bei beides
      DREG LDL  BREG LDL  GT                    \ 1 bei BREG < DREG
      OR                                        \ 1 bei ABRG < CDRG
      4 CJ  CREG LDL  AREG STL  DREG LDL  BREG STL
      AREG LDL  SP LDL  2 STNL  BREG LDL  SP LDL  3 STNL
      SP LDL  8 ADC  SP STL  NEXT  END-CODE
CODE DMIN ( d1 d2 -- d ) \ d = min{d1,d2}
      SP LDL  0 LDNL  AREG STL  SP LDL  1 LDNL  BREG STL
      SP LDL  2 LDNL  CREG STL  SP LDL  3 LDNL  DREG STL
      TESTERR
      BREG LDL  DREG LDL  XOR  0 EQC            \ 1 bei BREG = DREG
      AREG LDL  CREG LDL  CSUB0  REV  TESTERR   \ 1 bei AREG < CREG
      AND                                       \ 1 bei beides
      DREG LDL  BREG LDL  GT                    \ 1 bei BREG < DREG
      OR  0 EQC                                 \ 0 bei ABRG < CDRG
      4 CJ  CREG LDL  AREG STL  DREG LDL  BREG STL
      AREG LDL  SP LDL  2 STNL  BREG LDL  SP LDL  3 STNL
      SP LDL  8 ADC  SP STL  NEXT  END-CODE


CR .( Interface, MEM-MEM, MEM-Stack, Stack-MEM: Host-Transputer )
ONLY FORTH ALSO DEFINITIONS
HEX

CODE C@-H ( seg-H ad-H -- c )  \ Byte c von Host-Langadresse auf TStack
     MINT         25 LDC   OUTBYTE   \ Transfer-Code
     MINT          4 LDC   OUTBYTE   \ Message-Lnge
     SP LDL 4 ADC MINT 2 LDC  OUT    \ Host-Segment seg vom TStack
     SP LDL       MINT 2 LDC  OUT    \ Host-Adresse  ad vom TStack
     SP LDL  4 ADC SP STL            \ TStack anpassen
      0 LDC SP LDL 0 STNL            \ zunchst alles = 0
     SP LDL                          \ Byte c
     MINT  10 ADC  1 LDC   IN        \ von Link zu TStack
     NEXT END-CODE

CODE C!-H ( c seg-H ad-H -- )  \ Byte c von TStack zu Host-Langadresse
     MINT         26 LDC   OUTBYTE   \ Transfer-Code
     MINT          5 LDC   OUTBYTE   \ Message-Lnge
     SP LDL 8  ADC MINT 1 LDC  OUT   \ Byte c vom TStack zum Link
     SP LDL 4  ADC MINT 2 LDC  OUT   \ Host-Segment seg vom TStack
     SP LDL        MINT 2 LDC  OUT   \ Host-Adresse  ad vom TStack
     SP LDL 0C ADC SP STL            \ TStack anpassen
     NEXT END-CODE

\ CODE  @-H ( seg-H ad-H -- cc ) \ Doppelbyte cc von Host-Langadresse auf TStack
\      MINT         27 LDC   OUTBYTE   \ Transfer-Code
\      MINT          4 LDC   OUTBYTE   \ Message-Lnge
\      SP LDL 4 ADC MINT 2 LDC  OUT    \ Host-Segment seg vom TStack
\      SP LDL       MINT 2 LDC  OUT    \ Host-Adresse  ad vom TStack
\      SP LDL  4 ADC SP STL            \ TStack anpassen
\       0 LDC SP LDL 0 STNL            \ zunchst alles = 0
\      SP LDL                          \ Doppelbyte cc
\      MINT   10 ADC  2 LDC     IN     \ von Link zu TStack
\      NEXT END-CODE
\ @-H wurde nach TKERNEL.FTH vorgezogen, da es dort schon bentigt
\ wurde.

CODE  !-H ( cc seg-H ad-H -- ) \ Doppelbyte cc vom TStack zu Host-Langadresse
     MINT         28 LDC   OUTBYTE   \ Transfer-Code
     MINT          6 LDC   OUTBYTE   \ Message-Lnge
     SP LDL 8  ADC MINT 2 LDC  OUT   \ Doppelbyte cc vom TStack zum Link
     SP LDL 4  ADC MINT 2 LDC  OUT   \ Host-Segment seg vom TStack
     SP LDL        MINT 2 LDC  OUT   \ Host-Adresse  ad vom TStack
     SP LDL 0C ADC SP STL            \ TStack anpassen
     NEXT END-CODE

CODE 2@-H ( seg-H ad-H -- n )  \ TWort n von Host-Langadresse auf TStack
     MINT         29 LDC   OUTBYTE   \ Transfer-Code
     MINT          4 LDC   OUTBYTE   \ Message-Lnge
     SP LDL 4 ADC MINT 2 LDC  OUT    \ Host-Segment seg vom TStack
     SP LDL       MINT 2 LDC  OUT    \ Host-Adresse  ad vom TStack
     SP LDL 4 ADC SP STL             \ TStack anpassen
     SP LDL                          \ Doppel-Hostwort als TWort n
     MINT  10 ADC  4 LDC      IN     \ von Link zu TStack
     NEXT END-CODE

CODE 2!-H ( n seg-H ad-H -- )  \ TWort n vom TStack zu Host-Langadresse
     MINT         2A LDC   OUTBYTE   \ Transfer-Code
     MINT          8 LDC   OUTBYTE   \ Message-Lnge
     SP LDL  8 ADC MINT 4 LDC  OUT   \ TWort n vom TStack zum Link
     SP LDL  4 ADC MINT 2 LDC  OUT   \ Host-Segment seg vom TStack
     SP LDL        MINT 2 LDC  OUT   \ Host-Adresse  ad vom TStack
     SP LDL 0C ADC SP STL            \ TStack anpassen
     NEXT END-CODE

CODE CMOVE-H>T ( seg-H ad-H ad-T len -- )
     \ Speicherblock der Lnge len ( < 64k ) von Host nach ad-T
     MINT          85 LDC  OUTBYTE   \ Transfer-Code
     SP LDL 0C ADC MINT 2 LDC  OUT   \ Host-Segment seg vom TStack zum Link
     SP LDL  8 ADC MINT 2 LDC  OUT   \ Host-Adresse  ad vom TStack zum Link
     SP LDL        MINT 2 LDC  OUT   \ Blocklnge   len vom TStack zum Link
     SP LDL  1 LDNL                  \ TAdresse
     MINT   10 ADC                   \ Eingabekanal
     SP LDL  0 LDNL            IN    \ len Bytes        vom Link zum TStack
     SP LDL 10 ADC     SP STL        \ TStack anpassen
     NEXT END-CODE

CODE CMOVE-T>H ( ad-T seg-H ad-H len -- )
     \ Speicherblock der Lnge len ( < 64k ) von ad-T zum Host
     MINT          86 LDC  OUTBYTE   \ Transfer-Code
     SP LDL  8 ADC MINT 2 LDC  OUT   \ Host-Segment seg vom TStack zum Link
     SP LDL  4 ADC MINT 2 LDC  OUT   \ Host-Adresse  ad vom TStack zum Link
     SP LDL        MINT 2 LDC  OUT   \ Blocklnge   len vom TStack zum Link
     SP LDL  3 LDNL                  \ TAdresse
     MINT                            \ Ausgabekanal
     SP LDL  0 LDNL            OUT   \ len Bytes        von ad-T   zum Link
     SP LDL 10 ADC     SP STL        \ TStack anpassen
     NEXT END-CODE

CODE $EXECUTE-HOST ( ad len -- )     \ Counted String ad:len im Host ausfhren
     MINT    87 LDC  OUTBYTE         \ Transfer-Code
     MINT                            \ Stringlnge len
     SP LDL  0 LDNL  OUTBYTE         \ zum Link
     SP LDL  1 LDNL                  \ Von TAdresse
     MINT                            \ ber Ausgabekanal
     SP LDL  0 LDNL  OUT             \ len Bytes zum Link
     SP LDL  8 ADC   SP STL          \ TStack anpassen
     NEXT END-CODE

: LOAD ( <name[.ext]> ad len -- len' ) \ Datei nach ad ins TSystem laden
     FILENAME 0 (OPEN) ?DOS-ERR >R
     DUP 0>
     IF
       OVER SWAP                     \ ad ad' len  ad':=ad
       BEGIN                         \ ad ad' len
         2DUP                        \ ad ad' len ad' len
         8000 <
         IF                          \ ad ad' len ad'
           OVER                      \ ad ad' len  ad' len
         ELSE                        \ ad ad' len ad'
           SWAP 8000 - SWAP 8000     \ ad ad' len ad' 8000  len:=len-8000
         THEN
         DSEGMENT 1000 + 0 ROT R@
         GET-HOST                    \ 32K einladen und
         ?DOS-ERR TUCK               \ rberschaufeln
         DSEGMENT 1000 + -ROT 0 -ROT
         CMOVE-H>T                   \ ad ad' len len'
         ROT OVER + -ROT             \ ad ad'+len' len len'
         8000 =                      \ ad ad' len       ad':=ad'+len'
         OVER 0> AND                 \ ad ad' len fl
         IF                          \ ad ad' len
           FALSE                     \ weiter ...
         ELSE                        \ ad ad' len
           DROP SWAP -               \ len' (insgesamt)
           TRUE
         THEN                        \ LOAD ist das Gegenstck zu SAVE. An-
       UNTIL                         \ fangsstck der Lnge  len  der Datei
     ELSE                            \ name.ext nach ad legen. len' ist die
       2DROP 0                       \ tatschliche Lnge,  die weniger als
     THEN                            \ len  betragen kann,  wenn  die Datei
     R> (CLOSE) ;                    \ krzer als len ist.  Keine Beschrn-
                                     \ kung auf 64 K !!!  Abgesichert gegen
                                     \ Eingabe von len <= 0 .


CR .( DOS-Programm im Host ausfhren )
ONLY FORTH ALSO FORTH DEFINITIONS
DECIMAL

\ : (PROGRAM) ( ad-filename ad-param mode -- fl ) ; \ wird durch EXEC ersetzt
\       DSEGMENT PAD-HOST 2DUP !-H 2DUP 2+ !-H 4 + !-H
\      " PAD @ PAD 2 + @ PAD 4 + @ (PROGRAM) PAD !" $EXECUTE-HOST
\      DSEGMENT PAD-HOST @-H ;
\      \ (PROGRAM) ist das Grundwort fr das Hinzuladen weiterer
\      \ DOS-Programme in den RAM-Speicher des Host-Systems.
\      \ ( Interrupt 21h, Dos-Funktion 4Bh ( "EXEC" )). Es bedeuten:
\      \ ad-filename : Host-Adresse des ASCII0-Strings, der
\      \               den Namen des Programms angibt
\      \ ad-param :    Host-Adresse des Parameterblocks
\      \ mode = 0 bei Host-DOS-Programmen mit PSP :  Paramblock von 14 Byte
\      \ mode = 3 bei Overlays ( ohne PSP )       :  Paramblock von  4 Byte
\      \ Die Rckkehr erfolgt zunchst zu dem aufrufenden Host-FORTH-System.
\
\ berholt !!!

: ALLOC ( #p -- block )     \ verndert  die Speicherplatz-
     DSEGMENT PAD-HOST !-H  \ zuordnung fr das Host-FORTH-
     " PAD @ ALLOC PAD !"   \ System
     $EXECUTE-HOST
     DSEGMENT PAD-HOST @-H ;
     \ Bei Aufruf des Host-FORTH-Systems von der DOS-Ebene aus wird der
     \ gesamte RAM-Speicher  ber die  Zuordnungstabelle  diesem System
     \ zugeordnet.  Um ein weiteres DOS-Programm  in das Host-RAM laden
     \ zu knnen, muss der zugeordnete Platz  reduziert werden.  #p ist
     \ die Anzahl der 16-Byte-Blcke ( "Paragraphen" ) ,  die dem neuen
     \ System zugeordnet werden sollen. Man braucht mindestens 64k, d.h.
     \ 4096 16-Byte-Blcke.  Man kann aber auch mehr vorsehen, wenn man
     \ beispielsweise mit Extra-Segmenten arbeiten will.  Der nach Aus-
     \ fhrung von ALLOC ( auf dem Stack des Transputer-FORTH-Systems )
     \ ausgegebene Parameter  block  gibt die Segmentadresse des insge-
     \ samt  zugeordneten  Speicherblocks  ( also den Anfang  des Host-
     \ FORTH-Systems ) an.

4096 CONSTANT HEIGHT    \ Mindestspeicherbedarf fr das Host-FORTH-System
                        \ Modifizierbar in Pseudokonstantenmanier z.B. zu
                        \ 8192 IS HEIGHT

1 STRING QUOTE$         \ Zur Eingabe von " in Stringvariablen.
                        \ In Stringkonstanten nicht mglich !!!

"  " QUOTE$ $! ASCII " QUOTE$ DROP C!  \ Belegung mit "

: PASS ( ad len -- )                   \ Parameterstring fr EXEC bergeben
     2 ?ENOUGH                         \ Noch Platz auf Stack ?
     QUOTE$   COMMAND$ $!              \ "
     "  "     COMMAND$ APPEND$         \ Zwischenraum  anhngen
              COMMAND$ APPEND$         \ String ad len anhngen
     QUOTE$   COMMAND$ APPEND$         \ "             anhngen
     "  PASS" COMMAND$ APPEND$         \ PASS          anhngen
              COMMAND$ $EXECUTE-HOST ; \ " ..." PASS im Host ausfhren

64 STRING PROGRAM$   \ Fr bergabe von Dateinamen bei zwischenzeitlichem
                     \ Aufrufen von DOS-Programmen ( nur .COM oder .EXE ).
                     \ Wird auch von EDIT ( siehe unten ) verwendet.

: EXEC ( ad len -- ) \ DOS-Programm ausfhren. Wenn fehlerlos ausgefhrt,
     2 ?ENOUGH       \ dann  Rckkehr  zum  Transputer-FORTH-System.  Bei
     PROGRAM$ $!     \ Fehler  Rckkehr  zum Host.  Dann BYE eingeben und
     PROGRAM$        \ anschlieend TRESUME .
     $EXECUTE-HOST ; \ Mit  EXEC  kann  ber  das  Host-FORTH-System  ein
                     \ DOS-.COM-  oder  -.EXE-Programm aufgerufen werden,
                     \ mit oder ohne zu bergebende Parameter:
                     \ Mit " PROGRAM DINGSDA.COM" EXEC  wird  DINGSDA.COM
                     \ ohne Parameter aufgerufen.
                     \ Mit   " /W xyz " PASS  " PROGRAM DINGSDA.COM" EXEC
                     \ wird  DINGSDA.COM  mit der Parameterzeile '/W xyz'
                     \ aufgerufen, also DINGSDA /W xyz  .
                     \ Man versuche:
                     \ " VOCS" PASS " PROGRAM FORTH.COM" EXEC  .
                     \ Hiermit wird vom Hostsystem aus ein weiteres FORTH
                     \ aufgerufen,  es werden dessen Vokabulare angezeigt
                     \ und es wird wieder in das Transputersystem zurck-
                     \ gekehrt.
                     \ Fr DOS-Befehle,  die  COMMAND.COM verwenden,  ist
                     \ der Spezialfall " befehl" SHELL vorgesehen.

: SHELL ( ad len  -- )       \ fhrt MS-DOS-Befehl ber COMMAND.COM aus
     PROGRAM$ $!             \ nimmt DOS-Befehl nebst eventuellen
     " /C " PROGRAM$         \ Parametern auf.
     0 INSERT$               \ und lsst /C vorausgehen.
     PROGRAM$ PASS           \ Setzt " ein und bertrgt auf Host
     " PROGRAM COMMAND.COM " \ Gegebenenfalls Pfad angeben, in dem
     EXEC ;                  \ COMMAND.COM liegt. Dann COMMAND.COM aufrufen.
     \ Beispiel: " DIR A:*.COM" SHELL
     \ Man achte darauf, dass sich COMMAND.COM
     \ im laufenden Verzeichnis befindet.

     \ Weitere Beispiele :
     \ " C:DIR/W" SHELL
     \ : TIME " TIME" SHELL ;
     \ : WP B: " A:WP" SHELL ;
     \ 20 STRING LIST$
     \ : LIST  BL WORD COUNT LIST$ $!
     \ " TYPE " LIST$ 0 INSERT$  LIST$ SHELL ;
     \ usw ...
     \ Es lassen sich auch  .COM- oder .EXE-Dateien ber SHELL auf-
     \ rufen. Dann wird aber jedesmal COMMAND.COM zuhilfe genommen.


HEX
CR .( DOS-Kommandozeile ausfhren )

\ Mit diesem Befehl lsst sich jedes beliebige DOS-Programm,  lassen sich
\ aber auch interne DOS-Befehle, Batch-Dateien usw., aus F-TP heraus auf-
\ rufen !!  Nach Abarbeiten auf der DOS-Ebene befindet man sich wieder im
\ Transputer-Forth-System F-TP.
\ Syntax: DOS xxx yyy www uuu ttt [RET]
\ ( xxx yyy uuu ttt = Kommandozeile )
\ Die Kommandozeile wird in den Stringvariablen COMMAND$ und PROGRAM$ zu-
\ sammengesetzt und zwischengespeichert. Es wird auerdem von der String-
\ variablen PROGRAM$ im Hostsystem Gebrauch gemacht. Diese ist 32 Zeichen
\ lang. Da der Kommandozeile aber noch ein "/C " ( per 0 INSERT$ ) voran-
\ gesetzt wird,  darf diese effektiv "nur" 29 Zeichen lang sein.  Es wird
\ davon ausgegangen, dass COMMAND.COM in C:\ liegt. Notfalls ndern !
\ Beispiel:
\ DOS EDIT LOAD-FTP.BAT [RET
\ ruft den DOS-Editor, der aus QBASIC heraus arbeitet, auf  und ber die-
\ sen die Textdatei LOAD-FP.BAT .  ( TKERNEL.FTH und TCORE.FTH waren fr
\ meinen Arbeitsspeicher zu gro. )
\ Vorhandene Host-Assembler-Programme an F-TP anbinden ? Ganz leicht. Man
\ giee diese in eine COM-Datei XXX.COM und verwende ( von F-TP aus ):
\ DOS XXX.COM [RET]

: DOS ( -- )
     0D WORD                    \ Kommandozeile bis (RET)
     COUNT PROGRAM$ $!          \ nach PROGRAM$ legen.
     " /C " PROGRAM$ 0 INSERT$  \ " /C " voransetzen.
     PROGRAM$ PASS              \ Weiterreichen.
     " PROGRAM C:\COMMAND.COM"  \ ber COMMAND.COM
     EXEC ;                     \ ausfhren.



CR .( Verschiebungen auf dem Stack )
HEX

CODE ?OVERFLOW ( -- n )     \ liefert bei Aufruf den Wert von AOFLAG auf Stack
     AOFLAG LDL 1PUSH END-CODE

CODE SHL ( u1 u2 -- u3 )    \ Shift Logical Left
     SP LDL  0 LDNL         \ u2 vom Stack holen
     21 LDC  CSUB0          \ wenn u2>20h oder u2<0, wird Errorflag gesetzt
     TESTERR 0=             \ Flag testen
     1IF                    \ gesetzt, dann
       0 LDC                \ Areg
       0 LDC                \ und Breg mit 0 laden.
     1ELSE                  \ Sonst
       0 LDC                \ Creg mit 0 laden
       SP LDL  1 LDNL       \ u1 vom Stack holen
       SP LDL  0 LDNL       \ u2 vom Stack holen
       LSHL                 \ Creg,Breg um u2 Bits nach links
     THEN
     SP LDL  1 STNL         \ Ergebnis auf Stack legen
     AOFLAG STL             \ eventueller berlauf nach AOFLAG
     SP LDL  4 ADC  SP STL  \ Stack ausgleichen
     NEXT END-CODE          \ und zurck

CODE SHR ( u1 u2 -- u3 )    \ Shift Logical Right
     SP LDL  0 LDNL         \ u2 vom Stack holen
     21 LDC  CSUB0          \ wenn u2>20h oder u2<0, wird Errorflag gesetzt
     TESTERR 0=             \ Flag testen
     1IF                    \ gesetzt, dann
       0 LDC                \ Areg
       0 LDC                \ und Breg mit 0 laden.
     1ELSE                  \ Sonst
       SP LDL  1 LDNL       \ u1 vom Stack holen
       0 LDC                \ Breg mit 0 laden
       SP LDL  0 LDNL       \ u2 vom Stack holen
       LSHR                 \ Creg,Breg um u2 Bits nach rechts
     THEN
     AOFLAG STL             \ eventueller berlauf nach AOFLAG
     SP LDL  1 STNL         \ Ergebnis auf Stack legen
     SP LDL  4 ADC  SP STL  \ Stack ausgleichen
     NEXT END-CODE          \ und zurck

: SAL ( n1 u -- n2 ) SHL ;  \ Shift Arithmetic Left

CODE SAR ( n1 u -- n2 )     \ Shift Arithmetic Right
     SP LDL  0 LDNL         \ u vom Stack holen
     21 LDC  CSUB0          \ wenn u > 20h oder u < 0, wird Errorflag gesetzt
     TESTERR 0=             \ Flag testen
     1IF                    \ gesetzt, dann
       0 LDC                \ Areg
       0 LDC                \ und Breg mit 0 laden.
     1ELSE                  \ Sonst
       SP LDL  1 LDNL       \ n1 vom Stack holen
       XDBLE                \ vorzeichenrichtig nach 64-Bit wandeln
       SP LDL  0 LDNL       \ u vom Stack holen
       LSHR                 \ Creg,Breg um u Bits nach rechts
     THEN
     SP LDL  1 STNL         \ Ergebnis auf Stack legen
     SP LDL  4 ADC  SP STL  \ Stack ausgleichen
     NEXT END-CODE

CODE ROL ( u1 u2 -- u3 )    \ Rotate Left
     SP LDL  0 LDNL         \ u2 vom Stack holen
     1F LDC AND AREG STL    \ ausblenden und zwischenspeichern
      0 LDC                 \ 0 nach Creg
     SP LDL  1 LDNL         \ u1 nach Breg
     AREG LDL               \ u2 wieder holen
     LSHL                   \ 64 Bit um u2 Stellen nach links verschieben
     OR                     \ was links raus, rechts rein
     SP LDL  1 STNL         \ Ergebnis auf Stack legen
     SP LDL  4 ADC  SP STL  \ Stack anpassen
     NEXT END-CODE

CODE ROR ( u1 u2 -- u3 )    \ Rotate Right
     SP LDL  0 LDNL         \ u2 vom Stack holen
     1F LDC AND AREG STL    \ ausblenden und zwischenspeichern
     SP LDL  1 LDNL         \ u1 nach Creg
      0 LDC                 \ 0 nach Breg
     AREG LDL               \ u2 wieder holen
     LSHR                   \ 64 Bit um u2 Stellen nach rechts verschieben
     OR                     \ was rechts raus, links rein
     SP LDL  1 STNL         \ Ergebnis auf Stack legen
     SP LDL  4 ADC  SP STL  \ Stack anpassen
     NEXT END-CODE

CODE NORML ( ud1 -- ud2 u ) \ Normalise Left
     SP LDL  1 LDNL         \ hole hherwertigen  Teil von ud1 vom Stack
     SP LDL  0 LDNL         \ hole niederwertigen Teil von ud1 vom Stack
     NORM                   \ schiebe nach links, bis 1. Bit eine 1
     AREG STL               \ zwischenspeichern
     SP LDL  1 STNL         \ lege hherwertigen  Teil von ud2 auf Stack
     AREG LDL               \ zurckholen
     SP LDL  0 STNL         \ lege niederwertigen Teil von ud2 auf Stack
     1PUSH END-CODE         \ lege Anzahl Schiftbits u auf Stack

CODE NORMR ( ud1 -- ud2 u ) \ Normalise Right
     SP LDL  0 LDNL         \ hole niederwertigen Teil von ud1 vom Stack
     BITREVWORD             \ bitweise spiegeln
     SP LDL  1 LDNL         \ hole hherwertigen  Teil von ud1 vom Stack
     BITREVWORD             \ bitweise spiegeln
     NORM                   \ schiebe nach links, bis 1. Bit eine 1
     BITREVWORD             \ bitweise spiegeln
     AREG STL               \ zwischenspeichern
     BITREVWORD             \ bitweise spiegeln
     SP LDL  0 STNL         \ lege niederwertigen Teil von ud2 auf Stack
     AREG LDL               \ zurckholen
     SP LDL  1 STNL         \ lege hherwertigen  Teil von ud2 auf Stack
     1PUSH END-CODE         \ lege Anzahl Schiftbits u auf Stack


CR .( Verschiebungen im String )
HEX

CODE SHL$  ( ad len n -- )           \ Im String ad,len  n Bytes nach links
     SP LDL  0 LDNL  EREG STL        \ n nach EREG
     EREG LDL  0>                    \ berspringen, wenn   n  0
     2IF
     SP LDL  1 LDNL  BREG STL        \ zunchst len nach BREG
     BREG LDL  0>                    \ berspringen, wenn len = 0
     2IF
     BREG LDL  EREG LDL  <=          \ wenn n  len,
     1IF
     BREG LDL  EREG STL              \ dann n = len
     THEN
     BREG LDL  EREG LDL  DIFF        \ len - n
     BREG STL                        \ als Verschiebungslnge nach BREG
     BREG LDL  0>                    \ berspringen, wenn = 0
     2IF
     SP LDL  2 LDNL  EREG LDL  SUM   \ Quelladresse
                     AREG STL        \ nach AREG
     SP LDL  2 LDNL  CREG STL        \ Zieladresse nach CREG
     CREG LDL  AREG LDL  <>          \ berspringen, wenn Ziel = Quelle
     2IF
     AREG LDL  LB  CREG LDL  SB      \ Von laufender Quelle nach lauf. Ziel
     CREG LDL   1 ADC  CREG STL      \ Zieladresse um 1 erhhen
     AREG LDLP  0C LDC  LEND         \ An Schleifenanfang
     EREG LDL          BREG STL      \ "n" fr "FILL" mit 20h nach BREG
       SP LDL   2 LDNL               \ Stringanfang
       SP LDL   1 LDNL  SUM          \ + Stringlnge
     EREG LDL   DIFF   AREG STL      \ nach AREG
     20 LDC  AREG LDL  SB            \ 20h nach AREG + laufender Lnge
     AREG LDLP    9 LDC  LEND        \ Zum Schleifenanfang
     THEN
     THEN
     THEN
     THEN
     SP LDL  0C ADC  SP STL          \ Stackanpassung
     NEXT END-CODE

: ROL$  ( ad len n -- )                       \ Im String ad,len  n Bytes
     PAD 300 + SP@ > BOLD                     \ nach links rotieren. Linke
     ABORT" Kein Platz fr Zwischenspeicher"  \ Bytes werden rechts angehngt.
     ATTOFF PAD 200 +                \ Zwischenspeicher bei PAD+200h
     ASM[
     SP LDL  0 LDNL  FREG STL        \ Adresse des Zwischenspeichers
     SP LDL  4 ADC     SP STL        \ Stackzwischenanpassung
     SP LDL  0 LDNL  EREG STL        \ n nach EREG
     EREG LDL  0>                    \ berspringen, wenn   n  0
     2IF
     SP LDL  1 LDNL  BREG STL        \ zunchst len nach BREG
     BREG LDL  0>                    \ berspringen, wenn len = 0
     2IF
     BREG LDL  EREG LDL  <=          \ wenn n  len,
     1IF
     BREG LDL  EREG STL              \ dann n = len
     THEN
     BREG LDL  EREG LDL  DIFF        \ len - n
     BREG STL                        \ als Verschiebungslnge nach BREG
     BREG LDL  0>                    \ berspringen, wenn = 0
     2IF
     SP LDL  2 LDNL  EREG LDL  SUM   \ Quelladresse
                     AREG STL        \ nach AREG
     SP LDL  2 LDNL  CREG STL        \ Zieladresse nach CREG
     CREG LDL  AREG LDL  <>          \ berspringen, wenn Ziel = Quelle
     2IF
     CREG LDL  FREG LDL  EREG LDL    \ Linke Bytes
     MOVE                            \ zwischenspeichern
     AREG LDL  LB  CREG LDL  SB      \ Von laufender Quelle nach lauf. Ziel
     CREG LDL   1 ADC  CREG STL      \ Zieladresse um 1 erhhen
     AREG LDLP  0C LDC  LEND         \ An Schleifenanfang
     FREG LDL                        \ Adresse des Zwischenspeichers
       SP LDL   2 LDNL               \ Stringanfang
       SP LDL   1 LDNL  SUM          \ + Stringlnge
     EREG LDL   DIFF   EREG LDL      \ - "n" mit Lnge "n"
     MOVE                            \ verschieben ( linke Bytes nach rechts )
     THEN
     THEN
     THEN
     THEN
     SP LDL  0C ADC  SP STL          \ Endgltige Stackanpassung
     NEXT
     ]FORTH ;

CODE SHR$  ( ad len n -- )           \ Im String ad,len  n Bytes nach rechts
     SP LDL  0 LDNL  EREG STL        \ n nach EREG
     EREG LDL  0>                    \ berspringen, wenn   n  0
     2IF
     SP LDL  1 LDNL  BREG STL        \ zunchst len nach BREG
     BREG LDL  0>                    \ berspringen, wenn len = 0
     2IF
     BREG LDL  EREG LDL  <=          \ wenn n  len,
     1IF
     BREG LDL  EREG STL              \ dann n = len
     THEN
     BREG LDL  EREG LDL  DIFF        \ len - n
     BREG STL                        \ als Verschiebungslnge nach BREG
     BREG LDL  0>                    \ berspringen, wenn = 0
     2IF
     SP LDL  2 LDNL   -1 ADC         \ Quelladresse-1
     DREG STL                        \ nach DREG
     DREG LDL  EREG LDL  SUM         \ Zieladresse-1
     CREG STL                        \ nach CREG
     CREG LDL  DREG LDL  <>          \ berspringen, wenn Ziel = Quelle
     2IF
     DREG LDL  BREG LDL  ADD  LB     \ Von Quelle + laufende Lnge
     CREG LDL  BREG LDL  ADD  SB     \ nach  Ziel + laufende Lnge
     AREG LDLP   0D LDC  LEND        \ AREG = Dummy; Kontrollstruktur-Beginn
     EREG LDL        BREG STL        \ Lnge fr "FILL" mit 20h nach BREG
     SP LDL  2 LDNL  AREG STL        \ Quelladresse nach AREG
     20 LDC  AREG LDL  SB            \ 20h nach Ziel + laufender Lnge
     AREG LDLP    9 LDC  LEND        \ Zum Schleifenanfang
     THEN
     THEN
     THEN
     THEN
     SP LDL  0C ADC  SP STL          \ Stackanpassung
     NEXT END-CODE

: ROR$  ( ad len n -- )                       \ Im String ad,len  n Bytes
     PAD 300 + SP@ > BOLD                     \ nach rechts rotieren. Rechte
     ABORT" Kein Platz fr Zwischenspeicher"  \ Bytes werden links angehngt.
     ATTOFF PAD 200 +                \ Zwischenspeicher bei PAD+200h
     ASM[
     SP LDL  0 LDNL  FREG STL        \ Adresse des Zwischenspeichers
     SP LDL  4 ADC     SP STL        \ Stackzwischenanpassung
     SP LDL  0 LDNL  EREG STL        \ n nach EREG
     EREG LDL  0>                    \ berspringen, wenn   n  0
     2IF
     SP LDL  1 LDNL  BREG STL        \ zunchst len nach BREG
     BREG LDL  0>                    \ berspringen, wenn len = 0
     2IF
     BREG LDL  EREG LDL  <=          \ wenn n  len,
     1IF
     BREG LDL  EREG STL              \ dann n = len
     THEN
     BREG LDL  EREG LDL  DIFF        \ len - n
     BREG STL                        \ als Verschiebungslnge nach BREG
     BREG LDL  0>                    \ berspringen, wenn = 0
     2IF
     SP LDL  2 LDNL   -1 ADC         \ Quelladresse-1
     DREG STL                        \ nach DREG
     DREG LDL  EREG LDL  SUM         \ Zieladresse-1
     CREG STL                        \ nach CREG
     CREG LDL  DREG LDL  <>          \ berspringen, wenn Ziel = Quelle
     2IF
       SP LDL   2 LDNL               \ Von Stringanfang
       SP LDL   1 LDNL  SUM          \ + Stringlnge
     EREG LDL   DIFF                 \ - "n"
     FREG LDL                        \ nach Adresse des Zwischenspeichers
     EREG LDL                        \ "n" Bytes
     MOVE                            \ verschieben ( rechte Bytes )
     DREG LDL  BREG LDL  ADD  LB     \ Von Quelle + laufende Lnge
     CREG LDL  BREG LDL  ADD  SB     \ nach  Ziel + laufende Lnge
     AREG LDLP   0D LDC  LEND        \ AREG = Dummy; Kontrollstruktur-Beginn
     FREG LDL                        \ Von Adresse des Zwischenspeichers
       SP LDL   2 LDNL   EREG LDL    \ nach Stringanfang "n" Bytes
     MOVE                            \ verschieben ( rechte Bytes nach links )
     THEN
     THEN
     THEN
     THEN
     SP LDL  0C ADC  SP STL          \ Endgltige Stackanpassung
     NEXT
     ]FORTH ;


CR .( Tastaturabfrage ohne Warten )
HEX

CODE WHICHKEY? ( -- cc )
     MINT         2D LDC   OUTBYTE   \ Transfer-Code
     MINT          0 LDC   OUTBYTE   \ Message-Lnge
     SP LDL -4 ADC SP STL            \ TStack anpassen
      0 LDC SP LDL 0 STNL            \ zunchst alles = 0
     SP LDL                          \ Doppelbyte cc
     MINT  10 ADC  2 LDC   IN        \ von Link zu TStack
     NEXT END-CODE
     \ hnlich wie  KEY? ,  jedoch mit Ausgabe des erweiterten Codes.
     \ Wenn kein Zeichen im Tastaturpuffer liegt, wird der Wert 0 auf
     \ den Stack gelegt.  Andernfalls wird der Scancode  als Highbyte
     \ und der ASCII-Code als Lowbyte auf den Stack gelegt.  Das Zei-
     \ chen verbleibt dann jedoch weiterhin auch noch im Tastaturpuf-
     \ fer.


CR .( Tastaturpuffer-Erweiterungen )
HEX

CODE KBUF! ( cc -- )                 \ Zeichen c in den Tastaturpuffer
     MINT         2C LDC   OUTBYTE   \ Transfer-Code
     MINT          2 LDC   OUTBYTE   \ Message-Lnge
     SP LDL       MINT   2 LDC OUT   \ Doppelbyte cc vom Stack zum Link
     SP LDL 4 ADC SP STL             \ Stack anpassen
     NEXT END-CODE

\ : KBUF!  ( c -- ) 2C SWAP OUTBYTE ;    \ ASCII-Code c in den Tastaturpuffer

\ : FKBUF! ( c -- ) 2D SWAP OUTBYTE ;    \ Funktionscode c in den Tastaturpuffer

: KBUF$! ( ad cnt -- )               \ String in den Tastaturpuffer
     40 82 @-H 40 80 @-H - 2/        \ Eingabestring lnger
     OVER <=                         \ als 15, bzw. 127 Byte ?
     ABORT" Eingabestring zu lang ! Puffer per KBUF128 [RET] erweitert ?"
     BOUNDS                          \ Grenzen fr DO
     DO I C@ DUP                     \ Nchstes Zeichen testen
        ASCII % = IF DROP 0D THEN    \ Wenn %, dann in 0Dh wandeln
        100 +                        \ Zu Nichtfunktionscode ergnzen
        KBUF!                        \ und in den Tastaturpuffer
     LOOP ;

: KBUF128 ( -- )                     \ Tastaturpuffer auf 128 Zeichen
     " KBUF128" $EXECUTE-HOST ;      \ ab 0060:0000 erhhen

: KBUF16 ( -- )                      \ Tastaturpuffer wieder auf 16
     " KBUF16"  $EXECUTE-HOST ;      \ Zeichen ab 0040:001E


CR .( BIOS-Daten aus Segment 40h abfragen )
ONLY FORTH ALSO DEFINITIONS
HEX

: KEYSTAT1@ ( -- c )     \ Kontrolltasten-Status 1 holen
     40 17 C@-H ;        \ Bedeutung der Bits siehe KEYSTAT1?
: KEYSTAT1? ( c -- fl )  \ Kontrolltasten-Status 1 berprfen
     KEYSTAT1@ = ;       \ 128 Insert      aktiv (toggle)
                         \  64 Shift-Lock  aktiv (toggle)
                         \  32 Num-Lock    aktiv (toggle)
                         \  16 Scroll-Lock aktiv (toggle)
                         \   8 Alt         gedrckt
                         \   4 Ctrl        gedrckt
                         \   2 Shift-left  gedrckt
                         \   1 Shift-right gedrckt
: KEYSTAT2@ ( -- c )     \ Kontrolltasten-Status 2 holen
     40 18 C@-H ;        \ Bedeutung der Bits siehe KEYSTAT2?
: KEYSTAT2? ( c -- fl )  \ Kontrolltasten-Status 2 berprfen
     KEYSTAT2@ = ;       \ 128 Insert      gedrckt
                         \  64 Shift-Lock  gedrckt
                         \  32 Num-Lock    gedrckt
                         \  16 Scroll-Lock gedrckt
                         \   8 Pause       aktiv
                         \                 ( zurckgesetzt durch andere Taste )
                         \   4 Sys-Request gedrckt
                         \   2 Alt-left    gedrckt
                         \   1 Ctrl-left   gedrckt
: KEYSTAT3@ ( -- c )     \ Keyb/ard-Flags holen
     40 96 C@-H ;        \ Bedeutung der Bits siehe KEYSTAT3?
: KEYSTAT3? ( c -- fl )  \ Keyboard-Flags berprfen
     KEYSTAT3@ = ;       \ 128 ID-Lesevorgang ist im Gang
                         \  64 Erstes ID-Zeichen empfangen
                         \  32 Schaltet auf Num-Lock, falls ID-Lesen und KBX
                         \  16 MF101/102-Tastatur
                         \   8 Rechte Alt-Taste gedrckt
                         \   4 Rechte Ctrl-Taste gedrckt
                         \   2 Letzter Code war erweiterter Scancode E0h
                         \   1 Letzter Code war erweiterter Scancode E1h
: KEYSTAT4@ ( -- c )     \ Keyboard-LED-Flags holen
     40 97 C@-H ;        \ Bedeutung der Bits siehe KEYSTAT4?
: KEYSTAT4? ( c -- fl )  \ Keyboard LED-Flags berprfen
     KEYSTAT4@ = ;       \ 128 Fehler bei der Tastaturbertragung
                         \  64 Mode-Indicator update. Ist gesetzt, solange
                         \     der LED-Setz-/Lschvorgang luft
                         \  32 Resend-Byte (FEh) erhalten: Aufforderung,
                         \     das zuletzt gesendete Byte zu wiederholen
                         \  16 Acknowledge-Byte (FAh) erhalten
                         \   8 Reserviert
                         \   4 LED-Caps-Lock   eingeschaltet
                         \   2 LED-Num-Lock    eingeschaltet
                         \   1 LED-Scroll-Lock eingeschaltet


CR .( Routinen fr die schrittweise Verarbeitung von High-Level-Worten )
ONLY FORTH ALSO DEFINITIONS
VOCABULARY BUG   BUG ALSO DEFINITIONS
VARIABLE 'DEBUG  \ Codefeld von TRACE bei schrittweiser Verarbeitung
VARIABLE IP>     \ Obere Grenze von IP
VARIABLE CNT     \ Zahl der Durchlufe fr NEXT

ASSEMBLER
HEX
LABEL DNEXT      \ Debugger-Ausgabe des normalen >NEXT
     IP LDL  0 LDNL  W STL  IP LDL  4 ADC  IP STL  W LDL  0 LDNL  GCALL
LABEL DEBNEXT
        <IP OFFSET LDL  IP LDL  U<
        IF  IP> OFFSET LDL  IP LDL  U>=
          IF  CNT OFFSET LDL  1 ADC  CNT OFFSET STL
              CNT OFFSET LDL  2 LDC  =
            IF  0 LDC  CNT OFFSET STL
               DNEXT LDC  NEXTP LDL  9 LDC  MOVE
               SP LDL -4 ADC  SP STL
               IP LDL  SP LDL  0 STNL
               'DEBUG OFFSET LDL  W STL   W LDL  0 LDNL  GCALL
            THEN
          THEN
        THEN    DNEXT LDC  GCALL
LABEL (PNEXT) DEBNEXT LDC  GCALL END-CODE
CODE PNEXT ( -- )    \ Sprung nach DEBNEXT ins normale >NEXT patchen
     (PNEXT) LDC  NEXTP LDL  9 LDC  MOVE  NEXT END-CODE
FORTH DEFINITIONS
CODE UNBUG ( -- ) DNEXT LDC  NEXTP LDL  9 LDC  MOVE  NEXT END-CODE


HEX
CR .( I/O-Ports des 80x86 lesen und beschreiben )
ONLY FORTH ALSO DEFINITIONS
CODE PC@ ( port# -- b )
      MINT    21 LDC  OUTBYTE           \ Transfer-Code zum Link
      MINT     2 LDC  OUTBYTE           \ Message-Lnge
      SP LDL  MINT    2 LDC        OUT  \ port# von Stack zu Link
       0 LDC  SP LDL  0 STNL            \ Byteblende
      SP LDL  MINT   10 ADC  1 LDC  IN  \ Byte b von Link auf Stack
      NEXT END-CODE
CODE P@ ( port# -- bb )
      MINT    22 LDC  OUTBYTE           \ Transfer-Code zum Link
      MINT     2 LDC  OUTBYTE           \ Message-Lnge
      SP LDL  MINT    2 LDC        OUT  \ port# von Stack zu Link
       0 LDC  SP LDL  0 STNL            \ Doppelbyteblende
      SP LDL  MINT   10 ADC  2 LDC  IN  \ Doppelbyte bb von Link auf Stack
      NEXT END-CODE
CODE PC! ( b port# -- )
      MINT   23 LDC  OUTBYTE            \ Transfer-Code zum Link
      MINT    3 LDC  OUTBYTE            \ Message-Lnge
      SP LDL  4 ADC  MINT  1 LDC  OUT   \ Byte b von Stack zu Link
      SP LDL         MINT  2 LDC  OUT   \ port# von Stack zu Link
      SP LDL  8 ADC  SP STL  NEXT END-CODE
CODE P! ( bb port# -- )
      MINT   24 LDC  OUTBYTE            \ Transfer-Code zum Link
      MINT    4 LDC  OUTBYTE            \ Message-Lnge
      SP LDL  4 ADC  MINT  2 LDC  OUT   \ Doppelbyte bb von Stack zu Link
      SP LDL         MINT  2 LDC  OUT   \ port# von Stack zu Link
      SP LDL  8 ADC  SP STL  NEXT END-CODE

CR .( Hilfsprogramme )
FORTH ALSO ROOT DEFINITIONS
: WORDS WORDS ;
FORTH DEFINITIONS
: WHEN ( f -- )  \ wiederholt Ausfhrung des vorhergehenden Wortes bis f= TRUE
     PAUSE NOT IF R> 8 - >R THEN ;
     \ Beispiel:
     \ : WEITER? ( -- f )
     \      CR ." Weiter: Taste 0 drcken !"
     \      KEY ASCII 0 = ;
     \ : TEST WEITER? WHEN BEEP ;
: ::   ( -- )   \ Sofortige Ausfhrung einer Colondefinition und dann Lschung
     HIDE HERE >R [ ' : @ ] LITERAL , !CSP ] R@ EXECUTE R> DP ! ;

CR .( Disassembler )
HEX
ONLY FORTH ALSO DEFINITIONS
: CASE:  ( n -- )
     CONSTANT  HIDE  ]
     DOES> ( #subscript -- )  \ fhrt das nte Wort aus
     2DUP @ U<
     IF 4+ SWAP 4* +
     ELSE CR
          ." Der Mehrfach-Auswahl-Vektor "
          DUP BODY> >NAME .ID
          ." erlaubt als Index [ 0 - " @ 1- . ." ]"
          CR . TRUE ABORT" berschreitet den Bereich"
     THEN PERFORM ;
\ ASSOCIATIVE: <wort>
\ <wort> = Wort, unter dem die umgekehrte Suchtabelle definiert wurde
: ASSOCIATIVE: ( n -- ) \ Suchen in umgekehrter Tabelle mit n Eingngen
     CONSTANT
     DOES>  ( Wert -- Index )
     DUP @ -ROT DUP @ 0
     DO   4+ 2DUP @ = ( in der Tabelle gefunden ? )
          IF 2DROP DROP I 0 0 LEAVE THEN
          ( liefert den Index des Wertes in der Tabelle )
     LOOP 2DROP ;
          ( liefert +1 zurck, wenn der Wert nicht in der Tabelle ist )

VOCABULARY DISASSEMBLER
DISASSEMBLER DEFINITIONS

VARIABLE SAVEBASE
VARIABLE AD             \ Laufende Adresse
VARIABLE ADBEG          \ Beginn
VARIABLE ADEND          \ Ende
VARIABLE BYTE           \ Byte, das gerade bearbeitet wird
VARIABLE BYTEPOS        \ Momentane Position zur Anzeige von BYTE
VARIABLE ASCIIPOS       \ Momentane Position zur Anzeige von BYTE in ASCII
VARIABLE OREG           \ Zum Sammeln der Operanden-Nibbles
VARIABLE ?DONE          \ Befehl fertig, neue Adresse ?
VARIABLE ?FPENTRY       \ Befehl mit 3 oder 4 Bytes ?
VARIABLE ?AB            \ Select1 mit Abbruch (=TRUE) oder ohne (=FALSE) ?

HEX
: BYTEASCIIPOS! ( -- ) 21 BYTEPOS ! 40 ASCIIPOS ! ;

CR .( Indizes der { auf WPTR bezogenen } "lokalen Variablen" )
HEX
ONLY FORTH ALSO ASSEMBLER ALSO DISASSEMBLER ALSO DEFINITIONS
12 ASSOCIATIVE: LOCAL
     ( 0 ) IP     ,  (  1 ) W      ,  (  2 ) RP      ,
     ( 3 ) SP     ,  (  4 ) AREG   ,  (  5 ) BREG    ,
     ( 6 ) CREG   ,  (  7 ) DREG   ,  (  8 ) EREG    ,
     ( 9 ) FREG   ,  (  A ) GREG   ,  (  B ) HREG    ,
     ( C ) BPUSHP ,  (  D ) CPUSHP ,  (  E ) NEXTP   ,
     ( F ) COLDP  ,  ( 10 ) WARMP  ,  ( 11 ) DODOESP ,
ONLY FORTH ALSO DISASSEMBLER ALSO DEFINITIONS
: ATCOL ( n -- )        \ Setze Cursor auf Spalte n
    (CURSOR) NIP AT ;
: INCAD ( -- )          \ Inhalt nach BYTE und Adresse um 1 weiter
     AD @ C@ BYTE ! AD 1+! ;
: .AD   ( -- )          \ Adresse anzeigen, Inhalt nach BYTE, Adr:=Adr+1
     CR AD @ S>D <# # # # # # # # # #> TYPE INCAD ;
: .ASCII ( -- )         \ BYTE als ASCII-Wert anzeigen
     BYTE @ [ FORTH ] ?ASCII [ DISASSEMBLER ] EMIT ;
: .BYTE ( -- )          \ Zeige Byte an momentaner Position an
     BYTEPOS  @ ATCOL BYTE @ S>D <# # # #> TYPE
     ASCIIPOS @ ATCOL .ASCII
     3 BYTEPOS +!  ASCIIPOS 1+!
     ASCIIPOS @ 48 > IF CR 40 ASCIIPOS ! THEN ;
: SPLIT ( -- opr opc ) \ Trennung von opr- und opc-Nibble in Byte c aus BYTE
     BYTE @ 0F AND BYTE @ 0F0 AND U16/ ;
: .PFIX ( c -- )         \ Nibble im pfix-Sinn an OPERAND hngen
     0F AND OREG @ 16* 0FFFFFFF0 AND OR     OREG ! ;
: .NFIX ( c -- )         \ Nibble im nfix-Sinn an OPERAND hngen
     0F AND OREG @ 16* 0FFFFFFF0 AND OR NOT OREG ! ;
: .SELF  ( -- )  \ Wort erzeugen, das seinen eigenen Namen anzeigt
     CREATE LAST @ , DOES> @ .ID ;
: .OREG ( c -- oreg ) \ Operanden anzeigen
     .PFIX 0A ATCOL OREG @ 8 U.R SPACE OREG @
     OREG OFF ?FPENTRY OFF ?DONE ON BYTEASCIIPOS! ;
: .J    ( c -- )
     .PFIX AD @ OREG +!
           0A ATCOL OREG @ 8 U.R SPACE
     OREG OFF ?FPENTRY OFF ?DONE ON BYTEASCIIPOS! ;

CR .( Lokale Variablen )
.SELF IP       .SELF W       .SELF RP       .SELF SP
.SELF AREG     .SELF BREG    .SELF CREG     .SELF DREG     .SELF EREG
.SELF FREG     .SELF GREG    .SELF HREG     .SELF BPUSHP   .SELF CPUSHP
.SELF NEXTP    .SELF COLDP   .SELF WARMP    .SELF DODOESP

CR .( 1-Byte-Befehle mit Operand )
.SELF ???
.SELF J        .SELF LDLP    .SELF PFIX     .SELF LDNL     .SELF LDC
.SELF LDNLP    .SELF NFIX    .SELF LDL      .SELF ADC      .SELF CALL
.SELF CJ       .SELF AJW     .SELF EQC      .SELF STL      .SELF STNL
.SELF OPR

CR .( 1-Byte-Befehle ohne Operand )
.SELF REV      .SELF LB      .SELF BSUB     .SELF ENDP     .SELF DIFF
.SELF ADD      .SELF GCALL   .SELF IN       .SELF PROD     .SELF GT
.SELF WSUB     .SELF OUT     .SELF SUB      .SELF STARTP   .SELF OUTBYTE
.SELF OUTWORD

CR .( 2-Byte-Befehle )
.SELF SETERR   .SELF RESETCH .SELF CSUB0                   .SELF STOPP
.SELF LADD     .SELF STLB    .SELF STHF     .SELF NORM     .SELF LDIV
.SELF LDPI     .SELF STLF    .SELF XDBLE    .SELF LDPRI    .SELF REM
.SELF RET      .SELF LEND    .SELF LDTIMER  .SELF TESTERR  .SELF TESTPRANAL
.SELF TIN      .SELF DIV     .SELF DIST     .SELF DISC     .SELF DISS
.SELF LMUL     .SELF NOT     .SELF XOR      .SELF BCNT     .SELF LSHR
.SELF LSHL     .SELF LSUM    .SELF LSUB     .SELF RUNP     .SELF XWORD
.SELF SB       .SELF GAJW    .SELF SAVEL    .SELF SAVEH    .SELF WCNT
.SELF SHR      .SELF SHL     .SELF MINT     .SELF ALT      .SELF ALTWT
.SELF ALTEND   .SELF AND     .SELF ENBT     .SELF ENBC     .SELF ENBS
.SELF MOVE     .SELF OR      .SELF CSNGL    .SELF CCNT1    .SELF TALT
.SELF LDIFF    .SELF STHB    .SELF TALTWT   .SELF SUM      .SELF MUL
.SELF STTIMER      .SELF STOPERR       .SELF CWORD         .SELF CLRHALTERR
.SELF SETHALTERR   .SELF TESTHALTERR   .SELF DUP           .SELF MOVE2DINIT
.SELF MOVE2DALL    .SELF MOVE2DNONZERO .SELF MOVE2DZERO    .SELF UNPACKSN
.SELF POSTNORMSN   .SELF ROUNDSN       .SELF LDINF         .SELF FMUL
.SELF CFLERR       .SELF CRCWORD       .SELF CRCBYTE       .SELF BITCNT
.SELF BITREVWORD   .SELF BITREVNBITS   .SELF WSUBDB        .SELF FPLDNLDBI
.SELF FPCHKERR     .SELF FPSTNLDB      .SELF FPLDNLSNI     .SELF FPADD
.SELF FPSTNLSN     .SELF FPSUB         .SELF FPLDNLDB      .SELF FPMUL
.SELF FPDIV        .SELF FPLDNLSN      .SELF FPREMFIRST    .SELF FPREMSTEP
.SELF FPNAN        .SELF FPORDERED     .SELF FPNOTFINITE   .SELF FPGT
.SELF FPEQ         .SELF FPI32TOR32    .SELF FPI32TOR64    .SELF FPB32TOR64
.SELF FPTESTERR    .SELF FPRTOI32      .SELF FPSTNLI32     .SELF FPLDZEROSN
.SELF FPLDZERODB   .SELF FPINT         .SELF FPDUP
.SELF FPREV        .SELF FPLDNLADDDB   .SELF FPLDNLMULDB
.SELF FPLDNLADDSN  .SELF FPENTRY       .SELF FPLDNLMULSN

CR .( Befehle, die nur im Buch von Reinecke/Schreiner dokumentiert sind )
.SELF TESTLDS      .SELF TESTLDE       .SELF TESTLDD       .SELF TESTSTS
.SELF TESTSTE      .SELF TESTSTD       .SELF TESTHARDCHAN  .SELF START

CR .( 3-Byte-Befehle )
.SELF FPUSQRTFIRST .SELF FPUSQRTSTEP   .SELF FPUSQRTLAST
.SELF FPURP        .SELF FPURM         .SELF FPURZ
.SELF FPUR32TOR64  .SELF FPUR64TOR32   .SELF FPUEXPDEC32
.SELF FPUEXPINC32  .SELF FPUABS        .SELF FPUNOROUND
.SELF FPUCHKI32    .SELF FPUCHKI64

CR .( 4-Byte-Befehle )
.SELF FPUDIVBY2    .SELF FPUMULBY2     .SELF FPURN
.SELF FPUSETERR    .SELF FPUCLRERR

12 CASE: (LOCAL)
(  0 ) IP          (  1 ) W             (  2 ) RP          (  3 ) SP
(  4 ) AREG        (  5 ) BREG          (  6 ) CREG        (  7 ) DREG
(  8 ) EREG        (  9 ) FREG          (  A ) GREG        (  B ) HREG
(  C ) BPUSHP      (  D ) CPUSHP        (  E ) NEXTP       (  F ) COLDP
( 10 ) WARMP       ( 11 ) DODOESP ;

0AD CASE: (OPR)
(  0 ) REV         (  1 ) LB            (  2 ) BSUB        (  3 ) ENDP
(  4 ) DIFF        (  5 ) ADD           (  6 ) GCALL       (  7 ) IN
(  8 ) PROD        (  9 ) GT            (  A ) WSUB        (  B ) OUT
(  C ) SUB         (  D ) STARTP        (  E ) OUTBYTE     (  F ) OUTWORD
( 10 ) SETERR      ( 11 ) ???           ( 12 ) RESETCH     ( 13 ) CSUB0
( 14 ) ???         ( 15 ) STOPP         ( 16 ) LADD        ( 17 ) STLB
( 18 ) STHF        ( 19 ) NORM          ( 1A ) LDIV        ( 1B ) LDPI
( 1C ) STLF        ( 1D ) XDBLE         ( 1E ) LDPRI       ( 1F ) REM
( 20 ) RET         ( 21 ) LEND          ( 22 ) LDTIMER     ( 23 ) TESTLDS
( 24 ) TESTLDE     ( 25 ) TESTLDD       ( 26 ) TESTSTS     ( 27 ) TESTSTE
( 28 ) TESTSTD     ( 29 ) TESTERR       ( 2A ) TESTPRANAL  ( 2B ) TIN
( 2C ) DIV         ( 2D ) TESTHARDCHAN  ( 2E ) DIST        ( 2F ) DISC
( 30 ) DISS        ( 31 ) LMUL          ( 32 ) NOT         ( 33 ) XOR
( 34 ) BCNT        ( 35 ) LSHR          ( 36 ) LSHL        ( 37 ) LSUM
( 38 ) LSUB        ( 39 ) RUNP          ( 3A ) XWORD       ( 3B ) SB
( 3C ) GAJW        ( 3D ) SAVEL         ( 3E ) SAVEH       ( 3F ) WCNT
( 40 ) SHR         ( 41 ) SHL           ( 42 ) MINT        ( 43 ) ALT
( 44 ) ALTWT       ( 45 ) ALTEND        ( 46 ) AND         ( 47 ) ENBT
( 48 ) ENBC        ( 49 ) ENBS          ( 4A ) MOVE        ( 4B ) OR
( 4C ) CSNGL       ( 4D ) CCNT1         ( 4E ) TALT        ( 4F ) LDIFF
( 50 ) STHB        ( 51 ) TALTWT        ( 52 ) SUM         ( 53 ) MUL
( 54 ) STTIMER     ( 55 ) STOPERR       ( 56 ) CWORD       ( 57 ) CLRHALTERR
( 58 ) SETHALTERR  ( 59 ) TESTHALTERR   ( 5A ) DUP         ( 5B ) MOVE2DINIT
( 5C ) MOVE2DALL   ( 5D ) MOVE2DNONZERO ( 5E ) MOVE2DZERO  ( 5F ) ???
( 60 ) ???         ( 61 ) ???           ( 62 ) ???         ( 63 ) ???
( 64 ) ???         ( 65 ) ???           ( 66 ) ???         ( 67 ) ???
( 68 ) ???         ( 69 ) ???           ( 6A ) ???         ( 6B ) ???
( 6C ) ???         ( 6D ) ???           ( 6E ) ???         ( 6F ) ???
( 70 ) ???         ( 71 ) ???           ( 72 ) FMUL        ( 73 ) ???
( 74 ) CRCWORD     ( 75 ) CRCBYTE       ( 76 ) BITCNT      ( 77 ) BITREVWORD
( 78 ) BITREVNBITS ( 79 ) ???           ( 7A ) ???         ( 7B ) ???
( 7C ) ???         ( 7D ) ???           ( 7E ) ???         ( 7F ) ???
( 80 ) ???         ( 81 ) WSUBDB        ( 82 ) FPLDNLDBI   ( 83 ) FPCHKERR
( 84 ) FPSTNLDB    ( 85 ) ???           ( 86 ) FPLDNLSNI   ( 87 ) FPADD
( 88 ) FPSTNLSN    ( 89 ) FPSUB         ( 8A ) FPLDNLDB    ( 8B ) FPMUL
( 8C ) FPDIV       ( 8D ) ???           ( 8E ) FPLDNLSN    ( 8F ) FPREMFIRST
( 90 ) FPREMSTEP   ( 91 ) FPNAN         ( 92 ) FPORDERED   ( 93 ) FPNOTFINITE
( 94 ) FPGT        ( 95 ) FPEQ          ( 96 ) FPI32TOR32  ( 97 ) ???
( 98 ) FPI32TOR64  ( 99 ) ???           ( 9A ) FPB32TOR64  ( 9B ) ???
( 9C ) FPTESTERR   ( 9D ) FPRTOI32      ( 9E ) FPSTNLI32   ( 9F ) FPLDZEROSN
( A0 ) FPLDZERODB  ( A1 ) FPINT         ( A2 ) ???         ( A3 ) FPDUP
( A4 ) FPREV       ( A5 ) ???           ( A6 ) FPLDNLADDDB ( A7 ) ???
( A8 ) FPLDNLMULDB ( A9 ) ???           ( AA ) FPLDNLADDSN ( AB ) FPENTRY
( AC ) FPLDNLMULSN ;

14 CASE: (FPENTRY)
(  0 ) ???
(  1 ) FPUSQRTFIRST  (  2 ) FPUSQRTSTEP  (  3 ) FPUSQRTLAST  (  4 ) FPURP
(  5 ) FPURM         (  6 ) FPURZ        (  7 ) FPUR32TOR64  (  8 ) FPUR64TOR32
(  9 ) FPUEXPDEC32   (  A ) FPUEXPINC32  (  B ) FPUABS       (  C ) ???
(  D ) FPUNOROUND    (  E ) FPUCHKI32    (  F ) FPUCHKI64    ( 10 ) ???
( 11 ) FPUDIVBY2     ( 12 ) FPUMULBY2    ( 13 ) ??? ;

: .FPENTRY ( -- )
     ?FPENTRY @ 22 = IF FPURN     ELSE
     ?FPENTRY @ 23 = IF FPUSETERR ELSE
     ?FPENTRY @ 9C = IF FPUCLRERR ELSE
     ?FPENTRY @ (FPENTRY) THEN THEN THEN
     OREG OFF ?FPENTRY OFF ?DONE ON BYTEASCIIPOS! ;
: .LDC    ( c -- )
     AD @ CC@ 0FB2A =
     IF   .PFIX
          INCAD .BYTE INCAD .BYTE    \ FB2A berspringen
          OREG @ ?FPENTRY ! OREG OFF \ xy von 2x4y nach ?FPENTRY
          13 ATCOL .FPENTRY          \ 4-Byte-Befehl anzeigen
     ELSE 0A ATCOL .OREG DROP LDC    \ " opr ldc " anzeigen
     THEN ?FPENTRY OFF ;
: .OPR    ( c -- )
     .PFIX
     13 ATCOL OREG @ [ FORTH ] DUP [ DISASSEMBLER ]
     0 0AC BETWEEN IF (OPR) ELSE DROP ??? THEN
     OREG OFF ?FPENTRY OFF ?DONE ON BYTEASCIIPOS! ;
: .START   ( -- )
     .AD .BYTE INCAD .BYTE INCAD .BYTE
     OREG OFF ?FPENTRY OFF ?DONE ON
     13 ATCOL START BYTEASCIIPOS! ;
: .LOCAL ( c -- )
     .OREG LOCAL [ FORTH ] DUP [ DISASSEMBLER ] 0 11 BETWEEN
     IF 0A ATCOL (LOCAL) ELSE DROP THEN 13 ATCOL ;

: SELECT1 ( ad1 ad2 -- )
     ADEND ! [ FORTH ] DUP [ DISASSEMBLER ] ADBEG ! AD !
     BASE @ SAVEBASE ! HEX ?AB @
     IF ?DONE ON ?FPENTRY OFF OREG OFF THEN
     BYTEASCIIPOS!
     BEGIN
     ?DONE @ AD @ 2+ ADEND @ < [ FORTH ] AND [ DISASSEMBLER ]
     IF   AD @ W@ 0FFFFFF [ FORTH ] AND [ DISASSEMBLER ] 0FF2F21 =
          IF 10 ELSE BYTEASCIIPOS! .AD .BYTE SPLIT THEN
     ELSE
       AD @ ADEND @ <=
       IF   BYTEASCIIPOS! .AD .BYTE SPLIT
       ELSE ?AB @
            IF  EXIT ELSE 11 THEN
       THEN
     THEN
     CASE
        0 OF .J     J           ENDOF
        1 OF .LOCAL LDLP        ENDOF
        2 OF .PFIX              ENDOF
        3 OF .OREG  DROP LDNL   ENDOF
        4 OF .LDC               ENDOF
        5 OF .OREG  DROP LDNLP  ENDOF
        6 OF .NFIX              ENDOF
        7 OF .LOCAL LDL         ENDOF
        8 OF .OREG  DROP ADC    ENDOF
        9 OF .J     CALL        ENDOF
       0A OF .J     CJ          ENDOF
       0B OF .OREG  DROP AJW    ENDOF
       0C OF .OREG  DROP EQC    ENDOF
       0D OF .LOCAL STL         ENDOF
       0E OF .OREG  DROP STNL   ENDOF
       0F OF .OPR               ENDOF
       10 OF .START             ENDOF
       11 OF NOOP               ENDOF
     ENDCASE
     STOP? AD @ ADEND @ >= ?DONE @
     [ FORTH ] AND OR
     UNTIL
     [ DISASSEMBLER ] SAVEBASE @ [ FORTH ] BASE ! ;

ONLY FORTH ALSO DEFINITIONS

: DIS ( ad1 ad2 -- )   \ Disassembler, ad1 = Anfang, ad2 = Ende
     BEGIN
     [ DISASSEMBLER ] ?AB OFF SELECT1 [ FORTH ]
     BOLD (CURSOR) -1 0 (FRAME) CR ." Weiter: +   Zurck: -   Exit: RET"
     DROP (CURSOR) NIP 1- ATTOFF AT
     KEY (CURSOR) CR 26 SPACES AT DUP ASCII + =
     IF   DROP [ DISASSEMBLER ] AD [ FORTH ] @ DUP 14 + FALSE
     ELSE ASCII - =
          IF   [ DISASSEMBLER ] ADBEG    [ FORTH ] @ DUP 14 - SWAP DARK FALSE
          ELSE [ DISASSEMBLER ] SAVEBASE [ FORTH ] @ BASE ! TRUE
          THEN
     THEN
     UNTIL 0C 0D (FRAME) CR ;

CR .( Decompiler: Die einzelnen Worttypen decompilieren )
DECIMAL
ONLY FORTH ALSO DEFINITIONS
DEFER (SEE)

: (C") ( -- ad )          \ Bei ad liegt "counted string"
       R>  DUP COUNT
       + EVEN >R ;

: (S") ( -- ad len )
       R> COUNT 2DUP
       + EVEN >R  ;

\ (C") und (S") sind hier schon ntig. Siehe aber ANS-Worte.

VOCABULARY HIDDEN
HIDDEN DEFINITIONS
VARIABLE 'CFA
VARIABLE ?['] \ Flag zur Einbeziehung von ['] UNNEST
: .POS     ( IP -- IP' )   DUP 'CFA @ - 4/ CR ." n" . 6 ?TAB ;
: .WORD    ( IP -- IP' )   DUP @ ['] ['] = ?['] @ 0= AND
                           IF ?['] ON ELSE ?['] OFF THEN
                           DUP @ >NAME .ID 4+ ;
: .INLINE  ( IP -- IP' )   .WORD   DUP  @  .  4+ ;
: .DINLINE ( IP -- IP' )   .WORD   DUP 2@ D. 8 + ;
: .BRANCH  ( IP -- IP' )   .WORD  DUP @ 'CFA @ - 4/ ." n" . 4+ .POS ;
: .QUOTE   ( IP -- IP' )   .WORD  .WORD ;
: .STRING  ( IP -- IP' )   .WORD     COUNT 2DUP TYPE SPACE + EVEN  .POS ;
: .(;CODE) ( IP -- IP' )   4+ DOES?
                           IF ." DOES> "
                           ELSE
                              8 - .WORD CR
                              ." END-CODE ber + per Hand suchen." CR
                              ." Liegt normalerweise nach:" CR
                              ."           NEXTP  F LDL" CR
                              ."                    GCALL"
                              DUP 14 + DIS 0
                           THEN ;
: .UNNEST  ( IP -- IP' )   ?['] @ 0=
                           IF ." ; " DROP 0 ELSE ?['] OFF .WORD  THEN ;
: .FINISH  ( IP -- IP' )   .WORD  @  H. ." ," 0  ;

CR .( Klassifizierung der einzelnen Worte einer Definition )

17 ASSOCIATIVE: EXECUTION-CLASS
     (  0 ) ' (LIT)   ,   (  1 ) ' ?BRANCH ,   (  2 ) ' BRANCH   ,
     (  3 ) ' (LOOP)  ,   (  4 ) ' (+LOOP) ,   (  5 ) ' (DO)     ,
     (  6 ) ' COMPILE ,   (  7 ) ' (.")    ,   (  8 ) ' (ABORT") ,
     (  9 ) ' (;CODE) ,   ( 10 ) ' UNNEST  ,   ( 11 ) ' (")      ,
     ( 12 ) ' (?DO)   ,   ( 13 ) ' (;USES) ,   ( 14 ) ' (C")     ,
     ( 15 ) ' (S")    ,   ( 16 ) ' (DLIT)  ,

18 CASE: .EXECUTION-CLASS
     (  0 )  .INLINE      (  1 )  .BRANCH      (  2 ) .BRANCH
     (  3 )  .BRANCH      (  4 )  .BRANCH      (  5 ) .BRANCH
     (  6 )  .QUOTE       (  7 )  .STRING      (  8 ) .STRING
     (  9 )  .(;CODE)     ( 10 )  .UNNEST      ( 11 ) .STRING
     ( 12 )  .BRANCH      ( 13 )  .FINISH      ( 14 ) .STRING
     ( 15 )  .STRING      ( 16 )  .DINLINE     ( 17 ) .WORD ;

CR .( Colon-Definition decompilieren )
: .PFA ( cfa -- )
     ?['] OFF               \ Zur Einbeziehung von ['] UNNEST
     DUP 'CFA ! >BODY .POS
     BEGIN #OUT @ 50 > IF .POS THEN
     DUP >R
     R@ @ R@ 12 + = R@ 12 + @ R@ 16 + = AND
     IF
       CR ." ASM[" R@ 16 + R@ 8 + @
       [ DISASSEMBLER ] ?AB ON SELECT1 SAVEBASE [ HIDDEN ] @ BASE !
       CR ." ]FORTH "  DROP R> 8 + @
     ELSE
       R> DROP
     THEN
     DUP @ EXECUTION-CLASS .EXECUTION-CLASS  DUP 0= STOP? OR
     UNTIL DROP ;

CR .( Anzeige der Wortkategorie )
: .CONSTANT  ( cfa -- ) DUP >BODY @ U. ." CONSTANT " >NAME .ID ;
: .VARIABLE  ( cfa -- ) DUP >BODY U. ." VARIABLE " DUP >NAME .ID
     ." , vorzeichenloser Inhalt = " >BODY @ U. ;
: .:     ( cfa -- ) 6 SPACES  ." : " DUP >NAME .ID .PFA ;
: .DOES> ( cfa -- ) ." DOES> " BODY> .PFA ;
: .USER-VARIABLE ( cfa -- ) DUP >BODY @ U.  ." USER-Variable "
     DUP >NAME .ID ." , vorzeichenloser Inhalt = " >IS @ U. ;
: .DEFER ( cfa -- )
     ." ber IS "
     DUP >NAME .ID
     ." vektorisiert nach "
     >IS @ (SEE) ;
: .USER-DEFER ( cfa -- )
     ." USER-definiert; ber IS "
     DUP >NAME .ID
     ." vektorisiert nach "
     >IS @ (SEE) ;
: .2CONSTANT ( cfa -- )
     DUP >BODY 2@ UD. ." 2CONSTANT " >NAME .ID ;
: .2VARIABLE ( cfa -- ) DUP >BODY U. ." 2VARIABLE " DUP >NAME .ID
     ." , vorzeichenloser Inhalt = " >BODY 2@ UD. ;
: .STRING$ ( cfa -- )
     DUP >BODY DUP C@ . ." STRING " SWAP >NAME .ID ."   Inhalt"
     ." : " 1+ COUNT TYPE ;
: .OTHER   ( cfa -- )
     DUP @ DOES?
     IF .DOES> DROP EXIT
     THEN
     DROP                        \ ist das richtig ? - 11.2.96
     DUP ['] (;CODE) OVER @ 4- @ =
     IF
        DUP >NAME .ID
        ." ist hchstwahrscheinlich eine ;CODE-Definition," CR
        ." kann aber auch ;USES-Definition oder von unbekanntem Typ sein." CR
        ." Wenn  ;CODE  oder  ;USES ,  dann auf jeden Fall Maschinencode." CR
        ." END-CODE ber + per Hand suchen." CR
        ." Liegt normalerweise nach:" CR
        ."           NEXTP  F LDL" CR
        ."                    GCALL"
        @ DUP 14 + DIS DROP EXIT
     THEN
     DUP @ OVER >BODY = ( cfa zeigt in Code-Definitionen auf die pfa )
     IF
        DUP >NAME .ID
        ." ist eine CODE-Definition, also in Maschinensprache."  CR
        ." END-CODE ber + per Hand suchen." CR
        ." Liegt normalerweise nach:" CR
        ."           NEXTP  F LDL" CR
        ."                    GCALL"
        >BODY DUP 14 + DIS DROP EXIT
     THEN
        DUP >NAME .ID
        ." ist eine  ;USER-Definition  oder von unbekanntem Typ." CR
        ." Wenn ;USER , dann auf jeden Fall Maschinencode. Dann:" CR
        ." END-CODE ber + per Hand suchen." CR
        ." Liegt normalerweise nach:" CR
        ."           NEXTP  F LDL" CR
        ."                    GCALL"
        @ DUP 14 + DIS DROP EXIT  ;


CR .( Klassifizierung eines Wortes nach der Funktion seiner cfa )

   2VARIABLE FRED ' FRED @   \ Damit kommt der Inhalt der cfa
FORGET FRED                  \ bei 2VARIABLEn  auf den Stack
0. 2CONSTANT FRED ' FRED @   \ Damit kommt der Inhalt der cfa
FORGET FRED                  \ bei 2CONSTANTen auf den Stack
 9 ASSOCIATIVE: DEFINITION-CLASS
     ( 0 )  ' QUIT @ ,   ( 1 )  ' FILES  @ ,
     ( 2 )  ' LAST @ ,   ( 3 )  ' BASE   @ ,   ( 4 )  ' KEY  @ ,
     ( 5 )  ' EMIT @ ,   ( 6 )    ( s.o. ) ,   ( 7 )  ' EXT$ @ ,
     ( 8 )  ( s.o. ) ,
10 CASE: .DEFINITION-CLASS
     ( 0 )  .:           ( 1 )  .CONSTANT
     ( 2 )  .VARIABLE    ( 3 )  .USER-VARIABLE
     ( 4 )  .DEFER       ( 5 )  .USER-DEFER
     ( 6 )  .2CONSTANT   ( 7 )  .STRING$
     ( 8 )  .2VARIABLE   ( 9 )  .OTHER ;

CR .( Decompiler, das Wort SEE )
: ((SEE)) ( cfa -- )
   CR  DUP
   DUP ['] (STR$) =            \ Ausnahmefall
   IF   .2VARIABLE
   ELSE DUP @ DEFINITION-CLASS .DEFINITION-CLASS
   THEN
   >NAME C@ 64 AND IF ." IMMEDIATE" THEN ;
' ((SEE)) IS (SEE)
FORTH DEFINITIONS
: SEE ( -- ) ' (SEE) ;


ONLY FORTH ALSO DEFINITIONS
CR .( Schrittweise Verarbeitung eines High-Level-Wortes anzeigen )
BUG ALSO DEFINITIONS
VARIABLE SLOW
VARIABLE RES
\ Debugger ein- und ausschalten
: TRACE   ( IP - )
   >R .S R>  CR @ >NAME 10 SWAP DUP .ID  DUP NAME> 1- - + SPACES
   SLOW @ NOT KEY? OR
   IF SLOW OFF RES OFF
     (CURSOR) SWAP 12 MAX SWAP AT ." --> " KEY UPC
     ASCII C OVER = IF SLOW @ NOT SLOW ! THEN
     ASCII F OVER = IF DROP BEGIN QUERY RUN RES @ UNTIL THEN
     ASCII Q OVER = ABORT" Schrittweise Verarbeitung beendet"
     DROP
   THEN PNEXT ;
' TRACE  'DEBUG !
FORTH DEFINITIONS
: DEBUG   ( -- )
     ' 4-  DUP [ BUG ]
     BEGIN 1+ DUP W@ ['] UNNEST = UNTIL
     1 CNT !  IP> !  <IP !  PNEXT ;
: RESUME  ( -- )
     [ BUG ]  RES ON  0  PNEXT ;

ONLY FORTH ALSO DEFINITIONS

CR .( Ein erweiterbares In-Line-Dokumentationssystem )
20 STRING VOKPATH  \ DOS-Verzeichnis, in dem die .VOK-Dateien zu finden sind
HIDDEN DEFINITIONS
VARIABLE #WORDS   \ Anzahl der Worte im zuletzt dokumentierten Vokabular
VARIABLE #DOC     \ Anzahl dokumentierter Worte in besagtem Vokabular
VARIABLE #UNDOC   \ Anzahl undokumentierter Worte
VARIABLE #MULTI   \ Anzahl mehrfach definierter Worte
: VIEWSOFF ( -- ) \ lscht alle View-Felder ( vfa's ) des Kontext-Vokabulars
          #WORDS OFF                           \ Wortzhler zurcksetzen
          CONTEXT @ #THREADS
          0 DO DUP I 4* +
               BEGIN @ ?DUP WHILE
                     DUP 4- ( lfa > vfa ) OFF  \ vfa lschen
                     #WORDS 1+!                \ Wortzhler weitersetzen
               REPEAT LOOP DROP ;
: UNDOCUMENTED ( -- ) \ Bildschirmausgabe der nicht dokumentierten Worte
          #UNDOC OFF  #MULTI OFF               \ Zurcksetzen
          CONTEXT @ #THREADS
          0 DO DUP I 4* +
               BEGIN @ ?DUP WHILE
                     DUP 4- ( lfa > vfa ) @ 0=
                     IF                        \ Wenn vfa = 0,
                       DUP L>NAME HERE OVER    \ Namensfeld nach
                       C@ 31 AND 1+ CMOVE      \ HERE verschieben.
                       HERE C@ 31 AND HERE C!  \ Countbyte normalisieren.
                       HERE HERE C@ + DUP C@   \ Endbyte holen
                       127 AND SWAP C!         \ und normalisieren.
                       HERE HERE               \ liegt jetzt der Name.
                       CONTEXT @ HASH @        \ Jetzt Suche
                       (FIND)                  \ im Suchvokabular.
                       IF >LINK OVER <>        \ Wenn gefunden, dann:
                         IF ." * " #MULTI 1+!  \ wenn ungleich, dann Stern
                         THEN                  \ und #MULTI weiterrcken.
                       ELSE DROP               \ Wenn nicht gefunden, dann weg.
                       THEN
                       DUP L>NAME .ID SPACE    \ Schlielich Namen ausgeben
                       #UNDOC 1+!              \ und #UNDOC weiterrcken.
                     THEN
               REPEAT
            LOOP DROP ;
: VOKFILE ( voc -- hndl ) \ Dokumentationsdatei vom Typ .VOK ffnen
     >R VOKPATH -TRAILING HERE C! HERE COUNT CMOVE  HERE C@
     R> BODY> >NAME COUNT 31 AND 8 MIN ( die ersten 8 Zeichen des Vokabulars )
     TUCK HERE COUNT + SWAP CMOVE  + HERE 2DUP C! +
     128 SWAP CRESET ( Das letzte Zeichen in der nfa des Vokabulars hinzufgen )
     " .VOK" HERE COUNT + SWAP CMOVE
     HERE DUP C@ 4+ OVER C!
     DSEGMENT FLIP HERE-HOST OR OUTWDBUF OUT$ 0 H$B! HERE-HOST 1+
     ?OPEN 0 (OPEN) ?DOS-ERR ;
: CONTINUES? ( -- fl ) \ Test, ob die nchste Zeile leer oder EOF
  BUFFER COUNT -TRAILING NIP 0= EOF? @ OR NOT ;
: (LEARN)   ( -- )     \ View-Felder des CONTEXT-Vokabulars indizieren
       CONTEXT @ VOKFILE
       HANDLE @  >R >IN @ >R  HANDLE !
       VIEWSOFF                      \ Alte Referenzen lschen
       #DOC OFF                      \ Wortzhler zurcksetzen
       BEGIN 0 HANDLE @ 1
             ECHO @ 0=
             IF ASCII . EMIT THEN    \ Zur Wartezeitbelebung
             (SEEK) ?DOS-ERR         \ Dateizeiger-Position
             GETLINE >IN OFF
             BL WORD ?UPPERCASE DUP
             CONTEXT @ HASH @ (FIND) \ Suche in nur einem Vokabular
             IF   DUP >VIEW @ 0=
                  IF >VIEW !         \ Zeigerposition in vfa eintragen
                     #DOC 1+!        \ Wortzhler weitersetzen
                  ELSE 2DROP         \ Doppelzhlung vermeiden
                  THEN
                  BEGIN CONTINUES?   \ Wenn nchste Zeile nicht am linken
                  WHILE GETLINE      \ Rand beginnt, dann holen;
                  REPEAT             \ bis Anfang neue Erklrung
             ELSE 2DROP              \ Zeigerposition und cfa berflssig
             THEN
             EOF? @
       UNTIL
       CLOSE R> >IN ! R> HANDLE !
       BASE @ DECIMAL                                                   CR
       ." Undokumentiert geblieben sind:" CR  UNDOCUMENTED              CR
       ." Anzahl   der Worte insgesamt  im Vokabular "
          CONTEXT @ BODY> >NAME DUP .ID ." : " #WORDS ?                 CR
       ." Anzahl   dokumentierter Worte im Vokabular "
                                DUP .ID ." : " #DOC ?                   CR
       ." Anzahl undokumentierter Worte im Vokabular "
                                    .ID ." : " #UNDOC ?                 CR
       ." Anzahl berzhliger bei mehrfach definierten Worten : "
                                               #MULTI ?                 CR
       ." Diesen geht in der obigen Aufzhlung jeweils ein  *  voraus." CR
       BASE ! ;
: (HELP)  ( [<wort1> <wort2> ...] -- )    \ ein oder mehrere Wrter erklren
          HANDLE @ 0= >IN @ #TIB @ = AND  \ Test, ob nur HELP eingegeben
          BEGIN BL WORD ?UPPERCASE DUP C@
          IF FIND 0=
            IF CR HERE COUNT TYPE 11 ?TAB NUMBER?
              IF CR ." Direkt compilierte " DOUBLE?
                IF ." doppelt-genaue Zahl "
                ELSE ." Zahl " NIP S>D
                THEN
                2DUP D. 2DUP 0 0 D<
                IF   CR ." oder vorzeichenlos interpretiert "
                DOUBLE? NOT ROT XOR  SWAP UD.
                ELSE 2DROP
                THEN
              ELSE 2DROP ." unbekannt "
              THEN
            ELSE >VIEW @ ?DUP
              IF PRIOR @ VOKFILE HANDLE @ >R HANDLE !
                 HANDLE @ 0 (SEEK) ?DOS-ERR DROP
                 ECHO @ ECHO OFF GETLINE
                 0
                 BEGIN
                   1+ DUP 22 > IF .WEITER THEN
                   .LINE GETLINE CONTINUES?
                 WHILE
                 REPEAT
                 DROP
                 ECHO !
                 CLOSE R> HANDLE !
              ELSE CR HERE COUNT TYPE 11 ?TAB
                 ." Undokumentiertes Wort im Vokabular "
                 PRIOR @ BODY> >NAME DUP .ID ." ." CR
                 ." Haben Sie berhaupt schon ECHO OFF " .ID
                 ." LEARN [RET] durchgefhrt ?"
              THEN
            THEN
            STOP?
          ELSE DROP DUP  \ nur, wenn nur HELP eingegeben
            IF CR BOLD ." Zu dokumentierendes Wort oder Wortfolge eingeben:"
               ATTOFF CR QUERY #TIB @ 0=
            ELSE TRUE
            THEN
          THEN
          UNTIL DROP END? ON CR ;

ALSO FORTH DEFINITIONS               \ Die fr dem Benutzer gedachten
DEFER LEARN  ' (LEARN) IS LEARN      \ Worte ins Vokabular FORTH
DEFER HELP   ' (HELP)  IS HELP

\ Das Dokumentationssystem verwendet fr jedes Vokabular  eine eigene externe
\ Textdatei. Diese trgt den Namen des zu dokumentierenden Vokabulars mit der
\ Endung .VOK  und darf sich  in einem beliebigen Verzeichnis  oder Unterver-
\ zeichnis befinden.  Das K in .VOK wurde gewhlt,  um .VOC-Dateien des Host-
\ systems und .VOK-Dateien des Transputer-Systems,  die sich ja auf Vokabula-
\ re mit gleichen Namen beziehen,  nebeneinander im selben Verzeichnis aufbe-
\ waren zu knnen.  Eine .VOK-Datei wird per LEARN in das System eingebunden.
\ Und zwar  jeweils das erste Vokabular  in der Suchfolge  CONTEXT.  Der Ver-
\ zeichnisname kann vor Eingabe von LEARN der Stringvariablen VOCPATH berge-
\ ben werden. Die Erklrung eines Wortes <name> wird durch HELP <name> aufge-
\ rufen.  Angezeigt wird  der gesamte Text,  der in der VOK-Datei  auf <name>
\ folgt, bis zur nchsten Zeile, die am linken Rand beginnt. Hergestellt wer-
\ den knnen solche VOK-Dateien ber  ein beliebiges  Textverarbeitungssystem
\ oder einfach mit Hilfe eines Editors ( als reine ASCII-Datei,  ohne Steuer-
\ zeichen ).  Es kann ein Titel und es knnen Zwischenbemerkungen ( Teilber-
\ schriften ) enthalten sein.  Nur muss man dafr sorgen, dass keine auf eine
\ Leerzeile folgende Zeile  mit dem Namen eines Wortes des betreffenden Voka-
\ bular anfngt.  Jeder Zeilenblock  mit einer Worterklrung muss mit dem be-
\ treffenden Wort anfangen,  und dieses muss mit mindestens einem Leerzeichen
\ enden. Der Rest des jeweiligen Blockes kann beliebig aussehen. Eine 64K-Be-
\ schrnkung besteht nicht,  da die Date.positionen aus der VOK-Datei  in den
\ Viewfeldern ( vfa )  der zu dokumentierenden Worte  gespeichert werden  und
\ diese 32 Bit aufnehmen knnen.


ONLY FORTH ALSO DEFINITIONS

CR .( Externen Editor aufrufen )

12 STRING EDIT$

: EDIT ( -- )
     EDIT$ SHELL ;

CR .( Belegung der Funktionstasten F1 bis F12, allein oder mit SHFT, CTRL, ALT )
DECIMAL

CREATE FUNCTAB 192 ALLOT  FUNCTAB 192 ERASE \ Tabelle fr 48 Funktionen

DEFER OTHER-KEY ( code -- ) \ Reaktion auf andere Tasten: ALT-x, Cursor...
' DROP IS OTHER-KEY         \ Vorlufige Definition

: FUNCTION ( m ad n -- m ad n' )  \ fhrt Tastenbelegung aus
     LASTFKEY C@                  \ Tastencode, der nach dem Code 0 folgt
     DUP 59 68 BETWEEN            \ Tasten 1 bis 10
     IF 59 -
     ELSE DUP 84 113 BETWEEN      \ Tasten  11 bis 40
        IF  74 -
        ELSE DUP 133 140 BETWEEN  \ Tasten 41 bis 48
             IF   93 -
             ELSE OTHER-KEY EXIT
             THEN
        THEN
     THEN
     4* FUNCTAB + @ ?DUP          \ Taste belegt ?
     IF COUNT
        2DUP + 1- C@ ASCII % =
        IF >R >R BACK-UP R> R> THEN
        0 DO COUNT SWAP >R
             ASCII % OVER =
             IF DROP CR-IN R> LEAVE
             ELSE CHAR1 R>
             THEN
          LOOP
        DROP
     THEN ;

: ASSIGN$ ( tastencode <text[%]$> -- )  \ belegt Funktionstaste mit String [CR]
  DUP 1 48 BETWEEN NOT ABORT" Keine Funktionstaste"
  ASCII $ WORD DUP C@ 1+ ALLOT
  SWAP 1- 4* FUNCTAB + ! ; IMMEDIATE

\ ASSIGN$ wird folgendermaen verwendet:
\ 19 ASSIGN$ WORDS$  belegt die Taste SHIFT-F9 mit 'WORDS' .
\ Tasten F1 bis  F10  = Tastencodes 1 bis 10
\        SF1 bis SF10 =            11 bis 20
\        CF1 bis CF10 =            21 bis 30
\        AF1 bis AF10 =            31 bis 40
\        F11,F12,SF11,SF12,CF11,CF12,AF11,AF12 = 41 bis 48
\ Das  jeweilige  Stringende  wird  durch  $  gekennzeichnet.
\ Steht an der Stelle davor ein '%' , dann handelt es sich um
\ einen sofort auszufhrenden Befehl, d.h.'%' fhrt <CR> aus.
\ Die Tastenbelegungen werden  an den jeweils nchsten freien
\ Platz (= HERE)  ohne Wortkopf in das Dictionary compiliert.
\ Greift ein FORGET  auf eine Stelle weiter vorn zu, muss die
\ betreffende Taste,  und mssen alle spter belegten Tasten,
\ neu belegt werden.

' FUNCTION CC @ ! \ Aktiviert die Verarbeitung der
                  \ Funktionstasten ( xx00h in LASTKEY )

CR .( Neuen Editor whlen )
: NEW-EDITOR      \ festlegen
    13 EMIT  ." Neuer Editor: "  EDIT$ INPUT$ ;
: VOK<DIR> ( -- ) \ .VOK-Dateien-Verzeichnis neu festlegen
   13 EMIT ." Verzeichnis, in dem die .VOK-Dateien sind = "
   VOKPATH -TRAILING DUP
   IF 2DUP TYPE
   ELSE ." Aktuelles DOS-Verzeichnis"
   THEN
   CR ." Mit <CR> besttigen oder Zugangspfad ndern "
   2DUP INPUT$ SPAN @ 0= IF SWAP 1- C! ELSE 2DROP THEN ;

: BYE? ( -- ) \ BYE mit Sicherheitsabfrage; nur zurck zum Hostsystem
     2 BACKSPACES ."  Sind Sie sicher (J/N) ?"
     KEY UPC  ASCII J = IF BYE THEN ;

: BYE-FOR-DOS? ( -- ) \ Wie BYE? , aber zurck zur DOS-Kommandoebene
     2 BACKSPACES ."  Sind Sie sicher (J/N) ?"
     KEY UPC  ASCII J = IF BYE-FOR-DOS THEN ;

VARIABLE ATT-TEMP \ Fr Umschaltung ATTRIBUTS ON/OFF

CR .( Menbelegung und Wahlmglichkeiten )
 1 ASSIGN$ DARK MENU%$     ( F1 )
 2 ASSIGN$ EDIT%$          ( F2 )
 3 ASSIGN$ INCLUDE $       ( F3 )
 4 ASSIGN$ SAVE-SYSTEM $   ( F4 )
 5 ASSIGN$ DIR%$           ( F5 )
 6 ASSIGN$ CHDIR $         ( F6 )
 8 ASSIGN$ BYE-FOR-DOS?%$  ( F8 )
11 ASSIGN$ ATTRIBUTS ON%$  ( SHIFT-F1 )
21 ASSIGN$ ATTRIBUTS OFF%$ ( CTRL-F1  )
12 ASSIGN$ ECHO ON%$       ( SHIFT-F2 )
22 ASSIGN$ ECHO OFF%$      ( CTRL-F2  )
13 ASSIGN$ STATUS? ON%$    ( SHIFT-F3 )
23 ASSIGN$ STATUS? OFF%$   ( CTRL-F3  )
14 ASSIGN$ CAPS ON%$       ( SHIFT-F4 )
24 ASSIGN$ CAPS OFF%$      ( CTRL-F4 )
16 ASSIGN$ NEW-EDITOR%$    ( SHIFT-F6 )
17 ASSIGN$ VOK<DIR>%$      ( SHIFT-F7 )


CR .( Fehlerbehandlung )

\ Genaue Beschreibungen ber HELP ( siehe VOK-Datei )

CODE CLRHALTERR  ( -- )             \ Clear halt on error
     CLRHALTERR  NEXT END-CODE
CODE SETHALTERR  ( -- )             \ Set halt on error
     SETHALTERR  NEXT END-CODE
CODE TESTHALTERR ( -- fl )          \ Test halt on error
     TESTHALTERR NEG 1PUSH END-CODE \ fl = TRUE,  wenn  Halt-Flag gesetzt
CODE STOPERR     ( -- )             \ Stop ( process ) on error
     STOPERR     NEXT END-CODE


CR .( Gleitkommateil )
HEX

CR .( Zahlenumwandlungen )

CODE FBS>RD ( u -- rd )   \ Wandelt vorzeichenlose 32-Bit-Ganzzahl in R64-Zahl.
     SP LDL               \ Stack-Adresse nach Areg
     FPLDNLSN             \ REAL32-Wert von Stack nach FAreg
     FPB32TOR64            \ Wandlung
     SP LDL -4 ADC SP STL \ Stack anpassen
     SP LDL               \ Stack-Adresse nach Areg
     FPSTNLDB             \ FAreg nach Stack-Adresse
     NEXT END-CODE

CODE FRS>RD ( rs -- rd )    \ Wandelt R32-Zahl in R64-Zahl.
     SP LDL                 \ Keine Rundung ntig. Die Wandlung ist exakt
     FPLDNLSN               \ REAL32-Wert von Stack nach FAreg
     FPUR32TOR64            \ Wandlung
     SP LDL  -4 ADC  SP STL \ Stack anpassen
     SP LDL                 \ Stack-Adresse nach Areg
     FPSTNLDB               \ FAreg nach Stack-Adresse
     NEXT END-CODE

CODE FRD>RS ( rd -- rs )    \ Wandelt R64-Zahl in R32-Zahl.
     SP LDL                 \ Stack-Adresse nach Areg
     FPLDNLDB               \ REAL64-Wert von Stack nach FAreg
     FPUR64TOR32            \ Wandlung
     SP LDL  4 ADC  SP STL  \ Stack anpassen
     SP LDL                 \ Stack-Adresse nach Areg
     FPSTNLSN               \ FAreg nach Stack-Adresse
     NEXT END-CODE

CODE FIS>RS ( n -- rs ) \ Wandelt 32-Bit-Ganzzahl in R32-Zahl. Es wird gerun-
     SP LDL             \ det. Das FP-Error-Flag wird aber nicht beeinflusst.
     FPI32TOR32         \ Stack-Wert gewandelt nach FAreg
     SP LDL             \ Stack-Adresse nach Areg
     FPSTNLSN           \ FAreg nach Stack-Adresse
     NEXT END-CODE

CODE FIS>RD ( n -- rd )     \ Wandelt 32-Bit-Ganzzahl in R64-Zahl.
     SP LDL                 \ Keine Rundung ntig. Die Wandlung ist exakt
     FPI32TOR64             \ Stack-Wert gewandelt nach FAreg
     SP LDL  -4 ADC  SP STL \ Stack anpassen
     SP LDL                 \ Stack-Adresse nach Areg
     FPSTNLDB               \ FAreg nach Stack-Adresse
     NEXT END-CODE

CODE FID>RD ( d -- rd )     \ Wandelt 64-Bit-Ganzzahl in R64-Zahl.
     SP LDL  4 ADC          \ Obere Hlfte des Stackwertes
     FPI32TOR64 FPUEXPINC32 \ gewandelt und nach oben verschoben nach FAreg.
     SP LDL                 \ Untere Hlfte
     FPB32TOR64 FPADD       \ gewandelt zu FAreg addiert.
     SP LDL                 \ Stack-Adresse nach Areg.
     FPSTNLDB               \ FAreg auf den CPU-Stack
     NEXT END-CODE


CR .( Konstanten )

7F7FFFFF CONSTANT MAX-FLOAT \ Grte verwendbare positive Gleitkommazahl
                            \ = 0,FFFFFF020
                            \ = 0,34028236839
                            \ = 0,111111111111111111111111000000010000000

0 CONSTANT &0               \ REAL32-Wert 0,0

: &1 ( -- 1rs ) 1 FIS>RS  ; \ Ldt REAL32-Wert 1 auf den Stack
: &2 ( -- 1rs ) 2 FIS>RS  ; \ Ldt REAL32-Wert 2 auf den Stack
: &3 ( -- 1rs ) 3 FIS>RS  ; \ Ldt REAL32-Wert 3 auf den Stack

0. 2CONSTANT D&0            \ REAL64-Wert 0,0

: D&1 ( -- 1rs ) 1 FID>RD ; \ Ldt REAL64-Wert 1 auf den Stack
: D&2 ( -- 1rs ) 2 FID>RD ; \ Ldt REAL64-Wert 2 auf den Stack
: D&3 ( -- 1rs ) 3 FID>RD ; \ Ldt REAL64-Wert 3 auf den Stack


CR .( Vergleiche )
HEX

CODE FABS ( rs -- rs )    \ 32-Bit-Absolutwert
     SP LDL                 \ Stack-Adresse nach Areg
     FPLDNLSN               \ REAL32-Wert von Stack nach FAreg
     FPUABS                 \ Absolutwert bilden
     SP LDL                 \ Stack-Adresse nach Areg
     FPSTNLSN               \ FAreg-32 nach Stack-Adresse
     NEXT END-CODE

CODE FDABS ( rd -- rd )   \ 64-Bit-Absolutwert
     SP LDL                 \ Stack-Adresse nach Areg
     FPLDNLDB               \ REAL64-Wert von Stack nach FAreg
     FPUABS                 \ Absolutwert bilden
     SP LDL                 \ Stack-Adresse nach Areg
     FPSTNLDB               \ FAreg-64 nach Stack-Adresse
     NEXT END-CODE

CODE F> ( rs1 rs2 -- fl )   \ fl = TRUE, wenn rs1 > rs2
     SP LDL  4 ADC          \ Stack-Adresse von rs1 nach Areg
     FPLDNLSN               \ REAL32-Wert von Stack nach FBreg
     SP LDL                 \ Stack-Adresse von rs2 nach Areg
     FPLDNLSN               \ REAL32-Wert von Stack nach FAreg
     SP LDL  4 ADC  SP STL  \ Stack angleichen
     FPGT                   \ Floating Point Greater Than
     NEG                    \ Fr FORTH: TRUE = -1
     SP LDL  0 STNL         \ Areg zum Stack
     NEXT END-CODE

CODE FD> ( rd1 rd2 -- fl )  \ fl = TRUE, wenn rd1 > rd2
     SP LDL  8 ADC          \ Stack-Adresse von rd1 nach Areg
     FPLDNLDB               \ REAL64-Wert von Stack nach FBreg
     SP LDL                 \ Stack-Adresse von rd2 nach Areg
     FPLDNLDB               \ REAL64-Wert von Stack nach FAreg
     SP LDL  0C ADC  SP STL \ Stack angleichen
     FPGT                   \ Floating Point Greater Than
     NEG                    \ Fr FORTH: TRUE = -1
     SP LDL  0 STNL         \ Areg zum Stack
     NEXT END-CODE

CODE F<= ( rs1 rs2 -- fl )  \ fl = TRUE, wenn rs1 <= rs2
     SP LDL  4 ADC          \ Stack-Adresse von rs1 nach Areg
     FPLDNLSN               \ REAL32-Wert von Stack nach FBreg
     SP LDL                 \ Stack-Adresse von rs2 nach Areg
     FPLDNLSN               \ REAL32-Wert von Stack nach FAreg
     SP LDL  4 ADC  SP STL  \ Stack angleichen
     FPGT                   \ Floating Point Greater Than
     -1 ADC                 \ Logische Umkehr nebst TRUE = -1
     SP LDL  0 STNL         \ Areg zum Stack
     NEXT END-CODE

CODE FD<= ( rd1 rd2 -- fl ) \ fl = TRUE, wenn rd1 <= rd2
     SP LDL  8 ADC          \ Stack-Adresse von rd1 nach Areg
     FPLDNLDB               \ REAL64-Wert von Stack nach FBreg
     SP LDL                 \ Stack-Adresse von rd2 nach Areg
     FPLDNLDB               \ REAL64-Wert von Stack nach FAreg
     SP LDL  0C ADC  SP STL \ Stack angleichen
     FPGT                   \ Floating Point Greater Than
     -1 ADC                 \ Logische Umkehr nebst TRUE = -1
     SP LDL  0 STNL         \ Areg zum Stack
     NEXT END-CODE

CODE F< ( rs1 rs2 -- fl )   \ fl = TRUE, wenn rs1 < rs2
     SP LDL                 \ Stack-Adresse von rs2 nach Areg
     FPLDNLSN               \ REAL32-Wert von Stack nach FBreg
     SP LDL  4 ADC          \ Stack-Adresse von rs1 nach Areg
     FPLDNLSN               \ REAL32-Wert von Stack nach FAreg
     SP LDL  4 ADC  SP STL  \ Stack angleichen
     FPGT                   \ Floating Point Greater Than
     NEG                    \ Fr FORTH: TRUE = -1
     SP LDL  0 STNL         \ Areg zum Stack
     NEXT END-CODE

CODE FD< ( rd1 rd2 -- fl )  \ fl = TRUE, wenn rd1 < rd2
     SP LDL                 \ Stack-Adresse von rd2 nach Areg
     FPLDNLDB               \ REAL64-Wert von Stack nach FBreg
     SP LDL  8 ADC          \ Stack-Adresse von rd1 nach Areg
     FPLDNLDB               \ REAL64-Wert von Stack nach FAreg
     SP LDL  0C ADC  SP STL \ Stack angleichen
     FPGT                   \ Floating Point Greater Than
     NEG                    \ Fr FORTH: TRUE = -1
     SP LDL  0 STNL         \ Areg zum Stack
     NEXT END-CODE

CODE F>= ( rs1 rs2 -- fl )  \ fl = TRUE, wenn rs1 >= rs2
     SP LDL                 \ Stack-Adresse von rs2 nach Areg
     FPLDNLSN               \ REAL32-Wert von Stack nach FBreg
     SP LDL  4 ADC          \ Stack-Adresse von rs1 nach Areg
     FPLDNLSN               \ REAL32-Wert von Stack nach FAreg
     SP LDL  4 ADC  SP STL  \ Stack angleichen
     FPGT                   \ Floating Point Greater Than
     -1 ADC                 \ Logische Umkehr nebst TRUE = -1
     SP LDL  0 STNL         \ Areg zum Stack
     NEXT END-CODE

CODE FD>= ( rd1 rd2 -- fl ) \ fl = TRUE, wenn rd1 >= rd2
     SP LDL                 \ Stack-Adresse von rd2 nach Areg
     FPLDNLDB               \ REAL64-Wert von Stack nach FBreg
     SP LDL  8 ADC          \ Stack-Adresse von rd1 nach Areg
     FPLDNLDB               \ REAL64-Wert von Stack nach FAreg
     SP LDL  0C ADC  SP STL \ Stack angleichen
     FPGT                   \ Floating Point Greater Than
     -1 ADC                 \ Logische Umkehr nebst TRUE = -1
     SP LDL  0 STNL         \ Areg zum Stack
     NEXT END-CODE

CODE F= ( rs1 rs2 -- fl )   \ fl = TRUE, wenn rs1 = rs2
     SP LDL  4 ADC          \ Stack-Adresse von rs1 nach Areg
     FPLDNLSN               \ REAL32-Wert von Stack nach FBreg
     SP LDL                 \ Stack-Adresse von rs2 nach Areg
     FPLDNLSN               \ REAL32-Wert von Stack nach FAreg
     SP LDL  4 ADC  SP STL  \ Stack angleichen
     FPEQ                   \ Floating Point Equals
     NEG                    \ Fr FORTH: TRUE = -1
     SP LDL  0 STNL         \ Areg zum Stack
     NEXT END-CODE

CODE FD= ( rd1 rd2 -- fl )  \ fl = TRUE, wenn rd1 = rd2
     SP LDL  8 ADC          \ Stack-Adresse von rd1 nach Areg
     FPLDNLDB               \ REAL64-Wert von Stack nach FBreg
     SP LDL                 \ Stack-Adresse von rd2 nach Areg
     FPLDNLDB               \ REAL64-Wert von Stack nach FAreg
     SP LDL  0C ADC  SP STL \ Stack angleichen
     FPEQ                   \ Floating Point Equals
     NEG                    \ Fr FORTH: TRUE = -1
     SP LDL  0 STNL         \ Areg zum Stack
     NEXT END-CODE

CODE F<> ( rs1 rs2 -- fl )  \ fl = TRUE, wenn rs1 <> rs2
     SP LDL  4 ADC          \ Stack-Adresse von rs1 nach Areg
     FPLDNLSN               \ REAL32-Wert von Stack nach FBreg
     SP LDL                 \ Stack-Adresse von rs2 nach Areg
     FPLDNLSN               \ REAL32-Wert von Stack nach FAreg
     SP LDL  4 ADC  SP STL  \ Stack angleichen
     FPEQ                   \ Floating Point Equals
     -1 ADC                 \ Logische Umkehr nebst TRUE = -1
     SP LDL  0 STNL         \ Areg zum Stack
     NEXT END-CODE

CODE FD<> ( rd1 rd2 -- fl ) \ fl = TRUE, wenn rd1 <> rd2
     SP LDL  8 ADC          \ Stack-Adresse von rd1 nach Areg
     FPLDNLDB               \ REAL64-Wert von Stack nach FBreg
     SP LDL                 \ Stack-Adresse von rd2 nach Areg
     FPLDNLDB               \ REAL64-Wert von Stack nach FAreg
     SP LDL  0C ADC  SP STL \ Stack angleichen
     FPEQ                   \ Floating Point Equals
     -1 ADC                 \ Logische Umkehr nebst TRUE = -1
     SP LDL  0 STNL         \ Areg zum Stack
     NEXT END-CODE

CODE FINF ( rs -- fl )      \ fl = TRUE, wenn rs =  oder NAN
     SP LDL                 \ Stack-Adresse von rs nach Areg
     FPLDNLSN               \ REAL32-Wert von Stack nach FAreg
     FPNOTFINITE            \ Floating Point Not Finite
     NEG                    \ Fr FORTH: TRUE = -1
     SP LDL  0 STNL         \ Areg zum Stack
     NEXT END-CODE

CODE FDINF ( rd -- fl )     \ fl = TRUE, wenn rd =  oder NAN
     SP LDL                 \ Stack-Adresse von rd2 nach Areg
     FPLDNLDB               \ REAL64-Wert von Stack nach FAreg
     FPNOTFINITE            \ Floating Point Not Finite
     NEG                    \ Fr FORTH: TRUE = -1
     SP LDL  4 ADC  SP STL  \ Stack angleichen
     SP LDL  0 STNL         \ Areg zum Stack
     NEXT END-CODE

CODE FNAN ( rs -- fl )      \ fl = TRUE, wenn rs = NAN
     SP LDL                 \ Stack-Adresse von rs nach Areg
     FPLDNLSN               \ REAL32-Wert von Stack nach FAre'
     FPNAN                  \ Floating Point Not A Number
     NEG                    \ Fr FORTH: TRUE = -1
     SP LDL  0 STNL         \ Areg zum Stack
     NEXT END-CODE

CODE FDNAN ( rd -- fl )     \ fl = TRUE, wenn rd = NAN
     SP LDL                 \ Stack-Adresse von rd2 nach Areg
     FPLDNLDB               \ REAL64-Wert von Stack nach FAreg
     FPNAN                  \ Floating Point Not A Number
     NEG                    \ Fr FORTH: TRUE = -1
     SP LDL  4 ADC  SP STL  \ Stack angleichen
     SP LDL  0 STNL         \ Areg zum Stack
     NEXT END-CODE

CODE FORD ( rs1 rs2 -- fl ) \ fl = FALSE, wenn rs1 = NAN  oder rs2 = NAN
     SP LDL  4 ADC          \ Stack-Adresse von rs1 nach Areg
     FPLDNLSN               \ REAL32-Wert von Stack nach FBreg
     SP LDL                 \ Stack-Adresse von rs2 nach Areg
     FPLDNLSN               \ REAL32-Wert von Stack nach FAreg
     SP LDL  4 ADC  SP STL  \ Stack angleichen
     FPORDERED              \ Floating Point Orderability
     NEG                    \ Fr FORTH: TRUE = -1
     SP LDL  0 STNL         \ Areg zum Stack
     NEXT END-CODE

CODE FDORD ( rd1 rd2 -- fl ) \ fl = FALSE, wenn rd1 = NAN oder rd2 = NAN
     SP LDL  8 ADC          \ Stack-Adresse von rd1 nach Areg
     FPLDNLDB               \ REAL64-Wert von Stack nach FBreg
     SP LDL                 \ Stack-Adresse von rd2 nach Areg
     FPLDNLDB               \ REAL64-Wert von Stack nach FAreg
     SP LDL  0C ADC  SP STL \ Stack angleichen
     FPORDERED              \ Floating Point Orderability
     NEG                    \ Fr FORTH: TRUE = -1
     SP LDL  0 STNL         \ Areg zum Stack
     NEXT END-CODE


CR .( Arithmetik )

CODE F+ ( rs1 rs2 -- rs )
     SP LDL 4 ADC           \ Stack-Adresse nach Areg
     FPLDNLSN               \ Summand von Stack nach FBreg
     SP LDL                 \ Stack-Adresse
     FPLDNLSN               \ Summator von Stack nach FAreg
     FPADD                  \ Summe nach FAreg
     SP LDL 4 ADC SP STL    \ Stack anpassen
     SP LDL                 \ Stack-Adresse nach Areg
     FPSTNLSN               \ FAreg-32 zum Datenstack
     NEXT END-CODE

CODE F- ( rs1 rs2 -- rs )
     SP LDL 4 ADC           \ Stack-Adresse nach Areg
     FPLDNLSN               \ Subtrahend von Stack nach FBreg
     SP LDL                 \ Stack-Adresse
     FPLDNLSN               \ Subtraktor von Stack nach FAreg
     FPSUB                  \ Differenz nach FAreg
     SP LDL 4 ADC SP STL    \ Stack anpassen
     SP LDL                 \ Stack-Adresse nach Areg
     FPSTNLSN               \ FAreg-32 zum Datenstack
     NEXT END-CODE

CODE F* ( rs1 rs2 -- rs )
     SP LDL 4 ADC           \ Stack-Adresse nach Areg
     FPLDNLSN               \ Multiplikand von Stack nach FBreg
     SP LDL                 \ Stack-Adresse
     FPLDNLMULSN            \ Multiplikator und dann Produkt nach FAreg
     SP LDL 4 ADC SP STL    \ Stack anpassen
     SP LDL                 \ Stack-Adresse nach Areg
     FPSTNLSN               \ FAreg-32 zum Datenstack
     NEXT END-CODE

CODE F/ ( rs1 rs2 -- rs )
     SP LDL 4 ADC           \ Stack-Adresse nach Areg
     FPLDNLSN               \ Dividend von Stack nach FBreg
     SP LDL                 \ Stack-Adresse
     FPLDNLSN               \ Divisor von Stack nach FAreg
     FPDIV                  \ Quotient nach FAreg
     SP LDL 4 ADC SP STL    \ Stack anpassen
     SP LDL                 \ Stack-Adresse nach Areg
     FPSTNLSN               \ FAreg-32 zum Datenstack
     NEXT END-CODE

CODE FD+ ( rd1 rd2 -- rd )
     SP LDL 8 ADC           \ Stack-Adresse nach Areg
     FPLDNLDB               \ Summand von Stack nach FBreg
     SP LDL                 \ Stack-Adresse
     FPLDNLDB               \ Summator von Stack nach FAreg
     FPADD                  \ Summe nach FAreg
     SP LDL 8 ADC SP STL    \ Stack anpassen
     SP LDL                 \ Stack-Adresse nach Areg
     FPSTNLDB               \ FAreg-64 zum Datenstack
     NEXT END-CODE

CODE FD- ( rd1 rd2 -- rd )
     SP LDL 8 ADC           \ Stack-Adresse nach Areg
     FPLDNLDB               \ Subtrahend von Stack nach FBreg
     SP LDL                 \ Stack-Adresse
     FPLDNLDB               \ Subtraktor von Stack nach FAreg
     FPSUB                  \ Differenz nach FAreg
     SP LDL 8 ADC SP STL    \ Stack anpassen
     SP LDL                 \ Stack-Adresse nach Areg
     FPSTNLDB               \ FAreg-64 zum Datenstack
     NEXT END-CODE

CODE FD* ( rd1 rd2 -- rd )
     SP LDL 8 ADC           \ Stack-Adresse nach Areg
     FPLDNLDB               \ Multiplikand von Stack nach FBreg
     SP LDL                 \ Stack-Adresse
     FPLDNLMULDB            \ Multiplikator und dann Produkt nach FAreg
     SP LDL 8 ADC SP STL    \ Stack anpassen
     SP LDL                 \ Stack-Adresse nach Areg
     FPSTNLDB               \ FAreg-64 zum Datenstack
     NEXT END-CODE

CODE FD/ ( rd1 rd2 -- rd )
     SP LDL 8 ADC           \ Stack-Adresse nach Areg
     FPLDNLDB               \ Dividend von Stack nach FBreg
     SP LDL                 \ Stack-Adresse
     FPLDNLDB               \ Divisor von Stack nach FAreg
     FPDIV                  \ Quotient nach FAreg
     SP LDL 8 ADC SP STL    \ Stack anpassen
     SP LDL                 \ Stack-Adresse nach Areg
     FPSTNLDB               \ FAreg-64 zum Datenstack
     NEXT END-CODE


CR .( Zahleneingabe )

 VARIABLE ASCII-E ASCII  ASCII-E !  \  Exponentzeichen, Vorbelegung 
 VARIABLE ASCII-. ASCII . ASCII-. !  \  Dezimalpunkt,    Vorbelegung .
 VARIABLE LOC-E                      \  Adresse des Exponentzeichens
 VARIABLE LOC-D                      \  Adresse von . oder ,
 VARIABLE LOC-SM                     \  Adresse von + oder - der Mantisse
 VARIABLE LOC-SE                     \  Adresse von + oder - des Exponenten
 VARIABLE LOC-M                      \  Adresse der Mantisse
2VARIABLE VAL-E                      \  Wert des Exponenten
2VARIABLE VAL-M                      \  Wert der Mantisse

: .FERR1 ( -- ) CR BOLD ." Unzulssige Exponentendarstellung" ABORT ;
: .FERR2 ( -- ) CR BOLD ." Unzulssige Zahlendarstellung"     ABORT ;
: .FERR3 ( -- ) CR BOLD ." Zahl nicht im zulssigen Bereich"  ABORT ;

: F(FRACEXP>R64) ( d n -- rd )    \  d = Mantisse, n = Exponent
     >R                           \ rd = aus d,n erzeugte R64-Zahl
     ASM[ SP LDL 4 ADC FPI32TOR64 FPUEXPINC32
          SP LDL       FPB32TOR64 FPADD  NEXT ]FORTH
     R@ 0>                        \ Exponent
     IF
       R@
       BEGIN
         DUP 0>
       WHILE
         BASE @
         ASM[ SP LDL FPI32TOR64 FPMUL
\              FPNAN
\              SP LDL -4 ADC SP STL SP LDL 0 STNL
              NEXT ]FORTH
\         IF .FERR3 ABORT THEN
         DROP 1-
       REPEAT
       DROP
     THEN
     R@ 0<                        \ Exponent
     IF
       R@
       BEGIN
         DUP 0<
       WHILE
         BASE @
         ASM[ SP LDL FPI32TOR64 FPDIV NEXT ]FORTH
         DROP 1+
       REPEAT
       DROP
     THEN
     R> DROP                      \ Exponent
     ASM[ SP LDL FPSTNLDB NEXT ]FORTH ;

CODE FFRACEXP>R64 ( rd -- rd fl )    \ fl = FALSE bei Fehler
     SP LDL  FPLDNLDB
     FPNOTFINITE  -1 ADC
     SP LDL  -4 ADC  SP STL
     SP LDL  0 STNL
     NEXT END-CODE

CODE FFRACEXP>R32 ( rd -- rs fl )    \ fl = FALSE bei Fehler
     SP LDL  FPLDNLDB FPUCLRERR
             FPURZ  FPUR64TOR32
             FPTESTERR NEG
     SP LDL  0 STNL
     SP LDL  4 ADC  FPSTNLSN
     NEXT END-CODE

: (&) ( <zahl> fl -- rs/rd )  \ fl = FALSE: 32 Bit, sonst 64 Bit
     LOC-D OFF  LOC-E OFF  LOC-SM OFF  LOC-SE OFF  0. VAL-E 2!
     BL WORD
     DUP COUNT UPPER                        \ Nur Grobuchstaben
     DUP 1+ LOC-M !                         \ Mantissenposition
     DUP COUNT BOUNDS
     DO
       I C@                                 \ Nchstes Zeichen
       CASE                                 \ Exponent ?
         ASCII E   OF
                     BASE @ 0F <
                     IF
                       LOC-E @ 0=
                       IF   I LOC-E !       \ Position festhalten.
                       ELSE .FERR1          \ Fehlermeldung und
                       THEN                 \ Abbruch beim zweiten
                     THEN           ENDOF   \ Auftreten.
         ASCII e   OF
                     BASE @ 0F <
                     IF
                       LOC-E @ 0=
                       IF   I LOC-E !       \ Nochmal fr 'e'
                       ELSE .FERR1
                       THEN
                     THEN           ENDOF
         ASCII-E @ OF
                     LOC-E @ 0=
                     IF   I LOC-E !         \ Nochmal fr (ASCII-E)
                     ELSE .FERR1
                     THEN           ENDOF
       ENDCASE
     LOOP
     DUP COUNT BOUNDS
     DO                                     \ Fehlermeldung und
       I C@ BASE @ DIGIT NIP 0=             \ Abbruch, wenn Zeichen
       IF                                   \ anders als . , + -
         I C@  DUP ASCII-E @ <>             \ oder Ziffer oder
              OVER ASCII   . <> AND         \ in ASCII-E vorgegebenes
              OVER ASCII   , <> AND         \ Zeichen fr Exponent
              OVER ASCII   + <> AND         \ oder E oder e .
              OVER ASCII   - <> AND
              OVER ASCII   E <> AND
              SWAP ASCII   e <> AND
              IF .FERR2 THEN
       THEN
     LOOP
     DUP COUNT BOUNDS
     DO
       I C@ ASCII / = ASCII-E C@ ASCII / <> AND
       IF LOC-E @ 0= I LOC-E @ < OR  IF .FERR2 ELSE .FERR1 THEN  THEN
       I C@ ASCII . = I C@ ASCII , = OR
       IF
         LOC-E @ 0<> I LOC-E @ > AND
         IF                             .FERR1 THEN
         LOC-E @ 0=  I LOC-E @ < OR LOC-D @ 0= AND
         IF ASCII . I C! I LOC-D ! ELSE .FERR2 THEN
       THEN
       I C@ ASCII + =
       IF
         LOC-M @ I =
         IF   ASCII 0 I C! I LOC-SM !       \ + in 0 wandeln
         ELSE                               \ und bei doppeltem
           LOC-E @ 0= I LOC-E @ < OR        \ Auftreten oder
           IF .FERR1                        \ nach . oder ,
           ELSE                             \ Fehler melden
              LOC-SE @ 0<>
              IF .FERR1 ELSE ASCII 0 I C! I LOC-SE ! THEN
           THEN
         THEN
       THEN
       I C@ ASCII - =
       IF
         LOC-M @ I =
         IF                I LOC-SM !       \ - belassen
         ELSE                               \ und bei doppeltem
           LOC-E @ 0= I LOC-E @ < OR        \ Auftreten oder
           IF .FERR2                        \ nach . oder ,
           ELSE                             \ Fehler melden
              LOC-SE @ 0<>
              IF .FERR1 ELSE              I LOC-SE ! THEN
           THEN
         THEN
       THEN
     LOOP
     LOC-E @
     IF   DUP DUP C@ + LOC-E @ - LOC-E @ C! LOC-E @ OVER 1+ - SWAP C!
     ELSE DROP
     THEN
     LOC-E @ LOC-E @ C@ 0= AND IF .FERR1 THEN
     LOC-E @
     IF
       LOC-E @
       \ NUMBER?  -- Am 20.11.96 durch das folgende Einschubsel ersetzt
       FALSE OVER COUNT BOUNDS               \ NUMBER?   ( ad -- d fl )
       ?DO I C@ BASE @ DIGIT NIP IF DROP TRUE LEAVE THEN LOOP
       IF                                    \ (NUMBER?) ( ad -- d fl )
         0 0  ROT  DUP 1+  C@  ASCII -  =  DUP  >R  -  -1 DPL !
         BEGIN                         \ CONVERT ( +d1 ad1 -- +d2 ad2 )
           BEGIN  1+  DUP >R  C@  BASE @  DIGIT
           WHILE  -ROT NIP BASE @ UM* ROT S>D D+ DUP 420 >
                  IF
                    CR BOLD ." Exponent betragsmig viel zu gro !"
                    CR      ." Eventuell hilft anderes Eingabeformat."
                    ABORT
                  THEN
                  R>
           REPEAT DROP R>                              \ ; Ende CONVERT
           DUP C@  ASCII , ASCII / BETWEEN
         WHILE   0 DPL !
         REPEAT -ROT R> IF DNEGATE THEN ROT C@ BL =  \ ; Ende (NUMBER?)
       ELSE
         DROP 0 0 FALSE
       THEN                                            \ ; Ende NUMBER?
       \ Ende des Einschubsels vom 20.11.96
       IF VAL-E 2! ELSE .FERR1 THEN  BL LOC-E @ C!
     THEN
     LOC-M @ 1-
     \ NUMBER?  -- Am 21.11.96 durch das folgende Einschubsel ersetzt
     FALSE OVER COUNT BOUNDS               \ NUMBER?   ( ad -- d fl )
     ?DO I C@ BASE @ DIGIT NIP IF DROP TRUE LEAVE THEN LOOP
     IF                                    \ (NUMBER?) ( ad -- d fl )
       0 0  ROT  DUP 1+  C@  ASCII -  =  DUP  >R  -  -1 DPL !
       BEGIN                         \ CONVERT ( +d1 ad1 -- +d2 ad2 )
         BEGIN
           1+  DUP >R  C@  BASE @  DIGIT
         WHILE
           0 2OVER 1FFFFFFFFFFFFF. D> NIP
           IF
             DROP R@ LOC-D @ < IF VAL-E 1+! THEN
           ELSE
             2DUP >R >R SWAP ROT BASE @ UM* SWAP
             IF
               DROP R> R>
             ELSE
               R> R> 2DROP
               -ROT BASE @ UM* D+
               DOUBLE?  IF DPL 1+! THEN
             THEN
           THEN
           R>
         REPEAT DROP R>                              \ ; Ende CONVERT
         DUP C@  ASCII , ASCII / BETWEEN
       WHILE   0 DPL !
       REPEAT -ROT R> IF DNEGATE THEN ROT C@ BL =  \ ; Ende (NUMBER?)
     ELSE
       DROP 0 0 FALSE
     THEN                                            \ ; Ende NUMBER?
     \ Ende des Einschubsels vom 21.11.96
     IF VAL-M 2! DPL @ LOC-D ! ELSE .FERR2 THEN
     VAL-E 2@ 0 DPL @ DUP -1 = IF DROP 0 THEN D- VAL-E 2!
     VAL-M 2@ VAL-E @ F(FRACEXP>R64)
     ROT
     IF FFRACEXP>R64 ELSE FFRACEXP>R32 THEN
     0= IF .FERR3 THEN ;
\ Das Wort (&), in der oben stehenden Bearbeitung,  ist ganz bestimmt keine
\ Meisterleistung der Programmierkunst.  Es ist  umstndlich aufgebaut  und
\ enthlt redundante Teile. Es ist das Ergebnis einer langen Kette von Ver-
\ suchen und Irrtmern.  Es scheint aber zu funktionieren  und ich lasse es
\ jetzt so,  um nicht noch  unntige Unstimmigkeiten hineinzubringen.  Eine
\ Neubearbeitung behalte ich mir fr spter vor.  -  Man beachte bei alldem
\ aber auch, dass dieses (&) fr Gleitkomma-Zahleneingaben nach dem Positi-
\ onsprinzip  fr beliebige Basen eingerichtet ist.  Wenn Knuth  im zweiten
\ Band eine ganze Seite voller Konstanten bis auf 40 Stellen genau  auch in
\ Oktaldarstellung angibt, mchte ich diese fr Vergleichszwecke berprfen
\ knnen. Und wenn jemand, wie man erfhrt, die 100.000.000.000te Hexadezi-
\ malstelle der Zahl Pi mit 9, gefolgt von C, angibt,  mchte ich zumindest
\ davon trumen knnen, das zu berprfen.  -  25.11.96

: &  ( <zahl> -- rs | compile rs )
     FALSE (&) STATE @ IF COMPILE  (LIT)   , THEN ; IMMEDIATE

: D& ( <zahl> -- rd | compile rd )
     TRUE  (&) STATE @ IF COMPILE (DLIT) , , THEN ; IMMEDIATE

: F#  NOOP ; IMMEDIATE   '  & IS F#
: FD# NOOP ; IMMEDIATE   ' D& IS FD#


CR .( Zahlenausgabe )
HEX

: FR32>FRACEXP ( rs -- n1 n2 )    \  n1 = Mantisse, n2 = Exponent
     1 ?ENOUGH
     0 VAL-M ! 0 VAL-E !
     DUP 7FFFFFFF AND DUP 0= IF 2DROP 0. EXIT THEN  \ Nullbehandlung
         7F7FFFFF         U> IF     8000 EXIT THEN  \ NaN
     DUP 80000000 AND 0<> SWAP                      \ Mantissenvorzeichen
     FABS                                           \ Absolutwert
     BEGIN
       DUP
       ASM[ SP LDL  FPLDNLSN  FPURZ FPUCLRERR FPRTOI32
            SP LDL  -4 ADC  SP STL
                    FPTESTERR -1 ADC
            SP LDL  1 STNL
            SP LDL  FPSTNLI32  NEXT ]FORTH
       DUP FF000000 AND ROT OR
       0<>
     WHILE
       DROP
       BASE @ FIS>RS F/ VAL-E 1+!                   \ Zur Normalisierung
     REPEAT
     DROP
     BEGIN
       DUP
       ASM[ SP LDL   FPLDNLSN FPURZ FPINT
            SP LDL   FPSTNLI32  NEXT ]FORTH
       DUP FF000000 AND
        0=
     WHILE
       DROP
       BASE @ FIS>RS F* VAL-E 1-!                   \ Zur Normalisierung
     REPEAT
     DROP
     BEGIN
       DUP
       ASM[ SP LDL   FPLDNLSN FPURZ FPINT
            SP LDL   FPSTNLI32  NEXT ]FORTH
       DUP FF000000 AND
        0<>
     WHILE
       DROP
       BASE @ FIS>RS F/ VAL-E 1+!                   \ Zur Normalisierung
     REPEAT
     NIP
     SWAP IF NEGATE THEN                            \ Mantissenvorzeichen
     DUP VAL-M ! VAL-E @ ;

: FR64>FRACEXP ( rd -- d n )     \  d = Mantisse, n = Exponent
     2 ?ENOUGH
     0. VAL-M 2! 0 VAL-E !
     2DUP 7FFFFFFFFFFFFFFF. 2AND 2DUP D0=
                    IF 2DROP 2DROP 0. 0  EXIT THEN  \ Nullbehandlung
          7FEFFFFFFFFFFFFF. DU>
                    IF             8000  EXIT THEN  \ NaN
     OVER 80000000 AND 0<> -ROT                     \ Mantissenvorzeichen
     FDABS                                          \ Absolutwert
     BEGIN
       2DUP
       ASM[ SP LDL  FPLDNLDB  FPURZ FPUCLRERR FPINT FPUCHKI64 FPDUP
            SP LDL  -4 ADC  SP STL
                    FPTESTERR -1 ADC
            SP LDL  2 STNL
            SP LDL  FPSTNLI32 FPUEXPDEC32
            SP LDL  4 ADC FPSTNLI32 NEXT ]FORTH
       2DUP FF70000000000000. 2AND DROP 3 ROLL OR
       0<>
     WHILE
       2DROP
       BASE @ FIS>RD FD/ VAL-E 1+!                  \ Zur Normalisierung
     REPEAT
     2DROP
     BEGIN
       2DUP
       ASM[ SP LDL       FPLDNLDB  FPURZ FPINT FPDUP
            SP LDL       FPSTNLI32 FPUEXPDEC32
            SP LDL 4 ADC FPSTNLI32 NEXT ]FORTH
            2DUP FFF0000000000000. 2AND DROP
       0=
     WHILE
       2DROP
       BASE @ FIS>RD FD* VAL-E 1-!                  \ Zur Normalisierung
     REPEAT
     2DROP
     BEGIN
       2DUP
       ASM[ SP LDL       FPLDNLDB  FPURZ FPINT FPDUP
            SP LDL       FPSTNLI32 FPUEXPDEC32
            SP LDL 4 ADC FPSTNLI32 NEXT ]FORTH
            2DUP FFF0000000000000. 2AND DROP
       0<>
     WHILE
       2DROP
       BASE @ FIS>RD FD/ VAL-E 1+!                  \ Zur Normalisierung
     REPEAT
     2NIP
     ROT IF DNEGATE THEN                            \ Mantissenvorzeichen
     2DUP VAL-M 2! VAL-E @ ;

: .+ ( n -- +/-n )   \ Ausgabe einer INT32-Zahl mit Vorzeichen ( auch + )
     DUP 0> IF ASCII + EMIT THEN . ;

: D.+ ( n -- +/-n )  \ Ausgabe einer INT64-Zahl mit Vorzeichen ( auch + )
     2DUP D0> IF ASCII + EMIT THEN D. ;

: F. ( rs -- )
     1 ?ENOUGH
     FR32>FRACEXP
     DUP 8000 = IF DROP  BOLD ." NaN " ATTOFF  H.  EXIT THEN
     OVER    0< IF ASCII - EMIT ELSE SPACE              THEN
     OVER    0= IF     0 . NIP  ELSE SWAP ABS (U.) TYPE THEN
     DUP     0= IF         DROP ELSE BASE @ 0E >
                                  IF   ASCII-E @
                                  ELSE ASCII E
                                  THEN          EMIT .+ THEN ;

: F.R  ( rs len -- )  \ Zahlenausgabe mit "Mantisse" der Lnge len
     2 ?ENOUGH
     0 MAX >R FR32>FRACEXP
     DUP 8000 =  IF R> 2DROP  BOLD ." NaN "  ATTOFF  H.  EXIT  THEN
     OVER    0<  IF ASCII - EMIT ELSE SPACE                    THEN
     OVER    0=  IF 0 R> .R      ELSE OVER ABS (U.) DUP R> MIN
                                      TUCK - 0 MAX -ROT TYPE + THEN
     SWAP    0= OVER 0= OR
                 IF        DROP  ELSE BASE @ 0E >
                                   IF   ASCII-E @
                                   ELSE ASCII E
                                   THEN                EMIT .+ THEN ;

: F.L  ( rs -- )    \ Genormte Zahlenausgabe, beginnend mit x.***
     1 ?ENOUGH
     FR32>FRACEXP
     DUP 8000 = IF DROP  BOLD ." NaN " ATTOFF H. EXIT THEN
     OVER    0< IF   ASCII - EMIT      ELSE SPACE     THEN
     OVER    0= IF ." 0.0 " 2DROP EXIT ELSE SWAP ABS  THEN
     (U.) 1- SWAP DUP C@ EMIT
     ASCII-. C@ EMIT 1+ OVER TYPE +
     DUP     0= IF           DROP      ELSE BASE @ 0E >
                                         IF   ASCII-E @
                                         ELSE ASCII E
                                         THEN EMIT .+ THEN ;

: F.LR ( rs len -- )     \ x.*** mit Mantisse der Lnge len
     2 ?ENOUGH
     0 MAX >R FR32>FRACEXP
     DUP 8000 = IF R> 2DROP BOLD ." NaN " ATTOFF H. EXIT THEN
     OVER    0< IF   ASCII -    EMIT ELSE SPACE          THEN
     OVER ABS (U.)
     OVER C@ EMIT ASCII-. @ EMIT
     1- SWAP 1+ OVER R> MIN TYPE +
     SWAP    0= IF DROP ASCII 0 EMIT ELSE BASE @ 0E >
                                       IF   ASCII-E @
                                       ELSE ASCII E
                                       THEN      EMIT .+ THEN ;

: FD.  ( rd -- )
     2 ?ENOUGH
     FR64>FRACEXP
     DUP 8000  = IF  DROP   BOLD ." NaN " ATTOFF  HD.  EXIT THEN
     0 2OVER D0< IF ASCII - EMIT ELSE SPACE                 THEN
       2OVER D0= IF 0. D.   2NIP ELSE 2SWAP DABS (UD.) TYPE THEN
       DROP
       DUP    0= IF         DROP ELSE BASE @ 0E >
                                   IF   ASCII-E @
                                   ELSE ASCII E
                                   THEN             EMIT .+ THEN ;

: FD.R  ( rd len -- )  \ Zahlenausgabe mit "Mantisse" der Lnge len
     3 ?ENOUGH
     0 MAX >R FR64>FRACEXP
     DUP 8000  = IF R> 2DROP BOLD ." NaN " ATTOFF HD. EXIT THEN
     0 2OVER D0< IF ASCII - EMIT ELSE SPACE                THEN
       2OVER D0= IF 0 R> D.R     ELSE 2OVER DABS (UD.) DUP
                                      R> MIN TUCK -  0 MAX
                                      -ROT TYPE NIP +      THEN
        -ROT D0= OVER 0= OR
                 IF         DROP ELSE BASE @ 0E >
                                   IF   ASCII-E @
                                   ELSE ASCII E
                                   THEN            EMIT .+ THEN ;

: FD.L  ( rd -- )      \ Genormte Zahlenausgabe, beginnend mit x.***
     2 ?ENOUGH
     FR64>FRACEXP
     DUP 8000  = IF DROP BOLD ." NaN " ATTOFF HD. EXIT THEN
     0 2OVER D0< IF ASCII - EMIT ELSE SPACE            THEN
       2OVER D0= IF ." 0.0 " 2DROP 2DROP EXIT
                                 ELSE DROP -ROT DABS   THEN
     (UD.) 1- SWAP DUP C@ EMIT
     ASCII-. C@ EMIT 1+ OVER TYPE +
     DUP      0= IF         DROP ELSE BASE @ 0E >
                                   IF   ASCII-E @
                                   ELSE ASCII E
                                   THEN       EMIT .+  THEN ;

: FD.LR ( rd len -- )  \ x.*** mit Mantisse der Lnge len
     3 ?ENOUGH
     0 MAX >R FR64>FRACEXP
     DUP 8000  = IF R> 2DROP BOLD ." NaN " ATTOFF HD. EXIT THEN
     0 2OVER D0< IF ASCII - EMIT      ELSE SPACE           THEN
       2OVER DABS (UD.)
     OVER C@ EMIT ASCII-. @ EMIT
     1- SWAP 1+ OVER R> MIN TYPE NIP +
        -ROT D0= IF DROP ASCII 0 EMIT ELSE BASE @ 0E >
                                        IF   ASCII-E @
                                        ELSE ASCII E
                                        THEN       EMIT .+ THEN ;


CR .( Fehlerbehandlung )
HEX

: F?ERR ( rs -- rs fl )  \  fl = FALSE,  wenn rs unzulssig
     DUP 7FFFFFFF AND 7F800000 <
     IF
       TRUE
     ELSE
       DUP CR
       CASE
         7FC00000  OF ." Division durch Null"           ENDOF
         7FA00000  OF ." Unendlich durch Unendlich"     ENDOF
         7F900000  OF ." Null mal Unendlich"            ENDOF
         7F880000  OF ." +(-) V - V --(-)"        ENDOF
         7F840000  OF ." Wurzel aus negativer Zahl"     ENDOF
         7F820000  OF ." REAL64 zu REAL32 mit NAN"      ENDOF
         7F804000  OF ." Restberechnung mit Dividend " ENDOF
         7F802000  OF ." Restberechnung mit Divisor 0"  ENDOF
         7F800000  OF ." +Unendlich"                    ENDOF
         FF800000  OF ." -Unendlich"                    ENDOF
              DUP  OF ." NaN von unbekannter Art"       ENDOF
       ENDCASE
       CR FALSE
     THEN ;

: FD?ERR ( rd -- rd fl )  \ fl = FALSE,  wenn rd unzulssig
     2DUP 7FFFFFFFFFFFFFFF. 2AND 7FF0000000000000. D<
     IF
       TRUE
     ELSE
       2DUP 0=
       IF
         CR
         CASE
           7FF80000  OF ." Division durch Null"           ENDOF
           7FF40000  OF ." Unendlich durch Unendlich"     ENDOF
           7FF20000  OF ." Null mal Unendlich"            ENDOF
           7FF10000  OF ." +(-) V - V --(-)"        ENDOF
           7FF08000  OF ." Wurzel aus negativer Zahl"     ENDOF
           7FF04000  OF ." REAL64 zu REAL32 mit NAN"      ENDOF
           7FF00800  OF ." Restberechnung mit Dividend " ENDOF
           7FF00400  OF ." Restberechnung mit Divisor 0"  ENDOF
           7FF00000  OF ." +Unendlich"                    ENDOF
           FFF00000  OF ." -Unendlich"                    ENDOF
                DUP  OF ." NaN von unbekannter Art"       ENDOF
         ENDCASE
         CR   FALSE
       ELSE
         DROP FALSE  CR ." NaN von unbekannter Art" CR
       THEN
     THEN ;

CODE FTESTERR  ( -- fl )       \ Gleitkomma-Errorflag testen und lschen
     FPTESTERR                 \ fl = TRUE,  wenn Error-Flag gesetzt
     -1 ADC   1PUSH END-CODE   \ Vorsicht,   in ASSEMBLER umgekehrt !
CODE FSETERR   ( -- )          \ Gleitkomma-Errorflag setzen
     FPUSETERR NEXT END-CODE
CODE FCLRERR   ( -- )          \ Gleitkomma-Errorflag lschen
     FPUCLRERR NEXT END-CODE


CR .( Multiplikation und Division mit einer Konstanten )

CODE F2* ( rs -- rs*2 )        \ 32-Bit-Multiplikation mit 2
     SP LDL                    \ Stack-Adresse nach Areg
     FPLDNLSN                  \ REAL32-Wert von Stack nach FAreg
     FPUMULBY2                 \ FAreg mal 2
     SP LDL                    \ Stack-Adresse nach Areg
     FPSTNLSN                  \ FAreg32 nach Stack-Adresse
     NEXT END-CODE

CODE F2^+32 ( rs -- rs*2^32 )  \ 32-Bit-Multiplikation mit 2^32
     SP LDL                    \ Stack-Adresse nach Areg
     FPLDNLSN                  \ REAL32-Wert von Stack nach FAreg
     FPUEXPINC32               \ FAreg mal 2 hoch 32
     SP LDL                    \ Stack-Adresse nach Areg
     FPSTNLSN                  \ FAreg32 nach Stack-Adresse
     NEXT END-CODE

CODE F2/ ( rs -- rs/2 )        \ 32-Bit-Division durch 2
     SP LDL                    \ Stack-Adresse nach Areg
     FPLDNLSN                  \ REAL32-Wert von Stack nach FAreg
     FPUDIVBY2                 \ FAreg durch 2
     SP LDL                    \ Stack-Adresse nach Areg
     FPSTNLSN                  \ FAreg32 nach Stack-Adresse
     NEXT END-CODE

CODE F2^-32 ( rs -- rs/2^32 )  \ 32-Bit-Division durch 2^32
     SP LDL                    \ Stack-Adresse nach Areg
     FPLDNLSN                  \ REAL32-Wert von Stack nach FAreg
     FPUEXPDEC32               \ FAreg durch 2 hoch 32
     SP LDL                    \ Stack-Adresse nach Areg
     FPSTNLSN                  \ FAreg32 nach Stack-Adresse
     NEXT END-CODE

CODE FD2* ( rd -- rd*2 )       \ 64-Bit-Multiplikation mit 2
     SP LDL                    \ Stack-Adresse nach Areg
     FPLDNLDB                  \ REAL64-Wert von Stack nach FAreg
     FPUMULBY2                 \ FAreg mal 2
     SP LDL                    \ Stack-Adresse nach Areg
     FPSTNLDB                  \ FAreg64 nach Stack-Adresse
     NEXT END-CODE

CODE FD2^+32 ( rd -- rd*2^32 ) \ 64-Bit-Multiplikation mit 2^32
     SP LDL                    \ Stack-Adresse nach Areg
     FPLDNLDB                  \ REAL64-Wert von Stack nach FAreg
     FPUEXPINC32               \ FAreg mal 2 hoch 32
     SP LDL                    \ Stack-Adresse nach Areg
     FPSTNLDB                  \ FAreg64 nach Stack-Adresse
     NEXT END-CODE

CODE FD2/ ( rd -- rd/2 )       \ 64-Bit-Division durch 2
     SP LDL                    \ Stack-Adresse nach Areg
     FPLDNLDB                  \ REAL64-Wert von Stack nach FAreg
     FPUDIVBY2                 \ FAreg durch 2
     SP LDL                    \ Stack-Adresse nach Areg
     FPSTNLDB                  \ FAreg64 nach Stack-Adresse
     NEXT END-CODE

CODE FD2^-32 ( rd -- rd/2^32 ) \ 64-Bit-Division durch 2^32
     SP LDL                    \ Stack-Adresse nach Areg
     FPLDNLDB                  \ REAL64-Wert von Stack nach FAreg
     FPUEXPDEC32               \ FAreg durch 2 hoch 32
     SP LDL                    \ Stack-Adresse nach Areg
     FPSTNLDB                  \ FAreg64 nach Stack-Adresse
     NEXT END-CODE


CR .( Gleitkomma-Konstanten )
HEX

40490FDB           CONSTANT  &PI
3FC90FDB           CONSTANT  &PI/2
3F490FDB           CONSTANT  &PI/4
3EA2F983           CONSTANT  &1/PI

400921FB54442D18. 2CONSTANT D&PI
3FF921FB54442D18. 2CONSTANT D&PI/2
3FE921FB54442D18. 2CONSTANT D&PI/4
3FD45F306DC9C883. 2CONSTANT D&1/PI
3FE62E42FEFA39EF. 2CONSTANT D&LN2
3FD34413509F79FF. 2CONSTANT D&LOG2
3FDBCB7B1526E50E. 2CONSTANT D&LOGE
4005BF0A8B145769. 2CONSTANT D&E
40026BB1BBB55516. 2CONSTANT D&LN10
3FF6A09E667F3BCD. 2CONSTANT D&SQRT2
3FFBB67AE8584CAA. 2CONSTANT D&SQRT3
40094C583ADA5B53. 2CONSTANT D&SQRT10


CR .( Rundungsmodus einstellen )

CODE FROUNDN ( -- )         \ Set rounding mode
     FPURN                  \ to round to nearest
     NEXT END-CODE

CODE FROUNDZ ( -- )         \ Set rounding mode
     FPURZ                  \ to round to zero
     NEXT END-CODE

CODE FROUNDP ( -- )         \ Set rounding mode
     FPURP                  \ to round toward plus infinity
     NEXT END-CODE

CODE FROUNDM ( -- )         \ Set rounding mode
     FPURM                  \ to round toward minus infinity
     NEXT END-CODE


CR .( Quadratwurzel )

CODE FSQRT    ( rs1 -- rs2 )   \ Quadratwurzel, round-to-nearest, 32 Bit
     SP LDL                    \ Stack-Adresse von rs1 nach Areg
     FPLDNLSN                  \ REAL32-Wert von Stack nach FAreg
     FPUSQRTFIRST
     FPUSQRTSTEP FPUSQRTSTEP
     FPUSQRTLAST
     SP LDL                    \ Stack-Adresse von rs2 nach Areg
     FPSTNLSN                  \ FAreg-32 zum Datenstack
     NEXT END-CODE

CODE FDSQRT   ( rd1 -- rd2 )   \ Quadratwurzel, round-to-nearest, 64 Bit
     SP LDL                    \ Stack-Adresse von rd1 nach Areg
     FPLDNLDB                  \ REAL64-Wert von Stack nach FAreg
     FPUSQRTFIRST
     FPUSQRTSTEP FPUSQRTSTEP FPUSQRTSTEP FPUSQRTSTEP FPUSQRTSTEP
     FPUSQRTLAST
     SP LDL                    \ Stack-Adresse von rd2 nach Areg
     FPSTNLDB                  \ FAreg-64 zum Datenstack
     NEXT END-CODE

CODE FSQRT-M  ( rs1 -- rs2 )   \ Quadratwurzel, round-to-minus, 32 Bit
     SP LDL                    \ Stack-Adresse von rs1 nach Areg
     FPLDNLSN                  \ REAL32-Wert von Stack nach FAreg
     FPUSQRTFIRST
     FPUSQRTSTEP FPUSQRTSTEP
     FPURM                     \ Round-to-minus-infinity
     FPUSQRTLAST
     SP LDL                    \ Stack-Adresse von rs2 nach Areg
     FPSTNLSN                  \ FAreg-32 zum Datenstack
     NEXT END-CODE

CODE FDSQRT-M ( rd1 -- rd2 )   \ Quadratwurzel, round-to-minus, 64 Bit
     SP LDL                    \ Stack-Adresse von rd1 nach Areg
     FPLDNLDB                  \ REAL64-Wert von Stack nach FAreg
     FPUSQRTFIRST
     FPUSQRTSTEP FPUSQRTSTEP FPUSQRTSTEP FPUSQRTSTEP FPUSQRTSTEP
     FPURM                     \ Round-to-minus-infinity
     FPUSQRTLAST
     SP LDL                    \ Stack-Adresse von rd2 nach Areg
     FPSTNLDB                  \ FAreg-64 zum Datenstack
     NEXT END-CODE

CODE FSQRT-P  ( rs1 -- rs2 )   \ Quadratwurzel, round-to-plus, 32 Bit
     SP LDL                    \ Stack-Adresse von rs1 nach Areg
     FPLDNLSN                  \ REAL32-Wert von Stack nach FAreg
     FPUSQRTFIRST
     FPUSQRTSTEP FPUSQRTSTEP
     FPURP                     \ Round-to-plus-infinity
     FPUSQRTLAST
     SP LDL                    \ Stack-Adresse von rs2 nach Areg
     FPSTNLSN                  \ FAreg-32 zum Datenstack
     NEXT END-CODE

CODE FDSQRT-P ( rd1 -- rd2 )   \ Quadratwurzel, round-to-plus, 64 Bit
     SP LDL                    \ Stack-Adresse von rd1 nach Areg
     FPLDNLDB                  \ REAL64-Wert von Stack nach FAreg
     FPUSQRTFIRST
     FPUSQRTSTEP FPUSQRTSTEP FPUSQRTSTEP FPUSQRTSTEP FPUSQRTSTEP
     FPURP                     \ Round-to-plus-infinity
     FPUSQRTLAST
     SP LDL                    \ Stack-Adresse von rd2 nach Areg
     FPSTNLDB                  \ FAreg-64 zum Datenstack
     NEXT END-CODE

CODE FSQRT-Z  ( rs1 -- rs2 )   \ Quadratwurzel, round-to-zero, 32 Bit
     SP LDL                    \ Stack-Adresse von rs1 nach Areg
     FPLDNLSN                  \ REAL32-Wert von Stack nach FAreg
     FPUSQRTFIRST
     FPUSQRTSTEP FPUSQRTSTEP
     FPURP                     \ Round-to-zero
     FPUSQRTLAST
     SP LDL                    \ Stack-Adresse von rs2 nach Areg
     FPSTNLSN                  \ FAreg-32 zum Datenstack
     NEXT END-CODE

CODE FDSQRT-Z ( rd1 -- rd2 )   \ Quadratwurzel, round-to-zero, 64 Bit
     SP LDL                    \ Stack-Adresse von rd1 nach Areg
     FPLDNLDB                  \ REAL64-Wert von Stack nach FAreg
     FPUSQRTFIRST
     FPUSQRTSTEP FPUSQRTSTEP FPUSQRTSTEP FPUSQRTSTEP FPUSQRTSTEP
     FPURP                     \ Round-to-zero
     FPUSQRTLAST
     SP LDL                    \ Stack-Adresse von rd2 nach Areg
     FPSTNLDB                  \ FAreg-64 zum Datenstack
     NEXT END-CODE

CR .( Ende des Gleitkommateils )


CR .( Erweiterung der Ganzzahl-Arithmetik )
HEX

\ Ich habe mich entschlossen, das "Pseudoregister" HREG ( vom ASSEMBLER aus
\ zugngig )  zur Zwischenspeicherung des CPU-Errorflags  und GREG  fr das
\ FPU-Errorflag zu verwenden.  Damit kann ich auch alle Ganzzahloperationen
\ mit Fehlerberprfmglichkeiten versehen, obwohl ich sie als Code-Defini-
\ tionen ausgefhrt habe, ohne dass deswegen ein auf dem Forthstack abzule-
\ gendes Flag  bemht zu werden bruchte.  HREG kann bei Bedarf  ( in einer
\ Testphase ) abgelesen werden,  man kann es aber auch ( nach Austesten des
\ Forthprogramms ) bleiben lassen.  Als Pseudonyme  habe ich AEFLAG := HREG
\ und FEFLAG := GREG eingefhrt.

CODE TESTERR ( -- fl )         \ fl =  TRUE, wenn AEFLAG = 0
     AEFLAG LDL  -1 ADC        \ fl = FALSE, wenn AEFLAG = 1
     1 LDC AEFLAG STL          \ AEFLAG wird dann auf 1 gesetzt.
     1PUSH END-CODE

CODE SETERR  ( -- )            \ AEFLAG wird      auf 0 gesetzt.
     0 LDC  AEFLAG STL
     NEXT END-CODE

: 2^N* ( n1 u -- n2 )          \ n1 mal 2 hoch u
     SAL ;                     \ Absicherung siehe SAL

: 2^N/ ( n1 u -- n2 )          \ n1 durch 2 hoch u
     SAR ;                     \ Absicherung siehe SAR

: SQRT ( n -- rem n )
     DUP 0< IF ABORT" Radikand negativ oder zu gro" THEN
     ASM[ SP LDL    0 LDNL DUP  CREG STL       \ C = n
          NORM  ADD  REV                       \ Anzahl Verschiebebits
          21 LDC  REV  DIFF                    \ als Anfangsstck mit
           1 LDC  SHR                          \ Korrektur durch 2
           1 LDC  REV  SHL                     \ 1000... erzeugen
             DUP  BREG STL                     \ Ausgang fr Halbierung
           1 LDC  SHR                          \ Durch 2
                  AREG STL                     \ Untere Grenze fr A
          SP LDL   -4 ADC         SP STL       \ Stack anpassen
          BEGIN
            BREG LDL  AREG LDL  1 ADC  >       \ solange wie B > A+1
          WHILE
               0 LDC
            AREG LDL  BREG LDL  LSUM           \ (A+B)
               1 LDC  LSHR DUP  DREG STL       \ D = (A+B)/2
                 DUP  PROD      EREG STL       \ E = D*D
            EREG LDL  CREG LDL  >=             \ E >= C ?
            IF   DREG LDL  BREG STL  THEN      \ ja: B = D
            EREG LDL  CREG LDL  <=             \ E <= C ?
            IF   DREG LDL  AREG STL  THEN      \ ja: A = D
          REPEAT
          AREG LDL    SP LDL    0 STNL
          CREG LDL  AREG LDL  DUP PROD
          DIFF SP LDL  4 ADC    0 STNL   NEXT ]FORTH ;


: DSQRT ( d -- rem d )
     2DUP D0< IF ABORT" Radikand negativ oder zu gro" THEN
     ASM[ SP LDL    0 LDNL DUP  CREG STL       \ C = n
          NORM  ADD  REV                       \ Anzahl Verschiebebits
          21 LDC  REV  DIFF                    \ als Anfangsstck mit
           1 LDC  SHR                          \ Korrektur durch 2
           1 LDC  REV  SHL                     \ 1000... erzeugen
             DUP  BREG STL                     \ Ausgang fr Halbierung
           1 LDC  SHR                          \ Durch 2
                  AREG STL                     \ Untere Grenze fr A
          SP LDL   -4 ADC         SP STL       \ Stack anpassen
          BEGIN
            BREG LDL  AREG LDL  1 ADC  >       \ solange wie B > A+1
          WHILE
               0 LDC
            AREG LDL  BREG LDL  LSUM           \ (A+B)
               1 LDC  LSHR DUP  DREG STL       \ D = (A+B)/2
                 DUP  PROD      EREG STL       \ E = D*D
            EREG LDL  CREG LDL  >=             \ E >= C ?
            IF   DREG LDL  BREG STL  THEN      \ ja: B = D
            EREG LDL  CREG LDL  <=             \ E <= C ?
            IF   DREG LDL  AREG STL  THEN      \ ja: A = D
          REPEAT
          AREG LDL    SP LDL    0 STNL
          CREG LDL  AREG LDL  DUP PROD
          DIFF SP LDL  4 ADC    0 STNL   NEXT ]FORTH ;


VARIABLE SEED  SEED 1+!     \ Vorgabe 1

: SEED! ( n -- )                         \ 1  n  7FFFFFFE
     DUP 1 7FFFFFFE BETWEEN
     IF   SEED !
     ELSE CR BOLD ." 1  seed  7FFFFFFE eingeben !" ATTOFF
     THEN ;

: RANDOM ( -- n )           \ 1  n = Zufallsganzzahl  7FFFFFFE
     SEED @
     ASM[
       0 LDC                \ fr Creg
       SP LDL  0 LDNL       \ seed
       41A7 LDC             \ Multiplikator a
       LMUL                 \ seed * a
       MINT                 \ Areg = 80000000
       -1 ADC               \ Areg = 7FFFFFFF
       LDIV  REV            \ Areg = Rest
       SP LDL  0 STNL  NEXT
     ]FORTH                 \ auf Stack
     DUP                    \ Wegen der zu diesem Zufallsgenerator gehrigen
     SEED ! ;               \ Theorie siehe Park, S.K. and K.W. Miller,
                            \ Communications of the ACM 31 (1988), 1192-1201

: RANDOM-0-1 ( -- c )             \ c = 0 oder 1 ( Zufallszahl )
     SEED @                       \ Anfangs-0-1-Folge
     ASM[ SP LDL  0 LDNL          \ seed vom Stack
          1 LDC  SHL   BREG STL   \ einfach geschiftetes seed nach BREG
          BREG LDL
          2 LDC SHL   2 LDC SHR   \ 2mal nach links, dann 2mal nach rechts
          AREG STL     BREG LDL   \ und nach AREG
          MINT  1 LDC  SHR  AND   \ ursprnglich hchstes Bit = 0 ?
          1IF
               53 LDC  AREG LDL   \ primitive polynomial ( siehe Knuth )
                  XOR  AREG STL   \ mit seed geXORt nach AREG
          THEN
          AREG LDL                \ geschiftetes seed
          DUP  1 LDC  AND         \ letztes Bit
          SP LDL  -4 ADC  SP STL  \ Stack anpassen
          SP LDL  1 STNL          \ letztes Bit auf Stack
          SP LDL  0 STNL          \ neues seed auf Stack
          NEXT            ]FORTH
     SEED! ;                      \ Wegen der diesem 0-1-Zufallszahlengene-
                                  \ rator  zugrundeliegenden Theorie  siehe
                                  \ Knuth,  D.E.:  The Art of Computer Pro-
                                  \ gramming, II. Addison-Wesley 1969, S.28.


CR .( Wahlmglichkeiten )
: OPTIONS ( -- )
     ['] CAPS ['] STATUS? ['] ECHO ['] ATTRIBUTS
     BASE @ >R  DECIMAL
     5 1 DO CR 2 SPACES BOLD ."  SHFT-F" I . ATTOFF ." / "
     BOLD ." CTRL-F" I . ATTOFF 27 ?TAB DUP >NAME .ID
     DUP ['] ATTRIBUTS = IF DROP ['] ATT-TEMP THEN
     31 ?TAB >IS @ IF BOLD ." ON " ATTOFF ." / OFF"
     ELSE ATTOFF ." ON / " BOLD ." OFF " ATTOFF THEN LOOP  R> BASE !
     CR 2 SPACES BOLD ."  SHFT-F6 " ATTOFF
     ."   Neuen Editor whlen"
     CR 2 SPACES BOLD ."  SHFT-F7 " ATTOFF
     ."   .VOK-Dateien-Pfad festlegen" ;

HEX
CR .( dpANS-5-Worte )
\ **********************************************************
\ Ende des ursprnglichen Teils, des F83-Teils von TCORE.FTH

\ Es folgen noch einige dpANS-5-Worte.      -    25.4.95
\ Ich habe mich an den Artikel "Omzetting van de 83-standaard naar dpANS-5"
\ von Willem Ouwerkerk  in "Het Vijgeblad" Nr.42,  der Clubzeitschrift  der
\ hollndischen "Forth-Gebruikersgroep", und an die Folgeartikel gehalten.

\ Von den CORE-Worten ( CORE im Sinne von dpANS-5 ):

\    2*        >NUMBER     ACCEPT    ALIGN       ALIGNED
\    BL        CELL+       CELLS     CHAR        CHAR+
\    CHARS     ENVIRONMENT EVALUATE  FM/MOD      LSHIFT
\    MOVE      POSTPONE    RSHIFT    RECURSE     S"
\    S>D       SM/REM      SOURCE    UNLOOP      [CHAR]

\ sind die folgenden im bisherigen Transputer-Forth-System
\ F-TP noch nicht enthalten und werden jetzt definiert:

\              >NUMBER     ACCEPT                ALIGNED
\              CELL+       CELLS     CHAR        CHAR+
\    CHARS     ENVIRONMENT EVALUATE  FM/MOD      LSHIFT
\              POSTPONE    RSHIFT                S"
\              SM/REM      SOURCE    UNLOOP      [CHAR]

\ --- wird bei Gelegenheit vervollstndigt

: CELL+ ( ad1 -- ad2 ) 4+ ; \ ad2 = ad1+4
: CELLS ( ad1 -- ad2 ) 4* ; \ ad2 = ad1*4
: CELL- ( ad1 -- ad2 ) 4- ; \ ad2 = ad1-4        kein dpANS-5-Wort

: CHAR+ ( ad1 -- ad2 ) 1+ ; \ ad2 = ad1+1
: CHARS ( ad1 -- ad2 )    ; \                    keine Wirkung
: CHAR- ( ad1 -- ad2 ) 1- ; \ ad2 = ad1-1        kein dpANS-5-Wort

: CHAR  ( <name> -- c )     \ wirkt wie ASCII im Interpretier-Modus
     BL WORD 1+ C@ ;
: [CHAR] ( <name> -- )      \ wirkt wie ASCII im Compile-Modus
     CHAR [COMPILE] LITERAL ; IMMEDIATE

: ALIGNED ( ad1 -- ad2 ) EVEN ;

: INVERT ( n1 -- n2 ) NOT ; \ n2 = not n1

CODE LSHIFT ( u1 u2 -- u3 ) \ Linksverschiebung von u1 um u2 Bits
     SP LDL  1 LDNL         \ Vorzeichenlosen 32-Bit-Wert u1
     SP LDL  0 LDNL         \ um u2
     1F LDC  AND            \ modulo 32d Bits
        SHL                 \ nach links. Rechts wird 0 aufgefllt.
     SP LDL  1 STNL         \ Ergebnis auf Stack legen
     SP LDL  4 ADC  SP STL  \ Stack anpassen
     NEXT END-CODE

CODE RSHIFT ( u1 u2 -- u3 ) \ Rechtsverschiebung von u1 um u2 Bits
     SP LDL  1 LDNL         \ Vorzeichenlosen 32-Bit-Wert u1
     SP LDL  0 LDNL         \ um u2
     1F LDC  AND            \ modulo 32d Bits
        SHR                 \ nach rechts. Links wird 0 aufgefllt.
     SP LDL  1 STNL         \ Ergebnis auf Stack legen
     SP LDL  4 ADC  SP STL  \ Stack anpassen
     NEXT END-CODE

CODE DLSHIFT ( ud1 u -- ud2 ) \ Linksverschiebung von ud1 um u Bits
     SP LDL  0 LDNL         \ Vorzeichenlosen Wert u
     3F LDC  AND            \ modulo 64d
       AREG  STL            \ nach Areg zwischenspeichern.
     SP LDL  2 LDNL         \ Vorzeichenlosen
     SP LDL  1 LDNL         \ 64-Bit-Wert ud1
       AREG  LDL            \ um u modulo 64d Bits
       LSHL                 \ nach links. Rechts wird 0 aufgefllt.
     SP LDL  1 STNL         \ Ergebnis
     SP LDL  2 STNL         \ auf Stack legen.
     SP LDL  4 ADC  SP STL  \ Stack anpassen.
     NEXT END-CODE          \ Kein dpANS-5-Wort !

CODE DRSHIFT ( ud1 u -- ud2 ) \ Rechtsverschiebung von ud1 um u Bits
     SP LDL  0 LDNL         \ Vorzeichenlosen Wert u
     3F LDC  AND            \ modulo 64d
       AREG  STL            \ nach Areg zwischenspeichern.
     SP LDL  2 LDNL         \ Vorzeichenlosen
     SP LDL  1 LDNL         \ 64-Bit-Wert ud1
       AREG  LDL            \ um u modulo 64d Bits
       LSHR                 \ nach rechts. Links wird 0 aufgefllt.
     SP LDL  1 STNL         \ Ergebnis
     SP LDL  2 STNL         \ auf Stack legen.
     SP LDL  4 ADC  SP STL  \ Stack anpassen.
     NEXT END-CODE          \ Kein dpANS-5-Wort !

CODE (UNLOOP) ( -- )        \ Schleifenebene nach Ende der Schleife verlassen
     RP LDL 0C ADC RP STL
     NEXT END-CODE

: UNLOOP COMPILE (UNLOOP) ; IMMEDIATE

: POSTPONE ( <name> -- )    \ Ersetzt COMPILE und [COMPILE]
     BL WORD FIND DUP 0=
     ABORT" Nicht auffindbar "
     -1 =
     IF COMPILE COMPILE THEN
     , ;  IMMEDIATE

\ (S") siehe bei (SEE) .

: S"    ( -- )
     STATE @
     IF   COMPILE (S") ,"
     ELSE 22 ( ASCII " ) PARSE
     THEN ; IMMEDIATE

: >NUMBER ( ud1 ad1 len1 -- ud2 ad2 len2 )
     BEGIN DUP 0= 0=
     WHILE OVER C@ BASE @ DIGIT
           0= IF DROP EXIT THEN
           >R 2SWAP SWAP
           BASE @ UM*
           NIP 0 ROT
           BASE @ UM* D+
           R> S>D
           D+
           2SWAP 1 /STRING
     REPEAT ;

: ACCEPT ( ad len1 -- len2 )
     EXPECT SPAN @ ;

\ SM/REM wurde schon  in TKERNEL.FTH definiert.  Es wurde dort ein paar Mal
\ bentigt. Ich hatte es ursprnglich als M/MOD vorgesehen.  Die Definition
\ von M/MOD im Sinne von Forth 83, also mit "floored division", folgt jetzt.
\ Zunchst jedoch FM/MOD .

: FM/MOD ( d1 n1 -- n2 n3 )       \ Wie SM/REM, aber mit "floored division"
     DUP >R SM/REM DUP 0<
     IF 1- SWAP R@ + SWAP THEN
     R> DROP ;

: M/MOD  ( d1 n1 -- n2 n3 )
     NOOP ;

' FM/MOD IS M/MOD                 \ Direkte Umleitung von M/MOD auf FM/MOD

: EVALUATE ( ad len -- )          \ EVALUATE scheint die Funktionen von
     NOOP ;                       \ $EXECUTE zu haben. Allerdings hat
                                  \ $EXECUTE komfortablere Fehlermeldungen.

' $EXECUTE IS EVALUATE            \ Direkte Umleitung

: EVALUATE-HOST ( ad len -- )     \ Nicht-ANS-Forth, aber in diesem
     NOOP ;                       \ Zusammenhang einleuchtend.

' $EXECUTE-HOST IS EVALUATE-HOST  \ Direkte Umleitung

\ Ich wei nicht, ob das folgende Wort M*/ zu Forth 83 gehrte. In meinem
\ Transputer-Forth-System  war es bisher nicht enthalten.  Es gehrt aber
\ auf jeden Fall zu den ANS-Forth-Worten.

CODE M*/   ( d1 n1 +n2 -- d2 ) \ t (96 Bit) = d1*n1 , d2 = t/+n2
     0 LDC  CREG STL       \ d1hi > 0  -->  CREG = 0
     SP LDL  3 LDNL        \ d1hi
     MINT    AND           \ negativ ?
     11 CJ                 \ Nein, dann Sprung
     1 LDC  CREG STL       \ d1hi < 0  -->  CREG = 1
     0 LDC                 \      :
     0 LDC  SP LDL  2 LDNL \      :
     LDIFF  SP LDL  2 STNL \      negate
     0 LDC  SP LDL  3 LDNL \      :
     LDIFF  SP LDL  3 STNL \      :
     0 LDC  DREG STL       \ nach hier. n1 > 0  -->  DREG = 0
     SP LDL  1 LDNL        \ n1
     MINT    AND           \ negativ ?
     9 CJ                  \ Nein, dann Sprung
     1 LDC  DREG STL       \ n1 < 0  -->  DREG = 1
     SP LDL  1 LDNL
     NOT  1 ADC            \ Negieren, wenn negativ
     SP LDL  1 STNL
     0 LDC                 \ nach hier. Ausgangs-"carry" laden.
     SP LDL  1 LDNL        \ n1
     SP LDL  2 LDNL        \ d1lo
     LMUL                  \ n1*d1lo in Areg, "carry" in Breg
     BREG STL              \ Zwischenspeichern
     SP LDL  1 LDNL        \ n1
     SP LDL  3 LDNL        \ d1hi
     LMUL                  \ n1*d1hi in Breg, "carry" in Creg
     SP LDL  0 LDNL        \ +n2 in Areg
     LDIV                  \ (n1*d1hi)/+n2 in Areg, "carry" in Breg
     AREG STL              \ Zwischenspeichern hi
     BREG LDL              \ "carry" in Creg, n1*d1lo in Breg
     SP LDL  0 LDNL        \ +n2 in Areg
     LDIV                  \ (n1*d1lo)/+n2
     BREG STL              \ Zwischenspeichern lo
     SP LDL  8 ADC SP STL  \ Stack anpassen
     CREG LDL              \ d1 oder n1 negativ
     DREG LDL  XOR         \ und das andere positiv ?
     0B CJ                 \ Nein, dann Sprung
     0 LDC                 \      :
     0 LDC  BREG LDL       \      :
     LDIFF  BREG STL       \      negate
     0 LDC  AREG LDL       \      :
     LDIFF  AREG STL       \      :
     BREG LDL              \ nach hier
     SP LDL  0 STNL        \ lo auf Stack
     AREG LDL
     SP LDL  1 STNL        \ hi auf Stack
     NEXT END-CODE

\ Es fehlt noch ENVIRONMENT .
\ berprft und den ANS-Forderungen angepasst werden muss noch SOURCE .

\ --------------------------------------------------------------

\ Von den CORE-Extension-Worten ( CORE im Sinne von dpANS-5 ):

\    .R        0<>         0>        2>R         2R>
\    2R@       :NONAME     <>        ?DO         AGAIN
\    C"        CASE        ENDCASE   ENDOF       ERASE
\    FALSE     MARKER      NIP       OF          PARSE
\    REFILL    RESTORE-INPUT         SAVE-INPUT  SOURCE-ID
\    TO        TRUE        TUCK      U.R         U>
\    UNUSED    VALUE       WITHIN    \

\ sind die folgenden im bisherigen Transputer-Forth-System
\ F-TP noch nicht enthalten und werden jetzt definiert:

\                                    2>R         2R>
\    2R@       :NONAME
\    C"
\              MARKER
\    REFILL    RESTORE-INPUT         SAVE-INPUT  SOURCE-ID
\    TO
\    UNUSED    VALUE


\    ---------- wird bei Gelegenheit vervollstndigt


CODE 2>R ( d -- )                   \ Entspricht SWAP >R >R
      RP LDL  -8 ADC  RP STL
      SP LDL  0 LDNL  RP LDL  0 STNL
      SP LDL  1 LDNL  RP LDL  1 STNL
      SP LDL   8 ADC  SP STL  NEXT END-CODE

CODE 2R> ( -- d )                   \ Entspricht R> R> SWAP
      SP LDL  -8 ADC  SP STL
      RP LDL  0 LDNL  SP LDL  0 STNL
      RP LDL  1 LDNL  SP LDL  1 STNL
      RP LDL   8 ADC  RP STL  NEXT END-CODE

CODE 2R@ ( -- d )                   \ Entspricht R> R> 2DUP >R >R SWAP
      SP LDL  -8 ADC  SP STL
      RP LDL  0 LDNL  SP LDL  0 STNL
      RP LDL  1 LDNL  SP LDL  1 STNL
                              NEXT END-CODE

: :NONAME ( -- xt )
      HERE !CSP
      ['] : @             \ Damit wird "NEST" auf den Stack gelegt.
      , ] ; IMMEDIATE

\ (C") siehe bei (SEE) .

: C"   ( -- )
      STATE @
      IF   COMPILE (C") ,"
      ELSE 22 ( ASCII " ) PARSE SWAP 1- TUCK C!
      THEN ; IMMEDIATE

: VALUE  ( <name> n -- : name -- n ) CREATE   , DOES>  @ ;
: 2VALUE ( <name> d -- : name -- d ) CREATE , , DOES> 2@ ;
                          \ 2VALUE ist kein dpANS-5-Wort

: UNUSED ( -- u ) SP0 @ HERE - ;

: TO     ( <name> n -- )
      ' >BODY  STATE @
      IF [COMPILE] LITERAL COMPILE  ! EXIT THEN  ! ; IMMEDIATE

: 2TO    ( <name> d -- )
      ' >BODY  STATE @
      IF [COMPILE] LITERAL COMPILE 2! EXIT THEN 2! ; IMMEDIATE
                          \    2TO ist kein dpANS-5-Wort

: +TO   ( <name> n -- )
      ' >BODY  STATE @
      IF [COMPILE] LITERAL COMPILE +! EXIT THEN +! ; IMMEDIATE
                          \ ANS oder nicht AS, ich mach das jetzt einfach !
                          \ 13.8.96

: 1+TO  ( <name> -- )
      1 ' >BODY  STATE @
      IF [COMPILE] LITERAL COMPILE +! EXIT THEN +! ; IMMEDIATE
                          \ ANS oder nicht ANS, ich mach das jetzt einfach !
                          \ 13.8.96

\ Es fehlen noch  REFILL  RESTORE-INPUT  SAVE-INPUT  SOURCE-ID
\ Das Wort MARKER befindet sich weiter unten am Schluss.


\ Weitere ANS-Forth-Worte
\ -----------------------
\ Inzwischen ( 20.8.96 ) ist mir das ANS-Forth-X3J14-Dokument bekannt ge-
\ worden. Ich werde zgig versuchen,  auch die dort zu findenden zur Wahl
\ gestellten ANS-Forth-Worte einzubauen.

\ Floating-Point Word Set
\ -----------------------
\ Der Transputer T800 hat einen ( drei Eintrge tiefen ) Gleitkomma-Stack.
\ Das reicht. Und wo es nicht reicht, verwende ich die sich auf den jewei-
\ ligen Workspace-Pointer beziehenden "lokalen Variablen"  AREG bis HREG .
\ Kompliziert zusammengesetzte Gleitkomma-Berechnungen  werden sicher bes-
\ ser gleich in Maschinensprache, also als Code-Definitionen, gefasst. Und
\ da ist eine  zustzliche Stackorganisation  eher hinderlich.  Im brigen
\ haben bei mir  einfachgenaue Gleitkommazahlen die Lnge 32 Bit  und dop-
\ peltgenaue die Lnge 64 Bit. DUP @ ! usw. brauchen sich also nicht darum
\ zu kmmern, ob der Operand, auf den sie wirken, eine Gleikomma-Zahl oder
\ eine "normale" Zahl ist.  Gleitkomma-Zahlen sind also, wenn sie wirklich
\ auf Stack gelegt werden mssen,  auf dem Datenstack gut aufgehoben.  Ich
\ kann also  eine ganze Reihe  von "F"-Worten,  die bei ANS  vorgeschlagen
\ werden,  durch einfache Umleitung  auf bei mir  schon lngst  bestehende
\ Worte zur Verfgung stellen:

\ Von den in der ANS-Dokumentation vorgeschlagenen Worten

\ >FLOAT     D>F        F!        F*       F+        F      F/
\ F0<        F0=        F<        F>D      F@        FALIGN  FALIGNED
\ FCONSTANT  FDEPTH     FDROP     FDUP     FLITERAL  FLOAT+  FLOATS
\ FLOOR      FMAX       FMIN      FNEGATE  FOVER     FROT    FROUND
\ FSWAP      FVARIABLE  REPRESENT

\ sind die folgenden im bisherigen Transputer-Forth-System
\ F-TP noch nicht enthalten und werden jetzt definiert:

\ >FLOAT     D>F        F!
\ F0<        F0=                  F>D      F@        FALIGN  FALIGNED
\ FCONSTANT  FDEPTH     FDROP     FDUP     FLITERAL  FLOAT+  FLOATS
\ FLOOR      FMAX       FMIN      FNEGATE  FOVER     FROT    FROUND
\ FSWAP      FVARIABLE  REPRESENT  ---- noch beenden !!!!

: F!        NOOP ;  ' !        IS F!
: F@        NOOP ;  ' @        IS F@
: FDROP     NOOP ;  ' DROP     IS FDROP
: FDUP      NOOP ;  ' DUP      IS FDUP
: FOVER     NOOP ;  ' OVER     IS FOVER
: FROT      NOOP ;  ' ROT      IS FROT
: FSWAP     NOOP ;  ' SWAP     IS FSWAP
: FVARIABLE NOOP ;  ' VARIABLE IS FVARIABLE
: FCONSTANT NOOP ;  ' CONSTANT IS FCONSTANT
: FLITERAL  NOOP ;    IMMEDIATE
                    ' LITERAL  IS FLITERAL
: FDEPTH    NOOP ;  ' DEPTH    IS FDEPTH
: FALIGN    [COMPILE] ALIGN ;  IMMEDIATE
: FALIGNED  EVEN ;

: FLOAT+ ( ad -- ad+4 ) \ Gleichbedeutend mit CELL+
     4+ ;
: FLOATS ( n1 -- n1*4 ) \ Gleichbedeutend mit CELLS
     4* ;

CODE F0< ( rs -- fl )       \ fl = TRUE, wenn rs < 0.0
     FPLDZEROSN             \ 0.0 nach FBreg
     SP LDL                 \ Stack-Adresse von rs nach Areg
     FPLDNLSN               \ REAL32-Wert von Stack nach FAreg
     FPGT                   \ Floating Point Greater Than
     NEG                    \ Fr FORTH: TRUE = -1
     SP LDL  0 STNL         \ Areg zum Stack
     NEXT END-CODE

CODE F0= ( rs -- fl )       \ fl = TRUE, wenn rs = 0.0
     FPLDZEROSN             \ 0.0 nach FBreg
     SP LDL                 \ Stack-Adresse von rs nach Areg
     FPLDNLSN               \ REAL32-Wert von Stack nach FAreg
     FPEQ                   \ Floating Point Equals
     NEG                    \ Fr FORTH: TRUE = -1
     SP LDL  0 STNL         \ Areg zum Stack
     NEXT END-CODE

CODE F>D ( rs -- d )        \ Ganzzahl-Anteil von r32 nach 64-Integer
     SP LDL                 \ Stack-Adresse nach Areg
     FPLDNLSN               \ rs von Stack nach FAreg
     FPUR32TOR64            \ r32-->r64
     FPINT                  \ Nur Ganzzahl-Anteil
     FPDUP                  \ Jetzt in FBreg und FAreg
     SP LDL -4 ADC  SP STL  \ Stack anpassen
     SP LDL                 \ Stack-Adresse nach Areg
     FPSTNLI32              \ Als 32-Bit-Integer-Zahl auf Stack ( low )
     SP LDL  4 ADC          \ nchste Stack-Adresse nach Areg
     FPUEXPDEC32            \ Durch 2**32 teilen
     FPSTNLI32              \ Als 32-Bit-Integer-Zahl auf Stack ( high )
     NEXT END-CODE

CODE D>F ( d -- rs )        \ 64-Bit-Ganzzahl nach r32-Zahl
     SP LDL  4 ADC          \ Stack-Adresse von d-hi nach Areg
     FPI32TOR64             \ d-hi mit  Vorzeichen nach r64 auf FBreg
     FPUEXPINC32            \ Mit 2**32 malnehmen
     SP LDL                 \ Stack-Adresse von d-lo nach Areg
     FPB32TOR64             \ d-lo ohne Vorzeichen nach r64 auf FAreg
     FPADD                  \ FBreg + FAreg --> FAreg
     FPUNOROUND             \ r64 ohne Rundung nach r32
     SP LDL  4 ADC  SP STL  \ Stack anpassen
     SP LDL                 \ Stack-Adresse nach Areg
     FPSTNLSN               \ r32 von FAreg nach Stack
     NEXT END-CODE

CODE FNEGATE ( rs -- -rs )
     FPLDZEROSN             \ 0.0 nach FBreg
     SP LDL                 \ Stack-Adresse nach Areg
     FPLDNLSN               \ rs von Stack nach FAreg
     FPSUB                  \ Differenz nach FAreg
     SP LDL                 \ Stack-Adresse nach Areg
     FPSTNLSN               \ FAreg-32 zum Datenstack
     NEXT END-CODE

CODE FROUND ( rs -- rs-int ) \ R32 nach Ganzzahl-Anteil von R32
     SP LDL                 \ Stack-Adresse nach Areg
     FPLDNLSN               \ rs von Stack nach FAreg
     FPURN                  \ Round-to-Nearest einstellen
     FPINT                  \ Auf Ganzzahl bringen
     SP LDL                 \ Stack-Adresse nach Areg
     FPSTNLSN               \ FAreg-32 zum Datenstack
     NEXT END-CODE

CODE FLOOR ( rs -- rs-int ) \ R32 nach Ganzzahl-Anteil von R32
     SP LDL                 \ Stack-Adresse nach Areg
     FPLDNLSN               \ rs von Stack nach FAreg
     FPURM                  \ Round-to-Minus einstellen
     FPINT                  \ Auf Ganzzahl bringen
     SP LDL                 \ Stack-Adresse nach Areg
     FPSTNLSN               \ FAreg-32 zum Datenstack
     NEXT END-CODE          \ Round-to-Minus bleibt

CODE FMIN ( rs1 rs2 -- rs3 ) \ rs3 = min{rs1,rs2}
     SP LDL  4 ADC          \ Stack-Adresse von rs1 nach Areg
     FPLDNLSN               \ rs1 von Stack nach FBreg
     SP LDL                 \ Stack-Adresse von rs2 nach Areg
     FPLDNLSN               \ rs2 von Stack nach FAreg
     FPGT                   \ Floating Point Greater Than
     4 CJ                   \ Sprung zur Stackanpassung ?
     SP LDL  0 LDNL         \ rs3 = rs2, falls rs1 > rs2
     SP LDL  1 STNL         \ rs3 = rs1 sonst
     SP LDL  4 ADC  SP STL  \ Stack anpassen
     NEXT END-CODE

CODE FMAX ( rs1 rs2 -- rs3 ) \ rs3 = max{rs1,rs2}
     SP LDL                 \ Stack-Adresse von rs2 nach Areg
     FPLDNLSN               \ rs2 von Stack nach FBreg
     SP LDL  4 ADC          \ Stack-Adresse von rs1 nach Areg
     FPLDNLSN               \ rs1 von Stack nach FAreg
     FPGT                   \ Floating Point Greater Than
     4 CJ                   \ Sprung zur Stackanpassung ?
     SP LDL  0 LDNL         \ rs3 = rs2, falls rs2 > rs1
     SP LDL  1 STNL         \ rs3 = rs1 sonst
     SP LDL  4 ADC  SP STL  \ Stack anpassen
     NEXT END-CODE

\ Es fehlen noch:  >FLOAT  REPRESENT


\ Floating-Point extension words
\ ------------------------------

\ Von den in der ANS-Dokumentation vorgeschlagenen Worten

\ DF!     DF@    DFALIGN  DFALIGNED  DFLOAT+  DFLOATS  F**     F.
\ FABS    FACOS  FACOSH   FALOG      FASIN    FASINH   FATAN   FATAN2
\ FATANH  FCOS   FCOSH    FE.        FEXP     FEXPM1   FLN     FLNP1
\ FLOG    FS.    FSIN     FSINCOS    FSINH    FSQRT    FTAN    FTANH
\ F~      PRECISION       SET-PRECISION       SF!      SF@     SFALIGN
\ SFALIGNED      SFLOAT+  SFLOATS

\ sind die folgenden im bisherigen Transputer-Forth-System
\ F-TP noch nicht enthalten und werden jetzt definiert:

\ DF!     DF@    DFALIGN  DFALIGNED  DFLOAT+  DFLOATS  F**     F.
\         FACOS  FACOSH   FALOG      FASIN    FASINH   FATAN   FATAN2
\ FATANH  FCOS   FCOSH    FE.        FEXP     FEXPM1   FLN     FLNP1
\ FLOG    FS.    FSIN     FSINCOS    FSINH             FTAN    FTANH
\ F~      PRECISION       SET-PRECISION       SF!      SF@     SFALIGN
\ SFALIGNED      SFLOAT+  SFLOATS

: DF!        NOOP ;  ' 2!        IS DF!
: DF@        NOOP ;  ' 2@        IS DF@
: SF!        NOOP ;  '  !        IS  F!
: SF@        NOOP ;  '  @        IS  F@

: DFLOAT+ ( ad -- ad+8 )    \ Gleichbedeutend mit 2 CELLS +
     8 + ;
: DFLOATS ( n1 -- n1*8 )    \ Gleichbedeutend mit 2*CELLS
     8 * ;
: SFLOAT+ ( ad -- ad+4 )    \ Gleichbedeutend mit   CELL+
     4+  ;
: SFLOATS ( n1 -- n1*4 )    \ Gleichbedeutend mit   CELLS
     4*  ;

: DFALIGN    [COMPILE] ALIGN ; IMMEDIATE
: DFALIGNED             EVEN ;
: SFALIGN    [COMPILE] ALIGN ; IMMEDIATE
: SFALIGNED             EVEN ;

\ Es folgen die ( einfachgenauen ) trigonometrischen Funktionen.  Von
\ diesen fehlen noch und werden spter eingebaut:
\                                                              F.
\                FACOSH   FALOG               FASINH           FATAN2
\ FATANH                  FE.
\         FS.
\         PRECISION       SET-PRECISION

CR .( Trigonometrische Funktionen )

VARIABLE MATHCONST    \ Konstanten-Tabelle
                      \ Zunchst 32-Bit-Werte
HEX
7F800010 MATHCONST !  \  0 undefined NaN
7F800008 ,  \  1 unstable  NaN
7F800004 ,  \  2 inexact   NaN
7F800000 ,  \  3 RInf
39800000 ,  \  4 Eps       --  2 ** (-Manbits/2)
48490FDB ,  \  5 SMax      --  Pi*(2^16)
47C90FDB ,  \  6 TMax      --  Pi/2*(2^16)

40490FDB ,  \  7 Pi        --  3.14159274 E+00
B3BBBD2E ,  \  8 Pi.err    -- -8.74227766 E-08
3FC907DB ,  \  9 Nearly.PiBy2 -- PiBy2 - Eps
3FC90FDB ,  \  A PiBy2
B33BBD2E ,  \  B PiBy2.err -- -4.37113883 E-08
3F490FDB ,  \  C PiBy4
3EA2F983 ,  \  D InvPi

3F22F983 ,  \  E TwoOverPi
00000001 ,  \  F MINREAL
7F7FFFFF ,  \ 10 MAXREAL   --  3.40282347 E+38
402DF854 ,  \ 11 E         --  2.71828174 E+00
3F317218 ,  \ 12 LOGE2     --  6.93147182 E-01
3EDE5BD9 ,  \ 13 LOG10E    --  4.34294492 E-01
3FB504F3 ,  \ 14 ROOT2     --  1.41421354 E+00

DECIMAL
&  1.1447298858     ,  \ 15 LOGEPI
& 57.295779513      ,  \ 16 RADIAN
&  1.74532925199-2 ,  \ 17 DEGREE
&  0.5772156649     ,  \ 18 GAMMA

&  2.601903036-6   ,  \ 19 fsin a(x**9)
& -1.980741872-4   ,  \ 1A fsin a(x**7)
&  8.333025139-3   ,  \ 1B fsin a(x**5)
& -1.666665668-1   ,  \ 1C fsin a(x**3)

&  1.0              ,  \ 1D

HEX

46490FDB ,  \ 1E XMax -- fr cos
40490000 ,  \ 1F C1   -- C1 + C2 = Pi doppeltgenau
3A7DAA22 ,  \ 20 C2

\ 64-Bit-Konstanten

7FF0000200000000. , ,  \ 21 Dundefined NaN
7FF0000100000000. , ,  \ 23 Dunstable NaN
7FF0000080000000. , ,  \ 25 Dinexact NaN
7FF0000000000000. , ,  \ 27 DRInf
3E50000000000000. , ,  \ 29 DEps
3FE62E42FEFA39EF. , ,  \ 2B DLn2

400921FB54442D18. , ,  \ 2D DPi
3CA1A62633145C07. , ,  \ 2F DPi.err
3FF921FB50442D18. , ,  \ 31 Nearly DPiBy2  -- DPiBy2 - Eps
3FF921FB54442D18. , ,  \ 33 DPiBy2
3C91A62633145C07. , ,  \ 35 DPiBy2.err
3FD45F306DC9C883. , ,  \ 37 DInvPi         -- 1/pi
3FE921FB54442D18. , ,  \ 39 DPiBy4

0000000000000001. , ,  \ 3B DMINREAL
7FEFFFFFFFFFFFFF. , ,  \ 3D DMAXREAL -- 1.7976931348623157E+308
4005BF0A8B145769. , ,  \ 3F DE       -- 2.7182818284590451E+000
3FE62E42FEFA39EF. , ,  \ 41 DLOGE2   -- 6.9314718055994529E-001
3FDBCB7B1526E50E. , ,  \ 43 DLOG10E  -- 4.3429448190325182E-001
3FF6A09E667F3BCD. , ,  \ 45 DROOT2   -- 1.4142135623730951E+000

DECIMAL

D& 1.1447298858494001741    , ,  \ 47 DLOGEPI
D& 57.295779513082320877    , ,  \ 49 DRADIAN
D& 1.7453292519943295769-2 , ,  \ 4B DDEGREE
D& 0.57721566490153286061   , ,  \ 4D DGAMMA

\ DZero          0.0(REAL64)
D& 0.5 , ,  \ 4F
D& 1.0 , ,  \ 51
D& 2.0 , ,  \ 53

\ Weitere 32-Bit-Konstanten

& -9.58017723-2 ,  \ 55 P1 fr FTAN
&  9.71685835-3 ,  \ 56 Q2 fr FTAN
& -4.29135777-1 ,  \ 57 Q1 fr FTAN

& -5.04400557-1 ,  \ 58 P2 fr FASIN
&  9.33935835-1 ,  \ 59 P1 fr FASIN
& -5.54846723    ,  \ 5A Q1 fr FASIN
&  5.60363004    ,  \ 5B Q0 fr FASIN

& -5.527074855-1 , \ 5C A0 fr FLN
& -6.632718214   ,  \ 5D B0 fr FLN

&  0.5           ,  \ 5E

HEX

3F3504F3         ,  \ 5F C0     fr FLN  -- SQRT(0.5)
42B17218         ,  \ 60 XMax   fr FEXP
42CE8ED1         ,  \ 61 XMin   fr FEXP
3FB8AA3B         ,  \ 62 InvLn2 fr FEXP

807FFFFF         ,  \ 63 AND-Maske
3F000000         ,  \ 64  OR-Maske fr Exp = 126 in FLN

DECIMAL

&  4.1602886268-3 ,  \ 65 A0   fr FEXP
&  2.4999999950-1 ,  \ 66 A1   "
&  4.9987178778-2 ,  \ 67 B1   "

& -1.90333399-1 ,  \ 68 P1     fr FSINH
& -7.13793159    ,  \ 69 P0     "
& -4.28277109+1 ,  \ 6A Q0     "

HEX

42B2CCCD         ,  \ 6B XMax   "
41051EB8         ,  \ 6C XBig   "
37680897         ,  \ 6D VBy2M1 "
3F317300         ,  \ 6E LnV    "

41051592         ,  \ 6F XMax   fr FTANH
3F0C9F54         ,  \ 70 Ln3By2 "

DECIMAL

& -3.831010665-3  ,  \ 71 P1   "
& -8.237728127-1  ,  \ 72 P0   "
&  2.471319654     ,  \ 73 Q0   "

&  2.0             ,  \ 74

&  7.320508076-1  ,  \ 75  A fr FATAN
&  1.732050808     ,  \ 76 R3 "
& -5.090958253-2  ,  \ 77 P1 "
& -4.708325141-1  ,  \ 78 P0 "
&  1.412500740     ,  \ 79 Q0 "

HEX

3E8930A3         ,  \ 7A TwoSubR3 " -- 2-sqrt(3)
3F060A92         ,  \ 7B PiBy6 "
4B800000         ,  \ 7C XMax  "

\ 64-Bit-Konstanten

3C90000000000000. , , \ 7D Eps(64) fr F**
3FF71547652B82FE. , , \ 7F DInvLn2 "
3FE6A09E667F3BCD. , , \ 81 C0 -- SQRT(0.5) "

DECIMAL

D&   88.72                     , , \ 83 MaxLog "
D& -104.0                      , , \ 85 MinLog - ln(smallest real) "
D&   -7.895611288749125726-1 , , \ 87 A2 "        7
D&    1.638394356302153422+1 , , \ 89 A1 "        2
D&   -6.412494342374558114+1 , , \ 8B A0 "        7
D&   -3.566797773903464617+1 , , \ 8D B2 "        1
D&    3.120322209192453284+2 , , \ 8F B1 "        4
D&   -7.694993210849487977+2 , , \ 91 B0 "        7

\ 32-Bit-Konstanten

HEX

800FFFFF  ,  \ 93 AND-Maske fr F**
3FE00000  ,  \ 94  OR-Maske "


CR .( FSIN, FCOS, FSINCOS, FTAN )

HEX

CODE FSIN ( rs1 -- rs2 )    \ rs2 = sin (rs1) ; rs1,rs2 = REAL32
     MATHCONST LDC
     EREG STL               \ Hier jetzt Basisadresse der Konstanten
     SP LDL  FPLDNLSN       \ rs1 nach FBreg
     FPDUP                  \ und nach FAreg
     FPNOTFINITE            \ Unendlich oder NaN --> Areg = 1
     2IF
       FPDUP FPNAN          \ NaN --> Areg = 1
       1IF
         SP LDL FPSTNLSN    \ Ja,   dann NaN auf Stack
       1ELSE
         EREG LDL 0 LDNL    \ Nein, dann Undefined NaN
           SP LDL 0 STNL    \ auf Stack
       THEN
     2ELSE
                    FPDUP          \ Zunchst Argument reduzieren.
                    FPUR32TOR64
                    FPREV
       EREG LDL  0D LDNLP          \ InvPi
                    FPLDNLMULSN    \ x*InvPI
                    FPINT FPDUP    \ Auf ganzzahlig runden.
       CREG LDLP    FPSTNLI32      \ Fr Vorzeichen aufheben.
                    FPUR32TOR64
       EREG LDL  2D LDNLP          \ Mit DPi
                    FPLDNLMULDB    \ multiplizieren.
                    FPSUB
                    FPUR64TOR32    \ Argument jetzt reduziert.
                    FPDUP FPUABS   \ Sicherstellen, dass -1  sin(x)  +1
       EREG LDL   9 LDNLP          \ Nearly PiBy2
                    FPLDNLSN FPGT  \ Wenn grer,
       2IF
                    FPLDZEROSN FPGT
         1IF
           EREG LDL
           1D LDNLP   FPLDNLSN     \ dann +1.0
         1ELSE                     \ oder
                      FPLDZEROSN
           EREG LDL
           1D LDNLP   FPLDNLSN
                      FPSUB        \ -1.0
         THEN
       2ELSE                       \ Und jetzt eigentlicher Sinus
                      FPDUP
         BREG LDLP    FPSTNLSN
                      FPDUP FPMUL
                      FPDUP
         AREG LDLP    FPSTNLSN
         EREG LDL  19 LDNLP        \ a(x**9)
              DUP     FPLDNLMULSN
         4 ADC  DUP   FPLDNLADDSN  \ a(x**7)
         AREG LDLP    FPLDNLMULSN
         4 ADC  DUP   FPLDNLADDSN  \ a(x**5)
         AREG LDLP    FPLDNLMULSN
         4 ADC        FPLDNLADDSN  \ a(x**3)
         AREG LDLP    FPLDNLMULSN
         BREG LDLP    FPLDNLMULSN
         BREG LDLP    FPLDNLADDSN
       THEN
       CREG LDL   1 LDC
            AND                    \ Vorzeichen ?
       1IF
                      FPLDZEROSN   \ Ja, dann ndern.
                      FPREV FPSUB
       (THEN)                      \ (THEN) spart gegenber THEN 2 Bytes
       SP LDL         FPSTNLSN
     THEN
     NEXT END-CODE

\ Test am 20.9.96: sin(1) = 0.8414708    dezimal
\     Bei Knuth 2:        = 0.8414709848...
\                         = 0.6566524400 oktal
\     Bei Knuth 2:        = 0.6566524436...

\ Erwartete Genauigkeit auf jeden Fall:
\ 0.841470 dezimal    0.65665244 oktal
\ Die dazu jeweils nchste Stelle kann bei effektiven
\ 24 Mantissen-Bits  nicht mehr voll erwartet werden.


CODE FCOS ( rs1 -- rs2 )    \ rs2 = cos (rs1) ; rs1,rs2 = REAL32
     MATHCONST LDC
     EREG STL               \ Hier jetzt Basisadresse der Konstanten
     SP LDL  FPLDNLSN       \ rs1 nach FBreg
     FPDUP                  \ und nach FAreg
     FPNOTFINITE            \ Unendlich oder NaN --> Areg = 1
     2IF
       FPDUP FPNAN          \ NaN --> Areg = 1
       1IF
         SP LDL FPSTNLSN    \ Ja,   dann NaN auf Stack
       1ELSE
         EREG LDL 0 LDNL    \ Nein, dann Undefined NaN
           SP LDL 0 STNL    \ auf Stack
       THEN
     2ELSE
                      FPUABS         \ cos ist symmetrisch
                      FPDUP
       BREG LDLP      FPSTNLSN       \ abs(x) aufbewahren
                      FPDUP
       EREG LDL    1E LDNLP          \ XMax
                      FPLDNLSN  FPGT \ Wenn grer,
       2IF
         EREG LDL 2 LDNL             \ dann Inexact NaN
         SP LDL 0 STNL               \ auf Stack.
       2ELSE
         EREG LDL  0A LDNLP          \ PiBy2
                      FPLDNLADDSN    \ + abs(x) auf FStack
         EREG LDL  0D LDNLP          \ InvPi
                      FPLDNLMULSN    \ * dem Vorigen
                      FPINT          \ Auf ganzzahlig runden ( "N" ).
         CREG LDLP    FPSTNLI32      \ Fr Vorzeichen aufheben.
         CREG LDL   1 LDC SHL        \ N << 1
           -1 ADC
         DREG STL
         BREG LDLP    FPLDNLSN       \ abs(x) holen
         DREG LDLP    FPI32TOR32
                      FPUDIVBY2      \ abs(x) XN
                      FPDUP          \ abs(x) XN XN
         DREG LDLP    FPSTNLSN       \ Kopie aufbewahren
         EREG LDL  1F LDNLP
                      FPLDNLMULSN
                      FPSUB          \ abs(x) - XN*C1
         DREG LDLP    FPLDNLSN       \ Kopie von XN holen
         EREG LDL  20 LDNLP
                      FPLDNLMULSN    \ XN*C2
                      FPSUB          \ Argument jetzt reduziert
                                     \ Ab hier wie bei sin
         FPDUP  FPUABS               \ Sicherstellen, dass -1  cos(x)  +1
         EREG LDL  9 LDNLP           \ Nearly PiBy2
         FPLDNLSN  FPGT              \ Wenn grer,
         2IF
           FPLDZEROSN FPGT
           1IF
             EREG LDL
             1D LDNLP   FPLDNLSN     \ dann +1.0
           1ELSE                     \ oder
                        FPLDZEROSN
             EREG LDL
             1D LDNLP   FPLDNLSN
                        FPSUB        \ -1.0
           THEN
         2ELSE                       \ Und jetzt eigentlicher Sinus
                        FPDUP
           BREG LDLP    FPSTNLSN
                        FPDUP FPMUL
                        FPDUP
           AREG LDLP    FPSTNLSN
           EREG LDL  19 LDNLP        \ a(x**9)
                DUP     FPLDNLMULSN
           4 ADC  DUP   FPLDNLADDSN  \ a(x**7)
           AREG LDLP    FPLDNLMULSN
           4 ADC  DUP   FPLDNLADDSN  \ a(x**5)
           AREG LDLP    FPLDNLMULSN
           4 ADC        FPLDNLADDSN  \ a(x**3)
           AREG LDLP    FPLDNLMULSN
           BREG LDLP    FPLDNLMULSN
           BREG LDLP    FPLDNLADDSN
         THEN
         CREG LDL       1 LDC
              AND                    \ Vorzeichen ?
         1IF
                        FPLDZEROSN   \ Ja, dann ndern.
                        FPREV FPSUB
         (THEN)                      \ (THEN) spart 2 Bytes gegenber THEN
         SP LDL         FPSTNLSN     \ Ergebnis auf Stack
       THEN
     THEN
     NEXT END-CODE

\ Test am 22.9.96: cos(1) = 0.540302208    dezimal
\     Bei Knuth 2:        = 0.540302305...
\                         = 0.4245050000   oktal
\     Bei Knuth 2:        = 0.4245050037...

\ Erwartete Genauigkeit auf jeden Fall:
\ 0.540302 dezimal  \  noch bearbeiten !!!:  0.65665244 oktal
\ Die dazu jeweils nchste Stelle kann bei effektiven
\ 24 Mantissen-Bits  nicht mehr voll erwartet werden.

: FSINCOS ( rs1 -- rs2 rs3 )  \ rs2 = sin(rs1), rs3 = cos(rs1)
     DUP FSIN SWAP FCOS ;

CODE FTAN ( rs1 -- rs2 )    \ rs2 = tan(rs1) ; rs1,rs2 = REAL32
     MATHCONST LDC
     EREG STL                          \ Hier jetzt Basisadresse der Konstanten
     SP LDL             FPLDNLSN       \ rs1 nach FAreg
     FPNOTFINITE                       \ Unendlich oder NaN --> Areg = 1
     2IF
       FPNAN                           \ NaN --> Areg = 1
       1IF
       (1ELSE)
         EREG LDL     0 LDNLP
                        FPLDNLSN       \ Undefined NaN
       (THEN)
     (2ELSE)
                        FPDUP  FPUABS  \ x |x|
       EREG LDL       6 LDNLP          \ TMax
                        FPLDNLSN FPGT  \ Wenn |x| > TMax,
       1IF
         EREG LDL     2 LDNLP          \ dann Inexact NaN
                        FPLDNLSN
       (2ELSE)
                        FPDUP          \ x x
         EREG LDL    0E LDNLP          \ TwoOverPi
                        FPLDNLMULSN    \ x32*TwoOverPi
                        FPINT          \ Auf ganzzahlig runden ( N ).
         CREG LDLP      FPSTNLI32      \ Fr Vorzeichen aufheben.
                        FPUR32TOR64    \ x64
         CREG LDLP      FPI32TOR64     \ x64 N64
         EREG LDL    33 LDNLP
                        FPLDNLMULDB    \ x64 N64*DPiBy2
                        FPSUB          \ x64-(N64*DPiBy2)
                        FPUR64TOR32    \ Argument jetzt reduziert =: X
                        FPDUP FPDUP    \ Jetzt eigentlicher Tangens
         AREG LDLP      FPSTNLSN       \ X X
                        FPMUL FPDUP    \ X*X X*X
         EREG LDL    55 LDNLP
                        FPLDNLMULSN    \ X*X X*X*P1
         AREG LDLP      FPLDNLMULSN    \ X*X X*X*X*P1
         AREG LDLP      FPLDNLADDSN    \ X*X X+X*X*X*P1 =: XNum
         BREG LDLP      FPSTNLSN       \ XNum aufbewahren
                        FPDUP          \ X*X X*X
         EREG LDL    56 LDNLP
                        FPLDNLMULSN    \ X*X X*X*Q2
         EREG LDL    57 LDNLP
                        FPLDNLADDSN    \ X*X X*X*Q2+Q1
                        FPMUL          \ X*X*(X*X*Q2+Q1)
         EREG LDL    1D LDNLP
                        FPLDNLADDSN    \ (X*X*(X*X*Q2+Q1))+1.0 =: XDen
         BREG LDLP      FPLDNLSN       \ XDen XNum
         CREG LDL
         1 LDC  AND 0=                 \ N gerade ?
         1IF
                        FPREV FPDIV    \ XNum/XDen
         (2ELSE)
                        FPLDZEROSN
                        FPEQ           \ XDen
           1IF                         \ XNum = 0 ?
             EREG LDL 1 LDNLP
                        FPLDNLSN       \ XDen unstable-NaN
           (1ELSE)
             BREG LDLP  FPLDNLSN       \ XDen XNum
                        FPDIV          \ XDen/XNum
                        FPLDZEROSN
                        FPREV FPSUB    \ -XDen/XNum
           (THEN)
         (THEN)
       (THEN)
     (THEN)
     SP LDL             FPSTNLSN       \ Ergebnis auf Stack
     NEXT END-CODE

\ Test am 16.10.96 --- y = TAN(x) dezimal
\   x  Bronstein  y  F-TP
\  0.0   0.0     0.0
\  0.12  0.1206  0.1205793408
\  0.23  0.2341  0.234143360
\  0.37  0.3879  0.387863168
\ -0.41 -0.4346 -0.434631232
\  0.54  0.5994  0.599429696
\ -0.63 -0.7291 -0.729114752
\  0.79  1.0092  1.009246400
\  1.00  1.5574  1.557407872
\  1.24  2.9119  2.91192992
\  1.35  4.4552  4.45522240
\  1.53  24.498  24.4983968
\  1.56  92.620  92.6200000
\  1.57  1255.8  1255.848192
\  1.58 -108.65  -108.6486912


CR .( FASIN, FACOS, FEXP, FLN, FLOG, F~ )

CODE FASIN ( rs1 -- rs2 )   \ rs2 = arcsin(rs1); rs1,rs2 = REAL32
     MATHCONST LDC
     EREG STL                            \ Basisadresse der Konstanten
     SP LDL               FPLDNLSN       \ rs1 nach FAreg
                          FPNOTFINITE    \ Unendlich oder NaN --> Areg = 1
     2IF
                          FPNAN          \ NaN --> Areg = 1
       1IF
       (1ELSE)
         EREG LDL       0 LDNLP
                          FPLDNLSN       \ Nein, dann Undefined NaN
       (THEN)
     (2ELSE)
                          FPDUP          \ x x
       BREG LDLP          FPSTNLSN       \ x in BREG aufbewahren
                          FPUABS FPDUP   \ |x| |x|
       EREG LDL 1D LDNLP  FPLDNLSN       \ 1.0
                          FPGT           \ Wenn |x| > 1.0,
       1IF
         EREG LDL       0 LDNLP
                          FPLDNLSN       \ dann Undefined NaN.
       (2ELSE)
                          FPDUP          \ |x| |x|
         AREG LDLP        FPSTNLSN       \ |x| in AREG aufbewahren
         EREG LDL      1D LDNLP
                          FPLDNLSN       \ |x| 1.0
                          FPEQ           \ Wenn |x| = 1.0,
         2IF
                          FPLDZEROSN     \ 0.0
           BREG LDLP      FPLDNLSN       \ 0.0 x
                          FPGT           \ und 0 > x,
           1IF
                          FPLDZEROSN     \ 0.0
             EREG LDL  0A LDNLP
                          FPLDNLSN       \ 0.0 PiBy2
                          FPSUB          \ dann -PiBy2 ;
           (1ELSE)
             EREG LDL  0A LDNLP
                          FPLDNLSN       \ sonst PiBy2 .
           (THEN)
         (2ELSE)
           AREG LDLP      FPLDNLSN       \ |x| aus AREG holen
                          FPDUP          \ |x| |x|
           EREG LDL    5E LDNLP
                          FPLDNLSN       \ |x| |x| 0.5
                          FPGT           \ Wenn |x| > 0.5,
                          FPDUP          \ |x| |x|
           2IF                           \ dann Argument reduzieren und los;
             EREG LDL  1D LDNLP
                          FPLDNLSN       \ |x| 1.0
                          FPREV FPSUB    \ 1.0-|x|
                          FPUDIVBY2      \ =: G = (sin(/2))**2, wenn x = cos
                          FPDUP          \ G G
             AREG LDLP    FPSTNLSN       \ G in AREG aufbewahren
                          FPUSQRTFIRST
                          FPUSQRTSTEP
                          FPUSQRTSTEP
                          FPUSQRTLAST    \ sqrt(G)
                          FPLDZEROSN
                          FPREV FPSUB    \ -sqrt(G)
                          FPUMULBY2      \ =: Y, Winkelverdopplung eingebaut
             CREG LDLP    FPSTNLSN       \ Y jetzt in CREG
             AREG LDLP    FPLDNLSN       \ G aus AREG holen
                          FPDUP          \ G G
             EREG LDL  58 LDNLP          \ P2
                  DUP     FPLDNLMULSN    \ G P2*G
                4 ADC DUP FPLDNLADDSN    \ G P1+(P2*G)
                          FPMUL
             AREG LDLP    FPLDNLSN       \ G aus AREG holen
                4 ADC DUP FPLDNLADDSN    \ G*(P1+(P2*G)) G+Q1
             AREG LDLP    FPLDNLMULSN    \ G*(P1+(P2*G)) G*(G+Q1)
                4 ADC     FPLDNLADDSN    \ G*(P1+(P2*G)) G*(G+Q1)+Q0
                          FPDIV          \ G*(P1+(P2*G))/G*(G+Q1)+Q0
             CREG LDLP    FPLDNLMULSN    \ (...)*Y
             CREG LDLP    FPLDNLADDSN    \ ((...)*Y)+Y
             EREG LDL  0A LDNLP
                          FPLDNLADDSN    \ ((...)*Y)+Y+PiBy2 =: Z
                          FPLDZEROSN
             BREG LDLP    FPLDNLSN FPGT  \ Wenn 0 > x,
             1IF
                          FPLDZEROSN
                          FPREV FPSUB    \ dann -Z ;
             (THEN)                      \ sonst Z .
           (2ELSE)                       \ Sonst verbleibender Fall:
                          FPDUP FPMUL    \ |x| x*x
                          FPDUP FPDUP    \ x*x x*x x*x
             AREG LDLP    FPSTNLSN       \ x*x in AREG aufbewahren
             EREG LDL  58 LDNLP          \ P2
                  DUP     FPLDNLMULSN    \ x*x P2*x*x
                4 ADC DUP FPLDNLADDSN    \ x*x P1+(P2*x*x)
                          FPMUL
             AREG LDLP    FPLDNLSN       \ x*x aus AREG holen
                4 ADC DUP FPLDNLADDSN    \ x*x*(P1+(P2*x*x)) x*x+Q1
             AREG LDLP    FPLDNLMULSN    \ x*x*(P1+(P2*x*x)) x*x*(x*x+Q1)
                4 ADC     FPLDNLADDSN    \ x*x*(P1+(P2*x*x)) x*x*(x*x+Q1)+Q0
                          FPDIV          \ x*x*(P1+(P2*x*x))/x*x*(x*x+Q1)+Q0
             BREG LDLP    FPLDNLMULSN    \ (...)*x
             BREG LDLP    FPLDNLADDSN    \ ((...)*x)+x
           (THEN)
         (THEN)
       (THEN)
     (THEN)
     SP LDL               FPSTNLSN       \ Ergebnis auf Stack
     NEXT END-CODE

CODE FACOS ( rs1 -- rs2 )   \ rs2 = arccos(rs1); rs1,rs2 = REAL32
     MATHCONST LDC
     EREG STL                            \ Basisadresse der Konstanten
     SP LDL               FPLDNLSN       \ rs1 nach FAreg
                          FPNOTFINITE    \ Unendlich oder NaN --> Areg = 1
     2IF
                          FPNAN          \ NaN --> Areg = 1
       1IF
       (1ELSE)
         EREG LDL       0 LDNLP
                          FPLDNLSN       \ Nein, dann Undefined NaN
       (THEN)
     (2ELSE)
                          FPDUP          \ x x
       BREG LDLP          FPSTNLSN       \ x in BREG aufbewahren
                          FPUABS FPDUP   \ |x| |x|
       EREG LDL 1D LDNLP  FPLDNLSN       \ 1.0
                          FPGT           \ Wenn |x| > 1.0,
       1IF
         EREG LDL       0 LDNLP
                          FPLDNLSN       \ dann Undefined NaN.
       (2ELSE)
                          FPDUP          \ |x| |x|
         AREG LDLP        FPSTNLSN       \ |x| in AREG aufbewahren
         EREG LDL      1D LDNLP
                          FPLDNLSN       \ |x| 1.0
                          FPEQ           \ Wenn |x| = 1.0,
         2IF
                          FPLDZEROSN     \ 0.0
           BREG LDLP      FPLDNLSN       \ x aus BREG holen
                          FPGT           \ und 0 > x,
           1IF
           EREG LDL     7 LDNLP
                          FPLDNLSN       \ dann Pi,
           (1ELSE)
                          FPLDZEROSN     \ sonst 0.0 .
           (THEN)
         (2ELSE)
           AREG LDLP      FPLDNLSN       \ |x| aus AREG holen
                          FPDUP          \ |x| |x|
           EREG LDL    5E LDNLP
                          FPLDNLSN       \ |x| |x| 0.5
                          FPGT           \ Wenn |x| > 0.5,
           2IF                           \ dann Argument reduzieren und los;
             EREG LDL  1D LDNLP
                          FPLDNLSN       \ |x| 1.0
                          FPREV FPSUB    \ 1.0-|x|
                          FPUDIVBY2      \ =: G = (sin(/2))**2, wenn x = cos
                          FPDUP          \ G G
             AREG LDLP    FPSTNLSN       \ G in AREG aufbewahren
                          FPUSQRTFIRST
                          FPUSQRTSTEP
                          FPUSQRTSTEP
                          FPUSQRTLAST    \ sqrt(G)
                          FPUMULBY2      \ =: Y, Winkelverdopplung eingebaut
             CREG LDLP    FPSTNLSN       \ Y jetzt in CREG
             AREG LDLP    FPLDNLSN       \ G aus AREG holen
                          FPDUP          \ G G
             EREG LDL  58 LDNLP          \ P2
                  DUP     FPLDNLMULSN    \ G P2*G
                4 ADC DUP FPLDNLADDSN    \ G P1+(P2*G)
                          FPMUL
             AREG LDLP    FPLDNLSN       \ G aus AREG holen
                4 ADC DUP FPLDNLADDSN    \ G*(P1+(P2*G)) G+Q1
             AREG LDLP    FPLDNLMULSN    \ G*(P1+(P2*G)) G*(G+Q1)
                4 ADC     FPLDNLADDSN    \ G*(P1+(P2*G)) G*(G+Q1)+Q0
                          FPDIV          \ G*(P1+(P2*G))/G*(G+Q1)+Q0
             CREG LDLP    FPLDNLMULSN    \ (...)*Y
             CREG LDLP    FPLDNLADDSN    \ ((...)*Y)+Y =: Z
                          FPLDZEROSN
             BREG LDLP    FPLDNLSN FPGT  \ Wenn 0 > x,
             1IF
                          FPLDZEROSN
                          FPREV FPSUB    \ dann -Z
               EREG LDL 7 LDNLP
                          FPLDNLADDSN    \ + Pi,
             (THEN)                      \ sonst Z .
           (2ELSE)                       \ Sonst verbleibender Fall:
                          FPDUP FPMUL    \ x*x
                          FPDUP FPDUP    \ x*x x*x x*x
             AREG LDLP    FPSTNLSN       \ x*x in AREG aufbewahren
             EREG LDL  58 LDNLP          \ P2
                  DUP     FPLDNLMULSN    \ x*x P2*x*x
                4 ADC DUP FPLDNLADDSN    \ x*x P1+(P2*x*x)
                          FPMUL
             AREG LDLP    FPLDNLSN       \ x*x aus AREG holen
                4 ADC DUP FPLDNLADDSN    \ x*x*(P1+(P2*x*x)) x*x+Q1
             AREG LDLP    FPLDNLMULSN    \ x*x*(P1+(P2*x*x)) x*x*(x*x+Q1)
                4 ADC     FPLDNLADDSN    \ x*x*(P1+(P2*x*x)) x*x*(x*x+Q1)+Q0
                          FPDIV          \ x*x*(P1+(P2*x*x))/x*x*(x*x+Q1)+Q0
             BREG LDLP    FPLDNLMULSN    \ (...)*x
             BREG LDLP    FPLDNLADDSN    \ ((...)*x)+x
                          FPLDZEROSN
                          FPREV FPSUB
             EREG LDL  0A LDNLP
                          FPLDNLADDSN    \ Pi-((...)*x)+x,
           (THEN)
         (THEN)
       (THEN)
     (THEN)
     SP LDL               FPSTNLSN       \ Ergebnis auf Stack
     NEXT END-CODE

CODE FEXP ( rs1 -- rs2 )  \ rs2 = exp(rs1); rs1,rs2 = REAL32
     MATHCONST LDC        \ Nur fr -103,2789376 < rs1 < 88,7228416 d !!!
     EREG STL                            \ Basisadresse der Konstanten
     SP LDL               FPLDNLSN       \ rs1 nach FAreg
                          FPNOTFINITE    \ Unendlich oder NaN --> Areg = 1
     2IF
                          FPNAN          \ NaN --> Areg = 1
       1IF                               \ Ja, dann Resultat := x
       (2ELSE)
                          FPDUP          \ x x
                          FPLDZEROSN     \ x x 0
                          FPGT           \ Wenn x > 0.0 ,
         1IF
           EREG LDL     3 LDNLP
                          FPLDNLSN       \ dann Rinf;
         (1ELSE)
                          FPLDZEROSN     \ sonst 0.0
         (THEN)
       (THEN)
     (2ELSE)
                          FPDUP          \ x x
       EREG LDL        60 LDNLP
                          FPLDNLSN       \ x x XMax
                          FPGT           \ Wenn x > XMax ,
       1IF
         EREG LDL       3 LDNLP
                          FPLDNLSN       \ dann Rinf;
       (2ELSE)
                          FPDUP FPUABS   \ x |x|
         EREG LDL      61 LDNLP
                          FPLDNLSN       \ x |x| XMin
                          FPGT           \ sonst: Wenn |x| > XMin ,
         1IF
                          FPLDZEROSN     \ dann 0.0 ;
         (2ELSE)                         \ andernfalls geht es los:
                          FPDUP          \ x x
                          FPUR32TOR64
                          FPREV          \ x(64) x
           EREG LDL    62 LDNLP
                          FPLDNLMULSN    \ x(64) x*InvLn2
                          FPINT FPDUP    \ Auf ganzzahlig runden =: N
           CREG LDLP      FPSTNLI32      \ N aufbewahren , bleibt x(64) N
                          FPUR32TOR64
           EREG LDL    2B LDNLP
                          FPLDNLMULDB
                          FPSUB          \ x(64)-N*DLn2(64) =: X(64)
                          FPUR64TOR32    \ X(32) =: X
                          FPDUP FPDUP    \ X X X
                          FPMUL FPDUP    \ X X*X X*X =: Z
           AREG LDLP      FPSTNLSN       \ Z aufbewahren
           EREG LDL    65 LDNLP          \ A0
                          FPLDNLMULSN    \ X Z*A0
           EREG LDL    66 LDNLP          \ A1
                          FPLDNLADDSN    \ X Z*A0+A1
                          FPMUL FPDUP    \ GPZ GPZ := X*(Z*A0+A1)
           BREG LDLP      FPSTNLSN       \ GPZ aufbewahren
           AREG LDLP      FPLDNLSN       \ GPZ Z
           EREG LDL    67 LDNLP          \ B1
                          FPLDNLMULSN    \ GPZ Z*B1
           EREG LDL    5E LDNLP          \ 0.5
                          FPLDNLADDSN    \ GPZ Z*B1+0.5
           BREG LDLP      FPLDNLSN FPSUB \ GPZ (Z*B1+0.5)-GPZ
                          FPDIV          \ GPZ/((Z*B1+0.5)-GPZ)
           EREG LDL    5E LDNLP          \ 0.5
                          FPLDNLADDSN    \ (GPZ/((Z*B1+0.5)-GPZ))+0.5
           CREG LDL                      \ N
           1 ADC
           CREG STL                      \ N+1
           BREG LDLP      FPSTNLSN       \ Ergebnis aufbewahren
           BREG LDL
           EREG LDL    63 LDNL           \ 807FFFFF
                AND                      \ Exponentenbits = 0 setzen
           BREG LDL
              1 LDC SHL
             18 LDC SHR                  \ Die 8 Exponentenbits nach rechts
             7F LDC SUB
           CREG LDL                      \ N+1
                ADD                      \ hinzuaddieren.
             7F LDC ADD
             18 LDC SHL
              1 LDC SHR                  \ Wieder auf Normalposition
                 OR                      \ Jetzt Exponent *2**(N+1)
           BREG STL
           BREG LDLP      FPLDNLSN
         (THEN)
       (THEN)
     (THEN)
     SP LDL               FPSTNLSN       \ Ergebnis auf Stack
     NEXT END-CODE

\ Test F-TP        exp(1)  = 2.71828160  dezimal
\ am 8.10.96:      exp(2)  = 7.38905600
\                  exp(-1) = 0.367879424
\                exp(pi/4) = 2.19328032
\                  exp(8)  = 2980.95808
\                  exp(-8) = 0.000335462624
\                  exp(85) = 0.82230118437
\                 exp(-85) = 0.1216099072-36

\ Bei Knuth 2:     exp(1)  = 2.71828182...
\                  exp(2)  = 7.38905609...
\                  exp(-1) = 0.387879441..
\                exp(pi/4) = 2.19328005...
\ Bei Bronstein:   exp(8)  = 2981.0
\                  exp(-8) = 0.000335
\ Unbek.Tabelle:   exp(85) = 0.8223012714...37
\                 exp(-85) = 0.1216099299...-36

\ F-TP:            exp(1)  = 2.557605200 oktal
\                  exp(2)  = 7.307144600
\                  exp(-1) = 0.2742653100

\ Bei Knuth 2:     exp(1)  = 2.557605213...
\                  exp(2)  = 7.307144561...
\                  exp(-1) = 0.2742653066..

CODE FLN ( rs1 -- rs2 )     \ rs2 = ln(rs1) ; rs1,rs2 = REAL32
     MATHCONST LDC
     EREG STL                            \ Basisadresse der Konstanten
     SP LDL               FPLDNLSN       \ rs1 nach FAreg
                          FPNOTFINITE    \ Unendlich oder NaN --> Areg = 1
     1IF
                          FPNAN          \ NaN --> Areg = 1
       1IF                               \ Ja, dann Resultat := x
       (1ELSE)
         EREG LDL       0 LDNLP
                          FPLDNLSN       \ Undefined NaN
       (THEN)
     (2ELSE)
                          FPDUP          \ x x
                          FPLDZEROSN     \ x x 0
                          FPGT           \ x > 0.0 ?
       2IF
         BREG LDLP        FPSTNLSN       \ Ergebnis aufbewahren
         BREG LDL
            1 LDC SHL
           18 LDC SHR                    \ Die 8 Exponentenbits nach rechts
           7F LDC SUB                    \ N
         CREG STL                        \ aufbewahren
         BREG LDL
         EREG LDL      63 LDNL           \ 807FFFFF
              AND                        \ Exponentenbits =   0 setzen
         EREG LDL      64 LDNL           \ 3F000000
               OR                        \ Exponentenbits = 126 setzen
         BREG STL
         BREG LDLP        FPLDNLSN       \ 0.5  x < 1.0
                          FPDUP          \ x x
         EREG LDL      5F LDNLP
                          FPLDNLSN       \ x x C0
                          FPGT           \ x > C0 ?
         2IF
           CREG LDL
              1 ADC
           CREG STL                      \ N := N+1
                          FPDUP          \ x x
           EREG LDL    5E LDNLP          \ 0.5
                          FPLDNLSN
                          FPSUB          \ x x-0.5
           EREG LDL    5E LDNLP
                          FPLDNLSN
                          FPSUB          \ x (x-0.5)-0.5
                          FPREV
           EREG LDL    5E LDNLP          \ 0.5
                          FPLDNLMULSN    \ (x-0.5)-0.5 x*0.5
           EREG LDL    5E LDNLP
                          FPLDNLADDSN    \ (x-0.5)-0.5 (x*0.5)+0.5
                          FPDIV          \ =: Z
         (2ELSE)
           EREG LDL    5E LDNLP          \ 0.5
                          FPLDNLSN
                          FPSUB          \ x-0.5 =: ZNum
                          FPDUP          \ ZNum ZNum
           EREG LDL    5E LDNLP          \ 0.5
                          FPLDNLMULSN    \ ZNum ZNum*0.5
           EREG LDL    5E LDNLP
                          FPLDNLADDSN    \ ZNum (ZNum*0.5)+0.5
                          FPDIV          \ =: Z
         (THEN)
                          FPDUP FPDUP    \ Z Z Z
         AREG LDLP        FPSTNLSN       \ Z aufbewahren
                          FPMUL FPDUP    \ Z*Z Z*Z =: W
         EREG LDL      5C LDNLP          \ A0
                          FPLDNLMULSN    \ W W*A0
                          FPREV          \ W*A0 W
         EREG LDL      5D LDNLP          \ B0
                          FPLDNLADDSN    \ W*A0 W+B0
                          FPDIV          \ (W*A0)/(W+B0)
         AREG LDLP        FPLDNLMULSN    \ ((W*A0)/(W+B0))*Z
         AREG LDLP        FPLDNLADDSN    \ (((W*A0)/(W+B0))*Z)+Z =: R
         CREG LDL
            0 EQC                        \ N = 0 ?
         1IF
         (2ELSE)
                          FPUR32TOR64    \ R(64)
           CREG LDLP      FPI32TOR64     \ R(64) N(64)
           EREG LDL    2B LDNLP
                          FPLDNLMULDB    \ R(64) N(64)*DLn2
                          FPADD          \ R(64)+N(64)*DLn2
                          FPUR64TOR32
          (THEN)
       (2ELSE)
         EREG LDL       0 LDNLP
                          FPLDNLSN       \ Undefined NaN
       (THEN)
     (THEN)
     SP LDL               FPSTNLSN       \ Ergebnis auf Stack
     NEXT END-CODE

\ Test F-TP       ln(2)  = 0.693147200 ... dezimal
\ am 29.10.96:    ln(3)  = 1.098612352 ...
\                 ln(10) = 2.30258528  ...
\                 ln()  = 1.144729984 ...
\                 ln(2.718281828) = 0.999999872

\ Knuth,Bd.2:     ln(2)  = 0.693147180...
\ am 29.10.96:    ln(3)  = 1.098612288...
\                 ln(10) = 2.302585092...
\                 ln()  = 1.144729885...

CODE FLOG ( rs1 -- rs2 )  \ rs2 = 10log(rs1) ; rs1,rs2 = REAL32
     ASM]FORTH FLN                       \ ln(rs1)
     FORTH[ASM
     SP LDL               FPLDNLSN       \ rs1 nach FAreg
                          FPNAN
     1IF
     (1ELSE)
       MATHCONST LDC   13 LDNLP FPLDNLSN
                          FPMUL          \ 10logE*ln(rs1)
     (THEN)
     SP LDL               FPSTNLSN       \ Ergebnis auf Stack
     NEXT END-CODE

CODE F~ ( rs1 rs2 rs3 -- fl )
     SP LDL               FPLDNLSN       \ rs3
                          FPNOTFINITE
     SP LDL 4 ADC         FPLDNLSN       \ rs2
                          FPNOTFINITE
         OR
     SP LDL 8 ADC         FPLDNLSN       \ rs1
                          FPNOTFINITE
         OR
     1IF
       0 LDC AREG STL                    \ Wenn NaN, dann 0 auf Stack
     (2ELSE)
                          FPLDZEROSN     \ rs3 = 0.0 ?
       SP LDL             FPLDNLSN FPEQ
       2IF
         SP LDL 1 LDNL
         SP LDL 2 LDNL
            XOR
          0 EQC                          \ Wenn bitweise gleich,
         1IF
           -1 LDC AREG STL               \ dann fl = TRUE ;
         (1ELSE)
            0 LDC AREG STL               \ sonst FALSE .
         (THEN)
       (2ELSE)
         SP LDL           FPLDNLSN
                          FPLDZEROSN
                          FPGT           \ rs3 > 0.0 ?
         2IF
           SP LDL         FPLDNLSN       \ rs3
           SP LDL 2 LDNL  FPLDNLSN       \ rs3 rs1
           SP LDL 1 LDNL  FPLDNLSN       \ rs3 rs1 rs2
                          FPSUB FPUABS   \ rs3 |rs1-rs2|
                          FPGT           \ rs3 > |rs1-rs2| ?
           1IF
             -1 LDC AREG STL
           (1ELSE)
              0 LDC AREG STL
           (THEN)
         (2ELSE)
           SP LDL 2 LDNL  FPLDNLSN
                          FPUABS         \ |rs1|
           SP LDL 1 LDNL  FPLDNLSN
                          FPUABS FPADD   \ |rs1|+|rs2|
           SP LDL         FPLDNLSN
                          FPUABS FPMUL   \ (|rs1|+|rs2|)*|rs3|
           SP LDL 2 LDNL  FPLDNLSN
           SP LDL 1 LDNL  FPLDNLSN       \ (|rs1|+|rs2|)*|rs3| rs1 rs2
                          FPSUB FPUABS   \ (|rs1|+|rs2|)*|rs3| |rs1-rs2|
                          FPGT
           1IF
             -1 LDC AREG STL
           (1ELSE)
              0 LDC AREG STL
           (THEN)
         (THEN)
       (THEN)
     (THEN)
     AREG LDL  SP LDL   2 STNL
       SP LDL   8 ADC  SP STL
     NEXT END-CODE


CR .( FSINH, FCOSH, FTANH, FEXPM1, FLNP1 )

CODE FSINH ( rs1 -- rs2 )     \ rs2 = sinh(rs1) ; rs1,rs2 = REAL32
     MATHCONST LDC
     EREG STL                            \ Basisadresse der Konstanten
     SP LDL               FPLDNLSN       \ rs1 nach FAreg
                          FPNOTFINITE    \ Unendlich oder NaN --> Areg = 1
     1IF                                 \ Ja, dann Resultat := x
     (2ELSE)
                          FPDUP          \ x x
       DREG LDLP          FPSTNLSN       \ x aufbewahren
                          FPUABS FPDUP   \ |x| |x|
       EREG LDL        6B LDNLP
                          FPLDNLSN       \ |x| |x| XMax
                          FPGT           \ |x| > XMax ?
       2IF
                          FPLDZEROSN
                          FPDUP          \ |x| 0 0
         DREG LDLP        FPLDNLSN       \ 0 0 x
                          FPGT           \ x < 0.0 ?
         EREG LDL       3 LDNLP
                          FPLDNLSN       \ RInf
         1IF
                          FPSUB          \ -RInf
         (THEN)
       (2ELSE)
                          FPDUP          \ |x| |x|
         EREG LDL      6C LDNLP
                          FPLDNLSN       \ |x| |x| XBig
                          FPGT           \ |x| > XBig ?
         2IF
           EREG LDL    6E LDNLP
                          FPLDNLSN FPSUB \ |x|-LnV =: EX
             SP LDL       FPSTNLSN       \ |x|-LnV auf Stack
             ASM]FORTH FEXP              \ exp(|x|-LnV) =: EX
             FORTH[ASM
             SP LDL       FPLDNLSN       \ EX vom Stack
                          FPLDZEROSN     \ EX 0
           DREG LDLP      FPLDNLSN       \ EX 0 x
                          FPGT           \ x < 0 ?
                          FPDUP          \ EX EX
           EREG LDL    6D LDNLP
                          FPLDNLMULSN    \ EX EX*VBy2M1
                          FPADD          \ EX+EX*VBy2M1
           1IF
                          FPLDZEROSN
                          FPREV FPSUB    \ -(EX+EX*VBy2M1)
           (THEN)
         (2ELSE)
           EREG LDL    1D LDNLP
                          FPLDNLSN FPGT  \ |x| > 1.0 ?
           IF
             SP LDL       FPSTNLSN       \ |x| auf Stack
             ASM]FORTH FEXP              \ exp|x| =: EX
             FORTH[ASM
             SP LDL       FPLDNLSN       \ EX vom Stack
                          FPDUP          \ EX EX
             EREG LDL  1D LDNLP
                          FPLDNLSN FPREV \ EX 1.0 EX
                          FPDIV    FPSUB \ EX-1.0/EX
                          FPUDIVBY2      \ (EX-1.0/EX)/2
                          FPLDZEROSN
             DREG LDLP    FPLDNLSN FPGT  \ x < 0 ?
                          FPLDZEROSN
                          FPREV          \ 0 (EX-1.0/EX)/2
             1IF
                          FPSUB          \ -(EX-1.0/EX)/2
             (THEN)
           (2ELSE)
             DREG LDLP    FPLDNLSN       \ x
                          FPDUP FPMUL    \ x*x
                          FPDUP FPDUP    \ x*x x*x x*x =: G
             AREG LDLP    FPSTNLSN       \ G aufbewahren
             EREG LDL  68 LDNLP
                          FPLDNLMULSN    \ G G*P1
             EREG LDL  69 LDNLP
                          FPLDNLADDSN    \ G G*P1+P0
                          FPREV          \ G*P1+P0 G
             EREG LDL  6A LDNLP
                          FPLDNLADDSN    \ G*P1+P0 G+Q0
                          FPDIV          \ G*P1+P0/G+Q0
             AREG LDLP    FPLDNLMULSN    \ (G*P1+P0/G+Q0)*G
             DREG LDLP    FPLDNLMULSN    \ (G*G*P1+P0/G+Q0)*x
             DREG LDLP    FPLDNLADDSN    \ ((G*G*P1+P0/G+Q0)*x)+x
           (THEN)
         (THEN)
       (THEN)
     (THEN)
     SP LDL               FPSTNLSN       \ Ergebnis auf Stack
     NEXT END-CODE

\ Test F-TP       sinh(0.35) = 0.357189696  dezimal
\ am 15.10.96:    sinh(0.50) = 0.521095264
\                 sinh(0.72) = 0.783840576
\                 sinh(4.2)  = 33.3356608
\                 sinh(9.4)  = 6044.18816

\ Unbek.Tabelle:  sinh(0.35) = 0.357189729
\                 sinh(0.50) = 0.521095305
\                 sinh(0.72) = 0.783840477
\                 sinh(4.2)  = 33.335667732
\                 sinh(9.4)  = 6044.190323746


CODE FCOSH ( rs1 -- rs2 )     \ rs2 = cosh(rs1) ; rs1,rs2 = REAL32
     MATHCONST LDC
     EREG STL                            \ Basisadresse der Konstanten
     SP LDL               FPLDNLSN       \ rs1 nach FAreg
                          FPNOTFINITE    \ Unendlich oder NaN --> Areg = 1
     1IF
                          FPNAN
       1IF
                                         \ Wenn NaN, dann x
       (1ELSE)
         EREG LDL       3 LDNLP
                          FPLDNLSN       \ RInf
       (THEN)
     (2ELSE)
                          FPUABS FPDUP   \ |x| |x|
       EREG LDL        6B LDNLP
                          FPLDNLSN       \ |x| |x| XMax
                          FPGT           \ |x| > XMax ?
       1IF
         EREG LDL       3 LDNLP
                          FPLDNLSN       \ RInf
       (2ELSE)
                          FPDUP          \ |x| |x|
         EREG LDL      6C LDNLP
                          FPLDNLSN       \ |x| |x| XBig
                          FPGT           \ |x| > XBig ?
         2IF
           EREG LDL    6E LDNLP
                          FPLDNLSN FPSUB \ |x|-LnV =: EX
             SP LDL       FPSTNLSN       \ |x|-LnV auf Stack
           ASM]FORTH FEXP                \ exp(|x|-LnV) =: EX
           FORTH[ASM
             SP LDL       FPLDNLSN       \ EX vom Stack
                          FPDUP          \ EX EX
           EREG LDL    6D LDNLP
                          FPLDNLMULSN    \ EX EX*VBy2M1
                          FPADD          \ EX+EX*VBy2M1
         (2ELSE)
             SP LDL       FPSTNLSN       \ |x| auf Stack
           ASM]FORTH FEXP                \ exp(|x|) =: EX
           FORTH[ASM
             SP LDL       FPLDNLSN       \ EX vom Stack
                          FPDUP          \ EX EX
             EREG LDL  1D LDNLP
                          FPLDNLSN FPREV \ EX 1.0 EX
                          FPDIV    FPADD \ EX+(1.0/EX)
                          FPUDIVBY2      \ (EX+(1.0/EX))/2
         (THEN)
       (THEN)
     (THEN)
     SP LDL               FPSTNLSN       \ Ergebnis auf Stack
     NEXT END-CODE

\ Test F-TP       cosh(0.35) = 1.061877760  dezimal
\ am 16.10.96:    cosh(0.50) = 1.127625984
\                 cosh(0.72) = 1.270592768
\                 cosh(4.2)  = 33.3506592
\                 cosh(9.4)  = 6044.1881

\ Unbek.Tabelle:  cosh(0.35) = 1.061877819
\                 cosh(0.50) = 1.127625965
\                 cosh(0.72) = 1.270592733
\                 cosh(4.2)  = 33.350663309
\                 cosh(9.4)  = 6044.190406471

CODE FTANH ( rs1 -- rs2 )     \ rs2 = tanh(rs1) ; rs1,rs2 = REAL32
     MATHCONST LDC
     EREG STL                            \ Basisadresse der Konstanten
                          FPLDZEROSN     \ 0.0
     SP LDL               FPLDNLSN       \ 0 x
                          FPDUP          \ 0 x x
     DREG LDLP            FPSTNLSN       \ x aufbewahren
                          FPNOTFINITE    \ Unendlich oder NaN ?
     2IF
                          FPORDERED      \ Nach IEEE vergleichbar?
       2IF
                          FPGT           \ 0 > x ?
         1IF
                          FPLDZEROSN     \ 0.0
           EREG LDL    1D LDNLP
                          FPLDNLSN FPSUB \ -1.0
         (1ELSE)
           DREG LDLP      FPLDNLSN FPDUP \ x x
                          FPLDZEROSN     \ x x 0
                          FPGT           \ x > 0 ?
           1IF
             EREG LDL  1D LDNLP
                          FPLDNLSN       \ 1.0
           (THEN)
         (THEN)
       (THEN)
     (2ELSE)
                          FPUABS FPDUP   \ |x| |x|
       EREG LDL        6F LDNLP
                          FPLDNLSN       \ |x| |x| XMax
                          FPGT           \ |x| > XMax ?
       2IF
         DREG LDLP        FPLDNLSN       \ |x| x
                          FPLDZEROSN     \ |x| x 0
                          FPGT           \ |x| x > 0 ?
                          FPLDZEROSN     \ |x| 0
         EREG LDL      1D LDNLP
                          FPLDNLSN       \ |x| 0 1.0
         1IF
         (1ELSE)
                          FPSUB          \ |x| -1.0
         (THEN)
       (2ELSE)
                          FPDUP          \ |x| |x|
         EREG LDL      70 LDNLP
                          FPLDNLSN FPGT  \ |x| |x| > Ln3By2 ?
         2IF
                          FPUMULBY2      \ |x|*2
           SP LDL         FPSTNLSN       \ |x|*2 auf Stack
           ASM]FORTH      FEXP           \ exp(|x|*2) =: EX
           FORTH[ASM
           EREG LDL    1D LDNLP
                          FPLDNLSN       \ 1.0
           SP LDL         FPLDNLADDSN    \ 1.0+EX
           EREG LDL    74 LDNLP
                          FPLDNLSN FPREV \ 2.0 1.0+EX
                          FPDIV          \ 2.0/(1.0+EX) =: X
           DREG LDLP      FPLDNLSN       \ X x
                          FPLDZEROSN     \ X x 0
                          FPGT           \ x > 0 ?
           1IF
             EREG LDL  1D LDNLP
                          FPLDNLSN       \ X 1.0
                          FPREV          \ 1.0 X
                          FPSUB
           (2ELSE)
             EREG LDL  1D LDNLP
                          FPLDNLSN       \ X 1.0
                          FPSUB
           (THEN)
         (2ELSE)
           DREG LDLP      FPLDNLSN       \ |x| x
                          FPDUP          \ |x| x x
                          FPMUL FPDUP    \ |x| x*x x*x =: G
           AREG LDLP      FPSTNLSN       \ G aufbewahren
           EREG LDL    73 LDNLP
                          FPLDNLADDSN    \ |x| G+Q0 =: XDen
           AREG LDLP      FPLDNLSN       \ |x| XDen G
           EREG LDL    71 LDNLP
                          FPLDNLMULSN    \ XDen G*P1
           EREG LDL    72 LDNLP
                          FPLDNLADDSN    \ XDen (G*P1)+P0
           AREG LDLP      FPLDNLMULSN    \ XDen ((G*P1)+P0)*G =: XNum
                          FPREV FPDIV    \ XNum/XDen
           DREG LDLP      FPLDNLMULSN    \ (XNum/XDen)*x
           DREG LDLP      FPLDNLADDSN    \ ((XNum/XDen)*x)+x
         (THEN)
       (THEN)
     (THEN)
     SP LDL               FPSTNLSN       \ Ergebnis auf Stack
     NEXT END-CODE

: FEXPM1 ( rs1 -- rs2 )     \ rs2 = exp(rs1)-1 ; rs1,rs2 = REAL32
     FEXP 3F800000 F- ;

: FLNP1 ( rs1 -- rs2 )      \ rs2 = ln(rs1+1) ; rs1,rs2 = REAL32
     3F800000 F+ FLN ;


CR .( FATAN, F** )

CODE FATAN ( rs1 -- rs2 )   \ rs2 = arctan(rs1) ; rs1,rs2 = REAL32
     MATHCONST LDC
     EREG STL                            \ Basisadresse der Konstanten
                          FPLDZEROSN     \ 0.0
     SP LDL               FPLDNLSN FPDUP \ 0 x x
     DREG LDLP            FPSTNLSN       \ x aufbewahren
     0 LDC GREG STL                      \ Steuerung, zunchst berspringen
     1 LDC LDPI FREG STL                 \ Einsprungadresse aufbewahren
     \ --------------------------------  \ Funktion ReducedATan, 4 Aufrufe
     GREG LDL                            \ Funktion ausfhren ?
     2IF
       HREG STL                          \ Rcksprungadresse
       BREG LDLP          FPLDNLSN FPDUP \ Funktionsargument holen
       EREG LDL        7A LDNLP
                          FPLDNLSN FPGT  \ x > TwoSubR3 ?
       2IF
         1 LDC CREG STL                  \ Steuerung = TRUE
                          FPDUP          \ x x
         EREG LDL      75 LDNLP
                          FPLDNLMULSN    \ x x*A
         EREG LDL      5E LDNLP
                          FPLDNLSN FPSUB \ x (x*A)-0.5
         EREG LDL      5E LDNLP
                          FPLDNLSN FPSUB \ x ((x*A)-0.5)-0.5
                          FPADD          \ x+((x*A)-0.5)-0.5) =: XNum
         BREG LDLP        FPLDNLSN       \ XNum x
         EREG LDL      76 LDNLP
                          FPLDNLADDSN    \ XNum x+R3
                          FPDIV          \ XNum/x+R3 =: X
       (1ELSE)
         0 LDC CREG STL                  \ Steuerung = FALSE
                                         \ x =: X
       (THEN)
                          FPDUP FPDUP    \ X X X
       BREG LDLP          FPSTNLSN       \ X aufbewahren
                          FPMUL FPDUP    \ X*X X*X =: G
       AREG LDLP          FPSTNLSN       \ G aufbewahren
                          FPDUP          \ G G
       EREG LDL        77 LDNLP
                          FPLDNLMULSN    \ G G*P1
       EREG LDL        78 LDNLP
                          FPLDNLADDSN    \ G (G*P1)+P0
                          FPMUL          \ G*((G*P1)+P0) =: XNum
       EREG LDL        79 LDNLP
                          FPLDNLSN       \ XNum Q0
       AREG LDLP          FPLDNLADDSN    \ XNum Q0+G
                          FPDIV          \ XNum/Q0+G
       BREG LDLP          FPLDNLMULSN    \ (XNum/Q0+G)*X
       BREG LDLP          FPLDNLADDSN    \ ((XNum/Q0+G)*X)+X
       CREG LDL
       1IF
         EREG LDL      7B LDNLP
                          FPLDNLADDSN    \ Result+PiBy6
       (THEN)
       HREG LDL GCALL                    \ Rcksprung
     (THEN)
     \ --------------------------------  \ Ende Funktion ReducedATan
     1 LDC GREG STL                      \ Funktion freigeben
                          FPNOTFINITE    \ Unendlich oder NaN ?
     2IF
                          FPORDERED      \ Nach IEEE vergleichbar?
       2IF
                          FPGT           \ 0 > x ?
         1IF
                          FPLDZEROSN     \ 0.0
           EREG LDL    0A LDNLP
                          FPLDNLSN FPSUB \ -PiBy2
         (1ELSE)
           DREG LDLP      FPLDNLSN FPDUP \ x x
                          FPLDZEROSN     \ x x 0
                          FPGT           \ x > 0 ?
           1IF
             EREG LDL  0A LDNLP
                          FPLDNLSN       \ PiBy2
           (THEN)
         (THEN)
       (THEN)
     (2ELSE)
                          FPUABS FPDUP   \ |x| |x|
       EREG LDL        7C LDNLP
                          FPLDNLSN       \ |x| |x| XMax
                          FPGT           \ |x| > XMax ?
       2IF
         DREG LDLP        FPLDNLSN       \ |x| x
                          FPLDZEROSN     \ |x| x 0
                          FPGT           \ |x| x > 0 ?
                          FPLDZEROSN     \ |x| 0
         EREG LDL      0A LDNLP
                          FPLDNLSN       \ |x| 0 PiBy2
         1IF
         (1ELSE)
                          FPSUB          \ |x| -PiBy2
         (THEN)
       (2ELSE)
                          FPDUP          \ |x| |x|
         EREG LDL      1D LDNLP
                          FPLDNLSN FPGT  \ |x| |x| > 1.0 ?
         2IF
           EREG LDL    1D LDNLP
                          FPLDNLSN FPREV \ 1.0 |x|
                          FPDIV          \ 1.0/|x|
           BREG LDLP      FPSTNLSN
           FREG LDL GCALL                \ Funktion aufrufen
           EREG LDL    0B LDNLP          \ PiBy2.err
                          FPLDNLSN FPSUB
           EREG LDL    0A LDNLP
                          FPLDNLSN FPSUB \ =: X
           DREG LDLP      FPLDNLSN       \ X x
                          FPLDZEROSN     \ X x 0
                          FPGT           \ x > 0 ?
           1IF
                          FPLDZEROSN     \ X 0
                          FPREV FPSUB    \ -X
           (THEN)
         (2ELSE)
           BREG LDLP      FPSTNLSN       \ Mit |x|
           FREG LDL GCALL                \ Funktion aufrufen =: X
                          FPLDZEROSN     \ X 0
           DREG LDLP      FPLDNLSN       \ X 0 x
                          FPGT           \ x < 0 ?
           1IF
                          FPLDZEROSN     \ X 0
                          FPREV FPSUB    \ -X
           (THEN)
         (THEN)
       (THEN)
     (THEN)
     SP LDL               FPSTNLSN       \ Ergebnis auf Stack
     NEXT END-CODE

CODE F** ( rs1 rs2 -- rs3 )   \ rs3 = rs1^rs2 ; rs1,rs2 = REAL32
     MATHCONST LDC
     EREG STL                            \ Basisadresse der Konstanten
     SP LDL 1 LDNL
     AREG STL                            \ rs1 =: Base aufbewahren
     SP LDL 0 LDNL
     DREG STL                            \ rs2 =: Expn aufbewahren
     SP LDL 4 ADC SP STL                 \ Stack anpassen
     \ NaN-Vorspann --------------------------------------------------
     DREG LDLP            FPLDNLSN       \ Expn oder
     AREG LDLP            FPLDNLSN       \ Base
                          FPORDERED      \ = NaN ? oder
          INV
                          FPLDZEROSN
                          FPREV FPGT     \ 0 > Base ? oder
          OR                             \ Areg als Flag
     AREG LDLP            FPLDNLSN       \ Base = 0 und
                          FPLDZEROSN
                          FPEQ
     DREG LDLP            FPLDNLSN
                          FPLDZEROSN
                          FPGT
          INV AND OR                     \ Expn <= 0 ?
     1IF                                 \ Ja, dann
       EREG LDL         0 LDNL           \ Undefined NaN
         SP LDL         0 STNL
     (3ELSE)
       AREG LDLP          FPLDNLSN       \ Base = 0 und
                          FPLDZEROSN
                          FPEQ
       2IF
         DREG LDLP        FPLDNLSN
                          FPNOTFINITE    \ Expn = +/-inf ?
         1IF
           EREG LDL     1 LDNL           \ Unstable NaN
             SP LDL     0 STNL
         (1ELSE)
           AREG LDL
             SP LDL     0 STNL           \ Sonst Resultat = Base
         (THEN)
       (3ELSE)
         EREG LDL      1D LDNLP          \ 1.0
                          FPLDNLSN
         AREG LDLP        FPLDNLSN FPGT  \ Base < 1.0 und
         DREG LDLP        FPLDNLSN
                          FPNOTFINITE    \ Expn = +/-inf ?
              AND
         2IF
           DREG LDLP      FPLDNLSN
                          FPLDZEROSN
                          FPGT           \ Expn > 0
           1IF
              0 LDC
             SP LDL     0 STNL           \ Resultat = 0
           (1ELSE)
             EREG LDL   3 LDNL           \ RInf
               SP LDL   0 STNL
           (THEN)
         (3ELSE)
           EREG LDL    1D LDNLP          \ 1.0
                          FPLDNLSN
           AREG LDLP      FPLDNLSN FPEQ  \ Base = 1.0 und
           2IF
             DREG LDLP    FPLDNLSN
                          FPNOTFINITE    \ Expn = +/-inf ?
             1IF
               EREG LDL 1 LDNL           \ Unstable NaN
                 SP LDL 0 STNL
             (1ELSE)                     \ Sonst
               EREG LDL
                       1D LDNL
                 SP LDL 0 STNL           \ Resultat = 1.0
             (THEN)
           (3ELSE)
             AREG LDLP    FPLDNLSN
                          FPNOTFINITE    \ Base nicht endlich und
             2IF
               EREG LDL
                       1D LDNLP          \ 1.0
                          FPLDNLSN
               DREG LDLP  FPLDNLSN
                          FPGT
                    INV                  \ Expn >= 1 ?
               1IF
                 EREG LDL
                        3 LDNL           \ RInf
                   SP LDL
                        0 STNL
               (2ELSE)                   \ Sonst
                 DREG LDLP
                          FPLDNLSN       \ Expn
                 -1 LDC
                 CREG STL
                 CREG LDLP
                          FPI32TOR32 FPGT
                 INV                     \ Expn <= -1.0
                 1IF
                   0 LDC
                   SP LDL
                        0 STNL           \ Resultat = 0
                 (1ELSE)
                   EREG
                   LDL  0 LDNL           \ Undefined NaN
                   SP
                   LDL  0 STNL
                 (THEN)
               (THEN)
             (3ELSE)
               EREG LDL
                       1D LDNLP          \ 1.0
                          FPLDNLSN
               AREG LDLP  FPLDNLSN FPEQ  \ Base = 1.0 und
               2IF
                 DREG
                 LDLP     FPLDNLSN
                          FPNOTFINITE    \ Expn = +/-inf ?
                 1IF
                   EREG
                   LDL  1 LDNL           \ Unstable NaN
                   SP
                   LDL  0 STNL
                 (1ELSE)
                   AREG
                   LDL
                   SP
                   LDL  0 STNL           \ Sonst Resultat = Base
                 (THEN)
               (3ELSE)
                 AREG
                 LDLP     FPLDNLSN
                          FPNOTFINITE    \ Base = +/-inf und
                 2IF
                   EREG
                   LDL 1D LDNLP          \ 1.0
                          FPLDNLSN
                   DREG
                   LDLP   FPLDNLSN FPGT
                   INV                   \ Expn >= 1.0 ?
                   1IF
                     EREG
                     LDL
                        3 LDNL           \ RInf
                     SP
                     LDL
                        0 STNL
                   (2ELSE)
                     DREG
                     LDLP FPLDNLSN       \ Expn
                     EREG
                     LDL
                       1D LDNL           \ 1.0
                     MINT
                     OR
                          FPLDNLSN FPGT
                     INV                 \ Expn <= -1.0
                     1IF
                       0 LDC
                       SP LDL  0 STNL    \ Resultat = 0
                     (1ELSE)
                       EREG LDL  0 LDNL  \ Undefined NaN
                         SP LDL  0 STNL
                     (THEN)
                   (THEN)
                 (3ELSE)
                   EREG
                   LDL 1D LDNLP          \ 1.0
                          FPLDNLSN
                   DREG
                   LDLP   FPLDNLSN FPEQ  \ Expn = 1.0 ?
                   1IF
                     AREG LDL
                       SP LDL
                       0 STNL            \ Resultat = Base
                   (3ELSE)
                     DREG LDLP
                     FPLDNLSN
                     FPNOTFINITE         \ Expn = +/-inf und
                     2IF
                       DREG LDLP
                       FPLDNLSN
                       FPLDZEROSN FPGT   \ Expn > 0 ?
                       1IF
                         EREG LDL
                         3 LDNL          \ RInf
                         SP LDL 0 STNL
                       (1ELSE)
                         0 LDC
                         SP LDL 0 STNL   \ Resultat = 0
                       (THEN)
                     (3ELSE)
                       \ Ende des NaN-Vorspanns ----------------------------
       \ <-------------- Beginn des eigentlichen Berechnungsteils
       AREG LDLP          FPLDNLSN       \ B(ase)
                          FPUR32TOR64    \ B(64)
       AREG LDLP          FPSTNLDB       \ B(64) nach AREG,BREG
       BREG LDL
          1 LDC SHL
         15 LDC SHR                      \ Die 11 Exponentenbits nach rechts
        3FF LDC SUB                      \ N1
       CREG STL                          \ aufbewahren
       BREG LDL
       EREG LDL        93 LDNL           \ 800FFFFF
            AND                          \ Exponentenbits =    0 setzen
       EREG LDL        94 LDNL           \ 3FE00000
             OR                          \ Exponentenbits = 1022 setzen
       BREG STL
       AREG LDLP          FPLDNLDB       \ 0.5  X < 1.0
                          FPDUP          \ X X
       EREG LDL        81 LDNLP
                          FPLDNLDB       \ X X C0
                          FPGT           \ X > C0 ?
       2IF
         CREG LDL
            1 ADC
         CREG STL                        \ N1 := N1+1
                          FPDUP          \ X X
         EREG LDL      4F LDNLP          \ 0.5
                          FPLDNLDB
                          FPSUB          \ X X-0.5
         EREG LDL      4F LDNLP
                          FPLDNLDB
                          FPSUB          \ X (X-0.5)-0.5
                          FPREV
         EREG LDL      4F LDNLP          \ 0.5
                          FPLDNLMULDB    \ (X-0.5)-0.5 X*0.5
         EREG LDL      4F LDNLP
                          FPLDNLADDDB    \ (X-0.5)-0.5 (X*0.5)+0.5
                          FPDIV          \ =: Z
       (2ELSE)
         EREG LDL      4F LDNLP          \ 0.5
                          FPLDNLDB       \ X 0.5
                          FPSUB          \ X-0.5 =: ZNum
                          FPDUP          \ ZNum ZNum
         EREG LDL      4F LDNLP          \ 0.5
                          FPLDNLMULDB    \ ZNum ZNum*0.5
         EREG LDL      4F LDNLP
                          FPLDNLADDDB    \ ZNum (ZNum*0.5)+0.5
                          FPDIV          \ =: Z
       (THEN)
       \ --------------------------------- Logarithmus ---------------
                          FPDUP FPDUP    \ Z Z Z
                          FPMUL FPDUP    \ Z Z*Z Z*Z =: W
       GREG LDLP          FPSTNLDB       \ W aufbewahren
       EREG LDL        87 LDNLP          \ A2
                          FPLDNLMULDB    \ Z W*A2
       EREG LDL        89 LDNLP          \ A1
                          FPLDNLADDDB    \ Z (W*A2)+A1
       GREG LDLP          FPLDNLMULDB    \ Z ((W*A2)+A1)*W
       EREG LDL        8B LDNLP
                          FPLDNLADDDB    \ Z (((W*A2)+A1)*W)+A0
       GREG LDLP          FPLDNLMULDB    \ Z ((((W*A2)+A1)*W)+A0)*W =: RNum
       AREG LDLP          FPSTNLDB       \ RNum aufbewahren
       GREG LDLP          FPLDNLDB       \ Z W
       EREG LDL        8D LDNLP          \ B2
                          FPLDNLADDDB    \ Z W+B2
       GREG LDLP          FPLDNLMULDB    \ Z (W+B2)*W
       EREG LDL        8F LDNLP          \ B1
                          FPLDNLADDDB    \ Z ((W+B2)*W)+B1
       GREG LDLP          FPLDNLMULDB    \ Z (((W+B2)*W)+B1)*W
       EREG LDL        91 LDNLP          \ B0
                          FPLDNLADDDB    \ Z ((((W+B2)*W)+B1)*W)+B0 =: RDen
       AREG LDLP          FPLDNLDB       \ Z RDen RNum
                          FPREV FPDIV    \ Z RNum/RDen =: R
       AREG LDLP          FPSTNLDB FPDUP \ Z Z
       AREG LDLP          FPLDNLMULDB    \ Z Z*R
                          FPADD          \ Z+(Z*R) =: RW
       \ --------------------------------- Ende Logarithmus -----------
       CREG LDL
          0 EQC                          \ N1 = 0 ?
       1IF
       (2ELSE)
         CREG LDLP        FPI32TOR64     \ RW N1(64)
         EREG LDL      2B LDNLP          \ DLn2
                          FPLDNLMULDB    \ RW N1(64)*DLn2
                          FPADD          \ RW+((N1(64)*DLn2) =: RW1
       (THEN)
       DREG LDLP          FPLDNLSN       \ RW1 Expn(32)
                          FPUR32TOR64    \ RW1 Expn(64)
                          FPMUL          \ RW1*Expn(64) =: XW
                          FPDUP          \ XW XW
       EREG LDL        83 LDNLP
                          FPLDNLDB FPGT  \ XW > MaxLog ?
       1IF
         EREG LDL       3 LDNLP
                          FPLDNLSN       \ Result := RInf
       (2ELSE)
                          FPDUP          \ XW XW
         EREG LDL      85 LDNLP
                          FPLDNLDB FPREV \ XW MinLog XW
                          FPGT           \ MinLog > XW ?
         1IF
                          FPLDZEROSN     \ Result := 0.0
         (2ELSE)
                          FPDUP          \ XW XW
           EREG LDL    7F LDNLP
                          FPLDNLMULDB    \ XW XW*DInvLn2
                          FPINT          \ XW INT64(XW*DInvLn2) =: N2
           CREG LDLP      FPSTNLI32      \ N2 aufbewahren
           CREG LDLP      FPI32TOR64     \ XW N2(64)
           EREG LDL    2B LDNLP          \ DLn2
                          FPLDNLMULDB    \ XW N2*DLn2
                          FPSUB          \ XW-(N2*DLn2) =: XW1
                          FPUR64TOR32    \ XW1(32) =: XW1
                          FPDUP FPDUP    \ XW1 XW1 XW1
                          FPMUL FPDUP    \ XW1 XW1*XW1 XW1*XW1 =: Z
           AREG LDLP      FPSTNLSN       \ Z aufbewahren
           EREG LDL    65 LDNLP
                          FPLDNLMULSN    \ XW1 Z*A0
           EREG LDL    66 LDNLP
                          FPLDNLADDSN    \ XW1 (Z*A0)+A1
                          FPMUL          \ XW1*((Z*A0)+A1) =: GPZ
                          FPDUP          \ GPZ GPZ
           BREG LDLP      FPSTNLSN       \ GPZ aufbewahren
           AREG LDLP      FPLDNLSN       \ GPZ Z
           EREG LDL    67 LDNLP
                          FPLDNLMULSN    \ GPZ Z*B1
           EREG LDL    5E LDNLP
                          FPLDNLADDSN    \ GPZ (Z*B1)+B0
           BREG LDLP      FPLDNLSN       \ GPZ (Z*B1)+B0 GPZ
                          FPSUB FPDIV    \ GPZ/((Z*B1)+B0)-GPZ
           EREG LDL    5E LDNLP
                          FPLDNLADDSN    \ (GPZ/((Z*B1)+B0)-GPZ)+B0 =: Res
           \ Result := SCALEB(Res, N2+1) ------------------------------
           CREG LDL                      \ N2
              1 ADC
           CREG STL                      \ N2+1
           BREG LDLP      FPSTNLSN       \ Res aufbewahren
           BREG LDL
           EREG LDL    63 LDNL           \ 807FFFFF
                AND                      \ Exponentenbits = 0 setzen
           BREG LDL
              1 LDC SHL
             18 LDC SHR                  \ Die 8 Exponentenbits nach rechts
           CREG LDL                      \ N2+1
                ADD                      \ hinzuaddieren.
             18 LDC SHL
              1 LDC SHR                  \ Wieder auf Normalposition
                 OR                      \ Jetzt Exponent *2**(N2+1)
           BREG STL
           BREG LDLP      FPLDNLSN
           \ Ende SCALEB(Res,  N2+1) -----------------------------------
         (THEN)
       (THEN)
       SP LDL             FPSTNLSN       \ Ergebnis auf Stack
       \ Ende des eigentlichen Berechnungsteils ------------------------
       (THEN)
                   (THEN)
                 (THEN)
               (THEN)
             (THEN)
           (THEN)
         (THEN)
       (THEN)
     (THEN)
     NEXT END-CODE

\ Test F-TP am 3.12.96:
\ DECIMAL
\ F# 2.7182818        F# 7.123456  F** FLN F.L --> 7.123455
\ F# 2.7182818  FSQRT F# 7.123456  F** FLN F.L --> 3.561727
\ F# 7.123456         F# 2.0 F/            F.L --> 3.561728
\ F# 4.56789  F# 0.5  F** F.L --> 2.137262
\ F# 4.56789     FSQRT    F.L --> 2.137262
\ F# 2.137262  DUP F* F.L --> 4.567888
\ F# 5.24689  F# 0.5  F** DUP F* F.L --> 5.246889
\ F# 7.54  F# -1.0  F** F.L --> 1.3262600E-1
\ F# 1.00  F# 7.54  F/  F.L --> 1.3262600E-1
\ Bronstein: 1/7.54 = 0.1326

\ Generelle Bemerkung zu den Tests:
\ ---------------------------------
\ Ich habe F.L usw. jetzt so eingerichtet, dass Stellen, die nicht mehr
\ garantiert sind, abgeschnitten werden.  In den hier angegebenen Tests
\ zu F** ist das schon bercksichtigt. Die anderen Tests mssen wieder-
\ holt und die Ergebnisse mssen berichtigt werden. Ich mchte die Ver-
\ sion 1.00 von F-TP jetzt abschlieen und hole das alles spter nach.
\ - 7.12.96


\ Folgende weitere "ANS Forth Word Sets" mssen noch eingebaut oder auf
\ eventuell  unter anderer Bezeichnung  oder in abweichender Form schon
\ vorhandene Worte untersucht werden:

\  7. The optional Block word set
\  8. The optional Double-Number word set
\  9. The optional Exception word set
\ 10. The optional Facility word set
\ 11. The optional File-Access word set
\ 13. The optional Locals word set
\ 14. The optional Memory-Allocation word set
\ 15. The optional Programming-Tools word set
\ 16. The optional Search-Order word set
\ 17. The optional String word set

\ Diese Aufzhlung stammt aus den amerikanischen ANS-Forth-Empfehlungen

\ -----------------------------------

\ Ende des Einfgsels "dpANS-5-Worte"


CR .( System mit Umlauten in den Namen der Forth-Worte )
DECIMAL

CODE (FIND)-GER ( ad lfa -- cfa flag | ad false )
      SP LDL  0 LDNL  DREG STL      \ lfa
      DREG LDL  0=
      1IF  0 LDC  SP LDL  0 STNL  NEXT THEN
      BEGIN
        DREG LDL  BREG STL          \ String-Arbeitsspeicher
        BREG LDL 4 ADC BREG STL     \ nach nfa gehen
        SP LDL  1 LDNL  CREG STL    \ Stringadresse ( ursprnglich DI )
        CREG LDL  LB  EREG STL      \ EREG = Zhler fr Lnge
        BREG LDL  LB  CREG LDL  LB
        XOR  31 LDC  AND  AREG STL  \ Vergleichs-Arbeitsspeicher
        AREG LDL  0=
        2IF
          BEGIN
            EREG LDL -1 ADC  EREG STL         \ Zhler dekrementieren
            BREG LDL  1 ADC  BREG STL
            CREG LDL  1 ADC  CREG STL
            BREG LDL    LB   CREG LDL  LB
            XOR  AREG STL
            AREG LDL  0<>   EREG LDL  0=  OR  \ Bis ganze Lnge durchlaufen
          UNTIL
          AREG LDL  0=  EREG LDL  0=  AND
          2IF
            BREG LDL  2 ADC  SP LDL  1 STNL   \ Extrabyte bercksichtigen
            DREG LDL  BREG STL
            BREG LDL  4 ADC  BREG STL
            BREG LDL  LB  64 LDC  AND  AREG STL
            AREG LDL  0<>
            1IF
               1 LDC  AREG STL
            1ELSE
              -1 LDC  AREG STL
            THEN
            AREG LDL  SP LDL  0 STNL
            4 LDC  SP LDL  1 LDNL  3 LDC  AND  SUB  3 LDC  AND
            SP LDL  1 LDNL   ADD  SP LDL  1 STNL  NEXT
          THEN
        THEN
        DREG LDL  0 LDNL  DREG STL
        DREG LDL  0=
      UNTIL
      0 LDC  SP LDL  0 STNL  NEXT END-CODE
\ Diese Version ist fr die Umschaltung auf GERMAN gedacht. Sie testet
\ nicht auf hchstes Bit = 1 im letzten Zeichen des Namensfeldes.  Sie
\ wertet dafr aber auch das volle letzte Zeichen aus.  Das heit,  in
\ einem System,  das dort eine 1  im hchsten Bit des letzten Zeichens
\ als Steuerbit hat, wrde diese Version nicht richtig arbeiten.

CODE (FIND)-XXX ( ad lfa -- cfa flag | ad false )
      SP LDL  0 LDNL  DREG STL      \ lfa
      DREG LDL  0=
      1IF  0 LDC  SP LDL  0 STNL  NEXT THEN
      BEGIN
        DREG LDL  BREG STL          \ String-Arbeitsspeicher
        BREG LDL 4 ADC BREG STL     \ nach nfa gehen
        SP LDL  1 LDNL  CREG STL    \ Stringadresse ( ursprnglich DI )
        CREG LDL  LB  EREG STL      \ EREG = Zhler fr Lnge
        BREG LDL  LB  CREG LDL  LB
        XOR  31 LDC  AND  AREG STL  \ Vergleichs-Arbeitsspeicher
        AREG LDL 0=
        2IF
          EREG LDL  1 LDC >                   \ Name lnger als 1 ?
          2IF
            BEGIN
              EREG LDL -1 ADC  EREG STL       \ Zhler dekrementieren
              BREG LDL  1 ADC  BREG STL
              CREG LDL  1 ADC  CREG STL
              BREG LDL    LB   CREG LDL  LB
              XOR  AREG STL
              AREG LDL  0<>
              EREG LDL  1 LDC =  OR           \ Bis fast ganze Lnge
            UNTIL                             \ durchlaufen.
          THEN
          AREG LDL  0=  EREG LDL  1 LDC =
                                      AND
          BREG LDL  1 ADC  BREG STL           \ Letzte Bytes ( oh-
          CREG LDL  1 ADC  CREG STL           \ ne hchstes Bit )
          BREG LDL  LB  127 LDC  AND          \ einander gleich ?
          CREG LDL  LB  =             AND
          2IF
            BREG LDL  2 ADC  SP LDL  1 STNL   \ Extrabyte bercksichtigen
            DREG LDL  BREG STL
            BREG LDL  4 ADC  BREG STL
            BREG LDL  LB  64 LDC  AND  AREG STL
            AREG LDL  0<>
            1IF
               1 LDC  AREG STL
            1ELSE
              -1 LDC  AREG STL
            THEN
            AREG LDL  SP LDL  0 STNL
            4 LDC  SP LDL  1 LDNL  3 LDC  AND  SUB  3 LDC  AND
            SP LDL  1 LDNL   ADD  SP LDL  1 STNL  NEXT
          THEN
        THEN
        DREG LDL  0 LDNL  DREG STL
        DREG LDL  0=
      UNTIL
      0 LDC  SP LDL  0 STNL  NEXT END-CODE
\ Dieses Version ist als Zwischenversion fr das Umschalten von ENGLISH nach
\ GERMAN gedacht.  Sie testet  bei den Vergleichen der einzelnen Zeichen der
\ Namen nicht nach 1 im hchsten Bit, sondern verwendet als Abbruchkriterium
\ die im allerersten Byte gespeicherte Lnge des Namens.  Sie wertet aber im
\ letzten Byte das Zeichen nur als Zeichen von ASCII-Wert bis zu 127 . Diese
\ Version funktioniert also sowohl in einem System mit 1 im hchsten Bit des
\ letzten Namensbytes als auch in einem System ohne.  Vorausgesetzt, besagte
\ Systeme verwenden als letztes Zeichen im Namensfeld keins mit einem ASCII-
\ Wert ber 127 . Mit anderen Worten, die Umschaltung per ENGLISH und GERMAN
\ kann nur im eigentlichen System vorgenommen werden,  bei dem streng darauf
\ geachtet wurde, dass keine Namen mit Umlauten auftreten.  Sind bereits An-
\ wendungsworte  mit Umlauten in den Namen vorhanden,  geht das  nicht mehr.
\ Man kann dann natrlich per EMPTY auf das reine System zurckschalten, die
\ Umschaltung dann vornehmen  und die Anwendung erneut  ( gegebenenfalls per
\ INCLUDE ) hinzuladen.

HEX

: NAME>-GER ( nfa -- cfa )
     DUP C@ 1F AND + 2 + EVEN ;

: >NAME-GER ( cfa -- nfa )
      BEGIN
        1- DUP C@ 20 <>
      UNTIL
        DUP C@ 1F AND - 1- ;

: NAME-GER ( -- )
     VOC-LINK                        \ Verkettete Vokabularliste
       BEGIN @ ?DUP                  \ Bis erschpft ( = 0 )
       WHILE
         DUP #THREADS 4* -           \ Um 4 Strnge zurcksetzen
         #THREADS 0                  \ 4 Strnge durchlaufen
         DO DUP I 4* +
           BEGIN @ ?DUP WHILE        \ Jedes einzelne Wort
             80 OVER L>NAME          \ des Strangs bearbeiten.
             DUP C@ 1F AND +         \ An das Ende des Namens.
             CRESET                  \ zurcksetzen.
           REPEAT
         LOOP DROP
       REPEAT ;
\ Mit diesem Wort wird  in smtlichen Worten des gerade im Speicher befind-
\ lichen Systems ( eigentliches System und eventuell per INCLUDE "angehng-
\ te" Anwendungen ) das hchste Bit im letzten Zeichen im Namensfeld  auf 0
\ gesetzt.  Das betreffende System  ist dann "germanifiziert"  ( siehe auch
\ GERMAN und ENGLISH. Bis auf CRESET ist NAME-GER eine Kopie von NAME-ENG.

: NAME-ENG ( -- )
     VOC-LINK                        \ Verkettete Vokabularliste
       BEGIN @ ?DUP                  \ Bis erschpft ( = 0 )
       WHILE
         DUP #THREADS 4* -           \ Um 4 Strnge zurcksetzen
         #THREADS 0                  \ 4 Strnge durchlaufen
         DO DUP I 4* +
           BEGIN @ ?DUP WHILE        \ Jedes einzelne Wort
             80 OVER L>NAME          \ des Strangs bearbeiten.
             DUP C@ 1F AND +         \ An das Ende des Namens.
             CSET                    \ Setzen.
           REPEAT
         LOOP DROP
       REPEAT ;
\ Mit diesem Wort wird  in smtlichen Worten des gerade im Speicher befind-
\ lichen Systems ( eigentliches System und eventuell per INCLUDE "angehng-
\ te" Anwendungen ) das hchste Bit im letzten Zeichen im Namensfeld  auf 1
\ gesetzt.  Das betreffende System  ist  dann  "anglifiziert"  ( siehe auch
\ GERMAN und ENGLISH . Bis auf CSET ist NAME-ENG eine Kopie von NAME-GER .

: NAME-CLEAR ( -- )                  \ Nur vom "deutschen" System !
     VOC-LINK                        \ Verkettete Vokabularliste
       BEGIN @ ?DUP                  \ Bis erschpft ( = 0 )
       WHILE
         DUP #THREADS 4* -           \ Um 4 Strnge zurcksetzen
         #THREADS 0                  \ 4 Strnge durchlaufen
         DO DUP I 4* +
           BEGIN @ ?DUP WHILE        \ Jedes einzelne Wort
             DUP L>NAME              \ des Strangs bearbeiten.
             DUP C@ 1F AND DUP 1 >
             IF                      \ Nicht, wenn nur 1 Zeichen
               1
               DO DUP I +
                   80 SWAP CRESET    \ Umlaute beseitigen
               LOOP
             ELSE
               DROP
             THEN
             DROP
           REPEAT
         LOOP DROP
       REPEAT ;
\ Mit diesem Wort  wird in smtlichen Worten des gerade im Speicher befind-
\ lichen Systems ( eigentliches System und eventuell per INCLUDE "angehng-
\ te" Anwendungen ) das hchste Bit im ersten bis zum vorletzten Zeichen im
\ Namensfeld  auf 0 gesetzt.  Namen,  die Zeichen mit ASCII-Werten ber 127
\ enthalten ( wie sie beispielsweise in einem per GERMAN umgeschalteten Sy-
\ stem erzeugt ein knnten )  stren dann in einem auf ENGLISH geschalteten
\ System nicht. ( Allerdings ist es schwierig,  sie dort sinnvoll weiterzu-
\ verwenden.

: .ID-GER ( nfa -- )
     DUP <IP @ 4+ >NAME = IF BOLD THEN \ hervorgehoben, wenn Wort im TRACE-Mode
     DUP 1+ DUP C@ ROT C@ 1F AND 0
     ?DO EMIT
     1+ DUP C@
     LOOP ATTOFF 2DROP SPACE ;
\ Im Gegensatz zum bisherigen .ID, dem jetzigen .ID-ENG ( siehe TKERNEL.FTH ),
\ werden bei .ID-GER alle Bytes, die zu Zeichen des Namensfeldes gehren, voll
\ ausgegeben, also ohne dass ber 127 AND das hchste Bit beseitigt wird.

: GERMAN  ( -- )
     ['] NAME>-GER   IS NAME>
     ['] >NAME-GER   IS >NAME
     ['] (FIND)-XXX  IS (FIND)
     ['] "CREATE-GER IS "CREATE
         NAME-GER
     ['] (FIND)-GER  IS (FIND)
     ['] .ID-GER     IS .ID ;
\ Mit diesem Wort wird auf ein System umgeschaltet, bei welchem die Zeichen
\ im Namensfeld  auch ASCII-Werte  ber 127 haben knnen.  ( Alle TRAVERSE-
\ hnlichen Funktionen werden in der sich damit ergebenden Form des Systems
\ umgangen. )

: ENGLISH ( -- )
     ['] NAME>-ENG   IS NAME>
     ['] >NAME-ENG   IS >NAME
     ['] (FIND)-XXX  IS (FIND)
     ['] "CREATE-ENG IS "CREATE
         NAME-ENG
     ['] (FIND)-ENG  IS (FIND)
     ['] .ID-ENG     IS .ID ;
\ Mit diesem Wort wird auf ein System umgeschaltet,  bei welchem die Zeichen
\ im Namensfeld keine ASCII-Werte ber 127 haben drfen. Das ist die bliche
\ Form eines Systems, das dem Turbo-Forth oder F83 nachgebildet ist.  Das im
\ vorliegenden System F-TP  eingefhrte Extrabyte  am Schluss der Namensfel-
\ der, das  ( neben dem ersten Byte  ein zweites Mal )  die Stringlnge ent-
\ hlt, wird allerdings beibehalten.  Es besteht keine Veranlassung zur Ver-
\ mutung, dass das irgendwo stren knnte.



CR .( Parallelverarbeitung )
HEX

\ In diesem Teil  der Parallelverarbeitung  habe ich  versucht,  die von der
\ INMOS-Literatur bekannten OCCAM2-Konstrukte nach FORTH zu bertragen.  Na-
\ trlich in forth-gemen Formen.  In einigen Punkten erschien es mir ange-
\ bracht,  ber OCCAM2 hinauszugehen und Dinge einzubauen,  die es in OCCAM2
\ nicht explizit gibt,  die sich aber  bei Durchsicht der Transputer-Maschi-
\ nenbefehle anboten. Auf jeden Fall muss ganz besonders dieser Parallelver-
\ arbeitungsteil  als reine Betaversion  betrachtet werden,  die nach keiner
\ Seite hin Vollstndigkeit anstrebt  oder fehlerfrei zu sein  vorgibt.  Das
\ ursprngliche Multi-Task-Konzept von F83  oder Turbo-Forth  geht im OCCAM-
\ geprgten Parallelkonzept  auf.  Einige Relikte,  wie User-Variablen etc.,
\ sind aber  zunchst noch  beibehalten worden.  Es wird erwartet,  dass sie
\ nicht stren.  Eine endgltige Aufbereitung des Parallelkonzepts soll dann
\ in weiteren Versionen Schritt fr Schritt vorgenommen werden.

CODE WPTR@  ( --ad )         \ holt Workspace-Pointer auf Stack
     0 LDLP  1PUSH  END-CODE
CODE WPTR!  ( ad-- )         \ setzt Workspace-Pointer auf ad
     SP LDL  0 LDNL
     SP LDL  4 ADC  SP STL
     GAJW    NEXT END-CODE

: LOCAL  ( proc ad -- ad' )  \ Beispiel: SPOOLER #LINE LOCAL OFF  setzt die
     WPTR@ - + ;             \ Uservariable #LINE des Prozesses SPOOLER auf 0
                             \ ndern ???????

CR .( Priority-Pointer )

CODE SAVEHF ( -- n )         \ High-Priority-Front-Pointer auf Stack
     AREG LDLP  SAVEH
     AREG LDL
     1PUSH   END-CODE

CODE SAVEHB ( -- n )         \ High-Priority-Back-Pointer  auf Stack
     AREG LDLP  SAVEH
     BREG LDL
     1PUSH   END-CODE

CODE SAVELF ( -- n )         \ Low-Priority-Front-Pointer auf Stack
     AREG LDLP  SAVEL
     AREG LDL
     1PUSH   END-CODE

CODE SAVELB ( -- n )         \ Low-Priority-Back-Pointer  auf Stack
     AREG LDLP  SAVEL
     BREG LDL
     1PUSH   END-CODE

CODE STHF ( n -- )           \ High-Priority-Front-Pointer
     SP LDL  0 LDNL          \ auf den Wert n
     STHF                    \ setzen.
     SP LDL  4 ADC  SP STL   \ Stack anpassen.
     NEXT         END-CODE

CODE STHB ( n -- )           \ High-Priority-Back-Pointer
     SP LDL  0 LDNL          \ auf den Wert n
     STHB                    \ setzen.
     SP LDL  4 ADC  SP STL   \ Stack anpassen.
     NEXT         END-CODE

CODE STLF ( n -- )           \ Low-Priority-Front-Pointer setzen
     SP LDL  0 LDNL          \ auf den Wert n
     STLF                    \ setzen.
     SP LDL  4 ADC  SP STL   \ Stack anpassen.
     NEXT         END-CODE

CODE STLB ( n -- )           \ Low-Priority-Back-Pointer
     SP LDL  0 LDNL          \ auf den Wert n
     STLB                    \ setzen.
     SP LDL  4 ADC  SP STL   \ Stack anpassen.
     NEXT         END-CODE

CR .( Timer )

CODE TIMER! ( n -- )         \ Die beiden Timer-Register
     SP LDL  0 LDNL          \ mit dem Wert n laden
     STTIMER                 \ und starten.
     SP LDL  4 ADC  SP STL   \ Stack anpassen.
     NEXT         END-CODE

CODE TIMER@ ( -- n )         \ Den augenblicklichen Wert des
     LDTIMER                 \ Timer-Registers der aktuellen Prioritt
     1PUSH  END-CODE         \ auslesen und auf Stack legen.

CODE WAIT ( n -- )           \ Der ausfhrende Prozess wartet
     SP LDL  0 LDNL          \ auf den Zeitpunkt n ( siehe unten )
     TIN                     \ der ihm eigenen Prioritt.
     SP LDL  4 ADC  SP STL   \ Stack anpassen.
     NEXT         END-CODE
\ ..........................................................................
\ Liegt n in der "Zukunft", so wird der Prozess aus der Warteschlange seiner
\ Prioritt  herausgenommen  und  in den Wartezustand  versetzt.  Sobald der
\ Zeitpunkt n erreicht ist,  wird der Prozess  wieder an das Ende der Warte-
\ schlange seiner Prioritt gesetzt. Die in n enthaltene Zeiteinheit betrgt
\ 1 Mikrosekunde  fr Prozesse hoher Prioritt,  64 Mikrosekunden fr solche
\ niedriger Prioritt. Beispiel fr einen Prozess niedriger Prioritt:
\ [ DECIMAL ] TIMER@ 15625 + WAIT lsst den Prozess ( mind. ) 1 sec. warten.

CODE AFTER ( n1 n2 -- fl )   \ fl = TRUE, falls n1 zeitlich "nach" n2
     SP LDL  1 LDNL          \ n1 vom Stack
     SP LDL  0 LDNL          \ n2 vom Stack
     DIFF    0 LDC  GT       \ n1-n2 > 0 ?
     -1 ADC  NOT             \ 1/0 --> 0/-1 --> -1/0
     SP LDL  1 STNL          \ fl auf Stack legen.
     SP LDL  4 ADC  SP STL   \ Stack anpassen.
     NEXT         END-CODE
\ .............................................................................
\ Es kann  nicht einfach ">" statt "AFTER" verwendet werden,  da die "Zeit zyk-
\ lisch" ist. Genaueres zum Begriff AFTER lese man in der OCCAM-Literatur nach.
\ Hier nur  ein paar Beispiele,  um das Sichzurechtfinden  zu erleichtern.  Die
\ rechte Zahl jeder Zeile  ( einmal in der vorzeichenlosen Darstellung,  einmal
\ mit Vorzeichen dargestellt )  liegt  "AFTER"  der linken Zahl ( ohne oder mit
\ Vorzeichen ).
\          x                  y AFTER x
\   ohne       mit         ohne       mit Vorzeichen
\ 7FFFFFFF  7FFFFFFF     80000000  80000000
\ 7FFFFFF0  7FFFFFF0     8000000F -7FFFFFF1
\ 80000001 -7FFFFFFF     8000000F -7FFFFFF1
\ 7FFFFFF0  7FFFFFF0     7FFFFFFF  7FFFFFFF
\ FFFFFF01       -FF     FFFFFF10       -F0
\       F0        F0           FF        FF

CR .( Task, Par, Pri, Alt, Pripar )

: TASK: ( <name> len -- )    \ Erzeugt Prozessrahmen <name> der Lnge len
     DUP                     \ Aufruf von name liefert WPTR des Prozesses
     100 40 CELLS +          \ Sicherheitsabfrage
          #USER @ + TUCK <
     IF CR BOLD ." Lnge > " H. BS EMIT ." h whlen !" ATTOFF ABORT THEN
     DROP
     CREATE                  \ Wortkopf erzeugen
     9 CELLS ALLOT           \ fr Prozessparameter ( auch WPTR-6 bis WPTR-9 )
     HERE WPTR@ HERE
     20 CELLS CMOVE          \ Systemvariablen bertragen
     20 CELLS ALLOT          \ Dictionary-Pointer weiterrcken
     TOS HERE #USER @ CMOVE  \ USER-Variablen  bertragen
     #USER @  ALLOT          \ Dictionary-Pointer weiterrcken
     HERE OVER DP  LOCAL !   \ Lokales DP setzen
     TUCK   +  EVEN   DP !   \ DP auf nchstes Wort nach Task:
     HERE OVER RP0 LOCAL !   \ Wortende auf RP0 setzen.
     HERE 100 - SWAP         \ SP0 auf RP0 minus 100
               SP0 LOCAL !   \ setzen.
     DOES> 9 CELLS + ;       \ <name> liefert bei Aufruf seinen WPTR
\ ....................................................................
\ Ich bezeichne einen Prozessrahmen XXX , der per  TASK:  beispielsweise
\ ber  300 TASK: XXX  erzeugt wurde,  in den Stackkommentaren als xxx .
\ Per  ACTIVATE  wird beispielsweise ber
\ : YYY XXX ACTIVATE CR ." Alles klar ?" END-ACT ;
\ der eigentliche Ausfhrungsteil des Prozesses XXX erzeugt.  Diesen be-
\ zeichne ich in den Stackkommentaren als yyy .
\ XXX  legt bei Aufruf den  Workspace-Pointer des betreffenden Prozesses
\ auf den Stack.  YYY  aus der obigen Konstruktion legt bei Aufruf eben-
\ falls den Workspace-Pointer auf den Stack, initiiert aber gleichzeitig
\ noch RP, SP und IP des betreffenden Prozesses  und bereitet diesen so-
\ mit fr den erstmaligen Einsprung in ihn vor. GO-TASK und die Paralle-
\ lisierungskonstruktion : ZZZ PAR YYY1 YYY2 YYY3 ENDPAR ;  arbeiten mit
\ yyy, dem Prozess-Ausfhrungsteil; Worte, die einen oder mehrere unter-
\ brochene Prozesse wieder aufnehmen,  arbeiten mit xxx, dem Prozessrah-
\ men.  RP, SP  und insbesondere IP drfen bei solchen Worten nicht zwi-
\ schendurch verndert werden.

: NO-TASK? ( fl -- )
     ABORT" Kein oder ungltiger Prozess im Parallel-Konstrukt !" ;

: NR-TASK? ( fl -- )
     ABORT" Eingabezahl ndern oder mehr PRI-Prozesse angeben !" ;

: ALT-ERR? ( fl -- )
     ABORT" Kein Prozess oder ungltiger ALT-Konstrukt !" ;

: PAR ( -- sp )              \ sp = bisheriger Stackstand zur Laufzeit
     COMPILE SP@             \ der Doppelpunkt-Definition,  in der PAR
     COMPILE >R              \ auftritt. Zwischenspeichern.
     ; IMMEDIATE

: PRI ( -- sp )
     COMPILE SP@  COMPILE >R  ; IMMEDIATE
\ ....................................................................
\ PRI ist genauso aufgebaut wie PAR ( siehe dort ). PRI ist fr die Ein-
\ richtung eines Parallel-Konstrukts  fr Prozesse hoher Prioritt ( 0 )
\ gedacht. Im Gegensatz zu PAR lsst sich PRI auf jeden Prozess der Prio-
\ ritt 1 ( niedrig ) aufsetzen. PAR dagegen greift hierzu auf den Boot-
\ prozess zurck.   ?????????????????

: PRIPAR ( n -- n sp )       \ sp siehe PAR .
     COMPILE >R  COMPILE SP@  COMPILE >R ; IMMEDIATE
\ ....................................................................
\ Es wird ein Parallel-Konstrukt gebildet, der n Prozesse mit Prioritt
\ 0 ( hohe Prioritt ) und den Rest der Prozesse mit Prioritt 1 laufen
\ lsst. Fehlermeldung, wenn n grer als die Zahl der Prozesse.

: ALT ( -- sp )              \ ALT ist genauso aufgebaut wie PAR (siehe dort).
     COMPILE SP@  COMPILE >R  ; IMMEDIATE

CODE (ENDPAR) ( yyy1 ... yyyn sp{yyy1}+4 -- ) \ Einklinken von n bis 1
     SP LDL  0 LDNL          \ "yyy0" = erzeugender Prozess
     HREG STL                \ HREG = sp(yyy1)+4 .
     SP LDL  EREG STL        \ EREG = Schleifenzhler
     HREG LDL  SP LDL        \ SP = sp(yyyn)-4
     SUB  WCNT               \ Prozessanzahl + 1 ( fr "yyy0" )
     DREG STL                \ nach DREG
     BEGIN                   \ 1 Wort vor yyyn
      EREG LDL  4 ADC        \ Anfang bei sp(yyyn)
      EREG STL               \ Schleife um 1 Wort weiter
      NEXTP LDL              \ Code-Anfang bei allen Prozessen gleich
          4 LDC              \ Offset von nach LDPI bis nach STARTP
      LDPI  SUB              \ Offset von STARTP bis Prozess-Code bilden
      EREG LDL  0 LDNL       \ WPTR des laufenden Prozesses
      STARTP                 \ Laufenden Prozess einklinken
      HREG LDL  -4 ADC       \ Raus,
      EREG LDL  =            \ wenn = sp(yyy1)
     UNTIL
     HREG LDL  SP STL        \ Stack anpassen
     DREG  LDL  1 STL        \ Prozesszahl nach WPTR+1 von "yyy0"
     NEXTP LDL  0 STL        \ Code "Folgeprozess" nach WPTR+0 von "yyy0"
     0 LDLP                  \ WPTR von "yyy0"
     ENDP                    \ "yyy0" beenden
     NEXT END-CODE

CODE (ENDPRI) ( yyy1 ... yyyn sp{yyy1}+4 -- ) \ Einklinken von n bis 1
     SP LDL  0 LDNL
     HREG STL                \ HREG = sp(yyy1)+4 .
     SP LDL  EREG STL        \ EREG = Schleifenzhler
     HREG LDL  SP LDL        \ SP = sp(yyyn)-4
     SUB  WCNT               \ Prozessanzahl + 1 ( fr "erzeugenden Prozess" )
     DREG STL                \ nach DREG
        5 LDC                \ Offset
     LDPI                    \ von LDPI zum ersten Befehl im Hi-Pri-Prozess.
       -1 STL                \ Adresse des ersten Befehls in den Workspace.
        0 LDLP               \ WPTR des laufenden Prozesses
     RUNP                    \ Prozesskopie mit Prioritt 0 einklinken.
     BEGIN                   \ 1 Wort vor yyyn
      EREG LDL  4 ADC        \ Anfang bei sp(yyyn)
      EREG STL               \ Schleife um 1 Wort weiter
      NEXTP LDL              \ Code-Anfang bei allen Prozessen gleich
          4 LDC              \ Offset von nach LDPI bis nach STARTP
      LDPI  SUB              \ Offset von STARTP bis Prozess-Code bilden
      EREG LDL  0 LDNL       \ WPTR des laufenden Prozesses
      STARTP                 \ Laufenden Prozess einklinken
      HREG LDL  -4 ADC       \ Raus,
      EREG LDL  =            \ wenn = sp(yyy1)
     UNTIL
     HREG LDL  SP STL        \ Stack anpassen
     DREG  LDL  1 STL        \ Prozesszahl nach WPTR+1 des "Erzeugerprozess"
     NEXTP LDL  0 STL        \ Code "Folgeprozess" nach WPTR+0
        5 LDC                \ Offset von LDPI zu NEXT
     LDPI                    \ Sprungziel bei Rckkehr vom Hi-Pri-Prozess
     MINT     0C STNL        \ in SaveIptr plazieren.
     STOPP                   \ Hi-Pri-Prozesskopie definitiv herausnehmen.
     NEXT END-CODE
\ ....................................................................
\ (ENDPRI) ist in ENDPRI hnlich enthalten wie (ENDPAR) in ENDPAR.

CODE (ENDPRIPAR) ( yyy1 ... yyyn sp{yyy1}+4 #pri -- )
     SP LDL  0 LDNL          \ Einklinken von n bis 1
     GREG STL                \ GREG = Anzahl der PRI-Prozesse
     SP LDL  4 ADC  SP STL   \ Stack anpassen.
     SP LDL  0 LDNL          \ sp(yyy1)+4
     GREG LDL
      2 LDC  SHL  SUB
     HREG STL                \ HREG = sp(yyy1lopri)+4 .
     SP LDL  EREG STL        \ EREG = Schleifenzhler
     HREG LDL  SP LDL        \ SP = sp(yyyn)-4
     SUB  WCNT               \ LoPriProzessanzahl + 1 ( fr "yyy0" )
     DREG STL                \ nach DREG
     DREG LDL  GREG LDL  ADD \ Gesamtzahl der Prozesse ( hi + lo + 1 )
        1 STL                \ nach WPTR+1 von "yyy0" .
     NEXTP LDL  0 STL        \ Code "Folgeprozess" nach WPTR+0 von "yyy0"
     DREG LDL   1 LDC >      \ Sprung, wenn keine Prozesse niedriger Prioritt
     2IF
      BEGIN                  \ 1 Wort vor yyyn
       EREG LDL  4 ADC       \ Anfang bei sp(yyyn)
       EREG STL              \ Schleife um 1 Wort weiter
       NEXTP LDL             \ Code-Anfang bei allen Prozessen gleich
           4 LDC             \ Offset von nach LDPI bis nach STARTP
       LDPI  SUB             \ Offset von STARTP bis Prozess-Code bilden
       EREG LDL  0 LDNL      \ WPTR des laufenden Prozesses
       STARTP                \ Laufenden Prozess einklinken
       HREG LDL  -4 ADC      \ Raus,
       EREG LDL  =           \ wenn = sp(yyy1)
      UNTIL
     THEN
     GREG LDL  0>            \ Sprung, wenn keine Prozesse hoher Prioritt
     2IF
      HREG LDL               \ HREG = sp(yyy1lopri)+4 .
        -4 ADC  EREG STL     \ EREG = Schleifenzhler = sp(yyynhipri)-4 .
        SP LDL  0 LDNL
      HREG STL               \ HREG = sp(yyy1hipri)+4 .
         5 LDC               \ Offset
      LDPI                   \ von LDPI zum ersten Befehl im Hi-Pri-Prozess.
        -1 STL               \ Adresse des ersten Befehls in den Workspace.
         0 LDLP              \ WPTR des laufenden Prozesses
      RUNP                   \ Prozesskopie mit Prioritt 0 einklinken.
      BEGIN                  \ 1 Wort vor procnhi
       EREG LDL  4 ADC       \ Anfang bei sp(yyynhi)
       EREG STL              \ Schleife um 1 Wort weiter
       NEXTP LDL             \ Code-Anfang bei allen Prozessen gleich
           4 LDC             \ Offset von nach LDPI bis nach STARTP
       LDPI  SUB             \ Offset von STARTP bis Prozess-Code bilden
       EREG LDL  0 LDNL      \ WPTR des laufenden Prozesses
       STARTP                \ Laufenden Prozess einklinken
       HREG LDL  -4 ADC      \ Raus,
       EREG LDL  =           \ wenn = sp(yyy1) .
      UNTIL
        5 LDC                \ Offset von LDPI zu THEN
      LDPI                   \ Sprungziel bei Rckkehr vom Hi-Pri-Prozess
      MINT  0C STNL          \ in SaveIptr plazieren.
      STOPP                  \ Hi-Pri-Prozesskopie definitiv herausnehmen.
     THEN
     SP LDL  0 LDNL          \ sp(yyy1)+4 ( ursprnglicher Stackstand )
     SP STL                  \ Stack anpassen.
     0 LDLP                  \ WPTR von "yyy0"
     ENDP                    \ "yyy0" beenden
     NEXT  END-CODE
\ ....................................................................
\ (ENDPRIPAR) ist in ENDPRIPAR hnlich enthalten wie (ENDPAR) in ENDPAR.

CR .( Guard )

CODE SKIP-GUARD ( -- 0 0 alt-word )
     SP LDL -0C ADC  SP STL  \ Stack anpassen
      0 LDC  SP LDL  2 STNL  \ 0 auf Stack ( 1. Stackeintrag )
      0 LDC  SP LDL  1 STNL  \ 0 auf Stack ( 2. Stackeintrag )
     IP LDL  0 LDNL          \ nchstes Wort aus Datenflu
             SP LDL  0 STNL  \   auf Stack ( 3. Stackeintrag )
     IP LDL   4 ADC  IP STL  \ Returnstack anpassen
     NEXT  END-CODE

CODE CHAN-GUARD ( -- 1 alt-word )
     SP LDL  -8 ADC  SP STL  \ Stack anpassen
      1 LDC  SP LDL  1 STNL  \ 1 auf Stack ( 1. Stackeintrag )
     IP LDL  0 LDNL          \ nchstes Wort aus Datenflu
             SP LDL  0 STNL  \   auf Stack ( 2. Stackeintrag )
     IP LDL   4 ADC  IP STL  \ Returnstack anpassen
     NEXT  END-CODE

CODE TIME-GUARD ( -- 2 alt-word )
     SP LDL  -8 ADC  SP STL  \ Stack anpassen
      2 LDC  SP LDL  1 STNL  \ 2 auf Stack ( 1. Stackeintrag )
     IP LDL  0 LDNL          \ nchstes Wort aus Datenflu
             SP LDL  0 STNL  \   auf Stack ( 2. Stackeintrag )
     IP LDL   4 ADC  IP STL  \ Returnstack anpassen
     NEXT  END-CODE

CR .( Primitive zu ENDALT )

CODE (ENDALT) ( fl1 guard1 mode1 word1 .. fln guardn moden wordn sp{fl1}+4 -- )
     SP LDL  0 LDNL
     HREG STL                \ HREG = sp(fl1)+4 .
     0 LDC  GREG STL         \ GREG = ? Wchter aktiviert. Zunchst 0.
     0 LDC  DREG STL         \ DREG = ? Timer-Wchter.     Zunchst 0.
     SP LDL  -0C ADC         \ sp(wordn)-10
     EREG STL                \ EREG = Schleifenzhler
     BEGIN                   \ 4 Worte vor wordn
      EREG LDL  10 ADC       \ Anfang bei sp(moden)
      EREG STL               \ Schleife um 4 Worte weiter
      EREG LDL  1 LDNL       \ Wenn mode
         2 LDC  =            \ = 2 ,
      1IF                    \ dann
       1 LDC  DREG STL       \ DREG = 1 .
      THEN
      EREG LDL  3 LDNL  0<>  \ Wchter-Aktivierungswert ungleich 0 ?
      1IF                    \ Wenn ja,
       1 LDC  EREG LDL       \ dann auf den
                3 STNL       \ Wert 1 setzen und in
       1 LDC  GREG STL       \ GREG festhalten, dass mindestens 1 Wchter aktiv.
      THEN
      HREG LDL -10 ADC       \ Raus,
      EREG LDL  =            \ wenn = sp(word1)
     UNTIL
\ ....................................................................
     GREG LDL  0=            \ Wenn kein Wchter
     1IF                     \ aktiviert, dann
      HREG LDL  SP STL       \ Stack anpassen
      NEXTP LDL  GCALL       \ und raus.
     THEN
\ ....................................................................
     DREG LDL  0=            \ Wenn kein Timer-Guard,
     1IF                     \ dann
      ALT                    \ alt verwenden;
     1ELSE                   \ sonst
      TALT                   \ timer alt verwenden.
     THEN
\ ....................................................................
     SP LDL  -0C ADC         \ sp(wordn)-10
     EREG STL                \ EREG = Schleifenzhler
     BEGIN                   \ 4 Worte vor wordn
      EREG LDL  10 ADC       \ Anfang bei sp(wordn)
      EREG STL               \ Schleife um 4 Worte weiter
      EREG LDL  1 LDNL  0=   \ mode = 0 ( Skip-Guard ) ?
      1IF
       EREG LDL  3 LDNL      \ Wenn aktiviert,
       ENBS                  \ dann enable skip
      THEN
      EREG LDL  1 LDNL
      1 LDC  =               \ mode = 1 ( Channel-Guard ) ?
      1IF
       EREG LDL  2 LDNL      \ Kanalkontrollwort
       EREG LDL  3 LDNL      \ Wenn Wchter aktiviert,
       ENBC                  \ dann enable channel.
      THEN
      EREG LDL  1 LDNL
      2 LDC  =               \ mode = 2 ( Timer-Guard ) ?
      1IF
       EREG LDL  2 LDNL      \ Zeitwert
       EREG LDL  3 LDNL      \ Wenn Wchter aktiviert,
       ENBT                  \ dann enable timer.
      THEN
      HREG LDL -10 ADC       \ Raus,
      EREG LDL  =            \ wenn = sp(word1)
     UNTIL
\ ....................................................................
     GREG LDL  1 LDC  =      \ ALTWT oder TALTWT nur dann einschalten,
     2IF                     \ wenn (GREG) = 1.
      DREG LDL  0=           \ Wenn kein Timer-Guard,
      1IF                    \ dann
       ALTWT                 \ alt wait verwenden;
      1ELSE                  \ sonst
       TALTWT                \ timer alt wait verwenden.
      THEN
     THEN
\ ....................................................................
     SP LDL  -0C ADC         \ sp(wordn)-10
     EREG STL                \ EREG = Schleifenzhler
     BEGIN                   \ 4 Worte vor wordn
      EREG LDL  10 ADC       \ Anfang bei sp(wordn)
      EREG STL               \ Schleife um 4 Worte weiter
      EREG LDL  1 LDNL  0=   \ mode = 0 ( Skip-Guard ) ?
      1IF
       EREG LDL  3 LDNL      \ Wchteraktivierungsflag nach Breg.
       EREG LDL  0 LDNL      \ cfa des Verzweigungswortes nach Areg.
       DISS                  \ disable skip
      THEN
\ ....................................................................
      EREG LDL  1 LDNL
      1 LDC  =               \ mode = 1 ( Channel-Guard ) ?
      1IF
       EREG LDL  2 LDNL      \ Kanalkontrollwort nach Creg
       EREG LDL  3 LDNL      \ Wchteraktivierungsflag nach Breg
       EREG LDL  0 LDNL      \ cfa des Verzweigungswortes nach Areg.
       DISC                  \ disable channel.
      THEN
\ ....................................................................
      EREG LDL  1 LDNL
      2 LDC  =               \ mode = 2 ( Timer-Guard ) ?
      1IF
       EREG LDL  2 LDNL      \ Zeitwert nach Creg
       EREG LDL  3 LDNL      \ Wchteraktivierungsflag nach Breg
       EREG LDL  0 LDNL      \ cfa des Verzweigungswortes nach Areg.
       DIST                  \ disable timer.
      THEN
\ ....................................................................
      HREG LDL -10 ADC       \ Raus,
      EREG LDL  =            \ wenn = sp(word1)
     UNTIL
     HREG LDL  SP STL        \ Stack anpassen
\ ....................................................................
        0 LDL   W STL        \ cfa des ausgewhlten Verzweigungswortes.
        W LDL  0 LDNL  GCALL \ Sprung dorthin.
     NEXT END-CODE
\ ....................................................................
\ fl bestimmt zur Laufzeit,  ob der Wchter guard  eingeschaltet wird
\ ( 0 = nein, <>0 = ja ).
\ guard ist beim Channel-Wchter die Adresse des Kanalkontrollwortes,
\ beim Timer-Wchter der ( absolut genommene ) Zeitwert  ( in Ticker-
\ einheiten der jeweiligen Prioritt ), und beim Skip-Wchter hat die
\ Eingabe von guard zu unterbleiben.
\ mode ist eines der Worte SKIP-GUARD, CHAN-GUARD oder TIME-GUARD und
\ legt die Art des Wchters fest.
\ word ist das Forth-Wort, in das bei Alarmschlagen eines aktivierten
\ Wchters gesprungen wird.

CR .( Endpar, Endpri, Endpripar, Endalt )

: ENDPAR ( yyy1 ... yyyn -- )
     COMPILE SP@             \ Neuen Stackstand mit ursprnglichem
     COMPILE R@              \ Stackstand zur Laufzeit zweiter Ebene
     COMPILE =               \ vergleichen. Wenn gleich, dann
     COMPILE NO-TASK?        \ Ausstieg mit Fehlermeldung. Ansonsten
     COMPILE R>              \ ursprnglichen Stackstand holen und
     COMPILE (ENDPAR)        \ Parallelprozesse ( ber STARTP ) vorbereiten.
     ; IMMEDIATE             \ Das alles zur Laufzeit der Doppelpunkt-
                             \ Definition, in der sich ENDPAR befindet.
                             \ Anwendungsbeispiel:
                             \ : ZZZ ... PAR YYY1 ... YYYn ENDPAR ... ;

: ENDPRI ( yyy1 ... yyyn -- )
     COMPILE SP@             \ Neuen Stackstand mit ursprnglichem
     COMPILE R@              \ Stackstand zur Laufzeit zweiter Ebene
     COMPILE =               \ vergleichen. Wenn gleich, dann
     COMPILE NO-TASK?        \ Ausstieg mit Fehlermeldung. Ansonsten
     COMPILE R>              \ ursprnglichen Stackstand holen und
     COMPILE (ENDPRI)        \ Parallelprozesse ( ber STARTP ) vorbereiten.
     ; IMMEDIATE             \ Das alles zur Laufzeit der Doppelpunkt-
                             \ Definition, in der sich ENDPRI befindet.
                             \ Anwendungsbeispiel:
                             \ : ZZZ ... PRI YYY1 ... YYYn ENDPRI ... ;

\ Das Paar PRI ... ENDPRI wird hnlich verwendet wie PAR ... ENDPAR.  Bei
\ PAR ... ENDPAR werden ( parallel zu schaltende ) Prozesse von niedriger
\ Prioritt ( 1 ) erwartet, bei PRI ... ENDPRI solche hoher Prioritt.

: ENDPRIPAR ( yyy1 ... yyyn -- )
     COMPILE SP@             \ Neuen Stackstand mit ursprnglichem
     COMPILE R@              \ Stackstand zur Laufzeit zweiter Ebene
     COMPILE =               \ vergleichen. Wenn gleich, dann
     COMPILE NO-TASK?        \ Ausstieg mit Fehlermeldung.
     COMPILE SP@             \ Neuer Stackstand
     COMPILE R>              \ Urspnglicher Stackstand
     COMPILE TUCK            \ Fr gleich aufbewahren
     COMPILE OVER
     COMPILE R@              \ Anzahl PRI-Prozesse
     COMPILE 4*
     COMPILE +               \ Prozesszahl ermitteln
     COMPILE -ROT
     COMPILE BETWEEN
     COMPILE NOT             \ Nicht dazwischen, dann
     COMPILE NR-TASK?        \ Ausstieg mit Fehlermeldung
     COMPILE R>              \ Zahl der PRI-Prozesse holen
     COMPILE (ENDPRIPAR)     \ Parallelprozesse ( ber STARTP ) vorbereiten.
     ; IMMEDIATE             \ Das alles zur Laufzeit der Doppelpunkt-
                             \ Definition, in der sich ENDPRIPAR befindet.
                             \ Anwendungsbeispiel:
                             \ : ZZZ ... PRIPAR YYY1 ... YYYn ENDPRIPAR ... ;

: ENDALT ( fl1 guard1 mode1 word1 ... fln guardn moden wordn -- )
     COMPILE SP@             \ Neuer Stackstand
     COMPILE R@              \ Ursprnglicher Stackstand
     COMPILE -               \ Differenz
     COMPILE DUP             \ Nochmal
     COMPILE 0>=             \ Wenn >= 0, dann
     COMPILE ALT-ERR?        \ Ausstieg mit Fehlermeldung.
     COMPILE (LIT)  10 ,     \ Ansonsten durch 10h
     COMPILE MOD             \ teilen.
     COMPILE 0<>             \ Wenn Rest <> 0 ,
     COMPILE ALT-ERR?        \ dann Ausstieg mit Fehlermeldung.
     COMPILE R>              \ ursprnglichen Stackstand holen und
     COMPILE (ENDALT)        \ ALT-Prozess vorbereiten und durchfhren.
     ; IMMEDIATE             \ Das alles zur Laufzeit der Doppelpunkt-
                             \ Definition, in der sich ENDALT befindet.
\ ....................................................................
\ Anwendungsbeispiel:
\ : ZZZ ... ALT FL1 GUARD1 MODE1 WORD1 ... FLn GUARDn MODEn WORDn ENDALT ... ;
\ FL    = beliebiger Ausdruck, der einen Wahrheitswert ( TRUE/FALSE ) liefert
\         und zur Laufzeit ( bei Aufruf von ZZZ ) ausgewertet wird. Es wird
\         nur geprft, ob =0 oder <>0 . Dieser Wert wird bei Aufruf von ZZZ
\         auf den Stack gelegt und anschlieend von dem von ENDALT in ZZZ
\         hineincompilierten (ENDALT) ausgewertet.
\ GUARD = Zeitwert in Priorittseinheiten ( 1sec/64sec ) bei TIME ;
\         Kanaladresse bei CHAN ;
\         entfllt bei SKIP . ( Bei SKIP-GUARD darf fr MODEi GUARDi nur
\         SKIP-GUARD hingeschrieben werden, d.h., kein irgendwie gearteter
\         Wert fr GUARDi. SKIP-GUARD compiliert zweimal die Konstante 0
\         in ZZZ hinein.
\         Alle diese Werte werden bei Aufruf von ZZZ auf den Stack gelegt und
\         von dem weiter hinten in ZZZ von ENDALT hineincompilierten (ENDALT)
\         ausgewertet.
\ MODE  = eines der Worte SKIP-GUARD/CHAN-GUARD/TIME-GUARD. Sie legen bei
\         Aufruf von ZZZ beziehentlich die Werte 0./1/2 auf den Stack, welche
\         dann von dem von ENDALT in ZZZ hineincompilierten (ENDALT) ausgewer-
\         tet werden.
\ WORD  = beliebiges Forth-Wort. MODE setzt dafr beim Compilieren dann die
\         cfa von word ein. Natrlich muss das Forth-Wort word bei einem
\         Kanal-Wchter ( mode = 1 ) auf den betreffenden Kanal abgestimmt
\         sein, d.h., einen entsprechenden Eingabebefehl enthalten.

CR .( Pri, Stop, End, Restart )

CODE PRI@ ( -- b )           \ Holt Prioritt; b = 0 (hi) oder 1 (lo)
     LDPRI 1PUSH END-CODE

CODE PRI! ( b -- )           \ Setzt Prioritt; b = 0 (hi) oder 1 (lo)
     0 LDLP                  \ WPTR des laufenden Prozesses
     SP LDL  0 LDNL          \ gewnschte Prioritt ( b )
     OR                      \ Prozessdeskriptor zusammensetzen
     SP LDL  4 ADC  SP STL   \ Stack anpassen
     RUNP                    \ Kopie des Prozesses mit Prioritt b einklinken
     STOPP                   \ Original herausnehmen
     NEXT END-CODE

CODE STOP-ALL ( -- )         \ Nur fr Prozesse von niedriger Prioritt
        5 LDC                \ Offset
     LDPI                    \ von LDPI zum ersten Befehl im Hi-Pri-Prozess.
       -1 STL                \ Adresse des ersten Befehls in den Workspace.
        0 LDLP               \ WPTR des laufenden Prozesses
     RUNP                    \ Prozesskopie mit Prioritt 0 einklinken.
     WPTR LDC    AREG STL    \ WPTR des Bootprozesses ( proc0 ) nach AREG.
        0 LDLP               \ WPTR des laufenden Prozesses
     AREG LDL -9 STNL        \ in WPTR-9 von proc0 deponieren.
     AREG LDL                \ LowPriFPointer und LowPriBPointer
       -8 LDNLP  SAVEL       \ in WPTR-8 und WPTR-7 von proc0 deponieren.
     AREG LDL  1 LDNL        \ Anzahl der Prozesse aus WPTR+1 von proc0
     AREG LDL -6 STNL        \ in WPTR-6 von proc0 deponieren.
     MINT        STLF        \ Warteschlange der Prioritt 1 jetzt leer.
        1 LDC                \ Nur noch einen einzigen Prozess, den
     AREG LDL  1 STNL        \ laufenden, im Zhler belassen.
        5 LDC                \ Offset von LDPI zu AREG LDL
     LDPI                    \ Sprungziel bei Rckkehr vom Hi-Pri-Prozess
     MINT     0C STNL        \ in SaveIptr plazieren.
     STOPP                   \ Hi-Pri-Prozesskopie definitiv herausnehmen.
     AREG LDL                \ Unter Rckkehr zum Bootprozess ( proc0 )
     ENDP                    \ auch den Prozess niedriger Prioritt verlassen.
     NEXT END-CODE

CODE STOP-ALL-PRI ( -- )     \ Nur fr PRI-Konstrukte
     MINT        STHF        \ Warteschlange der Prioritt 0 jetzt leer.
        1 LDC                \ Nur noch 1 Prozess im Zhler
     WPTR LDC   AREG STL     \ des Rckkehrprozesses belassen.
     AREG LDL     1 STNL
                   STOPP     \ Prozess hoher Prioritt beenden.
     NEXT END-CODE
\ ....................................................................
\ STOP-ALL-PRI ist nur fr Parallel-Prozesse hoher Prioritt gedacht, Pro-
\ zesse also, die mit einer PRI...ENDPRI-Umklammerung erzeugt wurden.  Die
\ Prozesse  werden vom letzten her  abgearbeitet.  Sobald in einem  dieser
\ Prozesse ein STOP-ALL-PRI angetroffen wird,  wird der Pri-Konstrukt ver-
\ lassen. Das auch dann, wenn die bereits angelaufenen Prozesse, alle oder
\ einige davon, auf Kommunikationen warten. Die vor dem ( ersten ) Prozess
\ mit dem STOP-ALL-PRI liegenden Prozesse werden nicht mehr angelaufen.

CODE END-TASK
     WPTR LDC  AREG STL      \ WPTR des Bootprozesses ( yyy0 ) nach AREG.
       0 LDLP                \ WPTR des laufenden Prozesses
     AREG LDL   -9 STNL      \ in WPTR-9 von yyy0 deponieren.
     AREG LDL
     ENDP                    \ Laufenden Prozess beenden.
     NEXT END-CODE
\ ....................................................................
\ Im Gegensatz zu SLEEP beENDet END-TASK den laufenden Prozess ( niedriger
\ Prioritt in einem Parallel-Konstrukt ) . Ein eingeSLEEPter Prozess muss
\ spter (!) von einem anderen Prozess des Parallel-Konstrukts  wieder zum
\ Leben erWAKEt werden.  Bei END-TASK  springt der Parallel-Konstrukt nach
\ Beendigung  aller brigen  Parallel-Prozesse  wieder  in den Bootprozess
\ ( yyy0 ) zurck. Ist XXX der Name des Prozesskopfes ( des Prozesskopfes,
\ nicht des Prozesskrpers ),  so kann man  den "vorzeitig" beendeten Pro-
\ zess von yyy0 aus  ber XXX RESTART-TASK wieder aufrufen und von der Ab-
\ bruchstelle an bis zu Ende weiterarbeiten lassen. Werden mehrere Prozes-
\ se eines Parallel-Konstrukts  ber END-TASK  vorzeitig beendet,  so kann
\ man  den zuletzt beendeten Prozess  von proc0 aus  auch unmittelbar  per
\ RESTART-LAST ( ohne Angabe des Prozessnamens ) wieder zum Leben erwecken.

CODE RESTART-ALL ( -- )
        0 J                  \ Vorsorge fr berabgelaufene Zeitscheibe
        5 LDC                \ Offset
     LDPI                    \ von LDPI zum ersten Befehl im Hi-Pri-Prozess.
       -1 STL                \ Adresse des ersten Befehls in den Workspace.
        0 LDLP               \ WPTR des laufenden Prozesses
     RUNP                    \ Prozesskopie mit Prioritt 0 einklinken.
     WPTR LDC    AREG STL    \ WPTR des Bootprozesses ( proc0 ) nach AREG.
     AREG LDL
       -8 LDNL   STLF        \ LowPriFPointer wiederherstellen.
     AREG LDL
       -7 LDNL   STLB        \ LowPriBPointer wiederherstellen.
     AREG LDL -6 LDNL        \ Anzahl der Prozesse aus WPTR-6 von proc0
     AREG LDL  1 STNL        \ wieder in WPTR+1 von proc0 legen.
        5 LDC                \ Offset von LDPI zu AREG LDL
     LDPI                    \ Sprungziel bei Rckkehr vom Hi-Pri-Prozess
     MINT     0C STNL        \ in SaveIptr plazieren.
     STOPP                   \ Hi-Pri-Prozesskopie definitiv herausnehmen.
     AREG LDL -9 LDNL        \ Wieder in den Prozess zur Zeit von STOP-ALL
     GAJW                    \ springen.
     NEXT END-CODE
\ ....................................................................
\ RESTART-ALL ist nur vom Bootprozess ( proc0 ) aus vorgesehen und bewirkt,
\ dass die Arbeit eines Parallel-Konstrukts, dessen Prozesse ber STOP-ALL
\ allesamt abgebrochen wurden,  genau an den Abbruchstellen  wieder aufge-
\ nommen wird.

: RESTART-TASK ( xxx -- )
     WPTR! ;
\ ....................................................................
\ RESTART-TASK unterscheidet sich von GO-TASK dadurch, dass ersterer
\ vom Prozesskopf aus angesprungen wird, letzterer vom Prozesskrper.
\ Bei  GO-TASK  werden  RP, SP und IP  des anzuspringenden Prozesses
\ vorher noch initiiert.  RESTART-TASK  ist fr Prozesse von Priori-
\ tt 1 ( niedrige Prioritt ) gedacht, die ( zu Testzwecken ) durch
\ ein in die Doppelpunkt-Definition des betreffenden Prozesses  ein-
\ gestreutes END-TASK vorzeitig abgebrochen wurde.

CODE RESTART-LAST ( -- )
     -9 LDL  GAJW            \ WPTR des zuletzt ber END-TASK
     NEXT END-CODE           \ verlassenen Prozesses

CR .( Single, Multi )

CODE SINGLE ( -- )           \ Aktueller Prozess mi4 Prioritt 1 als einziger
        5 LDC                \ Offset
     LDPI                    \ von LDPI zum ersten Befehl im Hi-Pri-Prozess.
       -1 STL                \ Adresse des ersten Befehls in den Workspace.
        0 LDLP               \ WPTR des laufenden Prozesses
     RUNP                    \ Prozesskopie mit Prioritt 0 einklinken.
       -8 LDLP   SAVEL       \ LowPriFPtr und LowPriBPtr nach WPTR-8 und WPTR-7
     WPTR LDC    AREG STL    \ WPTR des Bootprozesses ( yyy0 ) nach AREG.
     AREG LDL  1 LDNL        \ Anzahl der Prozesse aus WPTR+1 von yyy0
       -6 STL                \ in WPTR-6 deponieren.
     MINT        STLF        \ Warteschlange der Prioritt 1 jetzt leer.
        1 LDC                \ Nur noch einen einzigen Prozess, den
     AREG LDL  1 STNL        \ laufenden, im Zhler belassen.
        5 LDC                \ Offset von LDPI zu NEXT
     LDPI                    \ Sprungziel bei Rckkehr vom Hi-Pri-Prozess
     MINT     0C STNL        \ in SaveIptr plazieren.
     STOPP                   \ Hi-Pri-Prozesskopie definitiv herausnehmen.
     NEXT END-CODE
\ ....................................................................
\ SINGLE ist nur fr Prozesse von niedriger Prioritt vorgesehen. Tritt es beim
\ Abarbeiten  eines Prozesses  niedriger Prioritt  in einem Parallel-Konstrukt
\ auf,  so schaltet es alle brigen Prozesse ab und fhrt den laufenden Prozess
\ als einzigen weiter. Hierzu wird zunchst eine Kopie hoher Prioritt des lau-
\ fenden Prozesse erzeugt. Hohe Prioritt, damit keine Unterbrechungen den Vor-
\ gang stren knnen.  Dann wird  von dort aus  die Warteschlange  fr Prozesse
\ niedriger Prioritt auf den Wert 1 gesetzt  ( nur noch der eine Prozess nied-
\ riger Prioritt,  der den Prozess hoher Prioritt als Kopie seiner selbst er-
\ zeugt hat ).  Auerdem  wird  die Adresse  fr den Rcksprung  in den Prozess
\ niedriger Prioritt  ( der Kopie seiner selbst )  korrigiert.  Und dann  wird
\ die Kopie ( hoher Prioritt geSTOPPt ).  brig bleibt  als einziger  der Pro-
\ zess niedriger Prioritt, der in normaler Weise bis zum vorgesehenen Ende ab-
\ gearbeitet  wird.  Der  Wert  des  Low-Priority-Front/Back-Pointers  wird  in
\ WPTR-8/WPTR-7 zwischengespeichert.  Tritt im Verlauf  des als einziger ablau-
\ fenden Prozesses  weiter hinten ein MULTI auf,  so wird es mit den Werten aus
\ WPTR-8 und WPTR-7 mglich, den Parallelbetrieb wieder aufzunehmen .  Dazu ist
\ allerdings  auch die ursprngliche Anzahl  der Prozesse im Parallel-Konstrukt
\ ntig, die zu diesem Zweck in WPTR-6 zwischengespeichert wurde.

CODE MULTI ( -- )
        5 LDC                \ Offset
     LDPI                    \ von LDPI zum ersten Befehl im Hi-Pri-Prozess.
       -1 STL                \ Adresse des ersten Befehls in den Workspace.
        0 LDLP               \ WPTR des laufenden Prozesses
     RUNP                    \ Prozesskopie mit Prioritt 0 einklinken.
       -8 LDL    STLF        \ LowPriFrontPointer wiederherstellen.
       -7 LDL    STLB        \ LowPriBackPointer  wiederherstellen.
       -6 LDL                \ Ursprngliche Prozessanzahl wieder
     WPTR LDC  1 STNL        \ in den erzeugenden Prozess ( proc0 ) schreiben.
        5 LDC                \ Offset von LDPI zu NEXT
     LDPI                    \ Sprungziel bei Rckkehr vom Hi-Pri-Prozess
     MINT     0C STNL        \ in SaveIptr plazieren.
     STOPP                   \ Hi-Pri-Prozesskopie definitiv herausnehmen.
     NEXT END-CODE
\ ....................................................................
\ MULTI ist nur  fr Prozesse von niedriger Prioritt vorgesehen.  Wird ein
\ solcher ber SINGLE aus dem Parallel-Konstrukt, in dem er wirkt,  heraus-
\ selektiert  und als einziger weitergefhrt,  so bewirkt das Auftreten von
\ MULTI weiter hinten im Prozess,  dass der gesamte Parallel-Konstrukt wie-
\ der hinzugeschaltet wird.  Die hierzu ntige  ursprngliche Prozessanzahl
\ und die ursprnglichen Low-Priority-Front/Back-Pointer  werden aus WPTR-6
\ und WPTR-8/WPTR-7 des betreffenden Prozesses,  wo SINGLE  sie zuvor abge-
\ speichert hat, geholt.

CODE SLEEP ( -- )            \ Laufenden Prozess stilllegen.
     STOPP
     NEXT  END-CODE
\ ....................................................................
\ Kann auch fr Prozesse der Prioritt 0 ( vorrangig ) verwendet werden.  Der
\ Transputer hngt sich bei einem Prozess der Prioritt 1 ( nachrangig ) auf,
\ wenn auf ein erfolgtes SLEEP hin  kein anderer Prozess des betreffenden Pa-
\ rallel-Konstrukts mehr in Erscheinung tritt,  der den eingeSLEEPten Prozess
\ wieder aufWAKEt.

CODE WAKE  ( b proc -- )     \ Stillliegenden Prozess wieder einklinken.
     SP LDL  0 LDNL          \ WPTR ( proc ) des Prozesses vom Stack.
     -4 LDC    AND           \ Die letzten zwei Bits = 0.
     SP LDL  1 LDNL          \ Gewnschte Prioritt vom Stack holen.
      1 LDC    AND           \ Wirklich nur das letzte Bit.
         OR                  \ Prozessdeskriptor herstellen.
     SP LDL  8 ADC  SP STL   \ Stack anpassen.
     RUNP
     NEXT  END-CODE
\ ....................................................................
\ WAKE klinkt einen Prozess, der mit SLEEP stillgelegt wurde,  wieder ein.
\ Die Prioritt darf dabei gendert werden.  b ist die gewnschte Priori-
\ tt. b=0 heit hohe Prioritt, b=1 heit niedrige Prioritt. Fr b kn-
\ nen beliebige Werte eingegeben werden.  Ausgewertet wird  immer nur das
\ letzte Bit.

: SET-TASK  ( ip xxx -- )
     TUCK
     [ ASSEMBLER ] IP        \ Setzt lokales IP
     [ FORTH ] CELLS + !     \ auf ip .
     RP0 OVER LOCAL @        \ Holt RP0 des Prozesses
     OVER                    \ und speichert es
     [ ASSEMBLER ] RP        \ in das
     [ FORTH ] CELLS + !     \ lokale RP .
     SP0 OVER LOCAL @        \ Holt SP0 des Prozesses
     SWAP                    \ und speichert es
     [ ASSEMBLER ] SP        \ in das
     [ FORTH ] CELLS + ! ;   \ lokale SP .

: ACTIVATE   ( xxx -- )
     R> OVER SET-TASK ;

CODE END-ACT ( -- )
     NEXTP LDL               \ Wo geht es weiter in "yyy0" ?
     WPTR LDC  AREG STL      \ Zwischenspeichern
     AREG LDL  0 STNL        \ In WPTR+0 von "yyy0" verankern.
     AREG LDL                \ WPTR von "yyy0"
     ENDP                    \ Laufenden Prozess beenden.
     NEXT END-CODE

\ Verwendungsbeispiel:
\ 300 TASK: XXX
\ : YYY XXX ACTIVATE CR ." Alles klar !" CR KEY EMIT END-ACT ;
\ : ZZZ PAR YYY ENDPAR ;

240 TASK: (SKIP)             \ Erzeugt universellen Prozesskopf

: SKIP-TASK ( -- )           \ "Leerer" Prozess
     (SKIP)
     ACTIVATE END-ACT ;

: GO-TASK ( yyy -- )
     WPTR! ;
\ ....................................................................
\ Jeder in einem PAR-Konstrukt auftretende Prozess kann per GO-TASK von
\ yyy0 (dem Bootprozess) aus direkt angesprungen und abgearbeitet werden.

: NO-LINK? ( n -- )
     DUP 0 3 BETWEEN NOT     \ n = 0...3 ? Nein, dann Fehlermeldung.
     ABORT" Ungltiger Linkkanal; 0..3 whlen !" ;

: LINKO    ( n -- ad )       \ Adresse von Link-Ausgabekanal n
     NO-LINK?                \ Fehlermeldung
     80000000 + ;            \ oder Adresse auf Stack.

: LINKI    ( n -- ad )       \ Adresse von Link-Eingabekanal n
     NO-LINK?                \ Fehlermeldung
     80000010 + ;            \ oder Adresse auf Stack.

CR .( Channel )

: CHANNEL  ( <name> -- | -- ad )
     CREATE 80000000 , DOES> ;
\ ....................................................................
\ CHANNEL erzeugt einen  mit dem Wert 80000000  ( NotProcess.p )
\ vorbelegten internen Kanal.  "name" liefert  bei Aufruf  seine
\ Adresse.  Dem Benutzer obliegt es,  festzulegen  und darauf zu
\ achten, ob es sich um einen Eingabe- oder Ausgabekanal handelt.

CODE RESET-CHANNEL ( ad -- )
     SP LDL  0 LDNL          \ Kanaladresse ad vom Stack
     RESETCH                 \ Kanal zurcksetzen
     SP LDL  0 STNL          \ Wert auf Stack. Wenn 80000000, dann o.k.,
     NEXT  END-CODE          \ sonst: Stackwert = Prozess-Deskriptor des
                             \ wartenden Prozesses.

CODE CHAN-OUTB ( chan c -- ) \ Byte c vom Stack zum Kanal chan
     SP LDL  1 LDNL          \ ber Kanal chan
     SP LDL  0 LDNL          \ Byte c
        OUTBYTE              \ senden.
     SP LDL  8 ADC  SP STL   \ Stack anpassen.
     NEXT  END-CODE

CODE CHAN-OUTW ( chan n -- ) \ Wort n vom Stack zum Kanal chan
     SP LDL  1 LDNL          \ ber Kanal chan
     SP LDL  0 LDNL          \ Wort n
        OUTWORD              \ senden.
     SP LDL  8 ADC  SP STL   \ Stack anpassen.
     NEXT  END-CODE

CODE CHAN-OUT$ ( chan ad len -- )  \ len Bytes von ad nach Kanal chan
     SP LDL  1 LDNL          \ Adresse ad
     SP LDL  2 LDNL          \ Kanal chan
     SP LDL  0 LDNL          \ len Bytes
        OUT                  \ ausgeben
     SP LDL  0C ADC  SP STL  \ Stack anpassen
     NEXT  END-CODE

CODE CHAN-INB  ( chan -- c ) \ Byte von Kanal auf Stack
     SP LDL                  \ Adresse des obersten Stackeintrags
     SP LDL  0 LDNL          \ Kanal
      1 LDC                  \ 1 Byte
        IN                   \ von Kanal chan holen
     SP LDL  0 STNL          \ und auf Stack legen.
     NEXT  END-CODE

CODE CHAN-INW  ( chan -- n ) \ Wort von Kanal auf Stack
     SP LDL                  \ Adresse des obersten Stackeintrags
     SP LDL  0 LDNL          \ Kanal
      4 LDC                  \ 4 Bytes
        IN                   \ von Kanal chan holen
     SP LDL  0 STNL          \ und auf Stack legen.
     NEXT  END-CODE

CODE CHAN-IN$ ( chan ad len -- )  \ len Bytes von Kanal chan nach ad
     SP LDL  1 LDNL          \ Adresse ad
     SP LDL  2 LDNL          \ Kanal chan
     SP LDL  0 LDNL          \ len Bytes
        IN                   \ einholen
     SP LDL  0C ADC  SP STL  \ Stack anpassen
     NEXT  END-CODE

\ Ende des Parallelverarbeitungsteils
\ ----------------------------------------------------------------


\ Es folgen Vorschlge fr Testbeispiele:

\ : TEST1 0 20001 0 DO PAUSE 1+ LOOP ;
\ : TEST2 0 20002 0 DO PAUSE 1+ LOOP ;
\ : TEST3 0  2000 0 DO PAUSE 1+ LOOP ;
\ : TEST4 0 BEGIN 1+ DUP 20000 > UNTIL ;
\ 300 TASK: XXX1
\ 300 TASK: XXX2
\ 300 TASK: XXX3
\ 300 TASK: XXX4
\ 300 TASK: XXX5
\ : YYY1 XXX1 ACTIVATE TEST1 END-ACT ;
\ : YYY2 XXX2 ACTIVATE TEST2 END-ACT ;
\ : YYY3 XXX3 ACTIVATE TEST3 END-ACT ;
\ : YYY4 XXX4 ACTIVATE TEST4 END-ACT ;
\ : YYY5 XXX5 ACTIVATE TEST1 END-ACT ;

\ : WWW1 XXX1 ACTIVATE ALT 1 TIMER@ 1200000 + TIME-GUARD TEST1
\                          1 TIMER@ 1800000 + TIME-GUARD TEST2
\                          1 TIMER@ 1C00000 + TIME-GUARD TEST3 ENDALT
\             STOP-ALL-PRI
\             END-ACT ;
\ : WWW2 XXX2 ACTIVATE ALT 1 TIMER@ 1C00000 + TIME-GUARD TEST1
\                          1 TIMER@ 1800000 + TIME-GUARD TEST2
\                          1 TIMER@ 1400000 + TIME-GUARD TEST3 ENDALT
\             END-ACT ;
\ : ZZZ PRI WWW1 WWW2 ENDPRI ;


\ Achtung: In TKERNEL.FTH das Wort DOES> mit DROP abschlieen:
\          ... 0F6 C, ; IMMEDIATE DROP
\ -..-..-..-..-..-..-..-..-..-..-..-..-..-..-..-..-..-..-..-..-


CR .( Tastatur-Eingabeeditor )
HEX

DEFER FORTHKEY            \ Tabelle zur Speicherung der bisherigen Eingaben

70 STRING CHAR-CURS@$               \ Belegung folgt und bleibt

" BASE @ HEX " CHAR-CURS@$ APPEND$  \ Host auf HEX schalten, Basis retten.
" 40 62 LC@ "  CHAR-CURS@$ APPEND$  \ Bildschirmseite holen.
" FLIP "       CHAR-CURS@$ APPEND$  \ Liegt im unteren Byte, muss ins obere.
" CODE XXX "   CHAR-CURS@$ APPEND$  \ CODE-Definition XXX aufbauen.
" BX POP "     CHAR-CURS@$ APPEND$  \ Bildschirmseite jetzt in BH.
" 8 # AH MOV " CHAR-CURS@$ APPEND$  \ Funktionsnummer fr Interrupt 10h.
" 10 INT "     CHAR-CURS@$ APPEND$  \ Interrupt 10h ausfhren.
" 1PUSH "      CHAR-CURS@$ APPEND$  \ Gelesenes Zeichen ( AL ) und Attribut
" END-CODE "   CHAR-CURS@$ APPEND$  \ ( AH ) auf Stack und Definition beenden.
" XXX "        CHAR-CURS@$ APPEND$  \ XXX im Host ausfhren.
" FORGET XXX " CHAR-CURS@$ APPEND$  \ XXX wieder beseitigen.
" 40 0FE L! "  CHAR-CURS@$ APPEND$  \ In "BIOS-Kommunikationsbereich" legen.
" BASE ! "     CHAR-CURS@$ APPEND$  \ Basis im Host wiederherstellen.

\ Das Ganze sieht nur so gefhrlich aus. Es erfordert aber wirklich nur etwas
\ mehr als die 70h Bytes fr den String, die auch dann angefallen wren, wenn
\ ich den String ber " ... " $EXECUTE-HOST direkt in das Wort CHAR-CURS@ hi-
\ neingeschrieben htte.

: CHAR-CURS@ ( -- xy )              \ xy = 16 Bit, x = Attribut, y = ASCII-Code
     CHAR-CURS@$ $EXECUTE-HOST      \ String im Host ausfhren.
     40 0FE @-H ;                   \ xy vom BIOS-Zwischenbereich holen.

9A STRING CHAR-CURS!$               \ Belegung folgt und bleibt

" BASE @ HEX " CHAR-CURS!$ APPEND$  \ Basis retten, Host auf HEX schalten.
" 40 0FC L@ "  CHAR-CURS!$ APPEND$  \ Erst Zeichen mit Attribut und dann Anzahl
" 40 0FE L@ "  CHAR-CURS!$ APPEND$  \ aus "BIOS-Kommunikationsbereich" holen.
" 40 62 LC@ "  CHAR-CURS!$ APPEND$  \ Bildschirmseite holen.
" FLIP "       CHAR-CURS!$ APPEND$  \ Liegt im unteren Byte, muss ins obere.
" CODE XXX "   CHAR-CURS!$ APPEND$  \ CODE-Definition XXX aufbauen.
" BX POP "     CHAR-CURS!$ APPEND$  \ Bildschirmseite jetzt in BH.
" CX POP "     CHAR-CURS!$ APPEND$  \ Anzahl nach CX.
" 9 # AH MOV " CHAR-CURS!$ APPEND$  \ Funktionsnummer fr Interrupt 10h.
" DX POP "     CHAR-CURS!$ APPEND$  \ Attribut-Byte und ASCII-Byte.
" DH BL MOV "  CHAR-CURS!$ APPEND$  \ Attribut-Byte nach BL.
" DL AL MOV "  CHAR-CURS!$ APPEND$  \ ASCII-Byte nach AL.
" 10 INT "     CHAR-CURS!$ APPEND$  \ Interrupt 10h ausfhren.
" NEXT "       CHAR-CURS!$ APPEND$  \ Von Code-Definition
" END-CODE "   CHAR-CURS!$ APPEND$  \ wieder zurck.
" XXX "        CHAR-CURS!$ APPEND$  \ XXX im Host ausfhren.
" FORGET XXX " CHAR-CURS!$ APPEND$  \ XXX wieder beseitigen.
" BASE ! "     CHAR-CURS!$ APPEND$  \ Basis im Host wiederherstellen.

: CHAR-CURS! ( xy n -- )            \ x = Attr-Byte, y = ASCII-Byte, n = Anzahl
       40 0FE !-H                   \ n  in den BIOS-Zwischenbereich legen.
       40 0FC !-H                   \ xy in den BIOS-Zwischenbereich legen.
       CHAR-CURS!$ $EXECUTE-HOST ;  \ String im Host ausfhren.

: CHAR-CURS-INV ( -- )
       CHAR-CURS@                   \ Zeichen mit Attribut holen.
       77 SP@ CELL+ 1+ CTOGGLE 1    \ Invertieren und 1-mal
       CHAR-CURS! ;                 \ an Cursor-Position speichern.

2VARIABLE CURS-AUX                  \ Zweiter Cursor

: CURS-AUX-MOVE ( hor vert -- )     \ hor vert : - + - + = left right up down
       (CURSOR) 40 4A @-H           \ hor vert col0 row0 col#
       CURS-AUX 2@ AT               \ Cursor auf Position des Hilfscursors.
       CHAR-CURS-INV                \ Dortiges Zeichen invertieren.
       (CURSOR) SWAP 6 ROLL + ROT   \ vert col0 row0 row col+hor col#
            MOD SWAP                \ vert col0 row0 colnew row
                     4 ROLL + 19    \ col0 row0 colnew row+vert 19h
            MOD 2DUP                \ col0 row0 colnew rownew colnew rownew
       CURS-AUX 2! AT               \ In Hilfscursor und Cursor dorthin.
       CHAR-CURS-INV                \ Dortiges Zeichen invertieren.
       AT ;                         \ Ursprnglichen Cursor wiederherstellen.

 VARIABLE ?SCREEN@                  \ Zeichen vom Bildschirm holen ?
?SCREEN@  OFF                       \ Vorgabe: Nein

: (?SCREEN@-OFF) ( -- )             \ Fr RET: Zeichen-Einsammeln ausschalten.
       ?SCREEN@ @                   \ Wenn EIN,
       IF ?SCREEN@ OFF              \ dann AUS.
          (CURSOR)                  \ Cursor aufbewahren.
          CURS-AUX 2@ AT            \ Cursor auf Position des Hilfscursors.
          CHAR-CURS-INV             \ Zeichen darunter (zurck)invertieren.
          AT                        \ Cursor wieder wie zuvor.
       THEN ;

' (?SCREEN@-OFF) IS ?SCREEN@-OFF    \ Wird in CR-IN verwendet.


CR .( Forthkey )

: (UPDATE-FORTHKEY) ( lenmax ad len -- lenmax ad len )
       DUP                                            \ TIB leer ?
       IF                                             \ Nein, dann ausfhren.
         FORTHKEY 2 CELLS +
         BEGIN DUP C@ DUP 0<> WHILE + 2 + REPEAT
         DROP                                         \ p-end
         DUP #TIB @ + 10 + FORTHKEY @ >               \ Noch Platz ?
         IF
           DUP FORTHKEY 2 CELLS +                     \ p-end p-end f+8
           BEGIN
             DUP C@ + 2 + DUP FORTHKEY 2 CELLS +
             #TIB @ + <                               \ Reduzierlnge ?
           WHILE
           REPEAT
           FORTHKEY 2 CELLS + OVER FORTHKEY @ SWAP -  \ Reduzieren
           >R 2DUP - R> SWAP >R MOVE R> - DUP
           FORTHKEY CELL+ !                           \ p-end p-end-neu
           NIP                                        \ p-end-neu
         THEN
         DUP SPAN @ SWAP C! 1+ 2 PICK OVER SPAN @     \ Letzte Zeile aufnehmen
         <MOVE> SPAN @ TUCK + TUCK C! 1+ DUP 0 SWAP C!
         FORTHKEY CELL+ !
       ELSE                                           \ Sonst nur
         .OK CR                                       \ Bereitschaftsmeldung.
       THEN ;

' (UPDATE-FORTHKEY) IS UPDATE-FORTHKEY

: FORTHKEY-DEL ( lenmax ad len key -- lenmax ad len key )
       OVER #COL0 @ + 40 4A @-H / (CURSOR)        \ Cursor an den
       NIP SWAP - #COL0 @ SWAP 2DUP AT            \ Eingabe-Anfang.
       #TIB @ BL REPLICATE                        \ Bisheriges lschen.
       AT                                         \ Wieder an den Anfang.
       NIP 0 SWAP #TIB OFF                        \ #TIB zurcksetzen.
       FORTHKEY 2 CELLS + DUP OFF
       FORTHKEY CELL+ ! ;                         \ Auf ltestes 'Record'.

: FORTHKEY+ ( lenmax ad len key -- lenmax ad len key )
       OVER >R
       OVER #COL0 @ + 40 4A @-H / (CURSOR)        \ Cursor an den
       NIP SWAP - #COL0 @ SWAP 2DUP AT            \ Eingabe-Anfang.
       #TIB @ BL REPLICATE                        \ Bisheriges lschen.
       AT                                         \ Wieder an den Anfang.
       NIP 0 SWAP                                 \ #TIB zurcksetzen
       FORTHKEY CELL+ @                           \ Record-Pointer
       DUP C@ 0<>
       IF
         R>                                       \ Eingabepuffer leer ?
         IF                                       \ Nein, dann
           DUP C@ + 2 +                           \ "Record" nachher
           DUP FORTHKEY CELL+ !                   \ In Record-Pointer.
         THEN
         DUP COUNT 4 ROLL
         >R R@ + 5 PICK MIN R@ - DUP 4 -ROLL
         TYPE 1+ 3 PICK 3 PICK R@ - <MOVE>
         R> #TIB !                                \ #TIB auf Eingabenlnge
       ELSE
         R> 2DROP
       THEN ;

: FORTHKEY- ( lenmax ad len key -- lenmax ad len key )
       FORTHKEY CELL+ @                           \ Zum jngsten 'Record'
       FORTHKEY 2 CELLS + <>
       IF
         OVER #COL0 @ + 40 4A @-H / (CURSOR)      \ Cursor an den
         NIP SWAP - #COL0 @ SWAP 2DUP AT          \ Eingabe-Anfang.
         #TIB @ BL REPLICATE                      \ Bisheriges lschen.
         AT                                       \ Wieder an den Anfang.
         NIP 0 SWAP                               \ #TIB zurcksetzen
         FORTHKEY CELL+ @
         1- DUP C@ - 1-                           \ 'Record' vorher
         DUP FORTHKEY CELL+ !                     \ In Record-Pointer
         DUP COUNT 4 ROLL
         >R R@ + 5 PICK MIN R@ - DUP 4 -ROLL
         TYPE 1+ 3 PICK 3 PICK R@ - <MOVE>
         R> #TIB !                                \ #TIB auf Eingabenlnge
       THEN ;

: FORTHKEY++ ( lenmax ad len key -- lenmax ad len key )
       FORTHKEY 2 CELLS +
       BEGIN DUP C@ DUP 0<> WHILE + 2 + REPEAT
       DROP                                       \ p-end
       >R
       OVER #COL0 @ + 40 4A @-H / (CURSOR)        \ Cursor an den
       NIP SWAP - #COL0 @ SWAP 2DUP AT            \ Eingabe-Anfang.
       #TIB @ BL REPLICATE                        \ Bisheriges lschen.
       AT                                         \ Wieder an den Anfang.
       NIP 0 SWAP #TIB OFF                        \ #TIB zurcksetzen
       R> DUP FORTHKEY 2 CELLS + <>
       IF
         1- DUP C@ - 1-                           \ Jngstes 'Record'
         DUP FORTHKEY CELL+ !                     \ In Record-Pointer
         DUP COUNT 4 ROLL
         >R R@ + 5 PICK MIN R@ - DUP 4 -ROLL
         TYPE 1+ 3 PICK 3 PICK R@ - <MOVE>
         R> #TIB !                                \ #TIB auf Eingabenlnge
       ELSE
         DROP
       THEN ;


: FORTHKEY-- ( lenmax ad len key -- lenmax ad len key )
       FORTHKEY 2 CELLS + FORTHKEY CELL+ !        \ ltestes 'Record'
         OVER #COL0 @ + 40 4A @-H / (CURSOR)      \ Cursor an den
         NIP SWAP - #COL0 @ SWAP 2DUP AT          \ Eingabe-Anfang.
         #TIB @ BL REPLICATE                      \ Bisheriges lschen.
         AT                                       \ Wieder an den Anfang.
         NIP 0 SWAP                               \ #TIB zurcksetzen
         FORTHKEY 2 CELLS +
         DUP COUNT 4 ROLL
         >R R@ + 5 PICK MIN R@ - DUP 4 -ROLL
         TYPE 1+ 3 PICK 3 PICK R@ - <MOVE>
         R> #TIB ! ;                              \ #TIB auf Eingabenlnge

: FORTHKEY$! ( ad len -- )
       FORTHKEY 2 CELLS +
       BEGIN DUP C@ DUP 0<> WHILE + 2 + REPEAT
       DROP                                       \ ad len p-end
       DUP 2 PICK + 10 + FORTHKEY @ >             \ Noch Platz ?
       IF
         DUP FORTHKEY 2 CELLS +                   \ ad len p-end p-end f+8
         BEGIN
           DUP C@ + 2 + DUP FORTHKEY 2 CELLS +
           5 PICK + <                             \ Reduzierlnge ?
         WHILE
         REPEAT
         FORTHKEY 2 CELLS + OVER FORTHKEY @ SWAP  \ Reduzieren
         - >R 2DUP - R> SWAP >R MOVE R> - DUP
         FORTHKEY CELL+ !                         \ ad len p-end p-end-neu
         NIP                                      \ ad len p-end-neu
       THEN
       2DUP C! 1+ 2 PICK OVER 3 PICK <MOVE>       \ String aufnehmen
       OVER TUCK + TUCK C! 1+ DUP 0 SWAP C!
       FORTHKEY CELL+ ! 2DROP ;


CR .( Forthkey-List )

: FORTHKEY-LIST ( len key -- len key )
       (CURSOR) NIP 17 > IF DARK THEN    \ Bild unten ?
       (CURSOR) NIP 1+ 0 SWAP AT 0       \ Auf neue Zeile gehen.
       FORTHKEY 2 CELLS + DUP C@
       IF
         0 >R
         BEGIN
           SWAP 1+ TUCK
           BASE @ DECIMAL SWAP . BASE ! BS EMIT ." :"
           DUP FORTHKEY CELL+ @ =        \ = momentaner Stand des Zeigers ?
           IF ." >" ELSE SPACE THEN      \ Ja, dann ">", sonst "Space".
           DUP COUNT TYPE CR
           R> 1+ DUP >R 16 >             \ Erster Bildschirm voll ?
           IF .WEITER THEN               \ Ja, dann erst auf Taste warten.
           DUP C@ + 2 + DUP C@
         WHILE
         REPEAT
         R> DROP                         \ Zeilenzhler beseitigen.
         .OK CR                          \ Bereitschaftsmeldung erzwingen.
       THEN
       2DROP
       NIP 0 SWAP 0 #TIB ! ;

: FORTHKEY-NR ( len key -- len key )
       BASE @ DECIMAL
       CR ." Zeilennummer: " 0
       BEGIN
         KEY DUP >R DUP 30 39 BETWEEN
         IF
           30 - DUP . BS EMIT SWAP 0A * +
         ELSE
           DROP
         THEN
         R> 0D =
       UNTIL
       SWAP BASE !                 \ len key nr
       DUP 2 < IF DROP 1 THEN      \ < 2 wird als 1 interpretiert
       FORTHKEY 2 CELLS + DUP C@   \ Lnge <> 0 heit,
       IF                          \ dass "Record" vorhanden.
         SWAP                      \ len key ad nr
         1                         \ Zhler beginnt mit 1.
         BEGIN                     \ len key ad nr cnt
           2DUP <>                 \ nr,cnt zum "Verbrauch".
         WHILE                     \ len key ad nr cnt
           1+                      \ Zhler weiter.
           ROT DUP C@ DUP 0=
           IF                      \ len key nr cnt ad len
             DROP NIP 1- DUP C@ -  \ Wenn Lnge = 0,
             1- SWAP DUP           \ dann len key ad-1-len-1 nr nr ;
           ELSE                    \ sonst Record-Adresse
             + 2 + -ROT            \ um eine Lnge weiter.
           THEN
         REPEAT
         2DROP                     \ len key ad
         TRUE                      \ Flag fr "Wirkung".
       ELSE                        \ Wenn kein "Record",
         2DROP FALSE               \ dann keine Wirkung.
         CR ." Kein Eintrag" CR
         .OK CR                    \ Bereitschaftsmeldung
       THEN
       IF
         CR COUNT KBUF$!           \ In den Tastatur-Puffer schreiben.
       THEN ;

DEFER HOTKEYS-AUX                  \ Zum Einklinken weiterer Hotkeys
                                   \ Wird in EMPTY auf NOOP gelegt,
' NOOP IS HOTKEYS-AUX              \ vorsichtshalber hier auch schon.

: (HOTKEYS) ( lenmax ad len key -- lenmax ad len key )
       HOTKEYS-AUX
       DUP
       CASE
         4800 OF ?SCREEN@ @
                 IF   0 -1 CURS-AUX-MOVE
                 ELSE FORTHKEY-
                 THEN                          ENDOF   \ Up
         5000 OF ?SCREEN@ @
                 IF   0  1 CURS-AUX-MOVE
                 ELSE FORTHKEY+
                 THEN                          ENDOF   \ Down
         4900 OF ?SCREEN@ @
                 IF   0 -8 CURS-AUX-MOVE
                 ELSE FORTHKEY--
                 THEN                          ENDOF   \ Bild up
         5100 OF ?SCREEN@ @
                 IF   0  8 CURS-AUX-MOVE
                 ELSE FORTHKEY++
                 THEN                          ENDOF   \ Bild down
         5300 OF ?SCREEN@ @ 0=
                 IF FORTHKEY-DEL         THEN  ENDOF   \ Entf-Taste
         4100 OF ?SCREEN@ @ 0=
                 IF FORTHKEY-LIST        THEN  ENDOF   \ F7
         4300 OF ?SCREEN@ @ 0=
                 IF FORTHKEY-NR          THEN  ENDOF   \ F9
         4400 OF ?SCREEN@ @
                 IF   (?SCREEN@-OFF)
                 ELSE ?SCREEN@ ON
                      (CURSOR) CURS-AUX 2!
                      CHAR-CURS-INV
                 THEN                          ENDOF   \ F10
         8600 OF ?SCREEN@ @ KEY? 0= AND
                 IF
                   OVER 0FE <
                   IF
                     (CURSOR)
                     CURS-AUX 2@ AT
                     CHAR-CURS@
                     1 0 CURS-AUX-MOVE
                     -ROT AT
                     0FF AND KBUF!
                   ELSE
                     BEEP
                   THEN
                 THEN                          ENDOF   \ F12
         4700 OF ?SCREEN@ @ 0=
                 IF
                   0 SWAP ROT #COL0 @ +
                   40 4A @-H / (CURSOR) NIP
                   SWAP - #COL0 @ SWAP AT
                 ELSE
                   (CURSOR)
                   0 CURS-AUX 2@ 2DUP AT
                   CHAR-CURS-INV NIP 2DUP
                   CURS-AUX 2! AT
                   CHAR-CURS-INV AT
                 THEN                          ENDOF   \ Pos1
         4F00 OF ?SCREEN@ @ 0=
                 IF
                   #TIB @ ROT - (CURSOR) -ROT +
                   40 4A @-H /MOD ROT + AT
                   #TIB @ SWAP
                 ELSE
                   (CURSOR)
                   40 4A @-H 1- CURS-AUX 2@ 2DUP AT
                   CHAR-CURS-INV NIP 2DUP
                   CURS-AUX 2! AT
                   CHAR-CURS-INV AT
                 THEN                          ENDOF   \ End
         5200 OF ?SCREEN@ @ 0=
                 IF
                   INS @ 0=
                   IF   INS ON  0C 0D (FRAME)          \ "Normalcursor"
                   ELSE INS OFF 0B 0E (FRAME)
                   THEN
                 THEN                          ENDOF   \ Ins
         4B00 OF ?SCREEN@ @ 0=
                 IF
                   OVER 0<>
                   IF (CURSOR) SWAP DUP 0 >
                     IF   1- SWAP
                     ELSE DROP 40 4A @-H 1- SWAP 1-
                     THEN
                     AT SWAP 1- SWAP
                   THEN
                 ELSE
                   -1 0 CURS-AUX-MOVE
                 THEN                          ENDOF   \ Left
         7300 OF ?SCREEN@ @ 0=
                 IF
                   OVER 0<>
                   IF (CURSOR) SWAP DUP 0 >
                     IF   1- SWAP
                     ELSE DROP 40 4A @-H 1- SWAP 1-
                     THEN
                     AT SWAP 1- SWAP
                     BEGIN
                       OVER 0<> 3 PICK 3 PICK +
                       DUP 1- C@ BL <> SWAP
                              C@ BL =  OR AND
                     WHILE
                       (CURSOR) SWAP DUP 0 >
                       IF   1- SWAP
                       ELSE DROP 40 4A @-H 1- SWAP 1-
                       THEN
                       AT SWAP 1- SWAP
                     REPEAT
                   THEN
                 ELSE
                     -14 0 CURS-AUX-MOVE
                 THEN                          ENDOF   \ Left+CTRL
         4D00 OF ?SCREEN@ @ 0=
                 IF
                   #TIB @ 2 PICK <>
                   IF (CURSOR) SWAP
                     DUP 40 4A @-H 1- <
                     IF   1+ SWAP
                     ELSE DROP 0 SWAP 1+
                     THEN
                     AT SWAP 1+ SWAP
                   THEN
                 ELSE
                   1 0 CURS-AUX-MOVE
                 THEN                          ENDOF   \ Right
         7400 OF ?SCREEN@ @ 0=
                 IF
                   #TIB @ 2 PICK <>
                   IF (CURSOR) SWAP
                     DUP 40 4A @-H 1- <
                     IF   1+ SWAP
                     ELSE DROP 0 SWAP 1+
                     THEN
                     AT SWAP 1+ SWAP
                     BEGIN
                       OVER 0<> 3 PICK 3 PICK +
                       DUP 1- C@ BL <> SWAP
                              C@ BL =  OR AND
                       2 PICK #TIB @ < AND
                     WHILE
                       (CURSOR) SWAP
                       DUP 40 4A @-H 1- <
                       IF   1+ SWAP
                       ELSE DROP 0 SWAP 1+
                       THEN
                       AT SWAP 1+ SWAP
                     REPEAT
                   THEN
                 ELSE
                   14 0 CURS-AUX-MOVE
                 THEN                          ENDOF   \ Right+CTRL
       ENDCASE ;

' (HOTKEYS) IS HOTKEYS      \ Jetzt wird (HOTKEYS) nach EXPECT geschaltet


CR .( Men erzeugen )
HEX

: (MENU)  CR  3 SPACES BOLD ." F" ;
: (MENU1) CR 27 SPACES BOLD ." F" ;
: MENU  ( -- )
     ATTRIBUTS @ ATT-TEMP ! ATTRIBUTS ON CR CR BOLD
     18 (CURSOR) NIP AT   ."  Funktionstastenbelegung:" CR
     (MENU1) ." 6" ATTOFF ."  CHDIR: Verzeichnis ndern"
     (MENU1) ." 7" ATTOFF ."  FORTHKEY-LIST anzeigen"
     (MENU1) ." 8" ATTOFF ."  BYE to FORTH und zurck zu DOS"
     (MENU1) ." 9" ATTOFF ."  FORTHKEY-NR eingeben"
     CR 26 SPACES         ."  Man verwende auch" BOLD
                          ."  HELP (HOTKEYS)" ATTOFF ."  [RET]"
     (CURSOR) 5 - AT
     (MENU)  ." 1" ATTOFF ."  Ruft dieses MENU auf"
     (MENU)  ." 2" ATTOFF ."  EDIT Quell-Text-Datei"
     (MENU)  ." 3" ATTOFF ."  INCLUDE: Quelltext compilieren"
     (MENU)  ." 4" ATTOFF ."  SAVE-SYSTEM: System abspeichern"
     (MENU)  ." 5" ATTOFF ."  DIR: Aktuelles DOS-Verzeichnis"
     OPTIONS ATT-TEMP @ ATTRIBUTS ! ;

: HELLO ( -- )
     ONLY FORTH ALSO DEFINITIONS
     HANDLE OFF ATTRIBUTS ON DARK
     BOOT$ DROP 1- DMA COUNT     \ ad len
     DUP 1 >                     \ Wenn berhaupt String vorhanden,
     IF                          \ dann Position von ^ ermitteln:
       TRUE -ROT TUCK 0 TUCK     \ -1 len ad 0 len 0
       ?DO
         DROP
         DUP I + C@ ASCII ^ =    \ Auf Begrenzer 5Eh prfen
         IF I LEAVE THEN I       \ ^ an letzter Stelle dasselbe wie kein ^
       LOOP                      \ -1 len ad I ( I = Offset Begrenzerposition )
       TUCK                      \ -1 len I ad I
       + 1+                      \ -1 len I ad+I+1
       -ROT - 1-                 \ -1 ad+I+1 len-I-1 ( Reststring )
       OVER C@ BL <>             \ -1 ad+I+1 len-I-1 -1|0
     ELSE
       FALSE -ROT TRUE           \  0 ad len -1
     THEN                        \ Wenn 1. Stelle hinter ^ <> BL oder gar
     IF                          \ kein String vorhanden, dann Begrung:
       3 SPACES INVERS 26 B1 REPLICATE ATTOFF CR
       3 SPACES INVERS B1 EMIT
                ."  F-TP 1.00              MS-DOS-Host " B1 EMIT ATTOFF CR
       3 SPACES INVERS B1 EMIT 24 SPACES                 B1 EMIT ATTOFF CR
       3 SPACES INVERS B1 EMIT
                ."  TURBO-Forth-83 fr Transputer T800 " B1 EMIT ATTOFF CR
       3 SPACES INVERS B1 EMIT 24 SPACES                 B1 EMIT ATTOFF CR
       3 SPACES INVERS B1 EMIT
                ."  Copyright (C) 1992  Fred Behringer " B1 EMIT ATTOFF CR
       3 SPACES INVERS B1 EMIT 24 SPACES                 B1 EMIT ATTOFF CR
       3 SPACES INVERS B1 EMIT
                ."  Planegger Str. 24    81241 Mnchen " B1 EMIT ATTOFF CR
       3 SPACES INVERS 26 B1 REPLICATE ATTOFF MENU CR
     THEN                        \ ( 0 ad len ) oder ( -1 ad+I+1 len-I-1 )
     ROT
     IF
       $EXECUTE                  \ Kommando hinter ^ ausfhren
     ELSE
       2DROP                     \ ad,len beseitigen
     THEN
     .OK ABORT ;

' HELLO IS BOOT
' BOOT ASSEMBLER WPTR 'BOOT 4 * + ! FORTH
" .FTH" EXT$ $!

\ : MARK    ( -- )
\      CREATE DOES> (FORGET) FORTH DEFINITIONS ;
\ MARK EMPTY  HERE FENCE !

\ Das ursprngliche MARK habe ich durch das allgemeinere
\ dpANS-5-Wort  MARKER ersetzt.  Das bercksichtigt beim
\ Wiederherstellen  auch  die gesamte Vokabularstruktur.
\ Allerdings beseitigt das durch MARKER xx erzeugte Wort
\ xx bei Aufruf auch sich selbst.  Das ist bei EMPTY aus
\ naheliegenden Grnden  nicht wnschenswert.  Also habe
\ ich EMPTY gesondert definiert.  Siehe auch KERNEL wei-
\ ter oben, am Anfang von TCORE.FTH, mit dem man das Sy-
\ stem bis auf den KERNEL reduzieren kann.

: MARKER
      CREATE CURRENT @ , HERE #VOCS 4* ALLOT
             CONTEXT     SWAP #VOCS 4* MOVE
      DOES>  >R R@ @  CURRENT !              \ erzeugte Wort wird bei
                R@ 4+ CONTEXT #VOCS 4* MOVE  \ Aufruf auch gelscht.
             R> BODY>   >VIEW (FORGET) ;


CR .( Abschluss )
HEX

\ Achtung:  Die jetzt folgende, etwas kunstvolle Konstruktion,  in der
\ FORTHKEY und EMPTY zusammenspielen, muss hier ( am Schluss ) bleiben.
\ Sie sorgt dafr, dass die Lnge des Eingabe-Aufbewahrpuffers aus dem
\ fertig-compilierten  laufenden System heraus  durch einfache Eingabe
\ von FORTHKEY-MAKE [RET] ( nachtrglich ) verndert werden kann,  oh-
\ ne dass die Wirkung von EMPTY aufgehoben wird.
\ Um es nochmal ganz konkret zu sagen:  Im folgenden Wort FORTKEY-MAKE
\ wird - etwas versteckt - auch das ( allerletzte ) Wort  EMPTY  defi-
\ niert.

55 STRING EMPTY$                    \ Belegung folgt und bleibt

" : EMPTY "         EMPTY$ APPEND$  \ Zur Inline-Erzeugung von EMPTY
" 7 FENCE ! "       EMPTY$ APPEND$  \ 7 = Platzhalter
" 7 (FORGET) "      EMPTY$ APPEND$  \ 7 = Platzhalter
" ['] NOOP "        EMPTY$ APPEND$  \ cfa von NOOP
" IS HOTKEYS-AUX "  EMPTY$ APPEND$  \ Nach HOTKEYS-AUX schalten
" ONLY FORTH ALSO " EMPTY$ APPEND$  \ Vokabular FORTH einschalten
" DEFINITIONS ;"    EMPTY$ APPEND$  \ Zum Definitionsvokabular machen

: FORTHKEY-MAKE ( n -- )                \ n = Lnge von FORTHKEY
     DEPTH 0<=
     ABORT" Lnge ?"                    \ Vergessen ?
     EVEN                               \ Aufgerundet. Jetzt durch 4 teilbar.
     DUP 20 <
     ABORT" Lnge negativ oder zu klein !"
     DUP SP0 @ PAD - >
     ABORT" Lnge zu gro !"
     " (FORTHKEY)" DROP 1- FIND         \ Schon da ?
     IF
       >VIEW DUP FENCE ! (FORGET)       \ Ja, dann zusammen mit EMPTY entfernen
     ELSE
       DROP                             \ Nein, dann Adresse vom Stack nehmen
     THEN
     " VARIABLE (FORTHKEY)" $EXECUTE
     " ' (FORTHKEY) IS FORTHKEY" $EXECUTE
     DUP HERE + FORTHKEY !              \ Tabellenende
     ALLOT                              \ Tabellenlnge
     FORTHKEY 8 + DUP OFF               \ Initiierung erstes "Record" = Lnge 0
     FORTHKEY 4+  !                     \ Zeiger auf erstes "Record"
     EMPTY$ $EXECUTE                    \ EMPTY erzeugen
                                        \ Aufruf von EMPTY reduziert
                                        \ das System auf KERNEL+TCORE .
                                        \ Das Wort EMPTY bleibt.
     " HERE ' EMPTY 2DUP 8 + ! 18 + !"  \ Diese Adresse,  das ist  die er-
     $EXECUTE                           \ ste Adresse nach dem Wort EMPTY,
                                        \ wird jetzt in das Wort EMPTY  so
                                        \ eingebracht, dass bei Aufruf von
                                        \ EMPTY  die  Variable  FENCE  auf
                                        \ diese Adresse  gesetzt  und  an-
                                        \ schlieend alles,  was auf EMPTY
                                        \ folgt, (FORGET)et wird.
                                        \ Siehe auch  KERNEL  am Ende  von
                                        \ TKERNEL.FTH.
     " EMPTY" $EXECUTE ;                \ Damit wird FENCE  auf den ersten
                                        \ Platz hinter EMPTY gesetzt.

800 FORTHKEY-MAKE                       \ Und schon wird das alles gemacht.

ECHO OFF

CR .( E N D E  D E S  L I S T I N G S ) CR CR BOLD
.( System geladen, Gre = )

HEX
HERE WPTR -
DECIMAL U. .( Bytes ) ATTOFF

: XXXX BOOT$ DROP 1- DMA COUNT \ ad len
   DUP 1 >                     \ Wenn berhaupt String vorhanden,
   IF                          \ dann Position von ^ ermitteln:
     0 TUCK                    \ ad 0 len 0
     ?DO
       DROP
       DUP I + C@ ASCII ^ =    \ Auf Begrenzer 5Eh prfen
       IF I LEAVE THEN I       \ ^ an letzter Stelle dasselbe wie kein ^
     LOOP                      \ ad I ( I = Offset Begrenzerposition )
     + 1+                      \ ad+I+1
     C@ BL <>                  \ -1|0
   ELSE
     2DROP TRUE                \ -1
   THEN                        \ Wenn 1. Stelle hinter ^ <> BL oder gar
   IF                          \ kein String, dann folgende Meldung:
     CR
     CR ." Jetzt gegebenenfalls fr HELP die Hilfsdateien"
     CR ." ber FORTH LEARN , ROOT LEARN usw. anbinden."
     CR ." Dann SAVE-SYSTEM TFORTH.FYS eingeben,"
     CR ." dann BYE-FOR-DOS ."
     CR ." Das Gesamtsystem einladen ber"
     CR ." TRANSSYS SERVER TRESET LOAD-SYSTEM TFORTH.FYS"
     CR ." oder krzer durch Eingabe von LOAD-FTP [RET]"
   THEN ;

XXXX FORGET XXXX               \ Nur fr den ersten Systemaufbau bentigt

HEX
ECHO ON  WARNING ON
